/*
	This file contains the DDL to build the Skolem meta-data tables in the ModelGen database.
*/

/*
DROP IF EXIXTS TABLE MSM_SkolemFunction;
DROP IF EXISTS TABLE MSM_SkolemFunctionArgument;
*/

NOROLLBACK DROP TABLE MSM_SkolemFunctionArgument;
NOROLLBACK DROP TABLE MSM_SkolemFunction;

CREATE TABLE MSM_SkolemFunction(
	//OID int primary key,
	OID identity primary key,
	name varchar, //The name of the skolem function
	constructOID int, //The construct which owns the SkolemFunction.
	foreign key (constructOID) references MSM_Construct(OID),
	unique (name)
);
//Its attributes:
CREATE TABLE MSM_SkolemFunctionArgument(
	//OID int,
	OID identity,
	name varchar,
	type varchar, //This will be set to an hardcode "INTEGER" until a revision of the current SkolemFunction class occurrs.
	sourceConstructOID int, // the construct the argument come from.
	functionOID int, //External key to the owning function.
	foreign key (sourceConstructOID) references MSM_Construct(OID),
	foreign key (functionOID) references MSM_SkolemFunction(OID)
	// cannot put a check constraint to check that arguments of functions with the same 
	// target construct have different name: this is a limitation of the current hsqldb
	// Currently, hsqldb allows to write check for just the current row.
	//primary key (functionOID,OID)
);
