INSERT INTO MSM_Construct(name, isLexical) VALUES('Aggregation',false);	//0
INSERT INTO MSM_Construct(name, isLexical) VALUES('Abstract',false);	//1

INSERT INTO MSM_Construct(name, isLexical) VALUES('StructOfAttributes',false);	//2


INSERT INTO MSM_Construct(name, isLexical) VALUES('AbstractAttribute',false);	//3
INSERT INTO MSM_Construct(name, isLexical) VALUES('BinaryAggregationOfAbstracts',false);	//4

INSERT INTO MSM_Construct(name, isLexical) VALUES('AggregationOfAbstracts',false);	//5
INSERT INTO MSM_Construct(name, isLexical) VALUES('ComponentOfAggregationOfAbstracts',false);	//6

INSERT INTO MSM_Construct(name, isLexical) VALUES('Generalization',false);	//7
INSERT INTO MSM_Construct(name, isLexical) VALUES('ChildOfGeneralization',false);	//8

INSERT INTO MSM_Construct(name, isLexical) VALUES('Nest',false);	//9
INSERT INTO MSM_Construct(name, isLexical) VALUES('Lexical',true);	//10

INSERT INTO MSM_Construct(name, isLexical) VALUES('ForeignKey',false);	//11
INSERT INTO MSM_Construct(name, isLexical) VALUES('ComponentOfForeignKey',false);	//12


INSERT INTO MSM_Reference(name, type, ownerConstructOID, targetConstructOID)
	SELECT 'binaryAggregationOfAbstractsOID', 'description', owner.OID, target.OID
	FROM MSM_Construct owner, MSM_Construct target
	WHERE owner.name = 'Lexical'
		AND target.name = 'BinaryAggregationOfAbstracts';

INSERT INTO MSM_Reference(name, type, ownerConstructOID, targetConstructOID)
	SELECT 'aggregationOfAbstractsOID', 'description', owner.OID, target.OID
	FROM MSM_Construct owner, MSM_Construct target
	WHERE owner.name = 'Lexical'
		AND target.name = 'AggregationOfAbstracts';

INSERT INTO MSM_Reference(name, type, ownerConstructOID, targetConstructOID)
	SELECT 'aggregationOID', 'description', owner.OID, target.OID
	FROM MSM_Construct owner, MSM_Construct target
	WHERE owner.name = 'Lexical'
		AND target.name = 'Aggregation';

INSERT INTO MSM_Reference(name, type, ownerConstructOID, targetConstructOID)
	SELECT 'aggregationFromOID', 'relation', owner.OID, target.OID
	FROM MSM_Construct owner, MSM_Construct target
	WHERE owner.name = 'ForeignKey'
		AND target.name = 'Aggregation';
INSERT INTO MSM_Reference(name, type, ownerConstructOID, targetConstructOID)
	SELECT 'aggregationToOID', 'relation', owner.OID, target.OID
	FROM MSM_Construct owner, MSM_Construct target
	WHERE owner.name = 'ForeignKey'
		AND target.name = 'Aggregation';

INSERT INTO MSM_Reference(name, type, ownerConstructOID, targetConstructOID)
	SELECT 'abstractFromOID', 'relation', owner.OID, target.OID
	FROM MSM_Construct owner, MSM_Construct target
	WHERE owner.name = 'ForeignKey'
		AND target.name = 'Abstract';
INSERT INTO MSM_Reference(name, type, ownerConstructOID, targetConstructOID)
	SELECT 'abstractToOID', 'relation', owner.OID, target.OID
	FROM MSM_Construct owner, MSM_Construct target
	WHERE owner.name = 'ForeignKey'
		AND target.name = 'Abstract';

INSERT INTO MSM_Reference(name, type, ownerConstructOID, targetConstructOID)
	SELECT 'structOfAttributesFromOID', 'relation', owner.OID, target.OID
	FROM MSM_Construct owner, MSM_Construct target
	WHERE owner.name = 'ForeignKey'
		AND target.name = 'StructOfAttributes';
INSERT INTO MSM_Reference(name, type, ownerConstructOID, targetConstructOID)
	SELECT 'structOfAttributesToOID', 'relation', owner.OID, target.OID
	FROM MSM_Construct owner, MSM_Construct target
	WHERE owner.name = 'ForeignKey'
		AND target.name = 'StructOfAttributes';

INSERT INTO MSM_Reference(name, type, ownerConstructOID, targetConstructOID)
	SELECT 'foreignKeyOID', 'description', owner.OID, target.OID
	FROM MSM_Construct owner, MSM_Construct target
	WHERE owner.name = 'ComponentOfForeignKey'
		AND target.name = 'ForeignKey';
		
INSERT INTO MSM_Reference(name, type, ownerConstructOID, targetConstructOID)
	SELECT 'lexicalFromOID', 'relation', owner.OID, target.OID
	FROM MSM_Construct owner, MSM_Construct target
	WHERE owner.name = 'ComponentOfForeignKey'
		AND target.name = 'Lexical';
INSERT INTO MSM_Reference(name, type, ownerConstructOID, targetConstructOID)
	SELECT 'lexicalToOID', 'relation', owner.OID, target.OID
	FROM MSM_Construct owner, MSM_Construct target
	WHERE owner.name = 'ComponentOfForeignKey'
		AND target.name = 'Lexical';

INSERT INTO MSM_Dependency(parent, child)
	SELECT Parent.OID, Child.OID
	FROM MSM_Construct Parent, MSM_Construct Child
	WHERE Parent.name = 'ForeignKey'
		AND Child.name = 'ComponentOfForeignKey';
	
INSERT INTO MSM_Property(constructOID, name, type, default)
	SELECT C.OID, 'isNullable', 'boolean', 'true'
	FROM MSM_Construct C
	WHERE C.name = 'Lexical';
	
INSERT INTO MSM_Property(constructOID, name, type, default)
	SELECT C.OID, 'isOptional', 'boolean', 'true'
	FROM MSM_Construct C
	WHERE C.name = 'Lexical';

INSERT INTO MSM_Property(constructOID, name, type, default)
	SELECT C.OID, 'isIdentifier', 'boolean', 'false'
	FROM MSM_Construct C
	WHERE C.name = 'Lexical';
	
INSERT INTO MSM_Property(constructOID, name, type, default)
	SELECT C.OID, 'type', 'varchar', 'int'
	FROM MSM_Construct C
	WHERE C.name = 'Lexical';
	
INSERT INTO MSM_Property(constructOID, name, type, default)
	SELECT C.OID, 'isNullable', 'boolean', 'true'
	FROM MSM_Construct C
	WHERE C.name = 'AbstractAttribute';

/*
INSERT INTO MSM_Property(constructOID, name, type, default)
	SELECT C.OID, 'isIdentifier', 'boolean', 'false'
	FROM MSM_Construct C
	WHERE C.name = 'AbstractAttribute';
*/

INSERT INTO MSM_Property(constructOID, name, type, default)
	SELECT C.OID, 'role1', 'varchar', 'int'
	FROM MSM_Construct C
	WHERE C.name = 'BinaryAggregationOfAbstracts';

INSERT INTO MSM_Property(constructOID, name, type, default)
	SELECT C.OID, 'isOptional1', 'boolean', 'true'
	FROM MSM_Construct C
	WHERE C.name = 'BinaryAggregationOfAbstracts';

INSERT INTO MSM_Property(constructOID, name, type, default)
	SELECT C.OID, 'isFunctional1', 'boolean', 'false'
	FROM MSM_Construct C
	WHERE C.name = 'BinaryAggregationOfAbstracts';

INSERT INTO MSM_Property(constructOID, name, type, default)
	SELECT C.OID, 'isIdentified', 'boolean', 'false'
	FROM MSM_Construct C
	WHERE C.name = 'BinaryAggregationOfAbstracts';

INSERT INTO MSM_Property(constructOID, name, type, default)
	SELECT C.OID, 'role2', 'varchar', 'int'
	FROM MSM_Construct C
	WHERE C.name = 'BinaryAggregationOfAbstracts';

INSERT INTO MSM_Property(constructOID, name, type, default)
	SELECT C.OID, 'isOptional2', 'boolean', 'true'
	FROM MSM_Construct C
	WHERE C.name = 'BinaryAggregationOfAbstracts';

INSERT INTO MSM_Property(constructOID, name, type, default)
	SELECT C.OID, 'isFunctional2', 'boolean', 'false'
	FROM MSM_Construct C
	WHERE C.name = 'BinaryAggregationOfAbstracts';
	
/* QUI INIZIA Struct */
INSERT INTO MSM_Property(constructOID, name, type, default)
	SELECT C.OID, 'isSet', 'boolean', 'false'
	FROM MSM_Construct C
	WHERE C.name = 'StructOfAttributes';

INSERT INTO MSM_Property(constructOID, name, type, default)
	SELECT C.OID, 'isOptional', 'boolean', 'true'
	FROM MSM_Construct C
	WHERE C.name = 'StructOfAttributes';
	
INSERT INTO MSM_Property(constructOID, name, type, default)
	SELECT C.OID, 'isNullable', 'boolean', 'true'
	FROM MSM_Construct C
	WHERE C.name = 'StructOfAttributes';

INSERT INTO MSM_Reference(name, type, ownerConstructOID, targetConstructOID)
	SELECT 'abstractOID', 'description', owner.OID, target.OID
	FROM MSM_Construct owner, MSM_Construct target
	WHERE owner.name = 'StructOfAttributes'
		AND target.name = 'Abstract';

INSERT INTO MSM_Reference(name, type, ownerConstructOID, targetConstructOID)
	SELECT 'aggregationOID', 'description', owner.OID, target.OID
	FROM MSM_Construct owner, MSM_Construct target
	WHERE owner.name = 'StructOfAttributes'
		AND target.name = 'Aggregation';

INSERT INTO MSM_Reference(name, type, ownerConstructOID, targetConstructOID)
	SELECT 'structOfAttributesOID', 'description', owner.OID, target.OID
	FROM MSM_Construct owner, MSM_Construct target
	WHERE owner.name = 'AbstractAttribute'
		AND target.name = 'StructOfAttributes';

INSERT INTO MSM_Reference(name, type, ownerConstructOID, targetConstructOID)
	SELECT 'aggregationOID', 'description', owner.OID, target.OID
	FROM MSM_Construct owner, MSM_Construct target
	WHERE owner.name = 'AbstractAttribute'
		AND target.name = 'Aggregation';

INSERT INTO MSM_Reference(name, type, ownerConstructOID, targetConstructOID)
	SELECT 'structOfAttributesOID', 'description', owner.OID, target.OID
	FROM MSM_Construct owner, MSM_Construct target
	WHERE owner.name = 'Lexical'
		AND target.name = 'StructOfAttributes';
/*  QUI FINISCE Struct */
		
INSERT INTO MSM_Reference(name, type, ownerConstructOID, targetConstructOID)
	SELECT 'abstractOID', 'description', owner.OID, target.OID
	FROM MSM_Construct owner, MSM_Construct target
	WHERE owner.name = 'Lexical'
		AND target.name = 'Abstract';
		
INSERT INTO MSM_Reference(name, type, ownerConstructOID, targetConstructOID)
	SELECT 'abstractOID', 'description', owner.OID, target.OID
	FROM MSM_Construct owner, MSM_Construct target
	WHERE owner.name = 'AbstractAttribute'
		AND target.name = 'Abstract';

INSERT INTO MSM_Reference(name, type, ownerConstructOID, targetConstructOID)
	SELECT 'abstractToOID', 'relation', owner.OID, target.OID
	FROM MSM_Construct owner, MSM_Construct target
	WHERE owner.name = 'AbstractAttribute'
		AND target.name = 'Abstract';

INSERT INTO MSM_Reference(name, type, ownerConstructOID, targetConstructOID)
	SELECT 'abstract1OID', 'relation', owner.OID, target.OID
	FROM MSM_Construct owner, MSM_Construct target
	WHERE owner.name = 'BinaryAggregationOfAbstracts'
		AND target.name = 'Abstract';

INSERT INTO MSM_Reference(name, type, ownerConstructOID, targetConstructOID)
	SELECT 'abstract2OID', 'relation', owner.OID, target.OID
	FROM MSM_Construct owner, MSM_Construct target
	WHERE owner.name = 'BinaryAggregationOfAbstracts'
		AND target.name = 'Abstract';
		
INSERT INTO MSM_Dependency(Parent, Child)
	SELECT Parent.OID, Child.OID
	FROM MSM_Construct Parent, MSM_Construct Child
	WHERE Child.name = 'AbstractAttribute'
		AND Parent.name = 'Abstract';

INSERT INTO MSM_Dependency(Parent, Child)
	SELECT Parent.OID, Child.OID
	FROM MSM_Construct Parent, MSM_Construct Child
	WHERE Child.name = 'BinaryAggregationOfAbstracts'
		AND Parent.name = 'Abstract';


INSERT INTO MSM_Property(constructOID, name, type, default)
	SELECT C.OID, 'isOptional', 'boolean', 'true'
	FROM MSM_Construct C
	WHERE C.name = 'ComponentOfAggregationOfAbstracts';

INSERT INTO MSM_Property(constructOID, name, type, default)
	SELECT C.OID, 'isFunctional', 'boolean', 'false'
	FROM MSM_Construct C
	WHERE C.name = 'ComponentOfAggregationOfAbstracts';

INSERT INTO MSM_Property(constructOID, name, type, default)
	SELECT C.OID, 'isIdentified', 'boolean', 'false'
	FROM MSM_Construct C
	WHERE C.name = 'ComponentOfAggregationOfAbstracts';

INSERT INTO MSM_Reference(name, type, ownerConstructOID, targetConstructOID)
	SELECT 'abstractOID', 'relation', owner.OID, target.OID
	FROM MSM_Construct owner, MSM_Construct target
	WHERE owner.name = 'ComponentOfAggregationOfAbstracts'
		AND target.name = 'Abstract';

INSERT INTO MSM_Reference(name, type, ownerConstructOID, targetConstructOID)
	SELECT 'aggregationOfAbstractsOID', 'description', owner.OID, target.OID
	FROM MSM_Construct owner, MSM_Construct target
	WHERE owner.name = 'ComponentOfAggregationOfAbstracts'
		AND target.name = 'AggregationOfAbstracts';

INSERT INTO MSM_Dependency(Parent, Child)
	SELECT Parent.OID, Child.OID
	FROM MSM_Construct Parent, MSM_Construct Child
	WHERE Child.name = 'AggregationOfAbstracts'
		AND Parent.name = 'Abstract';

INSERT INTO MSM_Dependency(Parent, Child)
	SELECT Parent.OID, Child.OID
	FROM MSM_Construct Parent, MSM_Construct Child
	WHERE Child.name = 'ComponentOfAggregationOfAbstracts'
		AND Parent.name = 'AggregationOfAbstracts';

// Le generalizzazioni
		


INSERT INTO MSM_Property(constructOID, name, type, default)
	SELECT C.OID, 'isTotal', 'boolean', 'false'
	FROM MSM_Construct C
	WHERE C.name = 'Generalization';

//INSERT INTO MSM_Property(constructOID, name, type, default)
//	SELECT C.OID, 'isExclusive', 'boolean', 'false'
//	FROM MSM_Construct C
//	WHERE C.name = 'Generalization';

INSERT INTO MSM_Reference(name, type, ownerConstructOID, targetConstructOID)
	SELECT 'parentAbstractOID', 'relation', owner.OID, target.OID
	FROM MSM_Construct owner, MSM_Construct target
	WHERE owner.name = 'Generalization'
		AND target.name = 'Abstract';

INSERT INTO MSM_Reference(name, type, ownerConstructOID, targetConstructOID)
	SELECT 'generalizationOID', 'description', owner.OID, target.OID
	FROM MSM_Construct owner, MSM_Construct target
	WHERE owner.name = 'ChildOfGeneralization'
		AND target.name = 'Generalization';

INSERT INTO MSM_Reference(name, type, ownerConstructOID, targetConstructOID)
	SELECT 'childAbstractOID', 'relation', owner.OID, target.OID
	FROM MSM_Construct owner, MSM_Construct target
	WHERE owner.name = 'ChildOfGeneralization'
		AND target.name = 'Abstract';

/* QUI INIZIA Set e Struct */
INSERT INTO MSM_Reference(name, type, ownerConstructOID, targetConstructOID)
	SELECT 'structOfAttributesTopOID', 'description', owner.OID, target.OID
	FROM MSM_Construct owner, MSM_Construct target
	WHERE owner.name = 'Nest'
		AND target.name = 'StructOfAttributes';
		
INSERT INTO MSM_Reference(name, type, ownerConstructOID, targetConstructOID)
	SELECT 'structOfAttributesNestedOID', 'relation', owner.OID, target.OID
	FROM MSM_Construct owner, MSM_Construct target
	WHERE owner.name = 'Nest'
		AND target.name = 'StructOfAttributes';
/* QUI FNISCE Set e Struct */
		
INSERT INTO MSM_Dependency(Parent, Child)
	SELECT Parent.OID, Child.OID
	FROM MSM_Construct Parent, MSM_Construct Child
	WHERE Child.name = 'Generalization'
		AND Parent.name = 'Abstract';

INSERT INTO MSM_Dependency(Parent, Child)
	SELECT Parent.OID, Child.OID
	FROM MSM_Construct Parent, MSM_Construct Child
	WHERE Child.name = 'ChildOfGeneralization'
		AND Parent.name = 'Generalization';
		
		
/* proprietà isStub per i costrutti */

INSERT INTO MSM_Property(constructOID, name, type)
	SELECT C.OID, 'isStub', 'boolean'
	FROM MSM_Construct C
	WHERE C.name = 'Abstract';

INSERT INTO MSM_Property(constructOID, name, type)
	SELECT C.OID, 'isStub', 'boolean'
	FROM MSM_Construct C
	WHERE C.name = 'Aggregation';

INSERT INTO MSM_Property(constructOID, name, type)
	SELECT C.OID, 'isStub', 'boolean'
	FROM MSM_Construct C
	WHERE C.name = 'Lexical';	

INSERT INTO MSM_Property(constructOID, name, type)
	SELECT C.OID, 'isStub', 'boolean'
	FROM MSM_Construct C
	WHERE C.name = 'AbstractAttribute';
	
INSERT INTO MSM_Property(constructOID, name, type)
	SELECT C.OID, 'isStub', 'boolean'
	FROM MSM_Construct C
	WHERE C.name = 'Generalization';

INSERT INTO MSM_Property(constructOID, name, type)
	SELECT C.OID, 'isStub', 'boolean'
	FROM MSM_Construct C
	WHERE C.name = 'ChildOfGeneralization';

INSERT INTO MSM_Property(constructOID, name, type)
	SELECT C.OID, 'isStub', 'boolean'
	FROM MSM_Construct C
	WHERE C.name = 'StructOfAttributes';
	
INSERT INTO MSM_Property(constructOID, name, type)
	SELECT C.OID, 'isStub', 'boolean'
	FROM MSM_Construct C
	WHERE C.name = 'Nest';

INSERT INTO MSM_Property(constructOID, name, type)
	SELECT C.OID, 'isStub', 'boolean'
	FROM MSM_Construct C
	WHERE C.name = 'AggregationOfAbstracts';

INSERT INTO MSM_Property(constructOID, name, type)
	SELECT C.OID, 'isStub', 'boolean'
	FROM MSM_Construct C
	WHERE C.name = 'ComponentOfAggregationOfAbstracts';

INSERT INTO MSM_Property(constructOID, name, type)
	SELECT C.OID, 'isStub', 'boolean'
	FROM MSM_Construct C
	WHERE C.name = 'ForeignKey';

INSERT INTO MSM_Property(constructOID, name, type)
	SELECT C.OID, 'isStub', 'boolean'
	FROM MSM_Construct C
	WHERE C.name = 'ComponentOfForeignKey';
	
INSERT INTO MSM_Property(constructOID, name, type)
	SELECT C.OID, 'isStub', 'boolean'
	FROM MSM_Construct C
	WHERE C.name = 'BinaryAggregationOfAbstracts';		
		
/* Creazione degli insiemi caratterizzanti */

/* Insiemi per StructOfAttributes */

/* 1 */
INSERT INTO MSM_CarSet(Name, constructOID)
	SELECT 'AbstractStructOfAttributes', OID
	FROM MSM_Construct
	WHERE name = 'StructOfAttributes';
	
INSERT INTO MSM_CAR (CarSetOID, referenceOID) 
	SELECT c.OID, r.OID
	FROM MSM_CarSet c, MSM_Reference r, MSM_Construct cons
	WHERE c.Name = 'AbstractStructOfAttributes'  AND
                    r.Name = 'abstractOID' AND
                    r.ownerConstructOID = cons.OID AND
                    cons.Name = 'StructOfAttributes';
                    

/* 2 */
INSERT INTO MSM_CarSet(Name, constructOID)
	SELECT 'AggregationStructOfAttributes', OID
	FROM MSM_Construct
	WHERE name = 'StructOfAttributes';

INSERT INTO MSM_CAR (CarSetOID, referenceOID) 
	SELECT c.OID, r.OID
	FROM MSM_CarSet c, MSM_Reference r, MSM_Construct cons
	WHERE c.Name = 'AggregationStructOfAttributes'  AND
                    r.Name = 'aggregationOID' AND
                    r.ownerConstructOID = cons.OID AND
                    cons.Name = 'StructOfAttributes';


/* Insiemi per AbstractAttribute */

/* 1 */

INSERT INTO MSM_CarSet(Name, constructOID)
	SELECT 'AbstractAbstractAttribute', OID
	FROM MSM_Construct
	WHERE name = 'AbstractAttribute';


INSERT INTO MSM_CAR (CarSetOID, referenceOID) 
	SELECT c.OID, r.OID
	FROM MSM_CarSet c, MSM_Reference r, MSM_Construct cons
	WHERE c.Name = 'AbstractAbstractAttribute'  AND
                    r.Name = 'abstractOID' AND
                    r.ownerConstructOID = cons.OID AND
                    cons.Name = 'AbstractAttribute';
                    
INSERT INTO MSM_CAR (CarSetOID, referenceOID) 
	SELECT c.OID, r.OID
	FROM MSM_CarSet c, MSM_Reference r, MSM_Construct cons
	WHERE c.Name = 'AbstractAbstractAttribute'  AND
                    r.Name = 'abstractToOID' AND
                    r.ownerConstructOID = cons.OID AND
                    cons.Name = 'AbstractAttribute';
                    

/* 2 */

INSERT INTO MSM_CarSet(Name, constructOID)
	SELECT 'AggregationAbstractAttribute', OID
	FROM MSM_Construct
	WHERE name = 'AbstractAttribute';

INSERT INTO MSM_CAR (CarSetOID, referenceOID) 
	SELECT c.OID, r.OID
	FROM MSM_CarSet c, MSM_Reference r, MSM_Construct cons
	WHERE c.Name = 'AggregationAbstractAttribute'  AND
                    r.Name = 'aggregationOID' AND
                    r.ownerConstructOID = cons.OID AND
                    cons.Name = 'AbstractAttribute';
                    
INSERT INTO MSM_CAR (CarSetOID, referenceOID) 
	SELECT c.OID, r.OID
	FROM MSM_CarSet c, MSM_Reference r, MSM_Construct cons
	WHERE c.Name = 'AggregationAbstractAttribute'  AND
                    r.Name = 'abstractToOID' AND
                    r.ownerConstructOID = cons.OID AND
                    cons.Name = 'AbstractAttribute';
	
/* 3 */

INSERT INTO MSM_CarSet(Name, constructOID)
	SELECT 'StructOfAttributesAbstractAttribute', OID
	FROM MSM_Construct
	WHERE name = 'AbstractAttribute';

INSERT INTO MSM_CAR (CarSetOID, referenceOID) 
	SELECT c.OID, r.OID
	FROM MSM_CarSet c, MSM_Reference r, MSM_Construct cons
	WHERE c.Name = 'StructOfAttributesAbstractAttribute'  AND
                    r.Name = 'structOfAttributesOID' AND
                    r.ownerConstructOID = cons.OID AND
                    cons.Name = 'AbstractAttribute';

INSERT INTO MSM_CAR (CarSetOID, referenceOID) 
	SELECT c.OID, r.OID
	FROM MSM_CarSet c, MSM_Reference r, MSM_Construct cons
	WHERE c.Name = 'StructOfAttributesAbstractAttribute'  AND
                    r.Name = 'abstractToOID' AND
                    r.ownerConstructOID = cons.OID AND
                    cons.Name = 'AbstractAttribute';
                    
/* Insiemi per BinaryAggregationOfAbstracts */

/* 1 */

INSERT INTO MSM_CarSet(Name, constructOID)
	SELECT 'BinaryAggregationOfAbstracts', OID
	FROM MSM_Construct
	WHERE name = 'BinaryAggregationOfAbstracts';

INSERT INTO MSM_CAR (CarSetOID, referenceOID) 
	SELECT c.OID, r.OID
	FROM MSM_CarSet c, MSM_Reference r, MSM_Construct cons
	WHERE c.Name = 'BinaryAggregationOfAbstracts'  AND
                    r.Name = 'abstract1OID' AND
                    r.ownerConstructOID = cons.OID AND
                    cons.Name = 'BinaryAggregationOfAbstracts';

INSERT INTO MSM_CAR (CarSetOID, referenceOID) 
	SELECT c.OID, r.OID
	FROM MSM_CarSet c, MSM_Reference r, MSM_Construct cons
	WHERE c.Name = 'BinaryAggregationOfAbstracts'  AND
                    r.Name = 'abstract2OID' AND
                    r.ownerConstructOID = cons.OID AND
                    cons.Name = 'BinaryAggregationOfAbstracts';

/* Insiemi per ComponentOfAggregationOfAbstracts */

/* 1 */

INSERT INTO MSM_CarSet(Name, constructOID)
	SELECT 'ComponentOfAggregationOfAbstracts', OID
	FROM MSM_Construct
	WHERE name = 'ComponentOfAggregationOfAbstracts';


INSERT INTO MSM_CAR (CarSetOID, referenceOID) 
	SELECT c.OID, r.OID
	FROM MSM_CarSet c, MSM_Reference r, MSM_Construct cons
	WHERE c.Name = 'ComponentOfAggregationOfAbstracts'  AND
                    r.Name = 'abstractOID' AND
                    r.ownerConstructOID = cons.OID AND
                    cons.Name = 'ComponentOfAggregationOfAbstracts';
                    
INSERT INTO MSM_CAR (CarSetOID, referenceOID) 
	SELECT c.OID, r.OID
	FROM MSM_CarSet c, MSM_Reference r, MSM_Construct cons
	WHERE c.Name = 'ComponentOfAggregationOfAbstracts'  AND
                    r.Name = 'aggregationOfAbstractsOID' AND
                    r.ownerConstructOID = cons.OID AND
                    cons.Name = 'ComponentOfAggregationOfAbstracts';
                    
/* Insiemi per Generalization */

/* 1 */

INSERT INTO MSM_CarSet(Name, constructOID)
	SELECT 'Generalization', OID
	FROM MSM_Construct
	WHERE name = 'Generalization';

INSERT INTO MSM_CAR (CarSetOID, referenceOID) 
	SELECT c.OID, r.OID
	FROM MSM_CarSet c, MSM_Reference r, MSM_Construct cons
	WHERE c.Name = 'Generalization'  AND
                    r.Name = 'parentAbstractOID' AND
                    r.ownerConstructOID = cons.OID AND
                    cons.Name = 'Generalization';

/* Insiemi per ChildOfGeneralization */

/* 1 */

INSERT INTO MSM_CarSet(Name, constructOID)
	SELECT 'ChildOfGeneralization', OID
	FROM MSM_Construct
	WHERE name = 'ChildOfGeneralization';

INSERT INTO MSM_CAR (CarSetOID, referenceOID) 
	SELECT c.OID, r.OID
	FROM MSM_CarSet c, MSM_Reference r, MSM_Construct cons
	WHERE c.Name = 'ChildOfGeneralization'  AND
                    r.Name = 'generalizationOID' AND
                    r.ownerConstructOID = cons.OID AND
                    cons.Name = 'ChildOfGeneralization';
                    
INSERT INTO MSM_CAR (CarSetOID, referenceOID) 
	SELECT c.OID, r.OID
	FROM MSM_CarSet c, MSM_Reference r, MSM_Construct cons
	WHERE c.Name = 'ChildOfGeneralization'  AND
                    r.Name = 'childAbstractOID' AND
                    r.ownerConstructOID = cons.OID AND
                    cons.Name = 'ChildOfGeneralization';

/* Insiemi per Nest */

/* 1 */

INSERT INTO MSM_CarSet(Name, constructOID)
	SELECT 'Nest', OID
	FROM MSM_Construct
	WHERE name = 'Nest';

INSERT INTO MSM_CAR (CarSetOID, referenceOID) 
	SELECT c.OID, r.OID
	FROM MSM_CarSet c, MSM_Reference r, MSM_Construct cons
	WHERE c.Name = 'Nest'  AND
                    r.Name = 'structOfAttributesTopOID' AND
                    r.ownerConstructOID = cons.OID AND
                    cons.Name = 'Nest';

INSERT INTO MSM_CAR (CarSetOID, referenceOID) 
	SELECT c.OID, r.OID
	FROM MSM_CarSet c, MSM_Reference r, MSM_Construct cons
	WHERE c.Name = 'Nest'  AND
                    r.Name = 'structOfAttributesNestedOID' AND
                    r.ownerConstructOID = cons.OID AND
                    cons.Name = 'Nest';
                    
/* Insiemi per Lexical */

/* 1 */

INSERT INTO MSM_CarSet(Name, constructOID)
	SELECT 'AbstractLexical', OID
	FROM MSM_Construct
	WHERE name = 'Lexical';

INSERT INTO MSM_CAR (CarSetOID, referenceOID) 
	SELECT c.OID, r.OID
	FROM MSM_CarSet c, MSM_Reference r, MSM_Construct cons
	WHERE c.Name = 'AbstractLexical'  AND
                    r.Name = 'abstractOID' AND
                    r.ownerConstructOID = cons.OID AND
                    cons.Name = 'Lexical';
	
/* 2 */

INSERT INTO MSM_CarSet(Name, constructOID)
	SELECT 'AggregationLexical', OID
	FROM MSM_Construct
	WHERE name = 'Lexical';
	
INSERT INTO MSM_CAR (CarSetOID, referenceOID) 
	SELECT c.OID, r.OID
	FROM MSM_CarSet c, MSM_Reference r, MSM_Construct cons
	WHERE c.Name = 'AggregationLexical'  AND
                    r.Name = 'aggregationOID' AND
                    r.ownerConstructOID = cons.OID AND
                    cons.Name = 'Lexical';

/* 3 */

INSERT INTO MSM_CarSet(Name, constructOID)
	SELECT 'StructOfAttributesLexical', OID
	FROM MSM_Construct
	WHERE name = 'Lexical';
	
INSERT INTO MSM_CAR (CarSetOID, referenceOID) 
	SELECT c.OID, r.OID
	FROM MSM_CarSet c, MSM_Reference r, MSM_Construct cons
	WHERE c.Name = 'StructOfAttributesLexical'  AND
                    r.Name = 'structOfAttributesOID' AND
                    r.ownerConstructOID = cons.OID AND
                    cons.Name = 'Lexical';

/* 4 */

INSERT INTO MSM_CarSet(Name, constructOID)
	SELECT 'BinaryAggregationOfAbstractsLexical', OID
	FROM MSM_Construct
	WHERE name = 'Lexical';

INSERT INTO MSM_CAR (CarSetOID, referenceOID) 
	SELECT c.OID, r.OID
	FROM MSM_CarSet c, MSM_Reference r, MSM_Construct cons
	WHERE c.Name = 'BinaryAggregationOfAbstractsLexical'  AND
                    r.Name = 'binaryAggregationOfAbstractsOID' AND
                    r.ownerConstructOID = cons.OID AND
                    cons.Name = 'Lexical';

/* 5 */

INSERT INTO MSM_CarSet(Name, constructOID)
	SELECT 'AggregationOfAbstractsLexical', OID
	FROM MSM_Construct
	WHERE name = 'Lexical';

INSERT INTO MSM_CAR (CarSetOID, referenceOID) 
	SELECT c.OID, r.OID
	FROM MSM_CarSet c, MSM_Reference r, MSM_Construct cons
	WHERE c.Name = 'AggregationOfAbstractsLexical'  AND
                    r.Name = 'aggregationOfAbstractsOID' AND
                    r.ownerConstructOID = cons.OID AND
                    cons.Name = 'Lexical';

/* Insiemi per ForeignKey */

/* 1 */

INSERT INTO MSM_CarSet(Name, constructOID)
	SELECT 'AggregationToAggregationForeignKey', OID
	FROM MSM_Construct
	WHERE name = 'ForeignKey';

INSERT INTO MSM_CAR (CarSetOID, referenceOID) 
	SELECT c.OID, r.OID
	FROM MSM_CarSet c, MSM_Reference r, MSM_Construct cons
	WHERE c.Name = 'AggregationToAggregationForeignKey'  AND
                    r.Name = 'aggregationFromOID' AND
                    r.ownerConstructOID = cons.OID AND
                    cons.Name = 'ForeignKey';
                    
INSERT INTO MSM_CAR (CarSetOID, referenceOID) 
	SELECT c.OID, r.OID
	FROM MSM_CarSet c, MSM_Reference r, MSM_Construct cons
	WHERE c.Name = 'AggregationToAggregationForeignKey'  AND
                    r.Name = 'aggregationToOID' AND
                    r.ownerConstructOID = cons.OID AND
                    cons.Name = 'ForeignKey';



/* 2 */

INSERT INTO MSM_CarSet(Name, constructOID)
	SELECT 'AggregationToAbstractForeignKey', OID
	FROM MSM_Construct
	WHERE name = 'ForeignKey';

INSERT INTO MSM_CAR (CarSetOID, referenceOID) 
	SELECT c.OID, r.OID
	FROM MSM_CarSet c, MSM_Reference r, MSM_Construct cons
	WHERE c.Name = 'AggregationToAbstractForeignKey'  AND
                    r.Name = 'aggregationFromOID' AND
                    r.ownerConstructOID = cons.OID AND
                    cons.Name = 'ForeignKey';
                    
INSERT INTO MSM_CAR (CarSetOID, referenceOID) 
	SELECT c.OID, r.OID
	FROM MSM_CarSet c, MSM_Reference r, MSM_Construct cons
	WHERE c.Name = 'AggregationToAbstractForeignKey'  AND
                    r.Name = 'abstractToOID' AND
                    r.ownerConstructOID = cons.OID AND
                    cons.Name = 'ForeignKey';

/* 3 */

INSERT INTO MSM_CarSet(Name, constructOID)
	SELECT 'AggregationToStructForeignKey', OID
	FROM MSM_Construct
	WHERE name = 'ForeignKey';
	
INSERT INTO MSM_CAR (CarSetOID, referenceOID) 
	SELECT c.OID, r.OID
	FROM MSM_CarSet c, MSM_Reference r, MSM_Construct cons
	WHERE c.Name = 'AggregationToStructForeignKey'  AND
                    r.Name = 'aggregationFromOID' AND
                    r.ownerConstructOID = cons.OID AND
                    cons.Name = 'ForeignKey';
                    
INSERT INTO MSM_CAR (CarSetOID, referenceOID) 
	SELECT c.OID, r.OID
	FROM MSM_CarSet c, MSM_Reference r, MSM_Construct cons
	WHERE c.Name = 'AggregationToStructForeignKey'  AND
                    r.Name = 'structToOID' AND
                    r.ownerConstructOID = cons.OID AND
                    cons.Name = 'ForeignKey';

/* 4 */

INSERT INTO MSM_CarSet(Name, constructOID)
	SELECT 'AbstractToAggregationForeignKey', OID
	FROM MSM_Construct
	WHERE name = 'ForeignKey';

INSERT INTO MSM_CAR (CarSetOID, referenceOID) 
	SELECT c.OID, r.OID
	FROM MSM_CarSet c, MSM_Reference r, MSM_Construct cons
	WHERE c.Name = 'AbstractToAggregationForeignKey'  AND
                    r.Name = 'abstractFromOID' AND
                    r.ownerConstructOID = cons.OID AND
                    cons.Name = 'ForeignKey';
                    
INSERT INTO MSM_CAR (CarSetOID, referenceOID) 
	SELECT c.OID, r.OID
	FROM MSM_CarSet c, MSM_Reference r, MSM_Construct cons
	WHERE c.Name = 'AbstractToAggregationForeignKey'  AND
                    r.Name = 'aggregationToOID' AND
                    r.ownerConstructOID = cons.OID AND
                    cons.Name = 'ForeignKey';

/* 5 */

INSERT INTO MSM_CarSet(Name, constructOID)
	SELECT 'AbstractToAbstractForeignKey', OID
	FROM MSM_Construct
	WHERE name = 'ForeignKey';
	
INSERT INTO MSM_CAR (CarSetOID, referenceOID) 
	SELECT c.OID, r.OID
	FROM MSM_CarSet c, MSM_Reference r, MSM_Construct cons
	WHERE c.Name = 'AbstractToAbstractForeignKey'  AND
                    r.Name = 'abstractFromOID' AND
                    r.ownerConstructOID = cons.OID AND
                    cons.Name = 'ForeignKey';
                    
INSERT INTO MSM_CAR (CarSetOID, referenceOID) 
	SELECT c.OID, r.OID
	FROM MSM_CarSet c, MSM_Reference r, MSM_Construct cons
	WHERE c.Name = 'AbstractToAbstractForeignKey'  AND
                    r.Name = 'abstractToOID' AND
                    r.ownerConstructOID = cons.OID AND
                    cons.Name = 'ForeignKey';

/* 6 */

INSERT INTO MSM_CarSet(Name, constructOID)
	SELECT 'AbstractToStructForeignKey', OID
	FROM MSM_Construct
	WHERE name = 'ForeignKey';
	
INSERT INTO MSM_CAR (CarSetOID, referenceOID) 
	SELECT c.OID, r.OID
	FROM MSM_CarSet c, MSM_Reference r, MSM_Construct cons
	WHERE c.Name = 'AbstractToStructForeignKey'  AND
                    r.Name = 'abstractFromOID' AND
                    r.ownerConstructOID = cons.OID AND
                    cons.Name = 'ForeignKey';
                    
INSERT INTO MSM_CAR (CarSetOID, referenceOID) 
	SELECT c.OID, r.OID
	FROM MSM_CarSet c, MSM_Reference r, MSM_Construct cons
	WHERE c.Name = 'AbstractToStructForeignKey'  AND
                    r.Name = 'structToOID' AND
                    r.ownerConstructOID = cons.OID AND
                    cons.Name = 'ForeignKey';

/* 7 */

INSERT INTO MSM_CarSet(Name, constructOID)
	SELECT 'StructToAggregationForeignKey', OID
	FROM MSM_Construct
	WHERE name = 'ForeignKey';
	
INSERT INTO MSM_CAR (CarSetOID, referenceOID) 
	SELECT c.OID, r.OID
	FROM MSM_CarSet c, MSM_Reference r, MSM_Construct cons
	WHERE c.Name = 'StructToAggregationForeignKey'  AND
                    r.Name = 'structFromOID' AND
                    r.ownerConstructOID = cons.OID AND
                    cons.Name = 'ForeignKey';
                    
INSERT INTO MSM_CAR (CarSetOID, referenceOID) 
	SELECT c.OID, r.OID
	FROM MSM_CarSet c, MSM_Reference r, MSM_Construct cons
	WHERE c.Name = 'StructToAggregationForeignKey'  AND
                    r.Name = 'aggregationToOID' AND
                    r.ownerConstructOID = cons.OID AND
                    cons.Name = 'ForeignKey';

/* 8 */

INSERT INTO MSM_CarSet(Name, constructOID)
	SELECT 'StructToAbstractForeignKey', OID
	FROM MSM_Construct
	WHERE name = 'ForeignKey';
	
INSERT INTO MSM_CAR (CarSetOID, referenceOID) 
	SELECT c.OID, r.OID
	FROM MSM_CarSet c, MSM_Reference r, MSM_Construct cons
	WHERE c.Name = 'StructToAbstractForeignKey'  AND
                    r.Name = 'structFromOID' AND
                    r.ownerConstructOID = cons.OID AND
                    cons.Name = 'ForeignKey';
                    
INSERT INTO MSM_CAR (CarSetOID, referenceOID) 
	SELECT c.OID, r.OID
	FROM MSM_CarSet c, MSM_Reference r, MSM_Construct cons
	WHERE c.Name = 'StructToAbstractForeignKey'  AND
                    r.Name = 'abstractToOID' AND
                    r.ownerConstructOID = cons.OID AND
                    cons.Name = 'ForeignKey';


/* 9 */

INSERT INTO MSM_CarSet(Name, constructOID)
	SELECT 'StructToStructForeignKey', OID
	FROM MSM_Construct
	WHERE name = 'ForeignKey';
	
INSERT INTO MSM_CAR (CarSetOID, referenceOID) 
	SELECT c.OID, r.OID
	FROM MSM_CarSet c, MSM_Reference r, MSM_Construct cons
	WHERE c.Name = 'StructToStructForeignKey'  AND
                    r.Name = 'structFromOID' AND
                    r.ownerConstructOID = cons.OID AND
                    cons.Name = 'ForeignKey';
                    
INSERT INTO MSM_CAR (CarSetOID, referenceOID) 
	SELECT c.OID, r.OID
	FROM MSM_CarSet c, MSM_Reference r, MSM_Construct cons
	WHERE c.Name = 'StructToStructForeignKey'  AND
                    r.Name = 'structToOID' AND
                    r.ownerConstructOID = cons.OID AND
                    cons.Name = 'ForeignKey';
                    
/* Insiemi per ComponentOfForeignKey */

/* 1 */

INSERT INTO MSM_CarSet(Name, constructOID)
	SELECT 'ComponentOfForeignKey', OID
	FROM MSM_Construct
	WHERE name = 'ComponentOfForeignKey';
	
INSERT INTO MSM_CAR (CarSetOID, referenceOID) 
	SELECT c.OID, r.OID
	FROM MSM_CarSet c, MSM_Reference r, MSM_Construct cons
	WHERE c.Name = 'ComponentOfForeignKey'  AND
                    r.Name = 'foreignKeyOID' AND
                    r.ownerConstructOID = cons.OID AND
                    cons.Name = 'ComponentOfForeignKey';
                    
INSERT INTO MSM_CAR (CarSetOID, referenceOID) 
	SELECT c.OID, r.OID
	FROM MSM_CarSet c, MSM_Reference r, MSM_Construct cons
	WHERE c.Name = 'ComponentOfForeignKey'  AND
                    r.Name = 'lexicalFromOID' AND
                    r.ownerConstructOID = cons.OID AND
                    cons.Name = 'ComponentOfForeignKey';
                    
INSERT INTO MSM_CAR (CarSetOID, referenceOID) 
	SELECT c.OID, r.OID
	FROM MSM_CarSet c, MSM_Reference r, MSM_Construct cons
	WHERE c.Name = 'ComponentOfForeignKey'  AND
                    r.Name = 'lexicalToOID' AND
                    r.ownerConstructOID = cons.OID AND
                    cons.Name = 'ComponentOfForeignKey';
                    
/* Fine creazione degli insiemi caratterizzanti */



		
/* ******************************** */
//Popolamento Model: CapiFamiglia

//famiglia vuota
INSERT INTO Family(name) VALUES ('EMPTY');

//OBJECT ORIENTED
INSERT INTO Model(name, shortname, familyOID, isAncestor) VALUES('ObjectOriented', 'OO', 1, 'true');//0
INSERT INTO MM_Construct(name, modelOID, modelName, signature, bonds) VALUES('object', 0, 'ObjectOriented', 'true', 'true');//0
INSERT INTO MM_Construct(name, modelOID, modelName, signature, bonds) VALUES('field', 0, 'ObjectOriented', 'true', 'true');//1
INSERT INTO MM_Construct(name, modelOID, modelName, signature, bonds) VALUES('reference', 0, 'ObjectOriented', 'true', 'true');//2
INSERT INTO MM_Construct(name, modelOID, modelName, signature, bonds) VALUES('generalization', 0, 'ObjectOriented', 'true', 'true');//3
INSERT INTO MM_Construct(name, modelOID, modelName, signature, bonds) VALUES('childOfGeneralization', 0, 'ObjectOriented', 'true', 'true');//4
INSERT INTO MM_Property(constructOID, name, type) VALUES(1, 'isKey', 'boolean');//0
INSERT INTO MM_Property(constructOID, name, type) VALUES(1, 'type', 'varchar');//1
INSERT INTO MM_Property(constructOID, name, type) VALUES(3, 'isTotal', 'boolean');//2
INSERT INTO MM_Reference(ownerConstructOID, name, type, targetConstructOID) VALUES(1, 'objectOID', 'description', 0);//0
INSERT INTO MM_Reference(ownerConstructOID, name, type, targetConstructOID) VALUES(2, 'objectOID', 'description', 0);//1
INSERT INTO MM_Reference(ownerConstructOID, name, type, targetConstructOID) VALUES(2, 'objectToOID', 'relation', 0);//2
INSERT INTO MM_Reference(ownerConstructOID, name, type, targetConstructOID) VALUES(3, 'parentObjectOID', 'relation', 0);//3
INSERT INTO MM_Reference(ownerConstructOID, name, type, targetConstructOID) VALUES(4, 'generalizationOID', 'description', 3);//4
INSERT INTO MM_Reference(ownerConstructOID, name, type, targetConstructOID) VALUES(4, 'childObjectOID', 'relation', 0);//5
INSERT INTO Mapping_MC_SMC(constructOID_M, constructOID_SM) VALUES(0, 1);	//0
INSERT INTO Mapping_MC_SMC(constructOID_M, constructOID_SM) VALUES(1, 10);
INSERT INTO Mapping_MP_SMP(propertyOID_M, propertyOID_SM) VALUES(0, 2);
INSERT INTO Mapping_MP_SMP(propertyOID_M, propertyOID_SM) VALUES(1, 3);
INSERT INTO Mapping_MC_SMC(constructOID_M, constructOID_SM) VALUES(2, 3);
INSERT INTO Mapping_MC_SMC(constructOID_M, constructOID_SM) VALUES(3, 7);
INSERT INTO Mapping_MP_SMP(propertyOID_M, propertyOID_SM) VALUES(2, 18);
INSERT INTO Mapping_MC_SMC(constructOID_M, constructOID_SM) VALUES(4, 8);
INSERT INTO Mapping_MR_SMR(referenceOID_M, referenceOID_SM) VALUES(0, 17);
INSERT INTO Mapping_MR_SMR(referenceOID_M, referenceOID_SM) VALUES(1, 18);
INSERT INTO Mapping_MR_SMR(referenceOID_M, referenceOID_SM) VALUES(2, 19);
INSERT INTO Mapping_MR_SMR(referenceOID_M, referenceOID_SM) VALUES(3, 24);
INSERT INTO Mapping_MR_SMR(referenceOID_M, referenceOID_SM) VALUES(4, 25);
INSERT INTO Mapping_MR_SMR(referenceOID_M, referenceOID_SM) VALUES(5, 26);
CREATE MEMORY TABLE OO_OBJECT(OID INTEGER NOT NULL PRIMARY KEY,SCHEMEOID INTEGER NOT NULL,NAME VARCHAR NOT NULL,CONSTRAINT SYS_FK_508 FOREIGN KEY(SCHEMEOID) REFERENCES SCHEME(OID))
CREATE MEMORY TABLE OO_OBJECT_SK(OID INTEGER GENERATED BY DEFAULT AS IDENTITY(START WITH 0) NOT NULL PRIMARY KEY,SCHEMEOID INTEGER NOT NULL,OID_COPY INTEGER)
CREATE MEMORY TABLE OO_FIELD(OID INTEGER NOT NULL PRIMARY KEY,SCHEMEOID INTEGER NOT NULL,NAME VARCHAR NOT NULL,ISKEY BOOLEAN,TYPE VARCHAR,OBJECTOID INTEGER,CONSTRAINT SYS_FK_513 FOREIGN KEY(OBJECTOID) REFERENCES OO_OBJECT(OID),CONSTRAINT SYS_FK_514 FOREIGN KEY(SCHEMEOID) REFERENCES SCHEME(OID))
CREATE MEMORY TABLE OO_FIELD_SK(OID INTEGER GENERATED BY DEFAULT AS IDENTITY(START WITH 0) NOT NULL PRIMARY KEY,SCHEMEOID INTEGER NOT NULL,OID_COPY INTEGER)
CREATE MEMORY TABLE OO_REFERENCE(OID INTEGER NOT NULL PRIMARY KEY,SCHEMEOID INTEGER NOT NULL,NAME VARCHAR NOT NULL,OBJECTOID INTEGER,OBJECTTOOID INTEGER,CONSTRAINT SYS_FK_521 FOREIGN KEY(OBJECTOID) REFERENCES OO_OBJECT(OID),CONSTRAINT SYS_FK_522 FOREIGN KEY(OBJECTTOOID) REFERENCES OO_OBJECT(OID),CONSTRAINT SYS_FK_523 FOREIGN KEY(SCHEMEOID) REFERENCES SCHEME(OID))
CREATE MEMORY TABLE OO_REFERENCE_SK(OID INTEGER GENERATED BY DEFAULT AS IDENTITY(START WITH 0) NOT NULL PRIMARY KEY,SCHEMEOID INTEGER NOT NULL,OID_COPY INTEGER)
CREATE MEMORY TABLE OO_GENERALIZATION(OID INTEGER NOT NULL PRIMARY KEY,SCHEMEOID INTEGER NOT NULL,NAME VARCHAR NOT NULL,ISTOTAL BOOLEAN,PARENTOBJECTOID INTEGER,CONSTRAINT SYS_FK_532 FOREIGN KEY(PARENTOBJECTOID) REFERENCES OO_OBJECT(OID),CONSTRAINT SYS_FK_533 FOREIGN KEY(SCHEMEOID) REFERENCES SCHEME(OID))
CREATE MEMORY TABLE OO_GENERALIZATION_SK(OID INTEGER GENERATED BY DEFAULT AS IDENTITY(START WITH 0) NOT NULL PRIMARY KEY,SCHEMEOID INTEGER NOT NULL,OID_COPY INTEGER)
CREATE MEMORY TABLE OO_CHILDOFGENERALIZATION(OID INTEGER NOT NULL PRIMARY KEY,SCHEMEOID INTEGER NOT NULL,NAME VARCHAR NOT NULL,GENERALIZATIONOID INTEGER,CHILDOBJECTOID INTEGER,CONSTRAINT SYS_FK_540 FOREIGN KEY(GENERALIZATIONOID) REFERENCES OO_GENERALIZATION(OID),CONSTRAINT SYS_FK_541 FOREIGN KEY(CHILDOBJECTOID) REFERENCES OO_OBJECT(OID),CONSTRAINT SYS_FK_542 FOREIGN KEY(SCHEMEOID) REFERENCES SCHEME(OID))
CREATE MEMORY TABLE OO_CHILDOFGENERALIZATION_SK(OID INTEGER GENERATED BY DEFAULT AS IDENTITY(START WITH 0) NOT NULL PRIMARY KEY,SCHEMEOID INTEGER NOT NULL,OID_COPY INTEGER)


INSERT INTO Family(name, modelOID) VALUES ('OO', 0);

//ENTITY RELATIONSHIP
INSERT INTO Model(name, shortname, familyOID, isAncestor) VALUES('EntityRelationship', 'ER', 2, 'true');//1
INSERT INTO MM_Construct(name, modelOID, modelName, signature, bonds) VALUES('entity', 1, 'EntityRelationship', 'true', 'true');//5
INSERT INTO Mapping_MC_SMC(constructOID_M, constructOID_SM) VALUES(5, 1);
INSERT INTO MM_Construct(name, modelOID, modelName, signature, bonds) VALUES('relationship', 1, 'EntityRelationship', '(BinaryAggregationOfAbstracts.isFunctional1 OR (NOT BinaryAggregationOfAbstracts.isFunctional2))', '(isFunctional1 OR (NOT isFunctional2))');//6
INSERT INTO Mapping_MC_SMC(constructOID_M, constructOID_SM) VALUES(6, 4);
INSERT INTO MM_Property(constructOID, name, type) VALUES(6, 'role1', 'varchar');//3
INSERT INTO Mapping_MP_SMP(propertyOID_M, propertyOID_SM) VALUES(3, 5);
INSERT INTO MM_Property(constructOID, name, type) VALUES(6, 'isOptional1', 'boolean');//4
INSERT INTO Mapping_MP_SMP(propertyOID_M, propertyOID_SM) VALUES(4, 6);
INSERT INTO MM_Property(constructOID, name, type) VALUES(6, 'isFunctional1', 'boolean');//5
INSERT INTO Mapping_MP_SMP(propertyOID_M, propertyOID_SM) VALUES(5, 7);
INSERT INTO MM_Property(constructOID, name, type) VALUES(6, 'isIdentified', 'boolean');//6
INSERT INTO Mapping_MP_SMP(propertyOID_M, propertyOID_SM) VALUES(6, 8);
INSERT INTO MM_Property(constructOID, name, type) VALUES(6, 'role2', 'varchar');//7
INSERT INTO Mapping_MP_SMP(propertyOID_M, propertyOID_SM) VALUES(7, 9);
INSERT INTO MM_Property(constructOID, name, type) VALUES(6, 'isOptional2', 'boolean');//8
INSERT INTO Mapping_MP_SMP(propertyOID_M, propertyOID_SM) VALUES(8, 10);
INSERT INTO MM_Property(constructOID, name, type) VALUES(6, 'isFunctional2', 'boolean');//9
INSERT INTO Mapping_MP_SMP(propertyOID_M, propertyOID_SM) VALUES(9, 11);
INSERT INTO MM_Construct(name, modelOID, modelName, signature, bonds) VALUES('attribute', 1, 'EntityRelationship', 'true', 'true');//7
INSERT INTO Mapping_MC_SMC(constructOID_M, constructOID_SM) VALUES(7, 10);
INSERT INTO MM_Property(constructOID, name, type) VALUES(7, 'isKey', 'boolean');//10
INSERT INTO Mapping_MP_SMP(propertyOID_M, propertyOID_SM) VALUES(10, 2);
INSERT INTO MM_Property(constructOID, name, type) VALUES(7, 'isOptional', 'boolean');//11
INSERT INTO Mapping_MP_SMP(propertyOID_M, propertyOID_SM) VALUES(11, 1);
INSERT INTO MM_Property(constructOID, name, type) VALUES(7, 'type', 'varchar');//12
INSERT INTO Mapping_MP_SMP(propertyOID_M, propertyOID_SM) VALUES(12, 3);
INSERT INTO MM_Construct(name, modelOID, modelName, signature, bonds) VALUES('generalization', 1, 'EntityRelationship', 'true', 'true');//8
INSERT INTO Mapping_MC_SMC(constructOID_M, constructOID_SM) VALUES(8, 7);
INSERT INTO MM_Property(constructOID, name, type) VALUES(8, 'isTotal', 'boolean');//13
INSERT INTO Mapping_MP_SMP(propertyOID_M, propertyOID_SM) VALUES(13, 18);
INSERT INTO MM_Construct(name, modelOID, modelName, signature, bonds) VALUES('childOfGeneralization', 1, 'EntityRelationship', 'true', 'true');//9
INSERT INTO Mapping_MC_SMC(constructOID_M, constructOID_SM) VALUES(9, 8);
INSERT INTO MM_Reference(ownerConstructOID, name, type, targetConstructOID) VALUES(6, 'abstract1OID', 'relation', 5);//6
INSERT INTO Mapping_MR_SMR(referenceOID_M, referenceOID_SM) VALUES(6, 20);
INSERT INTO MM_Reference(ownerConstructOID, name, type, targetConstructOID) VALUES(6, 'abstract2OID', 'relation', 5);//7
INSERT INTO Mapping_MR_SMR(referenceOID_M, referenceOID_SM) VALUES(7, 21);
INSERT INTO MM_Reference(ownerConstructOID, name, type, targetConstructOID) VALUES(7, 'binaryAggregationOfAbstractsOID', 'description', 6);//8
INSERT INTO Mapping_MR_SMR(referenceOID_M, referenceOID_SM) VALUES(8, 0);
INSERT INTO MM_Reference(ownerConstructOID, name, type, targetConstructOID) VALUES(7, 'abstractOID', 'description', 5);//9
INSERT INTO Mapping_MR_SMR(referenceOID_M, referenceOID_SM) VALUES(9, 17);
INSERT INTO MM_Reference(ownerConstructOID, name, type, targetConstructOID) VALUES(8, 'parentAbstractOID', 'relation', 5);//10
INSERT INTO Mapping_MR_SMR(referenceOID_M, referenceOID_SM) VALUES(10, 24);
INSERT INTO MM_Reference(ownerConstructOID, name, type, targetConstructOID) VALUES(9, 'generalizationOID', 'description', 8);//11
INSERT INTO Mapping_MR_SMR(referenceOID_M, referenceOID_SM) VALUES(11, 25);
INSERT INTO MM_Reference(ownerConstructOID, name, type, targetConstructOID) VALUES(9, 'childAbstractOID', 'relation', 5);//12
INSERT INTO Mapping_MR_SMR(referenceOID_M, referenceOID_SM) VALUES(12, 26);
CREATE MEMORY TABLE ER_ENTITY(OID INTEGER NOT NULL PRIMARY KEY,SCHEMEOID INTEGER NOT NULL,NAME VARCHAR NOT NULL,CONSTRAINT SYS_FK_551 FOREIGN KEY(SCHEMEOID) REFERENCES SCHEME(OID))
CREATE MEMORY TABLE ER_ENTITY_SK(OID INTEGER GENERATED BY DEFAULT AS IDENTITY(START WITH 0) NOT NULL PRIMARY KEY,SCHEMEOID INTEGER NOT NULL,OID_COPY INTEGER)
CREATE MEMORY TABLE ER_RELATIONSHIP(OID INTEGER NOT NULL PRIMARY KEY,SCHEMEOID INTEGER NOT NULL,NAME VARCHAR NOT NULL,ROLE1 VARCHAR,ISOPTIONAL1 BOOLEAN,ISFUNCTIONAL1 BOOLEAN,ISIDENTIFIED BOOLEAN,ROLE2 VARCHAR,ISOPTIONAL2 BOOLEAN,ISFUNCTIONAL2 BOOLEAN,ABSTRACT1OID INTEGER,ABSTRACT2OID INTEGER,CONSTRAINT SYS_FK_556 FOREIGN KEY(ABSTRACT1OID) REFERENCES ER_ENTITY(OID),CONSTRAINT SYS_FK_557 FOREIGN KEY(ABSTRACT2OID) REFERENCES ER_ENTITY(OID),CONSTRAINT SYS_FK_558 FOREIGN KEY(SCHEMEOID) REFERENCES SCHEME(OID))
CREATE MEMORY TABLE ER_RELATIONSHIP_SK(OID INTEGER GENERATED BY DEFAULT AS IDENTITY(START WITH 0) NOT NULL PRIMARY KEY,SCHEMEOID INTEGER NOT NULL,OID_COPY INTEGER)
CREATE MEMORY TABLE ER_ATTRIBUTE(OID INTEGER NOT NULL PRIMARY KEY,SCHEMEOID INTEGER NOT NULL,NAME VARCHAR NOT NULL,ISKEY BOOLEAN,ISOPTIONAL BOOLEAN,TYPE VARCHAR,BINARYAGGREGATIONOFABSTRACTSOID INTEGER,ABSTRACTOID INTEGER,CONSTRAINT SYS_FK_567 FOREIGN KEY(BINARYAGGREGATIONOFABSTRACTSOID) REFERENCES ER_RELATIONSHIP(OID),CONSTRAINT SYS_FK_568 FOREIGN KEY(ABSTRACTOID) REFERENCES ER_ENTITY(OID),CONSTRAINT SYS_FK_569 FOREIGN KEY(SCHEMEOID) REFERENCES SCHEME(OID))
CREATE MEMORY TABLE ER_ATTRIBUTE_SK(OID INTEGER GENERATED BY DEFAULT AS IDENTITY(START WITH 0) NOT NULL PRIMARY KEY,SCHEMEOID INTEGER NOT NULL,OID_COPY INTEGER)
CREATE MEMORY TABLE ER_GENERALIZATION(OID INTEGER NOT NULL PRIMARY KEY,SCHEMEOID INTEGER NOT NULL,NAME VARCHAR NOT NULL,ISTOTAL BOOLEAN,PARENTABSTRACTOID INTEGER,CONSTRAINT SYS_FK_578 FOREIGN KEY(PARENTABSTRACTOID) REFERENCES ER_ENTITY(OID),CONSTRAINT SYS_FK_579 FOREIGN KEY(SCHEMEOID) REFERENCES SCHEME(OID))
CREATE MEMORY TABLE ER_GENERALIZATION_SK(OID INTEGER GENERATED BY DEFAULT AS IDENTITY(START WITH 0) NOT NULL PRIMARY KEY,SCHEMEOID INTEGER NOT NULL,OID_COPY INTEGER)
CREATE MEMORY TABLE ER_CHILDOFGENERALIZATION(OID INTEGER NOT NULL PRIMARY KEY,SCHEMEOID INTEGER NOT NULL,NAME VARCHAR NOT NULL,GENERALIZATIONOID INTEGER,CHILDABSTRACTOID INTEGER,CONSTRAINT SYS_FK_586 FOREIGN KEY(GENERALIZATIONOID) REFERENCES ER_GENERALIZATION(OID),CONSTRAINT SYS_FK_587 FOREIGN KEY(CHILDABSTRACTOID) REFERENCES ER_ENTITY(OID),CONSTRAINT SYS_FK_588 FOREIGN KEY(SCHEMEOID) REFERENCES SCHEME(OID))
CREATE MEMORY TABLE ER_CHILDOFGENERALIZATION_SK(OID INTEGER GENERATED BY DEFAULT AS IDENTITY(START WITH 0) NOT NULL PRIMARY KEY,SCHEMEOID INTEGER NOT NULL,OID_COPY INTEGER)


INSERT INTO Family(name, modelOID) VALUES ('ER', 1);

//XSD
INSERT INTO MODEL(name, shortname, familyOID, isAncestor) VALUES('XSD','XSD',3,'true');	//2
INSERT INTO MM_CONSTRUCT(modelOID, name, modelName, signature, bonds) VALUES(2,'rootElement','XSD', 'true', 'true');//10
INSERT INTO MM_CONSTRUCT(modelOID, name, modelName, signature, bonds) VALUES(2,'complexElement','XSD', 'true', 'true');//11
INSERT INTO MM_CONSTRUCT(modelOID, name, modelName, signature, bonds) VALUES(2,'nest','XSD', 'true', 'true');//12
INSERT INTO MM_CONSTRUCT(modelOID, name, modelName, signature, bonds) VALUES(2,'simpleElement','XSD', 'true', 'true');//13
INSERT INTO MM_CONSTRUCT(modelOID, name, modelName, signature, bonds) VALUES(2,'foreignKey','XSD', 'true', 'true');//14
INSERT INTO MM_CONSTRUCT(modelOID, name, modelName, signature, bonds) VALUES(2,'componentOfForeignKey','XSD', 'true', 'true');//15
INSERT INTO MM_PROPERTY(constructOID, name, type) VALUES(11,'isSet','boolean');//14
INSERT INTO MM_PROPERTY(constructOID, name, type) VALUES(11,'isNillable','boolean');//15
INSERT INTO MM_PROPERTY(constructOID, name, type) VALUES(11,'isOptional','boolean');//16
INSERT INTO MM_PROPERTY(constructOID, name, type) VALUES(13,'isKey','boolean');//17
INSERT INTO MM_PROPERTY(constructOID, name, type) VALUES(13,'isNillable','boolean');//18
INSERT INTO MM_PROPERTY(constructOID, name, type) VALUES(13,'isOptional','boolean');//19
INSERT INTO MM_PROPERTY(constructOID, name, type) VALUES(13,'type','varchar');//20
INSERT INTO MM_REFERENCE(ownerConstructOID, name, type, targetConstructOID) VALUES(11,'rootElementOID','description',10);//13
INSERT INTO MM_REFERENCE(ownerConstructOID, name, type, targetConstructOID) VALUES(12,'complexElementTopOID','description',11);//14
INSERT INTO MM_REFERENCE(ownerConstructOID, name, type, targetConstructOID) VALUES(12,'complexElementNestedOID','relation',11);//15
INSERT INTO MM_REFERENCE(ownerConstructOID, name, type, targetConstructOID) VALUES(13,'complexElementOID','description',11);//16
INSERT INTO MM_REFERENCE(ownerConstructOID, name, type, targetConstructOID) VALUES(13,'rootElementOID','description',10);//17
INSERT INTO MM_REFERENCE(ownerConstructOID, name, type, targetConstructOID) VALUES(14,'rootElementFromOID','relation',10);//18
INSERT INTO MM_REFERENCE(ownerConstructOID, name, type, targetConstructOID) VALUES(14,'rootElementToOID','relation',10);//19
INSERT INTO MM_REFERENCE(ownerConstructOID, name, type, targetConstructOID) VALUES(14,'complexElementFromOID','relation',11);//20
INSERT INTO MM_REFERENCE(ownerConstructOID, name, type, targetConstructOID) VALUES(14,'complexElementToOID','relation',11);//21
INSERT INTO MM_REFERENCE(ownerConstructOID, name, type, targetConstructOID) VALUES(15,'foreignKeyOID','description',14);//22
INSERT INTO MM_REFERENCE(ownerConstructOID, name, type, targetConstructOID) VALUES(15,'simpleElementFromOID','relation',13);//23
INSERT INTO MM_REFERENCE(ownerConstructOID, name, type, targetConstructOID) VALUES(15,'simpleElementToOID','relation',13);//24
INSERT INTO MAPPING_MC_SMC(CONSTRUCTOID_SM, CONSTRUCTOID_M) VALUES(1,10);
INSERT INTO MAPPING_MC_SMC(CONSTRUCTOID_SM, CONSTRUCTOID_M) VALUES(2,11);
INSERT INTO MAPPING_MC_SMC(CONSTRUCTOID_SM, CONSTRUCTOID_M) VALUES(9,12);
INSERT INTO MAPPING_MC_SMC(CONSTRUCTOID_SM, CONSTRUCTOID_M) VALUES(10,13);
INSERT INTO MAPPING_MC_SMC(CONSTRUCTOID_SM, CONSTRUCTOID_M) VALUES(11,14);
INSERT INTO MAPPING_MC_SMC(CONSTRUCTOID_SM, CONSTRUCTOID_M) VALUES(12,15);
INSERT INTO MAPPING_MP_SMP(PROPERTYOID_SM, PROPERTYOID_M) VALUES(12,14);
INSERT INTO MAPPING_MP_SMP(PROPERTYOID_SM, PROPERTYOID_M) VALUES(14,15);
INSERT INTO MAPPING_MP_SMP(PROPERTYOID_SM, PROPERTYOID_M) VALUES(13,16);
INSERT INTO MAPPING_MP_SMP(PROPERTYOID_SM, PROPERTYOID_M) VALUES(2,17);
INSERT INTO MAPPING_MP_SMP(PROPERTYOID_SM, PROPERTYOID_M) VALUES(0,18);
INSERT INTO MAPPING_MP_SMP(PROPERTYOID_SM, PROPERTYOID_M) VALUES(1,19);
INSERT INTO MAPPING_MP_SMP(PROPERTYOID_SM, PROPERTYOID_M) VALUES(3,20);
INSERT INTO MAPPING_MR_SMR(REFERENCEOID_SM, REFERENCEOID_M) VALUES(12,13);
INSERT INTO MAPPING_MR_SMR(REFERENCEOID_SM, REFERENCEOID_M) VALUES(27,14);
INSERT INTO MAPPING_MR_SMR(REFERENCEOID_SM, REFERENCEOID_M) VALUES(28,15);
INSERT INTO MAPPING_MR_SMR(REFERENCEOID_SM, REFERENCEOID_M) VALUES(16,16);
INSERT INTO MAPPING_MR_SMR(REFERENCEOID_SM, REFERENCEOID_M) VALUES(17,17);
INSERT INTO MAPPING_MR_SMR(REFERENCEOID_SM, REFERENCEOID_M) VALUES(5,18);
INSERT INTO MAPPING_MR_SMR(REFERENCEOID_SM, REFERENCEOID_M) VALUES(6,19);
INSERT INTO MAPPING_MR_SMR(REFERENCEOID_SM, REFERENCEOID_M) VALUES(7,20);
INSERT INTO MAPPING_MR_SMR(REFERENCEOID_SM, REFERENCEOID_M) VALUES(8,21);
INSERT INTO MAPPING_MR_SMR(REFERENCEOID_SM, REFERENCEOID_M) VALUES(9,22);
INSERT INTO MAPPING_MR_SMR(REFERENCEOID_SM, REFERENCEOID_M) VALUES(10,23);
INSERT INTO MAPPING_MR_SMR(REFERENCEOID_SM, REFERENCEOID_M) VALUES(11,24);
CREATE MEMORY TABLE XSD_ROOTELEMENT(OID INTEGER NOT NULL PRIMARY KEY,SCHEMEOID INTEGER NOT NULL,NAME VARCHAR NOT NULL,CONSTRAINT SYS_FK_442 FOREIGN KEY(SCHEMEOID) REFERENCES SCHEME(OID))
CREATE MEMORY TABLE XSD_ROOTELEMENT_SK(OID INTEGER GENERATED BY DEFAULT AS IDENTITY(START WITH 0) NOT NULL PRIMARY KEY,SCHEMEOID INTEGER NOT NULL,OID_COPY INTEGER)
CREATE MEMORY TABLE XSD_COMPLEXELEMENT(OID INTEGER NOT NULL PRIMARY KEY,SCHEMEOID INTEGER NOT NULL,NAME VARCHAR NOT NULL,ISSET BOOLEAN,ISNILLABLE BOOLEAN,ISOPTIONAL BOOLEAN,ROOTELEMENTOID INTEGER,CONSTRAINT SYS_FK_447 FOREIGN KEY(ROOTELEMENTOID) REFERENCES XSD_ROOTELEMENT(OID),CONSTRAINT SYS_FK_448 FOREIGN KEY(SCHEMEOID) REFERENCES SCHEME(OID))
CREATE MEMORY TABLE XSD_COMPLEXELEMENT_SK(OID INTEGER GENERATED BY DEFAULT AS IDENTITY(START WITH 0) NOT NULL PRIMARY KEY,SCHEMEOID INTEGER NOT NULL,OID_COPY INTEGER)
CREATE MEMORY TABLE XSD_NEST(OID INTEGER NOT NULL PRIMARY KEY,SCHEMEOID INTEGER NOT NULL,NAME VARCHAR NOT NULL,COMPLEXELEMENTTOPOID INTEGER,COMPLEXELEMENTNESTEDOID INTEGER,CONSTRAINT SYS_FK_455 FOREIGN KEY(COMPLEXELEMENTTOPOID) REFERENCES XSD_COMPLEXELEMENT(OID),CONSTRAINT SYS_FK_456 FOREIGN KEY(COMPLEXELEMENTNESTEDOID) REFERENCES XSD_COMPLEXELEMENT(OID),CONSTRAINT SYS_FK_457 FOREIGN KEY(SCHEMEOID) REFERENCES SCHEME(OID))
CREATE MEMORY TABLE XSD_NEST_SK(OID INTEGER GENERATED BY DEFAULT AS IDENTITY(START WITH 0) NOT NULL PRIMARY KEY,SCHEMEOID INTEGER NOT NULL,OID_COPY INTEGER)
CREATE MEMORY TABLE XSD_SIMPLEELEMENT(OID INTEGER NOT NULL PRIMARY KEY,SCHEMEOID INTEGER NOT NULL,NAME VARCHAR NOT NULL,ISKEY BOOLEAN,ISNILLABLE BOOLEAN,ISOPTIONAL BOOLEAN,TYPE VARCHAR,COMPLEXELEMENTOID INTEGER,ROOTELEMENTOID INTEGER,CONSTRAINT SYS_FK_466 FOREIGN KEY(COMPLEXELEMENTOID) REFERENCES XSD_COMPLEXELEMENT(OID),CONSTRAINT SYS_FK_467 FOREIGN KEY(ROOTELEMENTOID) REFERENCES XSD_ROOTELEMENT(OID),CONSTRAINT SYS_FK_468 FOREIGN KEY(SCHEMEOID) REFERENCES SCHEME(OID))
CREATE MEMORY TABLE XSD_SIMPLEELEMENT_SK(OID INTEGER GENERATED BY DEFAULT AS IDENTITY(START WITH 0) NOT NULL PRIMARY KEY,SCHEMEOID INTEGER NOT NULL,OID_COPY INTEGER)
CREATE MEMORY TABLE XSD_FOREIGNKEY(OID INTEGER NOT NULL PRIMARY KEY,SCHEMEOID INTEGER NOT NULL,NAME VARCHAR NOT NULL,ROOTELEMENTFROMOID INTEGER,ROOTELEMENTTOOID INTEGER,COMPLEXELEMENTFROMOID INTEGER,COMPLEXELEMENTTOOID INTEGER,CONSTRAINT SYS_FK_477 FOREIGN KEY(ROOTELEMENTFROMOID) REFERENCES XSD_ROOTELEMENT(OID),CONSTRAINT SYS_FK_478 FOREIGN KEY(ROOTELEMENTTOOID) REFERENCES XSD_ROOTELEMENT(OID),CONSTRAINT SYS_FK_479 FOREIGN KEY(COMPLEXELEMENTFROMOID) REFERENCES XSD_COMPLEXELEMENT(OID),CONSTRAINT SYS_FK_480 FOREIGN KEY(COMPLEXELEMENTTOOID) REFERENCES XSD_COMPLEXELEMENT(OID),CONSTRAINT SYS_FK_481 FOREIGN KEY(SCHEMEOID) REFERENCES SCHEME(OID))
CREATE MEMORY TABLE XSD_FOREIGNKEY_SK(OID INTEGER GENERATED BY DEFAULT AS IDENTITY(START WITH 0) NOT NULL PRIMARY KEY,SCHEMEOID INTEGER NOT NULL,OID_COPY INTEGER)
CREATE MEMORY TABLE XSD_COMPONENTOFFOREIGNKEY(OID INTEGER NOT NULL PRIMARY KEY,SCHEMEOID INTEGER NOT NULL,NAME VARCHAR NOT NULL,FOREIGNKEYOID INTEGER,SIMPLEELEMENTFROMOID INTEGER,SIMPLEELEMENTTOOID INTEGER,CONSTRAINT SYS_FK_494 FOREIGN KEY(FOREIGNKEYOID) REFERENCES XSD_FOREIGNKEY(OID),CONSTRAINT SYS_FK_495 FOREIGN KEY(SIMPLEELEMENTFROMOID) REFERENCES XSD_SIMPLEELEMENT(OID),CONSTRAINT SYS_FK_496 FOREIGN KEY(SIMPLEELEMENTTOOID) REFERENCES XSD_SIMPLEELEMENT(OID),CONSTRAINT SYS_FK_497 FOREIGN KEY(SCHEMEOID) REFERENCES SCHEME(OID))
CREATE MEMORY TABLE XSD_COMPONENTOFFOREIGNKEY_SK(OID INTEGER GENERATED BY DEFAULT AS IDENTITY(START WITH 0) NOT NULL PRIMARY KEY,SCHEMEOID INTEGER NOT NULL,OID_COPY INTEGER)


INSERT INTO Family(name, modelOID) VALUES ('XSD', 2);


//RELATIONAL
INSERT INTO MODEL(name, shortname, familyOID, isAncestor) VALUES('Relational','Rel',4, 'true');//3
INSERT INTO MM_CONSTRUCT(modelOID, name, modelName, signature, bonds) VALUES(3,'table', 'Relational','true','true');//16
INSERT INTO MM_CONSTRUCT(modelOID, name, modelName, signature, bonds) VALUES(3,'column', 'Relational','true','true');//17
INSERT INTO MM_CONSTRUCT(modelOID, name, modelName, signature, bonds) VALUES(3,'foreignKey', 'Relational','true','true');//18
INSERT INTO MM_CONSTRUCT(modelOID, name, modelName, signature, bonds) VALUES(3,'componentOfForeignKey', 'Relational','true','true');//19
INSERT INTO MM_PROPERTY(constructOID, name, type) VALUES(17,'isNullable','boolean');//21
INSERT INTO MM_PROPERTY(constructOID, name, type) VALUES(17,'isKey','boolean');//22
INSERT INTO MM_PROPERTY(constructOID, name, type) VALUES(17,'type','varchar');//23
INSERT INTO MM_REFERENCE(ownerConstructOID, name, type, targetConstructOID) VALUES(17,'tableOID','description',16);//25
INSERT INTO MM_REFERENCE(ownerConstructOID, name, type, targetConstructOID) VALUES(18,'tableFromOID','relation',16);//26
INSERT INTO MM_REFERENCE(ownerConstructOID, name, type, targetConstructOID) VALUES(18,'tableToOID','relation',16);//27
INSERT INTO MM_REFERENCE(ownerConstructOID, name, type, targetConstructOID) VALUES(19,'foreignKeyOID','description',18);//28
INSERT INTO MM_REFERENCE(ownerConstructOID, name, type, targetConstructOID) VALUES(19,'columnFromOID','relation',17);//29
INSERT INTO MM_REFERENCE(ownerConstructOID, name, type, targetConstructOID) VALUES(19,'columnToOID','relation',17);//30
INSERT INTO MAPPING_MC_SMC(CONSTRUCTOID_SM, CONSTRUCTOID_M) VALUES(0,16);
INSERT INTO MAPPING_MC_SMC(CONSTRUCTOID_SM, CONSTRUCTOID_M) VALUES(10,17);
INSERT INTO MAPPING_MC_SMC(CONSTRUCTOID_SM, CONSTRUCTOID_M) VALUES(11,18);
INSERT INTO MAPPING_MC_SMC(CONSTRUCTOID_SM, CONSTRUCTOID_M) VALUES(12,19);
INSERT INTO MAPPING_MP_SMP(PROPERTYOID_SM, PROPERTYOID_M) VALUES(0,21);
INSERT INTO MAPPING_MP_SMP(PROPERTYOID_SM, PROPERTYOID_M) VALUES(2,22);
INSERT INTO MAPPING_MP_SMP(PROPERTYOID_SM, PROPERTYOID_M) VALUES(3,23);
INSERT INTO MAPPING_MR_SMR(REFERENCEOID_SM, REFERENCEOID_M) VALUES(2,25);
INSERT INTO MAPPING_MR_SMR(REFERENCEOID_SM, REFERENCEOID_M) VALUES(3,26);
INSERT INTO MAPPING_MR_SMR(REFERENCEOID_SM, REFERENCEOID_M) VALUES(4,27);
INSERT INTO MAPPING_MR_SMR(REFERENCEOID_SM, REFERENCEOID_M) VALUES(9,28);
INSERT INTO MAPPING_MR_SMR(REFERENCEOID_SM, REFERENCEOID_M) VALUES(10,29);
INSERT INTO MAPPING_MR_SMR(REFERENCEOID_SM, REFERENCEOID_M) VALUES(11,30);
CREATE MEMORY TABLE REL_TABLE(OID INTEGER NOT NULL PRIMARY KEY,SCHEMEOID INTEGER NOT NULL,NAME VARCHAR NOT NULL,CONSTRAINT SYS_FK_691 FOREIGN KEY(SCHEMEOID) REFERENCES SCHEME(OID))
CREATE MEMORY TABLE REL_TABLE_SK(OID INTEGER GENERATED BY DEFAULT AS IDENTITY(START WITH 0) NOT NULL PRIMARY KEY,SCHEMEOID INTEGER NOT NULL,OID_COPY INTEGER)
CREATE MEMORY TABLE REL_COLUMN(OID INTEGER NOT NULL PRIMARY KEY,SCHEMEOID INTEGER NOT NULL,NAME VARCHAR NOT NULL,ISNULLABLE BOOLEAN,ISKEY BOOLEAN,TYPE VARCHAR,TABLEOID INTEGER,CONSTRAINT SYS_FK_696 FOREIGN KEY(TABLEOID) REFERENCES REL_TABLE(OID),CONSTRAINT SYS_FK_697 FOREIGN KEY(SCHEMEOID) REFERENCES SCHEME(OID))
CREATE MEMORY TABLE REL_COLUMN_SK(OID INTEGER GENERATED BY DEFAULT AS IDENTITY(START WITH 0) NOT NULL PRIMARY KEY,SCHEMEOID INTEGER NOT NULL,OID_COPY INTEGER)
CREATE MEMORY TABLE REL_FOREIGNKEY(OID INTEGER NOT NULL PRIMARY KEY,SCHEMEOID INTEGER NOT NULL,NAME VARCHAR NOT NULL,TABLEFROMOID INTEGER,TABLETOOID INTEGER,CONSTRAINT SYS_FK_704 FOREIGN KEY(TABLEFROMOID) REFERENCES REL_TABLE(OID),CONSTRAINT SYS_FK_705 FOREIGN KEY(TABLETOOID) REFERENCES REL_TABLE(OID),CONSTRAINT SYS_FK_706 FOREIGN KEY(SCHEMEOID) REFERENCES SCHEME(OID))
CREATE MEMORY TABLE REL_FOREIGNKEY_SK(OID INTEGER GENERATED BY DEFAULT AS IDENTITY(START WITH 0) NOT NULL PRIMARY KEY,SCHEMEOID INTEGER NOT NULL,OID_COPY INTEGER)
CREATE MEMORY TABLE REL_COMPONENTOFFOREIGNKEY(OID INTEGER NOT NULL PRIMARY KEY,SCHEMEOID INTEGER NOT NULL,NAME VARCHAR NOT NULL,FOREIGNKEYOID INTEGER,COLUMNFROMOID INTEGER,COLUMNTOOID INTEGER,CONSTRAINT SYS_FK_715 FOREIGN KEY(FOREIGNKEYOID) REFERENCES REL_FOREIGNKEY(OID),CONSTRAINT SYS_FK_716 FOREIGN KEY(COLUMNFROMOID) REFERENCES REL_COLUMN(OID),CONSTRAINT SYS_FK_717 FOREIGN KEY(COLUMNTOOID) REFERENCES REL_COLUMN(OID),CONSTRAINT SYS_FK_718 FOREIGN KEY(SCHEMEOID) REFERENCES SCHEME(OID))
CREATE MEMORY TABLE REL_COMPONENTOFFOREIGNKEY_SK(OID INTEGER GENERATED BY DEFAULT AS IDENTITY(START WITH 0) NOT NULL PRIMARY KEY,SCHEMEOID INTEGER NOT NULL,OID_COPY INTEGER)


INSERT INTO Family(name, modelOID) VALUES ('Relational', 3);//4


//ERNARY
INSERT INTO MODEL(name, shortname, familyOID, isAncestor) VALUES('EntityRelationshipNary','ERnary',5,'true');//4
INSERT INTO MM_CONSTRUCT(modelOID, name, modelName, signature, bonds) VALUES(4,'entity','EntityRelationshipNary','true','true');
INSERT INTO MM_CONSTRUCT(modelOID, name, modelName, signature, bonds) VALUES(4,'relationship','EntityRelationshipNary','true','true');
INSERT INTO MM_CONSTRUCT(modelOID, name, modelName, signature, bonds) VALUES(4,'componentOfRelationship','EntityRelationshipNary','true','true');
INSERT INTO MM_CONSTRUCT(modelOID, name, modelName, signature, bonds) VALUES(4,'attribute','EntityRelationshipNary','true','true');
INSERT INTO MM_CONSTRUCT(modelOID, name, modelName, signature, bonds) VALUES(4,'generalization','EntityRelationshipNary','true','true');
INSERT INTO MM_CONSTRUCT(modelOID, name, modelName, signature, bonds) VALUES(4,'childOfGeneralization','EntityRelationshipNary','true','true');//25
INSERT INTO MM_PROPERTY(constructOID, name, type) VALUES(22,'isOptional','boolean');
INSERT INTO MM_PROPERTY(constructOID, name, type) VALUES(22,'isFunctional','boolean');
INSERT INTO MM_PROPERTY(constructOID, name, type) VALUES(22,'isIdentified','boolean');
INSERT INTO MM_PROPERTY(constructOID, name, type) VALUES(23,'isKey','boolean');
INSERT INTO MM_PROPERTY(constructOID, name, type) VALUES(23,'isOptional','boolean');
INSERT INTO MM_PROPERTY(constructOID, name, type) VALUES(23,'type','varchar');
INSERT INTO MM_PROPERTY(constructOID, name, type) VALUES(24,'isTotal','boolean');//30
INSERT INTO MM_REFERENCE(ownerConstructOID, name, type, targetConstructOID) VALUES(22,'entityOID','relation',20);
INSERT INTO MM_REFERENCE(ownerConstructOID, name, type, targetConstructOID) VALUES(22,'relationshipOID','description',21);
INSERT INTO MM_REFERENCE(ownerConstructOID, name, type, targetConstructOID) VALUES(23,'relationshipOID','description',21);
INSERT INTO MM_REFERENCE(ownerConstructOID, name, type, targetConstructOID) VALUES(23,'entityOID','description',20);
INSERT INTO MM_REFERENCE(ownerConstructOID, name, type, targetConstructOID) VALUES(24,'parentEntityOID','relation',20);
INSERT INTO MM_REFERENCE(ownerConstructOID, name, type, targetConstructOID) VALUES(25,'generalizationOID','description',24);
INSERT INTO MM_REFERENCE(ownerConstructOID, name, type, targetConstructOID) VALUES(25,'childEntityOID','relation',20);//37
INSERT INTO MAPPING_MC_SMC(CONSTRUCTOID_SM, CONSTRUCTOID_M) VALUES(1,20);
INSERT INTO MAPPING_MC_SMC(CONSTRUCTOID_SM, CONSTRUCTOID_M) VALUES(5,21);
INSERT INTO MAPPING_MC_SMC(CONSTRUCTOID_SM, CONSTRUCTOID_M) VALUES(6,22);
INSERT INTO MAPPING_MC_SMC(CONSTRUCTOID_SM, CONSTRUCTOID_M) VALUES(10,23);
INSERT INTO MAPPING_MC_SMC(CONSTRUCTOID_SM, CONSTRUCTOID_M) VALUES(7,24);
INSERT INTO MAPPING_MC_SMC(CONSTRUCTOID_SM, CONSTRUCTOID_M) VALUES(8,25);
INSERT INTO MAPPING_MP_SMP(PROPERTYOID_SM, PROPERTYOID_M) VALUES(15,24);
INSERT INTO MAPPING_MP_SMP(PROPERTYOID_SM, PROPERTYOID_M) VALUES(16,25);
INSERT INTO MAPPING_MP_SMP(PROPERTYOID_SM, PROPERTYOID_M) VALUES(17,26);
INSERT INTO MAPPING_MP_SMP(PROPERTYOID_SM, PROPERTYOID_M) VALUES(2,27);
INSERT INTO MAPPING_MP_SMP(PROPERTYOID_SM, PROPERTYOID_M) VALUES(1,28);
INSERT INTO MAPPING_MP_SMP(PROPERTYOID_SM, PROPERTYOID_M) VALUES(3,29);
INSERT INTO MAPPING_MP_SMP(PROPERTYOID_SM, PROPERTYOID_M) VALUES(18,30);
INSERT INTO MAPPING_MR_SMR(REFERENCEOID_SM, REFERENCEOID_M) VALUES(22,31);
INSERT INTO MAPPING_MR_SMR(REFERENCEOID_SM, REFERENCEOID_M) VALUES(23,32);
INSERT INTO MAPPING_MR_SMR(REFERENCEOID_SM, REFERENCEOID_M) VALUES(1,33);
INSERT INTO MAPPING_MR_SMR(REFERENCEOID_SM, REFERENCEOID_M) VALUES(17,34);
INSERT INTO MAPPING_MR_SMR(REFERENCEOID_SM, REFERENCEOID_M) VALUES(24,35);
INSERT INTO MAPPING_MR_SMR(REFERENCEOID_SM, REFERENCEOID_M) VALUES(25,36);
INSERT INTO MAPPING_MR_SMR(REFERENCEOID_SM, REFERENCEOID_M) VALUES(26,37);
CREATE MEMORY TABLE ERNARY_ENTITY(OID INTEGER NOT NULL PRIMARY KEY,SCHEMEOID INTEGER NOT NULL,NAME VARCHAR NOT NULL,CONSTRAINT SYS_FK_1051 FOREIGN KEY(SCHEMEOID) REFERENCES SCHEME(OID))
CREATE MEMORY TABLE ERNARY_ENTITY_SK(OID INTEGER GENERATED BY DEFAULT AS IDENTITY(START WITH 0) NOT NULL PRIMARY KEY,SCHEMEOID INTEGER NOT NULL,OID_COPY INTEGER)
CREATE MEMORY TABLE ERNARY_RELATIONSHIP(OID INTEGER NOT NULL PRIMARY KEY,SCHEMEOID INTEGER NOT NULL,NAME VARCHAR NOT NULL,CONSTRAINT SYS_FK_1056 FOREIGN KEY(SCHEMEOID) REFERENCES SCHEME(OID))
CREATE MEMORY TABLE ERNARY_RELATIONSHIP_SK(OID INTEGER GENERATED BY DEFAULT AS IDENTITY(START WITH 0) NOT NULL PRIMARY KEY,SCHEMEOID INTEGER NOT NULL,OID_COPY INTEGER)
CREATE MEMORY TABLE ERNARY_COMPONENTOFRELATIONSHIP(OID INTEGER NOT NULL PRIMARY KEY,SCHEMEOID INTEGER NOT NULL,NAME VARCHAR NOT NULL,ISOPTIONAL BOOLEAN,ISFUNCTIONAL BOOLEAN,ISIDENTIFIED BOOLEAN,ENTITYOID INTEGER,RELATIONSHIPOID INTEGER,CONSTRAINT SYS_FK_1061 FOREIGN KEY(ENTITYOID) REFERENCES ERNARY_ENTITY(OID),CONSTRAINT SYS_FK_1062 FOREIGN KEY(RELATIONSHIPOID) REFERENCES ERNARY_RELATIONSHIP(OID),CONSTRAINT SYS_FK_1063 FOREIGN KEY(SCHEMEOID) REFERENCES SCHEME(OID))
CREATE MEMORY TABLE ERNARY_COMPONENTOFRELATIONSHIP_SK(OID INTEGER GENERATED BY DEFAULT AS IDENTITY(START WITH 0) NOT NULL PRIMARY KEY,SCHEMEOID INTEGER NOT NULL,OID_COPY INTEGER)
CREATE MEMORY TABLE ERNARY_ATTRIBUTE(OID INTEGER NOT NULL PRIMARY KEY,SCHEMEOID INTEGER NOT NULL,NAME VARCHAR NOT NULL,ISKEY BOOLEAN,ISOPTIONAL BOOLEAN,TYPE VARCHAR,RELATIONSHIPOID INTEGER,ENTITYOID INTEGER,CONSTRAINT SYS_FK_1072 FOREIGN KEY(RELATIONSHIPOID) REFERENCES ERNARY_RELATIONSHIP(OID),CONSTRAINT SYS_FK_1073 FOREIGN KEY(ENTITYOID) REFERENCES ERNARY_ENTITY(OID),CONSTRAINT SYS_FK_1074 FOREIGN KEY(SCHEMEOID) REFERENCES SCHEME(OID))
CREATE MEMORY TABLE ERNARY_ATTRIBUTE_SK(OID INTEGER GENERATED BY DEFAULT AS IDENTITY(START WITH 0) NOT NULL PRIMARY KEY,SCHEMEOID INTEGER NOT NULL,OID_COPY INTEGER)
CREATE MEMORY TABLE ERNARY_GENERALIZATION(OID INTEGER NOT NULL PRIMARY KEY,SCHEMEOID INTEGER NOT NULL,NAME VARCHAR NOT NULL,ISTOTAL BOOLEAN,PARENTENTITYOID INTEGER,CONSTRAINT SYS_FK_1083 FOREIGN KEY(PARENTENTITYOID) REFERENCES ERNARY_ENTITY(OID),CONSTRAINT SYS_FK_1084 FOREIGN KEY(SCHEMEOID) REFERENCES SCHEME(OID))
CREATE MEMORY TABLE ERNARY_GENERALIZATION_SK(OID INTEGER GENERATED BY DEFAULT AS IDENTITY(START WITH 0) NOT NULL PRIMARY KEY,SCHEMEOID INTEGER NOT NULL,OID_COPY INTEGER)
CREATE MEMORY TABLE ERNARY_CHILDOFGENERALIZATION(OID INTEGER NOT NULL PRIMARY KEY,SCHEMEOID INTEGER NOT NULL,NAME VARCHAR NOT NULL,GENERALIZATIONOID INTEGER,CHILDENTITYOID INTEGER,CONSTRAINT SYS_FK_1091 FOREIGN KEY(GENERALIZATIONOID) REFERENCES ERNARY_GENERALIZATION(OID),CONSTRAINT SYS_FK_1092 FOREIGN KEY(CHILDENTITYOID) REFERENCES ERNARY_ENTITY(OID),CONSTRAINT SYS_FK_1093 FOREIGN KEY(SCHEMEOID) REFERENCES SCHEME(OID))
CREATE MEMORY TABLE ERNARY_CHILDOFGENERALIZATION_SK(OID INTEGER GENERATED BY DEFAULT AS IDENTITY(START WITH 0) NOT NULL PRIMARY KEY,SCHEMEOID INTEGER NOT NULL,OID_COPY INTEGER)


INSERT INTO Family(name, modelOID) VALUES ('EntityRelationshipNary', 4);//5



//modifica alla tabella Model
//questa istruzione deve essere l'ultima
ALTER TABLE Model ADD foreign key (familyOID) references Family(OID);
