package org.modelgen.importexport.components;

import org.modelgen.importexport.ImportExportTool;
import org.modelgen.importexport.controller.ExportController;
import org.modelgen.importexport.dialog.IEDialog;
import org.modelgen.jpf.core.ToolBoxFrame;

import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.GroupLayout;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPasswordField;
import javax.swing.JTextField;
import javax.swing.LayoutStyle;
import javax.swing.WindowConstants;

public class ExportParameters extends IEDialog implements ActionListener {
	private static final long serialVersionUID = 1L;
	
	private ImportExportTool plugin;
	private String exporterName;
	
	/*jlabel che servono solo a definire cosa rappresentano i campi*/
	private JLabel jLabel1;
    private JLabel jLabel2;
    private JLabel jLabel3;
    private JLabel jLabel5;
    private JLabel jLabel6;
    private JLabel jLabel7;
    private JLabel jLabel8;
    //private JLabel jLabel9;
    
    /*campi con i valori*/
    private JTextField exportAddress;
    private JTextField exportPort;
    private JTextField exportDBName;
    private JTextField exportUser;
    private JPasswordField exportPassword;
    
    private JCheckBox exportCheckSchema;
    private JCheckBox exportCheckIstance;   
    //private JCheckBox exportCreateDB;   
   
    private JButton exportStart;	private JButton exportAnnulla;
    
    public ExportParameters(ImportExportTool plugin,String name) {
		this(ToolBoxFrame.getIstance(), "Parametri per l'export", true);
		this.plugin=plugin;
		this.pack();
        initComponents();
        this.setLocation(250,200);
        this.exporterName=name;
        this.setVisible(true);
	}

	public ExportParameters(Frame owner, String title, boolean modal) {
		super(ToolBoxFrame.getIstance(), title , true);
	}
    

	public void actionPerformed(ActionEvent e) {
		if (e.getSource() instanceof JButton) {
			JButton source=(JButton)e.getSource();
			if(source==exportStart) {
				/*ha premuto start, quindi devo fare un controllo(anche se grossolano sui dati inseriti)*/
				if(exportAddress.getText().length()>0 && exportDBName.getText().length()>0 && 
						exportUser.getText().length()>0 && (new String(exportPassword.getPassword())).length()>0
						&& exportCheckSchema.isSelected()) {
					/*ok, i parametri sono stati tutti inseriti, controllo inoltre che la porta sia veramente un numero*/
					try {
						int port=new Integer(exportPort.getText()).intValue();
						if(port>0 && port<65535) {
							/*eseguo l'export*/
							eseguiExport(port);
						}
					} catch (NumberFormatException nb) {
						JOptionPane.showMessageDialog(this,"La porta deve essere un numero","Errore di Formato",JOptionPane.ERROR_MESSAGE);
					}					
				}
				else {
					JOptionPane.showMessageDialog(this,"Inserire correttamente i parametri","Errore nei parametri",JOptionPane.ERROR_MESSAGE);
				}
			}
			else if (source==exportAnnulla) {
				this.dispose();	//chiudo
			}			
		}
		else if (e.getSource() instanceof JCheckBox) {
			JCheckBox source=(JCheckBox)e.getSource();
			if(source==exportCheckSchema && !exportCheckSchema.isSelected()) {
				JOptionPane.showMessageDialog(this,"Non vuoi esportare lo schema??","Errore",JOptionPane.ERROR_MESSAGE);
				exportCheckSchema.setSelected(true);
			}
		}
		
	}
	
	private void eseguiExport(int port) {
		/*ho verificato che i parametri sono corretti, quindi provo a fare l'export*/
		try {
			int schemaOID=Integer.parseInt(plugin.getExportSchema());
			//System.out.println("schemaOID :"+schemaOID);
			int instanceOID=-1;
			if(!plugin.getExportIstance().equals("Inesistente") && exportCheckIstance.isSelected())
				instanceOID=Integer.parseInt(plugin.getExportIstance());
			//System.out.println("instanceOID :"+instanceOID);
			
			this.dispose();
			new ExportController(this.exporterName,exportDBName.getText(),
					exportAddress.getText(),port,exportUser.getText(),new String(exportPassword.getPassword()),schemaOID,instanceOID).start();
			
		}
		catch (NumberFormatException e) {
			JOptionPane.showMessageDialog(this,"Errore di conversione numerico\n"+e.getMessage(),"Errore di export",JOptionPane.ERROR_MESSAGE);
		}
	
	}
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {
        jLabel1 = new JLabel();
        exportAddress = new JTextField();
        jLabel2 = new JLabel();
        exportPort = new JTextField();
        jLabel3 = new JLabel();
        exportDBName = new JTextField();
        jLabel5 = new JLabel();
        exportUser = new JTextField();
        jLabel6 = new JLabel();
        exportPassword = new JPasswordField();
        jLabel7 = new JLabel();
        exportCheckSchema = new JCheckBox();
        jLabel8 = new JLabel();
        exportCheckIstance = new JCheckBox();
        //exportCreateDB = new JCheckBox();
        exportStart = new JButton();
        exportAnnulla = new JButton();
        //jLabel9= new JLabel("Creare un nuovo db: ");
        //jLabel9.setToolTipText("selezionare per creare un nuovo database, " +
        //		"invece di utilizzarne uno esistente");

        setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
        jLabel1.setText("Indirizzo del Server:");
        jLabel1.setToolTipText("Inserire l'indirizzo del server,sia come indirizzo IP che come stringa");

        exportAddress.setText("localhost");

        jLabel2.setText("Porta del Server:");
        jLabel2.setToolTipText("Inserire la porta del server");

        exportPort.setText("50000");

        jLabel3.setText("Nome del Database:");
        jLabel3.setToolTipText("Inserire il nome del Dabatase sotto forma di stringa");

        jLabel5.setText("UserId :");
        jLabel5.setToolTipText("Inserire l'UserId");

        exportUser.setText("db2admin");

        jLabel6.setText("Password:");
        jLabel6.setToolTipText("Inserire la Password");

        jLabel7.setText("Esporta lo Schema:");

        exportCheckSchema.setSelected(true);
        exportCheckSchema.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
        exportCheckSchema.setMargin(new java.awt.Insets(0, 0, 0, 0));
        exportCheckSchema.addActionListener(this);

        jLabel8.setText("Esporta le Istanze:");

        exportCheckIstance.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
        exportCheckIstance.setMargin(new java.awt.Insets(0, 0, 0, 0));
        
        //exportCreateDB.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
        //exportCreateDB.setMargin(new java.awt.Insets(0, 0, 0, 0));

        exportStart.setText("Start");
        exportStart.setToolTipText("Premere per avviare l'Export verso il database indicato");
        exportStart.addActionListener(this);
        
        exportAnnulla.setText("Annulla");
        exportAnnulla.setToolTipText("Premere per annullare l'Export");
        exportAnnulla.addActionListener(this);

        GroupLayout layout = new GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel1)
                            .addComponent(jLabel2))
                        .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(GroupLayout.Alignment.LEADING, false)
                            .addComponent(exportPort)
                            .addComponent(exportAddress, GroupLayout.DEFAULT_SIZE, 93, Short.MAX_VALUE)))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel3)
                        .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(exportDBName, GroupLayout.DEFAULT_SIZE, 92, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel5)
                        .addGap(61, 61, 61)
                        .addComponent(exportUser, GroupLayout.DEFAULT_SIZE, 93, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel6)
                        .addGap(50, 50, 50)
                        .addComponent(exportPassword, GroupLayout.DEFAULT_SIZE, 93, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addGap(23, 23, 23)
                                .addComponent(exportStart, GroupLayout.PREFERRED_SIZE, 69, GroupLayout.PREFERRED_SIZE))
                            .addComponent(jLabel8)
                            .addComponent(jLabel7)
                            //.addComponent(jLabel9)
                            )
                        .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(GroupLayout.Alignment.LEADING)
                            .addComponent(exportCheckSchema)
                            .addComponent(exportAnnulla)
                            .addComponent(exportCheckIstance)
                            //.addComponent(exportCreateDB)
                            )))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(exportAddress, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(exportPort, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(exportDBName, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel5)
                    .addComponent(exportUser, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel6)
                    .addComponent(exportPassword, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED, 15, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(GroupLayout.Alignment.TRAILING)
                    .addComponent(jLabel7)
                    .addComponent(exportCheckSchema))
                .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel8)
                    .addComponent(exportCheckIstance))
                .addGap(14, 14, 14)
                .addGroup(layout.createParallelGroup(GroupLayout.Alignment.LEADING)
                    //.addComponent(jLabel9)
                    //.addComponent(exportCreateDB)
                    )
                .addGap(14, 14, 14)
                .addGroup(layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
                    .addComponent(exportStart)
                    .addComponent(exportAnnulla))
                .addContainerGap())
        );
        pack();
    }

}
