package org.modelgen.importexport.components;

import org.modelgen.importexport.ImportExportTool;
import org.modelgen.importexport.Export.Exporter;
import org.modelgen.importexport.dialog.IEDialog;
import org.modelgen.importexport.utilities.Configurator;
import org.modelgen.importexport.utilities.ImportExportException;
import org.modelgen.jpf.core.ToolBoxFrame;

import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.GroupLayout;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.LayoutStyle;

public class ExportSelection extends IEDialog implements Runnable,ActionListener {
	private static final long serialVersionUID = -4076595073734287756L;
	
	/*componenti grafiche*/
    private JLabel jLabel1;		private JComboBox listaExporter;
    private JButton start;		private JButton annulla;
    
	/** Creates new form exportSelection */
    public ExportSelection() {
		this(ToolBoxFrame.getIstance(), "Export", true);
		initComponents();
        this.pack();
        Thread t1=new Thread(this);
        t1.start();
        this.setVisible(true);
	}

	public ExportSelection(Frame owner, String title, boolean modal) {
		super(ToolBoxFrame.getIstance(), title , true);
	}
    

	public void run() {
		String exportPackage=new String("org.modelgen.importexport.Export");
		//System.out.println("faccio la lista...");
		String[] exporters=Configurator.getInstance().getExporterClass();
		System.out.println(exporters);
		for(int i=0;i<exporters.length;i++) {
			//System.out.println("exporter: "+exporters[i]);
			try {
				String name=new String(exporters[i]);
				System.out.println(name);
				Exporter<?,?> exporter=(Exporter<?,?>)Class.forName(exportPackage+"."+name).newInstance();
				System.out.println(exporter.checkModel(1));
				if(exporter.checkModel(1)) {
					this.listaExporter.addItem(name);
				}
			} catch (InstantiationException e) {
			} catch (IllegalAccessException e) {
			} catch (ClassNotFoundException e) {
			} catch (ImportExportException e) {
			}
		}		
	}

	public void actionPerformed(ActionEvent e) {
		if (e.getSource() instanceof JButton) {
			JButton source=(JButton)e.getSource();
			if(source==start) {
				//String exportPackage=new String("org.modelgen.importexport.Export.");
				String exportClass=(String)listaExporter.getSelectedItem();
				//System.out.println("classe che dovr fare l'export "+exportClass);
				
				if(exportClass.equals("DB2RelationalExporter") || 
						exportClass.equals("DB2OOExporter") || exportClass.equals("DB2ORExporter")) {
					this.dispose();
					new ExportParameters(ImportExportTool.getIstance(),exportClass);
				}
				else if(exportClass.equals("XMLSchemaExporter")) {
					this.dispose();
					new ExportXsdParameter("XMLSchemaExporter").setVisible(true);
				}
//				else if(exportClass.equals("qualche classe")) {
//					
//				}
				else {
					this.dispose();
					JOptionPane.showMessageDialog(ImportExportTool.getIstance(),
						    "Non  stata trovata la classe per la selezione " +
						    "\ndei parametri corrispondente alla classe scelta",
						    "Errore di configurazione",JOptionPane.ERROR_MESSAGE);
				}
			}
			else if (source==annulla) {
				this.dispose();
			}			
		}	
	}
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
     private void initComponents() {
    	 this.setTitle("Lista dei possibili Exporter");
    	 this.setLocation(250,200);
    	 jLabel1 = new JLabel();
    	 listaExporter = new JComboBox();
    	 start = new JButton();
    	 annulla = new JButton();

    	 jLabel1.setText("Lista dei Exporter:");
    	 start.setText("OK");
    	 start.addActionListener(this);
    	 annulla.setText("Annulla");
    	 annulla.addActionListener(this);

    	 GroupLayout layout = new GroupLayout(getContentPane());
    	 getContentPane().setLayout(layout);
    	 layout.setHorizontalGroup(
    			 layout.createParallelGroup(GroupLayout.Alignment.LEADING)
    			 .addGroup(layout.createSequentialGroup()
    					 .addContainerGap()
    					 .addGroup(layout.createParallelGroup(GroupLayout.Alignment.TRAILING)
    							 .addComponent(jLabel1, GroupLayout.PREFERRED_SIZE, 100, GroupLayout.PREFERRED_SIZE)
    							 .addComponent(start, GroupLayout.PREFERRED_SIZE, 73, GroupLayout.PREFERRED_SIZE))
    							 .addGroup(layout.createParallelGroup(GroupLayout.Alignment.LEADING)
    									 .addGroup(layout.createSequentialGroup()
    											 .addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
    											 .addComponent(listaExporter, 0, 166, Short.MAX_VALUE))
    											 .addGroup(layout.createSequentialGroup()
    													 .addGap(36, 36, 36)
    													 .addComponent(annulla)))
    													 .addContainerGap())
    	 );
    	 layout.setVerticalGroup(
    			 layout.createParallelGroup(GroupLayout.Alignment.LEADING)
    			 .addGroup(layout.createSequentialGroup()
    					 .addContainerGap()
    					 .addGroup(layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
    							 .addComponent(jLabel1)
    							 .addComponent(listaExporter, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
    							 .addGap(28, 28, 28)
    							 .addGroup(layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
    									 .addComponent(start)
    									 .addComponent(annulla))
    									 .addContainerGap(GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
    	 );
     }
}
