package org.modelgen.importexport.components;

import org.modelgen.importexport.ImportExportTool;
import org.modelgen.importexport.controller.ImportController;
import org.modelgen.importexport.dialog.IEDialog;
import org.modelgen.importexport.utilities.PersistenceException;
import org.modelgen.jpf.core.ToolBoxFrame;

import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.GroupLayout;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPasswordField;
import javax.swing.JTextField;
import javax.swing.LayoutStyle;
import javax.swing.UIManager;
import javax.swing.WindowConstants;

/**
 * 
 *
 */
public class ImportConnectionParameters extends IEDialog implements ActionListener{
	private static final long serialVersionUID = 1L;
	
	/*da non togliere poi mi servir per l'import parametrico(forse :))*/
	private ImportExportTool plugin;
	
	/*componenti che invece sono utili per la gestione di eventi*/
	private JTextField importAddress;
	private JTextField importPort;
	private JTextField importDBName;
	private JTextField importSchema;
	private JTextField importUser;
	private JPasswordField importPassword;
	
	private JCheckBox importCheckSchema;
	private JCheckBox importCheckIstance;	
		
	private JButton importStart;
	private JButton importAnnulla;
	
	/** Creates new form ImportParameters */
	public ImportConnectionParameters() {
		this(ToolBoxFrame.getIstance(), "Parametri per l'import", true);
		initComponents();
		this.pack();
		try {
			UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
		} catch (Exception e) {
			System.out.println("non ci sono riuscito a caricare system l&f");
			//non faccio niente, la grafica sar solo bruttina
		} 
		this.plugin=ImportExportTool.getIstance();
		this.setLocation(250,200);
		this.setVisible(true);
	}

	public ImportConnectionParameters(Frame owner, String title, boolean modal) {
		super(ToolBoxFrame.getIstance(), title , true);
	}
	
	/**Serve???
	 */
	public ImportExportTool getUI() {
		return this.plugin;
	}


	public void actionPerformed(ActionEvent evt) {
		if (evt.getSource() instanceof JButton) {
			JButton source=(JButton)evt.getSource();
			if(source==importStart) {
				checkParameters();
			}
			else if (source==importAnnulla) {
				this.dispose();	//chiudo
			}			
		}
		else if (evt.getSource() instanceof JCheckBox) {
			JCheckBox source=(JCheckBox)evt.getSource();
			if(source==importCheckSchema && !importCheckSchema.isSelected()) {
				JOptionPane.showMessageDialog(this,"Non vuoi importare lo schema??","Errore",JOptionPane.ERROR_MESSAGE);
				importCheckSchema.setSelected(true);
			}
		}
	}
	
	private void checkParameters() {
		/*ha premuto start, quindi devo fare un controllo(anche se grossolano sui dati inseriti)*/
		if(importAddress.getText().length()>0 && importDBName.getText().length()>0 && 
				importSchema.getText().length()>0 && importUser.getText().length()>0 && importPassword.getPassword().toString().length()>0
				&& importCheckSchema.isSelected()) {
			/*ok, i parametri sono stati tutti inseriti, controllo inoltre che la porta sia veramente un numero*/
			try {
				int port=new Integer(importPort.getText()).intValue();
				if(port>0 && port<65535) {
					/*i parametri sono corretti, quindi provo a fare l'import*/
					this.dispose();
					
					importModel(port);
				}
			} catch (NumberFormatException e) {
				JOptionPane.showMessageDialog(this,"La porta deve essere un numero","Errore di Formato",JOptionPane.ERROR_MESSAGE);
			}					
		}
		else
			JOptionPane.showMessageDialog(this,"Inserire correttamente i parametri","Errore nei parametri",JOptionPane.ERROR_MESSAGE);
	}
	
	private void importModel(int port) {
		try {
			new ImportController(importDBName.getText(),importAddress.getText(),
					port,importUser.getText(),new String(importPassword.getPassword()),
					importSchema.getText(),importCheckIstance.isSelected()).start();
		} catch (PersistenceException e) {
			JOptionPane.showMessageDialog(this,"Errore nella persistenza\n"+e.getMessage(),"Errore nella persistenza",JOptionPane.ERROR_MESSAGE);
		}
	}

	
	/**Assolutamente da non toccare, inizializza tutti i componenti e li dispone 
	 * 
	 */
	private void initComponents() {
		jLabel1 = new JLabel();
		importAddress = new JTextField();
		jLabel2 = new JLabel();
		importPort = new JTextField();
		jLabel3 = new JLabel();
		importDBName = new JTextField();
		jLabel4 = new JLabel();
		importSchema = new JTextField();
		jLabel5 = new JLabel();
		importUser = new JTextField();
		jLabel6 = new JLabel();
		importPassword = new JPasswordField();
		jLabel7 = new JLabel();
		importCheckSchema = new JCheckBox();
		jLabel8 = new JLabel();
		importCheckIstance = new JCheckBox();
		importStart = new JButton();
		importAnnulla = new JButton();

		setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
		jLabel1.setText("Indirizzo del Server:");
		jLabel1.setToolTipText("Inserire l'indirizzo del server,sia come indirizzo IP che come stringa");

		importAddress.setText("localhost");

		jLabel2.setText("Porta del Server:");
		jLabel2.setToolTipText("Inserire la porta del server");

		importPort.setText("50000");

		jLabel3.setText("Nome del Database:");
		jLabel3.setToolTipText("Inserire il nome del Dabatase sotto forma di stringa");

		jLabel4.setText("Nome dello Schema:");
		jLabel4.setToolTipText("Inserire il nome dello schema");

		jLabel5.setText("UserId :");
		jLabel5.setToolTipText("Inserire l'UserId");

		importUser.setText("db2admin");

		jLabel6.setText("Password:");
		jLabel6.setToolTipText("Inserire la Password");

		jLabel7.setText("Importa lo Schema:");
		jLabel7.setToolTipText("Selezionare per importare lo schema");

		importCheckSchema.setSelected(true);
		importCheckSchema.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
		importCheckSchema.setMargin(new java.awt.Insets(0, 0, 0, 0));
		importCheckSchema.addActionListener(this);

		jLabel8.setText("Importa le Istanze:");
		jLabel8.setToolTipText("Selezionare per importare le istanze");

		importCheckIstance.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
		importCheckIstance.setMargin(new java.awt.Insets(0, 0, 0, 0));

		importStart.setText("Start");
		importStart.setToolTipText("Premere per avviare la procedura di Import");
		importStart.addActionListener(this);
		
		importAnnulla.setText("Annulla");
		importAnnulla.setToolTipText("Premere per tornare indietro");
		importAnnulla.addActionListener(this);

		GroupLayout layout = new GroupLayout(getContentPane());
		getContentPane().setLayout(layout);
		layout.setHorizontalGroup(
				layout.createParallelGroup(GroupLayout.Alignment.LEADING)
				.addGroup(layout.createSequentialGroup()
						.addContainerGap()
						.addGroup(layout.createParallelGroup(GroupLayout.Alignment.LEADING)
								.addGroup(layout.createSequentialGroup()
										.addGroup(layout.createParallelGroup(GroupLayout.Alignment.LEADING)
												.addComponent(jLabel1)
												.addComponent(jLabel2))
												.addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
												.addGroup(layout.createParallelGroup(GroupLayout.Alignment.LEADING)
														.addComponent(importAddress, GroupLayout.DEFAULT_SIZE, 98, Short.MAX_VALUE)
														.addComponent(importPort, GroupLayout.DEFAULT_SIZE, 98, Short.MAX_VALUE)))
														.addGroup(layout.createSequentialGroup()
																.addComponent(jLabel3)
																.addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
																.addComponent(importDBName, GroupLayout.DEFAULT_SIZE, 97, Short.MAX_VALUE))
																.addGroup(layout.createSequentialGroup()
																		.addGroup(layout.createParallelGroup(GroupLayout.Alignment.LEADING)
																				.addComponent(jLabel4)
																				.addComponent(jLabel5)
																				.addComponent(jLabel6)
																				.addComponent(jLabel7)
																				.addGroup(layout.createParallelGroup(GroupLayout.Alignment.TRAILING)
																						.addComponent(importStart, GroupLayout.PREFERRED_SIZE, 69, GroupLayout.PREFERRED_SIZE)
																						.addComponent(jLabel8, GroupLayout.Alignment.LEADING)))
																						.addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
																						.addGroup(layout.createParallelGroup(GroupLayout.Alignment.LEADING)
																								.addComponent(importCheckIstance)
																								.addComponent(importCheckSchema)
																								.addComponent(importPassword, GroupLayout.DEFAULT_SIZE, 98, Short.MAX_VALUE)
																								.addComponent(importUser, GroupLayout.DEFAULT_SIZE, 98, Short.MAX_VALUE)
																								.addComponent(importSchema, GroupLayout.DEFAULT_SIZE, 98, Short.MAX_VALUE)
																								.addComponent(importAnnulla))))
																								.addContainerGap())
		);
		layout.setVerticalGroup(
				layout.createParallelGroup(GroupLayout.Alignment.LEADING)
				.addGroup(layout.createSequentialGroup()
						.addContainerGap()
						.addGroup(layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
								.addComponent(jLabel1)
								.addComponent(importAddress, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
								.addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
								.addGroup(layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
										.addComponent(jLabel2)
										.addComponent(importPort, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
										.addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
										.addGroup(layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
												.addComponent(jLabel3)
												.addComponent(importDBName, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
												.addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
												.addGroup(layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
														.addComponent(jLabel4)
														.addComponent(importSchema, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
														.addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
														.addGroup(layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
																.addComponent(jLabel5)
																.addComponent(importUser, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
																.addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
																.addGroup(layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
																		.addComponent(jLabel6)
																		.addComponent(importPassword, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
																		.addGap(27, 27, 27)
																		.addGroup(layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
																				.addComponent(jLabel7)
																				.addComponent(importCheckSchema))
																				.addPreferredGap(LayoutStyle.ComponentPlacement.RELATED)
																				.addGroup(layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
																						.addComponent(jLabel8)
																						.addComponent(importCheckIstance))
																						.addGap(21, 21, 21)
																						.addGroup(layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
																								.addComponent(importStart)
																								.addComponent(importAnnulla))
																								.addContainerGap(GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
		);
		pack();
	}
	
	/*i vari label(inutile modificarli), non servono ad altro*/
	private JLabel jLabel1;
	private JLabel jLabel2;
	private JLabel jLabel3;
	private JLabel jLabel4;
	private JLabel jLabel5;
	private JLabel jLabel6;
	private JLabel jLabel7;
	private JLabel jLabel8;

}

