package org.modelgen.importexport.oo.model;

/**Represents a link between two OOObject from a Generalization.
 * Each class contains OOObject that are also in its parent; this class
 * links this two OOObject which have the same OID.
 * 
 * @version 0.9
 *
 */
public class ObjectGeneralization {
	private OOGeneralization generalization;
	private OOChild child;
	private OOObject parentObject;
	private OOObject childObject;
	
	/**
	 * @param generalization
	 * @param child
	 * @param parentObject
	 * @param childObject
	 */
	public ObjectGeneralization(OOGeneralization generalization, OOChild child, OOObject parentObject, OOObject childObject) {
		this.generalization = generalization;
		this.child = child;
		this.parentObject = parentObject;
		this.childObject = childObject;
	}

	public OOChild getChild() {
		return child;
	}

	public OOObject getChildObject() {
		return childObject;
	}

	public OOGeneralization getGeneralization() {
		return generalization;
	}

	public OOObject getParentObject() {
		return parentObject;
	}	
	
	public String toString() {
		return "\tGen: "+generalization.getName()+" child: "+child.getChild().getName()+
		" OID parent: "+parentObject.getObjectOID()+" OID child: "+childObject.getObjectOID();
	}
}
