package org.modelgen.importexport.oo.model;

/**Create a Reference between the the object containing this Reference and the given OOClass.
 * A Reference can be defined between OOClass or a ComplexType and a OOClass; in both cases 
 * we can handle the Reference with this class.
 *  
 * @version 0.9
 *
 */
public class Reference {
	//OID
	private int oid;
	//name
	private String name;
/*	Modifica del 30/04/07 AbstractAttribute non ha pi questi attributi, ma isNullable
 * private boolean isOptional;
	private boolean isIdentifier;
	*/
	private boolean isNullable;
	//class the link/reference points to
	private OOClass classTo;
	

	/**Create a Rference with the given parameter
	 * @param oid OID as stored in ModelGen
	 * @param name name as stored in ModelGen
	 * @param classTo the OOClass to which this Reference points
	 */
	public Reference(int oid, String name, boolean isNullable, OOClass classTo) {
		this.oid = oid;
		this.name = name;
		this.isNullable = isNullable;
		this.classTo = classTo;
	}
	
	public OOClass getClassTo() {
		return classTo;
	}

	public String getName() {
		return name;
	}

	public int getOid() {
		return oid;
	}
	
	public boolean isNullable() {
		return isNullable;
	}

	/**Returns a String representation of this Reference
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		StringBuilder sb=new StringBuilder("oid: ");
		sb.append(oid);
		sb.append(" name: ");
		sb.append(name);
		sb.append(" isNullable: ");
		sb.append(isNullable);
		sb.append(" references Class: ");
		sb.append(classTo.getName());
		
		return sb.toString();
	}

}
