package org.modelgen.importexport.oo.model;

/**Represents the actual value of a Field in a OOObject.
 * An OOObject must have a value corrispondenging to its Fields; this values can be null
 * or any other value.
 * In ModelGen this value it always a string.
 * 
 * @version 0.9
 *
 */
public class ValueComponent {
	//OID
	private int oid;
	//	value as a string
	private String value;
	//	reference to the scheme object it is instance of
	private Field ooField;
	//	the object owing this field instance
	private OOObject owner;
	
	/**
	 * @param oid
	 * @param value
	 * @param ooField
	 * @param owner
	 */
	public ValueComponent(int oid, String value, Field ooField, OOObject owner) {
		this.oid = oid;
		this.value = value;
		this.ooField = ooField;
		this.owner = owner;
	}
	
	/**Returns a String representation
	 * @see java.lang.Object#toString()
	 */
	public String toString(){
		if(value!=null)
			return "\t\tValueoid "+this.oid+", value "+this.value+"\n";
		else
			return "\t\tValueoid "+this.oid+", value :null \n";
	}
	
	public Field getOoField() {
		return ooField;
	}
	
	public String getValue() {
		return value;
	}
	
	public int getOid() {
		return oid;
	}
	
	public OOObject getOwner() {
		return owner;
	}
}