package org.modelgen.importexport.or.model;

import java.util.List;

/**Define a behavior needed to define an hierachy for ORSchema
 * This interface is implemented by ORClass, ORTable and ComplexType.
 * It defines only one metod taht return true if the object that this metod is called on 
 * can be inserted in the ordered list. For the condition of each object see each class.
 *  
 * @version 0.9
 * 
 */

public interface Insertable {

	/**Return true if the object can be inserted in the alreadyOrdered list
	 * @param alreadyOrdered the list which contains the elements already ordered
	 * @param schema the schema alle elements belong to(needed to get information)
	 * @return true is is possible to introduce this object without problem
	 */
	public boolean isInsertable(List<Insertable> alreadyOrdered,ORSchema schema);

}
