package org.modelgen.importexport.or.model;

/**Represents an instance of a Nest between two ComplexType.
 * It associates the instance of the two ComplexType.
 * 
 * @version 0.9
 */
public class NestComponent {
	//OID
	private int OID;
	//the instance of the ComplexType which contains the other component
	private ComplexTypeComponent top;
	//the component contained
	private ComplexTypeComponent nested;
	
	/**Creates a new NestComponent with the given parameters
	 * @param oid
	 * @param top
	 * @param nested
	 */
	public NestComponent(int oid, ComplexTypeComponent top, ComplexTypeComponent nested) {
		OID = oid;
		this.top = top;
		this.nested = nested;
	}

	public ComplexTypeComponent getNested() {
		return nested;
	}

	public int getOID() {
		return OID;
	}

	public ComplexTypeComponent getTop() {
		return top;
	}
}
