package org.modelgen.importexport.or.model;

import org.modelgen.importexport.oo.model.OOObject;

/**Represents an instance of a ORReference.
 * A ORReference is a Reference between an ORTable and a ORClass; so the component is
 * between a ORTuple a OOObject.
 * 
 * @version 0.9
 * 
 */
public class ORReferenceComponent {
	//OID
	private int OID;
	//the ref the instance belongs to
	private ORReference ref;
	//the tuple this instance belongs
	private ORTuple tuple;
	//the object this reference points to
	private OOObject object;
	
	/**Create a new ORReferenceComponent with the given parameters.
	 * @param oid
	 * @param ref
	 * @param tuple
	 * @param object
	 */
	public ORReferenceComponent(int oid, ORReference ref, ORTuple tuple, OOObject object) {
		OID = oid;
		this.ref = ref;
		this.tuple = tuple;
		this.object = object;
	}

	public OOObject getObject() {
		return object;
	}

	public int getOID() {
		return OID;
	}

	public ORReference getRef() {
		return ref;
	}
	
	public ORTuple getTuple() {
		return tuple;
	}
	
	/**Returns a String representation of this object
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		StringBuilder sb=new StringBuilder("REF: ");
		sb.append(OID);
		sb.append(",objectOID :");
		if(this.object==null)
			sb.append(" NULL");
		else 
			sb.append(object.getObjectOID());
		sb.append(",	");
		
		return sb.toString();
	}
}
