/**
 * 
 */
package org.modelgen.importexport.persistence;

import org.modelgen.importexport.utilities.PersistenceException;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;


/**
 * @author LordofDeceits
 *
 */
public class DB2Connection extends DbConnection {

	public DB2Connection(String dbName,String server,int port,
			String username, String password, String schema) throws PersistenceException {
		try {
			Class.forName("com.ibm.db2.jcc.DB2Driver");
			String db2URL = "jdbc:db2://" + server + ":" + port + "/" + dbName;
			Connection con=DriverManager.getConnection(db2URL, username, password);
			this.con=con;
			this.schema=schema;			
		} catch (ClassNotFoundException e) {
			throw new PersistenceException("Non trovata la classe del driver JDBC di DB2");
		} catch (SQLException e) {
			throw new PersistenceException("Errore SQL nella creazione della connessione a DB\n"+e.getMessage());
		}		
	}
}
