package org.modelgen.importexport.relational.model;

/**This represents a Column as in Relational Model
 * @version 0.9
 */
public class Column {
//OID of the Column
	private int OID;
//	column name
	private String name;
//	column type: it should be a valid SQL type
	private String type;
//	allows for null values
	private boolean isNull;
//	is part of the primary key
	private boolean isKey;

	
	/**Returns a new Column with the parameters given
	 * @param OID the column OID as in ModelGen
	 * @param name the column name as in ModelGen
	 * @param type the column type ATTENTION : it MUST be a valid SQL type
	 * @param isNull true is the values of this Column can be null 
	 * @param isKey true is this Column belong to the primary key
	 */
	public Column(int OID, String name, String type, boolean isNull, boolean isKey) {
		this.OID = OID;
		this.name = name;
		this.type = type;
		this.isNull = isNull;
		this.isKey = isKey;
	}

	public boolean isKey() {
		return isKey;
	}

	public boolean isNull() {
		return isNull;
	}

	public String getName() {
		return name;
	}

	public String getType() {
		return type;
	}

	public int getOID() {
		return OID;
	}

	public void setKey(boolean isKey) {
		this.isKey = isKey;
	}
	
	public void setOID(int oid) {
		OID = oid;
	}

	public String toString() {
		return "\toid: " + OID + " name: " + name + " type: " + type + " isNull: " + isNull +" isKey: " + isKey; 
	}
}
