package org.modelgen.importexport.relational.model;

import org.modelgen.importexport.oo.model.Field;

/**This represents a component of a FK.
 * Since a FK has at least one or more Column related e.g. fk in table1 refers id in table 2
 * we create for each couple of column a ComponentOfForeignKey.
 * This is not only for Relational FK but also FK between Table and OOCLass so the component 
 * can be a Column or a Field
 *
 * @version 0.9
 */
public class ComponentOfForeignKey {
	private int OID;
	private String name;
	private int fromOID;
	private int toOID;
	
	/**
	 * @param oid
	 * @param name
	 * @param from
	 * @param to
	 */
	public ComponentOfForeignKey(int oid, String name, Column from, Column to) {
		OID = oid;
		this.name = name;
		this.fromOID = from.getOID();
		this.toOID = to.getOID();
	}
	
	/**
	 * @param oid
	 * @param name
	 * @param from
	 * @param to
	 */
	public ComponentOfForeignKey(int oid, String name, Field from, Column to) {
		OID = oid;
		this.name = name;
		this.fromOID = from.getOid();
		this.toOID = to.getOID();
	}
	
	/**
	 * @param oid
	 * @param name
	 * @param from
	 * @param to
	 */
	public ComponentOfForeignKey(int oid, String name, Column from, Field to) {
		OID = oid;
		this.name = name;
		this.fromOID = from.getOID();
		this.toOID = to.getOid();
	}
	
	/**
	 * @param oid
	 * @param name
	 * @param from
	 * @param to
	 */
	public ComponentOfForeignKey(int oid, String name, Field from, Field to) {
		OID = oid;
		this.name = name;
		this.fromOID = from.getOid();
		this.toOID = to.getOid();
	}

	public String getName() {
		return name;
	}

	public int getOID() {
		return OID;
	}

	public int getFromOID() {
		return fromOID;
	}

	public int getToOID() {
		return toOID;
	}	
}
