package org.modelgen.importexport.relational.model;

import java.util.Vector;

/**This class represents a Tuple of a Table.
 * A Table has as its instances a number of Tuples; each tuple has a number of component that
 * corrispond to the value of the column defined for the Table
 *
 * @version 0.9
 */

public class Tuple {
	//OID
	protected int tupleOID;
//	the table this tuple belong to
	private Table table;
	//component of this tuple
	protected Vector<TupleComponent> tupleComponents;

	/**Creates a new Tuple for the table given Table 
	 * @param tupleOID
	 * @param table
	 */
	public Tuple(int tupleOID, Table table) {
		this.tupleOID = tupleOID;
		this.table = table;
		this.tupleComponents = new Vector<TupleComponent>();
	}
	
	/**Add a new TupleComponent to this tuple
	 * @param cTuple the componet to be added
	 */
	public void addTupleComponent(TupleComponent cTuple) {
		tupleComponents.add(cTuple);
	}

	public int getTupleOID() {
		return tupleOID;
	}

	public Vector<TupleComponent> getTupleComponents() {
		return tupleComponents;
	}

	public Table getTable() {
		return table;
	}
}
