package org.modelgen.importexport.relational.model;

/**This class represents a single value of a Tuple.
 * Each tuple has a number of component that corrispond to the value 
 * of the column defined for the Table
 * 
 * @version 0.9
 *
 */
public class TupleComponent {
	protected int oid;
//	For semplicity, I handle values with the String type
	protected String value;
//	the column this value is instance of
	protected Column column;

	/** Creates a new TupleComponent with the parameters given
	 * @param oid
	 * @param value
	 * @param column
	 */
	public TupleComponent(int oid, String value, Column column) {
		this.oid = oid;
		this.value = value;
		this.column = column;
	}

	public Column getColumn() {
		return column;
	}

	public String getValue() {
		return value;
	}

	public int getOid() {
		return oid;
	}
	
	public String toString() {
		if(this.value!=null)
			return "OID: "+this.getOid()+", valore: "+this.getValue() + " of " + this.getColumn().getName() + ",	";
		else 
			return "OID: "+this.getOid()+", valore: null of " + this.getColumn().getName() + ",		";
	}
}
