package org.modelgen.importexport.utilities.datatype;

import org.modelgen.importexport.utilities.ImportExportException;

import java.util.StringTokenizer;

/**Utility class to check a XmlSchema datatype and translate it into ModelGen representation.
 * 
 * @version 0.9
 */
public class XmlSchemaDataType {
	
	
	/**Return a String representing a correct data type in ModelGen or an error if the type in NOT allowed.
	 * 
	 * @param type
	 * @throws ImportExportException
	 */
	public static String getXmlDataType(String type) throws ImportExportException {
		if(type.contains(":")) {
			StringTokenizer st=new StringTokenizer(type,":");
			if(st.countTokens()==2) {
				st.nextToken();
				type=st.nextToken();				
			}
			else
				throw new ImportExportException("Il tipo non rispetta il pattern prefisso:nome_tipo");
		}
		else
			throw new ImportExportException("Il tipo non specifica il prefisso");
		/*tutti i tipi built-in che derivano da una stringa andranno salvato nel database di modelGen
		 * come una stringa pure(eliminando quindi le peculiarit di ogni stringa)*/
		if(type.equals("string") || type.equals("normalizedString") || type.equals("token") 
				|| type.equals("language") || type.equals("Name") || type.equals("NMTOKEN")
				|| type.equals("NCName") || type.equals("ID") || type.equals("IDREF") 
				|| type.equals("base64Binary") || type.equals("anyURI") || type.equals("ENTITY")
				|| type.equals("IDREFS") || type.equals("ENTITIES") || type.equals("NMTOKENS") 
				|| type.equals("hexBinary") || type.equals("QName") || type.equals("NOTATION") 	)
			return "string";
		/*tipo boolean*/
		else if (type.equals("boolean")) {
			return "boolean";
		}
		/*tipo double*/
		else if (type.equals("double")) {
			return "double";
		}
		/*tipi integer*/
		else if (type.equals("integer") || type.equals("nonPositiveInteger") || type.equals("long") 
				|| type.equals("nonNegativeInteger") || type.equals("int") || type.equals("unsignedLong")
				|| type.equals("positiveInteger") || type.equals("short") || type.equals("unsignedInt")
				|| type.equals("byte") || type.equals("unsignedShort") || type.equals("unsignedByte")) {
			return "integer";
		}
		else 
			throw new ImportExportException("Tipo di dato non ammesso :"+type);
	}
}
