package org.modelgen.importexport.xml.model;

/**Represents an Element of the Xml File.
 *
 */
public abstract class InstanceElement {
	protected int OID;
	protected Element schemaElement;	//l'elemento a livello di schema
	
	
	/**Creates a new InstanceElement; to be used only with child Class.
	 * @param oid
	 * @param e
	 */
	public InstanceElement(int oid,Element e) {
		super();
		OID = oid;
		this.schemaElement=e;
	}
	
	public InstanceElement(Element e) {
		super();
		this.OID=Numberable.NO_NUMBERED;
		this.schemaElement=e;
	}

	public int getOID() {
		return OID;
	}
	
	public void setOID(int oid) {
		OID = oid;
	}

	public Element getSchemaElement() {
		return schemaElement;
	}
	
	public abstract String getRepresentation(String base);

	/** Returns a String representation of this Object.
	 * 
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		StringBuilder sb=new StringBuilder("OID: ");
		sb.append(this.OID);
		sb.append(" Elemento: ");
		sb.append(this.schemaElement.getName());
		
		return sb.toString();
	}

}
