package org.modelgen.importexport.xml.model;

/**Represents an instance of a SimpleElement.
 * 
 * A element with a simple type must have a singular value like 'leonardo','10','true,false'.
 * This class represents such an alement.
 *
 */
public class SimpleInstance extends InstanceElement {
	private String value;

	
	public SimpleInstance(int oid,Element e, String value) {
		super(oid,e);
		this.value = value;
	}
	
	public SimpleInstance(Element e, String value) {
		super(e);
		this.value = value;
	}
	
	public String getValue() {
		return value;
	}
	
	/**Returns a String representation of this SimpleElement considering also the indentation.
	 * 
	 * @param base the indentation to be used
	 */
	public String getRepresentation(String base) {
		StringBuilder sb=new StringBuilder("SimpleInstace :");
		if(this.OID!=Numberable.NO_NUMBERED) { 
			sb.append(this.OID);
		}
		sb.append(" Elemento :");
		sb.append(this.schemaElement.getName());
		sb.append(" Valore: ");
		sb.append(this.value);

		return base+sb.toString();
	}

	/** Returns a String representation of this Object.
	 * 
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		return getRepresentation("");
	}
}
