package org.modelgen.importexport.xml.model;

/**Represents a XmlSchema SimpleType.
 * A simpleType in Xmlschema can have name(if it's global) and a number of child element which can be:
 * 1)list
 * 2)union
 * 3)restriction
 * The only one that we consider is restriction; for us a simpleType can nly be a 
 * restriction of a built in type(see thesis).
 * 
 * @version 0.9
 *
 */

public class SimpleType {
	//nome
	private String name;
	//tipo espresso come sitrnga senza prefisso
	private String type;
	
	/**Creates a SimpleType with the given name and type.
	 * The name should be used if the type is global otherwise can used the string "".
	 * The type must be one of the built-in type(not all are acceptable) and we do NOT
	 * consider the limitation imposed
	 * 
	 * @param name
	 * @param type
	 */
	public SimpleType(String name, String type) {
		this.name = name;
		this.type = type;
	}

	public String getName() {
		return name;
	}

	public String getType() {
		return type;
	}
        
	/**Returns a String representation of this object.
	 * 
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		StringBuilder sb=new StringBuilder("semplice: ");
		sb.append(this.name);
		sb.append(" tipo: ");
		sb.append(this.type);

		return sb.toString();
	}	
}

