/*
 * This class implements a listener for menu 
 */
package org.modelgen.jpf.applyInstanceRules;

import org.modelgen.jpf.applyInstanceRules.apply.PanelRules;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;


/**
 * @author kristina
 * This class implements a listener for menu
 */
class ActionListenerMenu implements ActionListener {
	// References to the class to listen
	private MenuApplyInstanceRule mnuApplyRule;
	private PanelRules pnlRules;
	
	/**
	 * Class constructor
	 * @param mnuApplyRule The references to the class to listen
	 * @param pnlRules To execute apply rules finction
	 */
	public ActionListenerMenu(MenuApplyInstanceRule mnuApplyRule,  PanelRules pnlRules) {
		super();
		this.mnuApplyRule = mnuApplyRule;
		this.pnlRules = pnlRules;
	}


	public void actionPerformed(ActionEvent e) {
		
		if(e.getSource() == this.mnuApplyRule.open)
			this.mnuApplyRule.openLoad();
		else if(e.getSource() == this.mnuApplyRule.save)
			this.mnuApplyRule.openSave();
		else if(e.getSource() == this.mnuApplyRule.execute)
			this.pnlRules.applyRules();
		else if(e.getSource() == this.mnuApplyRule.exit)
			this.mnuApplyRule.close();
			
	}
}