/*
 * This class implements a listener for tool bar 
 */
package org.modelgen.jpf.applyInstanceRules;

import org.modelgen.jpf.applyInstanceRules.apply.PanelRules;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;


/**
 * @author kristina
 * This class implements a listener for tool bar
 */
class ActionListenerTool implements ActionListener {
	// References to the class to listen
	private ToolBarApplyInstanceRule toolApplyRule;
	private PanelRules pnlRules;
	
	/**
	 * Class constructor
	 * @param toolApplyRule The references to the class to listen
	 * @param pnlRules To execute apply rules finction
	 */
	public ActionListenerTool(ToolBarApplyInstanceRule toolApplyRule,  
			PanelRules pnlRules) {
		super();
		this.toolApplyRule = toolApplyRule;
		this.pnlRules = pnlRules;
	}


	public void actionPerformed(ActionEvent e) {
		
		if(e.getSource() == this.toolApplyRule.btnOpen)
			this.toolApplyRule.openLoad();
		else if(e.getSource() == this.toolApplyRule.btnSave) 
			this.toolApplyRule.openSave();
		else if(e.getSource() == this.toolApplyRule.btnExecute)
			this.pnlRules.applyRules();
		else if(e.getSource() == this.toolApplyRule.btnRefresh)
			try {
				ApplyInstanceRulesTool.getIstance().updateGuiData();
			} catch (ClassNotFoundException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			} catch (Exception e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
	
	}
}