/*
 * Tool bar for apply instance rule 
 */
package org.modelgen.jpf.applyInstanceRules;

import org.modelgen.jpf.applyInstanceRules.apply.PanelRules;
import org.modelgen.jpf.applyInstanceRules.complex.ComplexRules;
import org.modelgen.jpf.applyInstanceRules.util.FactoryIcon;

import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JToolBar;

/**
 * @author kristina
 * Tool bar for apply instance rule
 */
class ToolBarApplyInstanceRule extends JToolBar {
	private static final long serialVersionUID = 8105446230570226130L;
	// Singleton
	private static ToolBarApplyInstanceRule instance;
	// Listener
	private ActionListener lstAction;
	// References to PanelRules
	private PanelRules pnlRules;
	// Bottons of tool bar
	protected JButton btnOpen;
	// Bottons of tool bar
	protected JButton btnSave;
	// Bottons of tool bar
	protected JButton btnExecute;
//	 Bottons of tool bar
	protected JButton btnRefresh;
		
	/**
	 * Class constructor
	 * @param pnlCopy The references to the panel with copy function
	 * @param pnlRules The references to the panel with apply instance rules function
	 */
	private ToolBarApplyInstanceRule( 
			PanelRules pnlRules) {
		super("ToolBarApplyInstanceRules", JToolBar.HORIZONTAL);
		this.pnlRules = pnlRules;
		this.lstAction = new ActionListenerTool(this,  pnlRules);
		// Creates component
		this.btnOpen = new JButton(FactoryIcon.createOpenIcon());
		this.btnOpen.setToolTipText("Open a complex rules");
		this.btnOpen.addActionListener(this.lstAction);
		this.btnSave = new JButton(FactoryIcon.createSaveIcon());
		this.btnSave.setToolTipText("Save a complex rules");
		this.btnSave.addActionListener(this.lstAction);
		this.btnExecute = new JButton(FactoryIcon.createDownIcon());
		this.btnExecute.setToolTipText("Execute rule(s)");
		this.btnExecute.addActionListener(this.lstAction);
		this.btnRefresh = new JButton(FactoryIcon.createRefresh());
		this.btnRefresh.setToolTipText("Refresh");
		this.btnRefresh.addActionListener(this.lstAction);
		
		// Add
		
		this.add(this.btnOpen);
		this.add(this.btnSave);		
		this.add(this.btnExecute);
		this.add(this.btnRefresh);
	}
	
	/**
	 * Return an instance of the class
	 * @param pnlCopy The references to the panel with copy function
	 * @param pnlRules The references to the panel with apply rules function
	 * @return ToolBarApplyInstanceRule
	 */
	protected static ToolBarApplyInstanceRule getInstance( 
			PanelRules pnlRules) {
		/* Singleton */
		if(instance == null)
			instance = new ToolBarApplyInstanceRule( pnlRules);
		return instance;
	}
	
	/**
	 * Open the file chooser to save the complex rules
	 */
	
	protected void openSave() {
		ComplexRules save = ComplexRules.getInstance(this.pnlRules);
		save.openSave();
	}
	
	/**
	 * Open the file chooser to load the complex rules
	 */
	
	protected void openLoad() {
		ComplexRules save = ComplexRules.getInstance(this.pnlRules);
		save.openLoad();
	}
	
}