/*
 * Mouse listener for panel rules 
 */
package org.modelgen.jpf.applyInstanceRules.apply;

import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

/**
 * @author kristina
 * Mouse listener for panel rules
 */
class MouseListenerRules implements MouseListener {
	// References to class to listen
	private PanelRules pnlRules;
	private PanelInfo pnlInfo;
	
	/**
	 * Class constructor
	 * @param pnlRules The reference to the class to listen
	 */
	protected MouseListenerRules(PanelRules pnlRules) {
		super();
		this.pnlRules = pnlRules;
	}
	
	/**
	 * Class constructor
	 * @param pnlInfo The reference to the class to listen
	 */
	protected MouseListenerRules(PanelInfo pnlInfo) {
		super();
		this.pnlInfo = pnlInfo;
	}

	public void mouseClicked(MouseEvent e) {	
		
			if(e.getSource() == this.pnlRules.lstRules) {
				if(e.getButton() == MouseEvent.BUTTON3 && e.getClickCount() == 1) 
					this.pnlRules.removeSelection();
				if(e.getButton() == MouseEvent.BUTTON1 && e.getClickCount() == 2)
					this.pnlRules.moveToUserList();
			} else if(e.getSource() == this.pnlRules.lstUserRules) {
				if(e.getButton() == MouseEvent.BUTTON3 && e.getClickCount() == 1) 
					this.pnlRules.removeSelection();
				if(e.getButton() == MouseEvent.BUTTON1 && e.getClickCount() == 2) 
					this.pnlRules.moveToList();
			}
			 
	}

	public void mouseEntered(MouseEvent arg0) {
	}

	public void mouseExited(MouseEvent e) {
	}

	public void mousePressed(MouseEvent e) {
		if(e.getSource() == this.pnlInfo.txtTraslated) {
			if(e.getButton() == MouseEvent.BUTTON1)
				if (this.pnlInfo.txtTraslated.getText().equals(PanelInfo.TXT_DEFAULT))
					this.pnlInfo.txtTraslated.setText("");
		}
	}

	public void mouseReleased(MouseEvent arg0) {
	}
}