/*
 * This class implements a loader for available rules 
 */
package org.modelgen.jpf.applyInstanceRules.load;

import org.modelgen.commons.utils.ModelgenConfigurationManager;

import java.io.File;
import java.util.Collection;
import java.util.LinkedList;

/**
 * @author kristina
 * This class implements a loader for available rules
 */
public class RulesLoader {
	/**
	 * Return a collection of available rules
	 * @return Collection
	 */
	@SuppressWarnings("unchecked")
	public static Collection<String> load() {
		//This was from the request, now we need to load the available rules.
		String rootnode = ModelgenConfigurationManager.getIstance().getProperty("rootnode", "", "paths");
		String macrorulePath = ModelgenConfigurationManager.getIstance().getProperty("macrorules", "", "paths");
		String filePath = rootnode + macrorulePath + "InstanceMacroRules";
		File macroRuleDir = new File(filePath);	
		
		LinkedList rules = new LinkedList();
		if (macroRuleDir.isDirectory()) {
			String sa_rules[] = macroRuleDir.list(new FileFilter());
			// All the .txt files are now in the array, but it should be easier to 
			// deal with a LinkedList.
			if (sa_rules != null)
				for (int i = 0; i < sa_rules.length; i++) {
					rules.add(sa_rules[i]);
				}
		} else 
			rules = null;
		return rules;
	}
}