/*
 * Create icon for button
 */
 
package org.modelgen.jpf.applyInstanceRules.util;

import org.modelgen.facade.ResourceFunctions;

import javax.swing.Icon;
import javax.swing.ImageIcon;

/**
 * @author kristina
 * Create icon for button
 */
public class FactoryIcon {
	// Parameter for icon
	private static final String OPEN = 
		"open.png";
	private static final String SAVE =
		"save.png";
	private static final String UP = 
		"arrow_up.png";
	private static final String ADD = 
		"arrow_right.png";
	private static final String ADD_ALL = 
		"book_next.png";
	private static final String REMOVE = 
		"arrow_left.png";
	private static final String REMOVE_ALL = 
		"book_previous.png";
	private static final String DOWN = 
		"arrow_down.png";
	private static final String REPORT = 
		"littleReport.png";
	private static final String CLOSE = 
		"button_cancel.png";
	private static final String REFRESH = 
		"refresh.png";
	
	/**
	 * Create image icon for open
	 * @return ImageIcon
	 */
	public static ImageIcon createOpenIcon() {
		return ResourceFunctions.openImageIcon(FactoryIcon.class, OPEN);
	}
	
	/**
	 * Create image icon for save
	 * @return ImageIcon
	 */
	public static ImageIcon createSaveIcon() {
		return ResourceFunctions.openImageIcon(FactoryIcon.class, SAVE);
	}
	
	/**
	 * Create image icon for up
	 * @return ImageIcon
	 */
	public static ImageIcon createUpIcon() {
		return ResourceFunctions.openImageIcon(FactoryIcon.class, UP);
	}
	
	/**
	 * Create image icon for down
	 * @return ImageIcon
	 */
	public static ImageIcon createDownIcon() {
		return ResourceFunctions.openImageIcon(FactoryIcon.class, DOWN);
	}
	
	/**
	 * Create image icon for add
	 * @return ImageIcon
	 */
	public static ImageIcon createAddIcon() {
		return ResourceFunctions.openImageIcon(FactoryIcon.class, ADD);
	}
	
	/**
	 * Create image icon for add all
	 * @return ImageIcon
	 */
	public static ImageIcon createAddAllIcon() {
		return ResourceFunctions.openImageIcon(FactoryIcon.class, ADD_ALL);
	}
	
	/**
	 * Create image icon for remove
	 * @return ImageIcon
	 */
	public static ImageIcon createRemoveIcon() {
		return ResourceFunctions.openImageIcon(FactoryIcon.class, REMOVE);
	}
	
	/**
	 * Create image icon for remove all
	 * @return ImageIcon
	 */
	public static ImageIcon createRemoveAllIcon() {
		return ResourceFunctions.openImageIcon(FactoryIcon.class, REMOVE_ALL);
	}
	
	/**
	 * Create image icon for report
	 * @return ImageIcon
	 */
	public static ImageIcon createReportIcon() {
		return ResourceFunctions.openImageIcon(FactoryIcon.class, REPORT);
	}
	
	/**
	 * Create icon for close
	 * @return ImageIcon
	 */
	public static ImageIcon createCloseIcon() {
		return ResourceFunctions.openImageIcon(FactoryIcon.class, CLOSE);
	}

	public static Icon createRefresh() {
		return ResourceFunctions.openImageIcon(FactoryIcon.class, REFRESH);
	}
}