/*
 * This class implements a listener for menu 
 */
package org.modelgen.jpf.applyRules;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import org.modelgen.jpf.applyRules.apply.PanelRules;
import org.modelgen.jpf.applyRules.copy.PanelCopy;

/**
 * @author  gabriele  This class implements a listener for menu
 */
class ActionListenerMenu implements ActionListener {
	// References to the class to listen
	private MenuApplyRule mnuApplyRule;
	private PanelCopy pnlCopy;
	private PanelRules pnlRules;
	
	/**
	 * Class constructor
	 * @param mnuApplyRule The references to the class to listen
	 * @param pnlCopy To execute copy function
	 * @param pnlRules To execute apply rules finction
	 */
	public ActionListenerMenu(MenuApplyRule mnuApplyRule, PanelCopy pnlCopy, PanelRules pnlRules) {
		super();
		this.mnuApplyRule = mnuApplyRule;
		this.pnlCopy = pnlCopy;
		this.pnlRules = pnlRules;
	}


	public void actionPerformed(ActionEvent e) {
		if(e.getSource() == this.mnuApplyRule.copyModel)
			this.pnlCopy.copyModelIntoSuperModel();
		else if(e.getSource() == this.mnuApplyRule.copySupermodel)
			this.pnlCopy.copySuperModelIntoModel();
		else if(e.getSource() == this.mnuApplyRule.open)
			this.mnuApplyRule.openLoad();
		else if(e.getSource() == this.mnuApplyRule.save)
			this.mnuApplyRule.openSave();
		else if(e.getSource() == this.mnuApplyRule.execute) 
			this.pnlRules.applyRules();
		else if(e.getSource() == this.mnuApplyRule.exit) 
			this.mnuApplyRule.close();
	}
}