/*
 * This class implements a listener for tool bar 
 */
package org.modelgen.jpf.applyRules;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import org.modelgen.jpf.applyRules.apply.PanelRules;
import org.modelgen.jpf.applyRules.copy.PanelCopy;

/**
 * @author  gabriele  This class implements a listener for tool bar
 */
class ActionListenerTool implements ActionListener {
	// References to the class to listen
	private ToolBarApplyRule toolApplyRule;
	private PanelCopy pnlCopy;
	private PanelRules pnlRules;
	
	/**
	 * Class constructor
	 * @param toolApplyRule The references to the class to listen
	 * @param pnlCopy To execute copy function
	 * @param pnlRules To execute apply rules finction
	 */
	public ActionListenerTool(ToolBarApplyRule toolApplyRule, PanelCopy pnlCopy, 
			PanelRules pnlRules) {
		super();
		this.toolApplyRule = toolApplyRule;
		this.pnlCopy = pnlCopy;
		this.pnlRules = pnlRules;
	}


	public void actionPerformed(ActionEvent e) {
		if(e.getSource() == this.toolApplyRule.btnCopyModel)
			this.pnlCopy.copyModelIntoSuperModel();
		else if(e.getSource() == this.toolApplyRule.btnCopySupermodel)
			this.pnlCopy.copySuperModelIntoModel();
		else if(e.getSource() == this.toolApplyRule.btnOpen)
			this.toolApplyRule.openLoad();
		else if(e.getSource() == this.toolApplyRule.btnSave) 
			this.toolApplyRule.openSave();
		else if(e.getSource() == this.toolApplyRule.btnExecute)
			this.pnlRules.applyRules();
		else if(e.getSource() == this.toolApplyRule.btnRefresh)
			try {
				ApplyRulesTool.getIstance().updateGuiData();
			} catch (ClassNotFoundException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			} catch (Exception e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
	}
}