/*
 * Tool bar for apply rule 
 */
package org.modelgen.jpf.applyRules;

import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JToolBar;

import org.modelgen.jpf.applyRules.apply.PanelRules;
import org.modelgen.jpf.applyRules.complex.ComplexRules;
import org.modelgen.jpf.applyRules.copy.PanelCopy;
import org.modelgen.jpf.applyRules.util.FactoryIcon;

/**
 * @author  gabriele  Tool bar for apply rule
 */
class ToolBarApplyRule extends JToolBar {
	private static final long serialVersionUID = -4874398185565421310L;
	// Singleton
	private static ToolBarApplyRule instance;
	// Listener
	private ActionListener lstAction;
	// References to PanelRules
	private PanelRules pnlRules;
	// Bottons of tool bar
	protected JButton btnOpen;
	// Bottons of tool bar
	protected JButton btnSave;
	// Bottons of tool bar
	protected JButton btnExecute;
	// Bottons of tool bar
	protected JButton btnCopyModel;
	// Bottons of tool bar
	protected JButton btnCopySupermodel;
//	 Bottons of tool bar
	protected JButton btnRefresh;
	
	/**
	 * Class constructor
	 * @param pnlCopy The references to the panel with copy function
	 * @param pnlRules The references to the panel with apply rules function
	 */
	private ToolBarApplyRule(PanelCopy pnlCopy, 
			PanelRules pnlRules) {
		super("ToolBarApplyRules", JToolBar.HORIZONTAL);
		this.pnlRules = pnlRules;
		this.lstAction = new ActionListenerTool(this, pnlCopy, pnlRules);  
		// Creates component
		this.btnOpen = new JButton(FactoryIcon.createOpenIcon());
		this.btnOpen.setToolTipText("Open a complex rules");
		this.btnOpen.addActionListener(this.lstAction);
		this.btnSave = new JButton(FactoryIcon.createSaveIcon());
		this.btnSave.setToolTipText("Save a complex rules");
		this.btnSave.addActionListener(this.lstAction);
		this.btnExecute = new JButton(FactoryIcon.createDownIcon());
		this.btnExecute.setToolTipText("Execute rule(s)");
		this.btnExecute.addActionListener(this.lstAction);
		this.btnCopyModel = new JButton(FactoryIcon.createAddAllIcon());
		this.btnCopyModel.setToolTipText("Copy a model into super model scheme");
		this.btnCopyModel.addActionListener(this.lstAction);
		this.btnCopySupermodel = new JButton(FactoryIcon.createRemoveAllIcon());
		this.btnCopySupermodel.setToolTipText("Copy a super model scheme into model");
		this.btnCopySupermodel.addActionListener(this.lstAction);
		this.btnRefresh = new JButton(FactoryIcon.createRefreshIcon());
		this.btnRefresh.setToolTipText("Refresh");
		this.btnRefresh.addActionListener(this.lstAction);
		// Add
		this.add(this.btnCopyModel);
		this.add(this.btnCopySupermodel);
		this.addSeparator();
		this.add(this.btnOpen);
		this.add(this.btnSave);		
		this.add(this.btnExecute);
		this.addSeparator();
		this.add(this.btnRefresh);
	}
	
	/**
	 * Return an instance of the class
	 * @param pnlCopy The references to the panel with copy function
	 * @param pnlRules The references to the panel with apply rules function
	 * @return ToolBarApplyRule
	 */
	protected static ToolBarApplyRule getInstance(PanelCopy pnlCopy, 
			PanelRules pnlRules) {
		/* Singleton */
		if(instance == null)
			instance = new ToolBarApplyRule(pnlCopy, pnlRules);
		return instance;
	}
	
	/**
	 * Open the file chooser to save the complex ruels
	 */
	protected void openSave() {
		ComplexRules save = ComplexRules.getInstance(this.pnlRules);
		save.openSave();
	}
	
	/**
	 * Open the file chooser to load the complex ruels
	 */
	protected void openLoad() {
		ComplexRules save = ComplexRules.getInstance(this.pnlRules);
		save.openLoad();
	}
}