/*
 * This class implements a file filter 
 */
package org.modelgen.jpf.applyRules.util;

import java.io.File;

/**
 * @author   gabriele  This class implements a file filter
 */
public class FileFilter extends javax.swing.filechooser.FileFilter {
	// Predefinited extension(s)
	public static final String CMP = ".cmp";
	public static final String DESCRIPTION_CMP = "Complex Rules";
	// SINGLETON
	private static FileFilter instance;
	// File description
	/**
	 * @uml.property  name="description"
	 */
	private String description;
	// File extension
	private String extension;
	
	/**
	 * Class constructor
	 */
	private FileFilter() {
	}

	/**
	 * Return an instance of the class
	 * @return  FileFilter
	 * @uml.property  name="instance"
	 */
	public static FileFilter getInstance() {
		// Implements SINGLETON
		if(instance == null)
			instance = new FileFilter();
		return instance;
	}
	
	/**
	 * Sets extension and description
	 * @param extension The file extension
	 * @param description File description
	 */
	public void setExstension(String extension, String description) {
		this.extension = extension;
		this.description = description;
	}
	
	/**
	 * Return descriptiom
	 * @return  String
	 * @uml.property  name="description"
	 */
	public String getDescription() {
		return this.description;
	}
	
	/**
	 * Aplly filter
	 */
	public boolean accept(File f) {
		if(f.isDirectory()) 
			return true;
		String path=f.getAbsolutePath();
		for(int i=0; i<this.extension.length(); i++) {
			if(path.endsWith(this.extension) && 
					(path.charAt(path.length()-this.extension.length())=='.'))
				return true;
		}
		return false;
	}
} 