/*
 * This class implements a listener for menu 
 */
package org.modelgen.jpf.automaticSignatureApplication.applicationView.action;

import org.modelgen.jpf.automaticSignatureApplication.applicationView.MenuSignatureApplication;
import org.modelgen.jpf.automaticSignatureApplication.applicationView.PanelRules;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;


/**
 * @author kristina
 * This class implements a listener for menu
 */
public class ActionListenerMenu implements ActionListener {
	// References to the class to listen
	private MenuSignatureApplication mnuApplyRule;
	private PanelRules pnlRules;
	
	/**
	 * Class constructor
	 * @param mnuApplyRule The references to the class to listen
	 * @param pnlRules To execute apply rules finction
	 */
	public ActionListenerMenu(MenuSignatureApplication mnuApplyRule,  PanelRules pnlRules) {
		super();
		this.mnuApplyRule = mnuApplyRule;
		this.pnlRules = pnlRules;
	}


	public void actionPerformed(ActionEvent e) {
		
		if(e.getSource() == this.mnuApplyRule.execute)
			this.pnlRules.execute();
		else if(e.getSource() == this.mnuApplyRule.exit)
			this.mnuApplyRule.close();
	}
}