package org.modelgen.jpf.defineModel.Components;

import org.modelgen.facade.ResourceFunctions;

import javax.swing.ImageIcon;
import javax.swing.table.DefaultTableCellRenderer;


/**
 * DMTableCellRenderer: rappresenta il renderer della tabella della console
 */
public class DMTableCellRenderer extends DefaultTableCellRenderer{
	/**
	 * Il serial version UID di questo DMTableCellRenderer
	 */
	private static final long serialVersionUID = 991265266751652369L;
	
	/**
	 * L'ERROR_ICON di questo DMTableCellRenderer
	 */
	public static ImageIcon ERROR_ICON;
	
	/**
	 * La WARNING_ICON di questo DMTableCellRenderer
	 */
	public static ImageIcon WARNING_ICON;
	
	/**
	 * L'INFORMATION_ICON di questo DMTableCellRenderer
	 */
	public static ImageIcon INFORMATION_ICON;
	
	/**
	 * La TASK_ICON di questo DMTableCellRenderer
	 */
	public static ImageIcon TASK_ICON;

	/**
	 *  L'istanza di questo DMTableCellRenderer
	 */
	private static DMTableCellRenderer instance;
	
	/**
	 * Ritorna l'istanza di questo DMTableCellRenderer
	 * @return l'istanza di questo DMTableCellRenderer
	 */
	public static DMTableCellRenderer getInstance(){
		if(instance==null)
			instance = new DMTableCellRenderer();
		return instance;
	}
	
	/**
	 * Crea un nuovo oggetto di tipo DMTableCellRenderer
	 *
	 */
	private DMTableCellRenderer(){
		super();
		
		ERROR_ICON = ResourceFunctions.openImageIcon(this.getClass(), "error.png");
		WARNING_ICON = ResourceFunctions.openImageIcon(this.getClass(), "warning.png");
		INFORMATION_ICON = ResourceFunctions.openImageIcon(this.getClass(), "information.png");
		TASK_ICON = ResourceFunctions.openImageIcon(this.getClass(), "task.png");
	}
	
	/**
	 * Setta le icone in base alle informazioni
	 * @param value il valore con cui viene settato il DMTableCellRenderer
	 */
    public void setValue(Object value) {
        String valueAsString = (String)value;
        ImageIcon icon = null;
        if(valueAsString.equals("warning"))
        	icon = WARNING_ICON;

        if(valueAsString.equals("error"))
        	icon = ERROR_ICON;
        
        if(valueAsString.equals("task"))
        	icon = TASK_ICON;
        
        if(valueAsString.equals("info"))
        	icon = INFORMATION_ICON;
        
        if(icon != null) {
        	setIcon(icon);
        }
    }


	
}
