package org.modelgen.jpf.defineModel.Components;

import org.modelgen.jpf.defineModel.Tree.WorkSpaceTree;

import java.awt.Component;

import javax.swing.AbstractButton;
import javax.swing.Action;
import javax.swing.JToolBar;

/**
 * Enables or Disables tool bar buttons by specifing the name of
 * "ClientProperty" of the button you eant to enable
 */
public class StatusUtility {
	
	private Component[] items;
	private Component[] items2;
	private JToolBar toolBar;
	
	public StatusUtility(JToolBar toolBar){
		this.toolBar = toolBar;
		items = toolBar.getComponents();
		items2 = new Component[items.length];
		System.arraycopy(items,0,items2,0,items.length);
	}
	
	public void enableStatus(String relativeNodeAtt){
		int i = 0;
		while(i<items.length){
			Component comp = items[i];
			if(!(comp instanceof AbstractButton)){
				i++;
				continue;
			}
			AbstractButton button = (AbstractButton)comp;
			Action action = button.getAction();
			String relativeNode = (String) button.getClientProperty("relativeNode");
			if(relativeNode.equals(relativeNodeAtt)){
				action.setEnabled(true);
				items2[i] = null;
			}
			i++;
		}
		toolBar.updateUI();
	}

	public void disableOthers(){
		int i = 0;
		while(i<items.length){
			Component comp2 = items2[i];
			if(comp2==null || !(comp2 instanceof AbstractButton)){
				i++;
				continue;
			}
			Component comp = items[i];
			AbstractButton button = (AbstractButton) comp;
			Action action = button.getAction();
			action.setEnabled(false);
			i++;
		}
		WorkSpaceTree.getIstance().updateUI();
	}
}
