package org.modelgen.jpf.defineModel.Dialog.dialogIMPL;

import org.modelgen.commons.beans.model.Construct;
import org.modelgen.commons.beans.model.Model;
import org.modelgen.facade.ResourceFunctions;
import org.modelgen.jpf.core.ToolBoxFrame;
import org.modelgen.jpf.defineModel.Components.ProblemsScroll;
import org.modelgen.jpf.defineModel.Dialog.DMDialog;
import org.modelgen.jpf.defineModel.utility.ErrorTable;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Frame;
import java.awt.LayoutManager;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.HashMap;
import java.util.Map;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFormattedTextField;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.SwingConstants;

public class RenameConstructDialog extends DMDialog implements ActionListener{
	private static final long serialVersionUID = 1445935257720138673L;
	private JFormattedTextField textName = null;
	private Model model;
	
	public RenameConstructDialog(Model mod) {
		this(ToolBoxFrame.getIstance(), "Rename Construct", true);
		model = mod;
	}

	public RenameConstructDialog(Frame owner, String title, boolean modal) {
		super(ToolBoxFrame.getIstance(), title , true);
		defineStructure(this.getContentPane());
	}

	private void defineStructure(Container contentPane) {
		super.setSize(new Dimension(350,150));
		ImageIcon icon = ResourceFunctions.openImageIcon(this.getClass(), "renameConstruct.gif");
		
		JLabel messageLabel = new JLabel("Construct renamination \n          ",icon,SwingConstants.LEFT);
		contentPane.add(BorderLayout.NORTH,messageLabel);

		JPanel infoPanel = new JPanel();
		JPanel firstRow = new JPanel();
		LayoutManager layout = new FlowLayout(FlowLayout.RIGHT,30,10);
			firstRow.setLayout(layout);
		
		// Artifici di separazione
		String leftSpace = "           ";
		Dimension textDimension = new Dimension(150,20);
		
		
		JLabel nameLabel = new JLabel(leftSpace+"Name        ");
		textName = new JFormattedTextField();
		textName.setPreferredSize(textDimension);
			firstRow.add(nameLabel);
			firstRow.add(textName);
			
		infoPanel.add(firstRow);	

		contentPane.add(BorderLayout.CENTER,infoPanel);

		//Serve a dare lo spazio dal margine sinistro
		contentPane.add(BorderLayout.EAST,new JLabel("  "));
		
		JPanel controlPanel = new JPanel();
			JButton okButton = new JButton("Ok");
				okButton.setActionCommand("commit");
				okButton.addActionListener(this);
			JButton resetButton = new JButton("reset");
//				resetButton.setActionCommand("reset");
				resetButton.addActionListener(this);
			controlPanel.add(okButton);
			controlPanel.add(resetButton);
		contentPane.add(BorderLayout.SOUTH,controlPanel);
		
	}

	public void actionPerformed(ActionEvent ae) {
		JButton actionButton = (JButton) ae.getSource();
		String actionCommand = actionButton.getActionCommand();
		if(actionCommand.equals("commit"))
			commit();
		else
			reset();
		
	}

	private void reset() {
		textName.setText("");
//		textShortName.setText("");		
	}

	private void commit() {
		String constructName = textName.getText();
//		String modelShortName = textShortName.getText();
		
		ErrorTable errors = new ErrorTable();

		if (constructName.equals("") | constructName.contains(" ") | !Construct.isValidName(constructName)){
			errors.addError("invalid construct name");
		}
		if (model.getConstruct(constructName)!=null){
			errors.addError("The model already contains a construct with this name");
		}
		if (!errors.isEmpty()){
			JOptionPane.showMessageDialog(this,"Errors:\n"+errors);
			ProblemsScroll.getInstance().logWarning("Check data","Rename Construct", "construct");
			this.getToolkit().beep();
			reset();
			return;
			// Non viene eseguito this.setVisible(true) quindi il controllo resta sulla Dialog corrente
		}

		Map<String,String> values= new HashMap<String,String>();
			values.put("constructName",constructName);
		super.setValues(values);		
		this.setVisible(false);
	}





}
