package org.modelgen.jpf.defineModel.Dialog.dialogIMPL;

import org.modelgen.commons.beans.model.Construct;
import org.modelgen.commons.beans.model.Property;
import org.modelgen.facade.ResourceFunctions;
import org.modelgen.jpf.core.ToolBoxFrame;
import org.modelgen.jpf.defineModel.Components.ProblemsScroll;
import org.modelgen.jpf.defineModel.Dialog.DMDialog;
import org.modelgen.jpf.defineModel.Tree.ObjectDescription.NodeInfo;
import org.modelgen.jpf.defineModel.Tree.Popup.PopupActions.ActionUtility;
import org.modelgen.jpf.defineModel.utility.ErrorTable;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Frame;
import java.awt.LayoutManager;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.HashMap;
import java.util.Map;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFormattedTextField;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.SwingConstants;

public class RenamePropertyDialog extends DMDialog implements ActionListener{
	private static final long serialVersionUID = -3827965353284910629L;
	private JFormattedTextField textName = null;
	
	public RenamePropertyDialog() {
		this(ToolBoxFrame.getIstance(), "Rename Property", true);
	}

	public RenamePropertyDialog(Frame owner, String title, boolean modal) {
		super(ToolBoxFrame.getIstance(), title , true);
		defineStructure(this.getContentPane());
	}

	private void defineStructure(Container contentPane) {
		super.setSize(new Dimension(350,150));
		ImageIcon icon = ResourceFunctions.openImageIcon(this.getClass(), "renameProperty.gif");
		
		JLabel messageLabel = new JLabel("Property renamination \n          ",icon,SwingConstants.LEFT);
		contentPane.add(BorderLayout.NORTH,messageLabel);

		JPanel infoPanel = new JPanel();
		JPanel firstRow = new JPanel();
		LayoutManager layout = new FlowLayout(FlowLayout.RIGHT,30,10);
			firstRow.setLayout(layout);
		
		// Artifici di separazione
		String leftSpace = "           ";
		Dimension textDimension = new Dimension(150,20);
		
		
		JLabel nameLabel = new JLabel(leftSpace+"Name        ");
		textName = new JFormattedTextField();
		textName.setPreferredSize(textDimension);
			firstRow.add(nameLabel);
			firstRow.add(textName);
			
		infoPanel.add(firstRow);	

		contentPane.add(BorderLayout.CENTER,infoPanel);

		//Serve a dare lo spazio dal margine sinistro
		contentPane.add(BorderLayout.EAST,new JLabel("  "));
		
		JPanel controlPanel = new JPanel();
			JButton okButton = new JButton("Ok");
				okButton.setActionCommand("commit");
				okButton.addActionListener(this);
			JButton resetButton = new JButton("reset");
//				resetButton.setActionCommand("reset");
				resetButton.addActionListener(this);
			controlPanel.add(okButton);
			controlPanel.add(resetButton);
		contentPane.add(BorderLayout.SOUTH,controlPanel);
		
	}

	public void actionPerformed(ActionEvent ae) {
		JButton actionButton = (JButton) ae.getSource();
		String actionCommand = actionButton.getActionCommand();
		if(actionCommand.equals("commit"))
			commit();
		else
			reset();
		
	}

	private void reset() {
		textName.setText("");	
	}

	private void commit() {
		NodeInfo nodeInfo = ActionUtility.getNodeInfo();
		Property property = nodeInfo.getProperty();
	    Construct construct = property.getOwnerConstruct();
	    
		String propertyName = textName.getText();
		
		ErrorTable errors = new ErrorTable();
//		String superName = property.getSuperModelProperty().getName();
		
//		if (superName.startsWith("is") && !propertyName.startsWith("is")){
//			errors.addError("The property name must start with the prefix 'is'");
//		} 
//		if (superName.startsWith("type") && !propertyName.startsWith("type")){
//		    errors.addError("The property name must start with the prefix 'type'");
//		}
//        if (superName.startsWith("role") && !propertyName.startsWith("role")){
//			errors.addError("The property name must start with the prefix 'role'");
//        }
		if (propertyName.equals("") | propertyName.contains(" ") | !Property.isValidName(propertyName)){
			errors.addError("invalid property name");
		}
		if (construct.getProperty(propertyName)!=null){
			errors.addError("The construct already contains a property with this name");
		}
		if (!errors.isEmpty()){
			JOptionPane.showMessageDialog(this,"Errors:\n"+errors);
			ProblemsScroll.getInstance().logWarning("Check data","Rename Property", "property");
			this.getToolkit().beep();
			reset();
			return;
			// Non viene eseguito this.setVisible(true) quindi il controllo resta sulla Dialog corrente
		}

		Map<String,String> values= new HashMap<String,String>();
			values.put("propertyName",propertyName);
		super.setValues(values);		
		this.setVisible(false);
	}





}