package org.modelgen.jpf.defineModel.Dialog.dialogIMPL;


import org.modelgen.commons.beans.model.Model;
import org.modelgen.facade.GeneralManagementFacade;
import org.modelgen.facade.ResourceFunctions;
import org.modelgen.jpf.core.ToolBoxFrame;
import org.modelgen.jpf.defineModel.Components.ProblemsScroll;
import org.modelgen.jpf.defineModel.Dialog.DMDialog;
import org.modelgen.jpf.defineModel.utility.ErrorTable;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Frame;
import java.awt.GridLayout;
import java.awt.LayoutManager;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.HashMap;
import java.util.Map;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFormattedTextField;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.SwingConstants;

public class SaveModelDialog extends DMDialog implements ActionListener{
	private static final long serialVersionUID = 1L;
	private JFormattedTextField textName = null;
	private JFormattedTextField textShortName = null;
//	private Model model;
	public SaveModelDialog() {
		this(ToolBoxFrame.getIstance(), "Save Model", true);
		
	}

	public SaveModelDialog(Frame owner, String title, boolean modal) {
		super(ToolBoxFrame.getIstance(), title , true);
//		model = ActionUtility.getModel();
		defineStructure(this.getContentPane());
	}

	private void defineStructure(Container contentPane) {
		super.setSize(new Dimension(350,150));
		ImageIcon icon = ResourceFunctions.openImageIcon(this.getClass(), "save.png");
		
		JLabel messageLabel = new JLabel("Model memorization \n          ",icon,SwingConstants.LEFT);
		contentPane.add(BorderLayout.NORTH,messageLabel);



		JPanel infoPanel = new JPanel();
			infoPanel.setLayout(new GridLayout(2,1));
		JPanel firstRow = new JPanel();
		LayoutManager layout = new FlowLayout(FlowLayout.RIGHT,30,0);
			firstRow.setLayout(layout);
		JPanel secondRow = new JPanel();
			secondRow.setLayout(layout);
	
		// Artifici di separazione
		String leftSpace = "           ";
		Dimension textDimension = new Dimension(150,20);
		
		JLabel nameLabel = new JLabel(leftSpace+"Name        ");
		textName = new JFormattedTextField(/*model.getName()*/);
			textName.setPreferredSize(textDimension);
			firstRow.add(nameLabel);
			firstRow.add(textName);
		JLabel shortNameLabel = new JLabel(leftSpace+"Shortname");
		textShortName = new JFormattedTextField(/*model.getShortName()*/);
			textShortName.setPreferredSize(textDimension);
			secondRow.add(shortNameLabel);
			secondRow.add(textShortName);
			
		infoPanel.add(firstRow);
		infoPanel.add(secondRow);

		contentPane.add(BorderLayout.CENTER,infoPanel);		
		


		//Serve a dare lo spazio dal margine sinistro
		contentPane.add(BorderLayout.EAST,new JLabel("  "));
		
		JPanel controlPanel = new JPanel();
			JButton okButton = new JButton("Ok");
				okButton.setActionCommand("commit");
				okButton.addActionListener(this);
			JButton resetButton = new JButton("reset");
//				resetButton.setActionCommand("reset");
				resetButton.addActionListener(this);
			controlPanel.add(okButton);
			controlPanel.add(resetButton);
		contentPane.add(BorderLayout.SOUTH,controlPanel);
		
	}

	public void actionPerformed(ActionEvent ae) {
		JButton actionButton = (JButton) ae.getSource();
		String actionCommand = actionButton.getActionCommand();
		if(actionCommand.equals("commit"))
			commit();
		else
			reset();
		
	}

	private void reset() {
		textName.setText(""/*model.getName()*/);
		textShortName.setText(""/*model.getShortName()*/);		
	}

	private void commit() {
		String modelName = textName.getText();
		String modelShortName = textShortName.getText();
		
		ErrorTable errors = new ErrorTable();

		if (modelName.equals("") | modelName.contains(" ") | !Model.isValidName(modelName)){
			errors.addError("invalid model name");
		}
		if (modelShortName.equals("") | modelShortName.contains(" ") | !Model.isValidShortName(modelShortName) ){
			errors.addError("invalid model shortname");
		}
//		if (InfoServer.getModelByName(modelName)!=null){
//			errors.addError("A model with this name aleady exists");
//		}
		if (GeneralManagementFacade.getInstance().getModelCachedByName(modelName)!=null){
			errors.addError("A model with this name aleady exists");
		}
		if (!errors.isEmpty()){
			JOptionPane.showMessageDialog(this,"Errors:\n"+errors);
			ProblemsScroll.getInstance().logWarning("Check data","Rename Model", "model");
			this.getToolkit().beep();
			reset();
			return;
			// Non viene eseguito this.setVisible(true) quindi il controllo resta sulla Dialog corrente
		}

		Map<String,String> values= new HashMap<String,String>();
			values.put("modelName",modelName);
			values.put("modelShortName",modelShortName);
		super.setValues(values);		
		this.setVisible(false);
	}

}
