package org.modelgen.jpf.defineModel.Tree.ObjectDescription;


import org.modelgen.commons.beans.model.Construct;
import org.modelgen.commons.beans.model.Model;
import org.modelgen.commons.beans.model.Property;
import org.modelgen.commons.beans.model.Reference;
import org.modelgen.facade.GeneralManagementFacade;
import org.modelgen.jpf.defineModel.Tree.WorkSpaceTree;
import org.modelgen.jpf.defineModel.Tree.Popup.PopupListener;

import java.util.LinkedList;
import java.util.List;

import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.MutableTreeNode;
import javax.swing.tree.TreeNode;
import javax.swing.tree.TreePath;
import javax.swing.tree.TreeSelectionModel;


public class TreeContent extends JTree /*implements TreeSelectionListener*/ {
	private static final long serialVersionUID = 6973697478599435970L;

	private static DefaultMutableTreeNode top;
	
	private static List<Model> msList = null;
	
//	private static PersistenceHandler ph=null;
	

	
//	/*Singleton*/
//	private static TreeContent istance;
//	
//	/*Singleton*/
//	public static TreeContent getIstance(){
//		if(istance==null)
//			istance = creaTreeContent();
//		
//	}

	
	public static TreeContent createsTreeContent() {	
		/*Alla prima richiesta di creazione dell'albero viene anche inizializzato il Ph*/
//
//		if(ph==null){
//			SwingUtilities.invokeLater(new Runnable() {
//			     					   public void run() {
////			     						   ph = InfoServer.getPesistenceHadler();
//			     						   ph = DefineModelFacade.getInstance().getPesistenceHadler();
//			     						   System.out.println("PesistenceHadler initialized");
//			     					   }
//									   });
//		}
		
		top = new DefaultMutableTreeNode(new NodeInfo("Models",null));
        try {
			createsNodes();
		} catch (Exception e) {
			/*Vedi gestione del Panel di error in WorkSpaceTree*/
			return null;
		}
		return new TreeContent(top);
	}

	
	/*Private for Singleton*/
	private TreeContent(DefaultMutableTreeNode topAttrib){
		 super(topAttrib);		 
		 /*Init Tree Properties*/
		 getSelectionModel().setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);
		 addMouseListener(new PopupListener());
		 
		 setRowHeight(20);
		 setCellRenderer(DMTreeCellRender.getInstance());
		 
		 /*Path nel tree precedente*/
//		 TreePath lastPath = WorkSpaceTree.getLastSelectedPath();
//		 if (lastPath!=null){
//			 /*getNodePath(lastPath): path nel tree dopo l'aggiornamento*/
////			 expandPath(getExpNodePath(lastPath));
//			 addSelectionPath(getExpNodePath2(lastPath));
//		 }
		 List<TreePath> lastPaths = WorkSpaceTree.getLastExpandedPaths();
		 if (lastPaths!=null){
			 for(TreePath lastPath: lastPaths){ 
				 expandPath(getExpandedNodePath(lastPath));
			 }
		}
		 TreePath lastPath = WorkSpaceTree.getLastSelectedPath();
		 if (lastPath!=null){
			 addSelectionPath(getExpandedNodePath(lastPath));
		 }

	}

	private TreePath getExpandedNodePath(TreePath tp) {
//		System.out.println("-getExpNodePath2");
//		TreePath path = null;
//		JTree tree = WorkSpaceTree.getIstance().getTree();
		TreeNode lastNode = null;
		List<DefaultMutableTreeNode> oldNodes = new LinkedList<DefaultMutableTreeNode>();
			oldNodes.add((DefaultMutableTreeNode) this.getModel().getRoot());
		for(Object newNode: tp.getPath()){
			lastNode = findsNode(oldNodes,(DefaultMutableTreeNode)newNode);
		}
//		String name = ((NodeInfo)((DefaultMutableTreeNode)tp.getLastPathComponent()).getUserObject()).getName();
//		TreeNode node = (TreeNode) tree.getNextMatch(name,0,Position.Bias.Forward).getLastPathComponent();
//		path = new TreePath(((DefaultTreeModel)tree.getModel()).getPathToRoot(node));
//		System.out.println(new TreePath(((DefaultTreeModel)tree.getModel()).getPathToRoot(lastNode)));
		
//		TreeNode[] nodes = ((DefaultTreeModel)tree.getModel()).getPathToRoot(lastNode);
//		int i = 0;
//		TreePath treePath = new TreePath(nodes[i]);
//		i++;
//		while(i<nodes.length){
//			treePath = treePath.pathByAddingChild(nodes[i]);
//			i++;
//		}
//		System.out.println(treePath);
//		return treePath;
		
		/*Controllo dovuto alle operazioni di cancellazione*/

		TreePath treePath = new TreePath(((DefaultTreeModel)this.getModel()).getPathToRoot(lastNode));
//		System.out.println(treePath);	
		return treePath;
		
//		return new TreePath(((DefaultMutableTreeNode)lastNode).getPath());
	}
	
	private TreeNode findsNode(List<DefaultMutableTreeNode> oldNodes, DefaultMutableTreeNode newNode) {
//		System.out.println("-cercaNodo");
		// TODO Auto-generated method stub
		DefaultMutableTreeNode foundNode = null; 
		for(DefaultMutableTreeNode n: oldNodes){
			if(n!=null){ //Controllo dovuto alle cancellazioni
				if(((NodeInfo)n.getUserObject()).getDataObject()==((NodeInfo)newNode.getUserObject()).getDataObject()){
//					System.out.println("--n: "+ ((NodeInfo)n.getUserObject()).getDataObject());
//					System.out.println("--newNode: "+ ((NodeInfo)newNode.getUserObject()).getDataObject());
					foundNode = n;
					break;
				}
			}
		}
		if(foundNode==null){
			oldNodes.clear();
			return top;
		}
//		System.out.println("--Found Node:" + foundNode);
		//Crea la lista dei figli
		LinkedList<DefaultMutableTreeNode> children = new LinkedList<DefaultMutableTreeNode>();
		int i = 0;
		while(i<foundNode.getChildCount()){
			children.add((DefaultMutableTreeNode) foundNode.getChildAt(i));
			i++;
		}
//		System.out.println("*Children size: "+children.size());
//		int oldNodesSize = oldNodes.size();
//	    i = 0;
//		while(i<oldNodesSize){
//			oldNodes.remove(i);
//			System.out.println("size: "+oldNodesSize);
//			System.out.println("I: "+i);
//			i++;
//		}
//		oldNodes.remove(oldNodes);
		oldNodes.clear();
		//Sostituisce alla lista dei vecchi nodi quella dei figli del nodo trovato
		oldNodes.addAll(new LinkedList<DefaultMutableTreeNode>(children));
//		System.out.println("*OldNodes size "+ oldNodes.size());
		return foundNode;
	}


	private static void createsNodes() throws Exception {
		/*Questo controllo avviene alla prima richiesta da parte del WorkSpaceTree per caricare i modelli
		 * dalla base di dati
		 * Nota: nei successivi "refresh" la mappa sar ormai inizializzata e il controllo false
		 * */
//		paoloc 20070328
//		carica sempre da db se necessario
//		if (msList==null) {
//			msList = DefineModelFacade.getInstance().getModels();
//		}
		msList = GeneralManagementFacade.getInstance().getModelsLoaded();
		
//		List<Model> ms = new ArrayList<Model>();
//		ms.addAll(msMap.values());
		
		for(Model m: msList){
//			System.out.println("modello: " + m.getName() + " " + m.getShortName());
			top.add(createsModelNode(m));
		}		
	}

	private static MutableTreeNode createsModelNode(Model m) {
		DefaultMutableTreeNode mNodo = new DefaultMutableTreeNode(new NodeInfo(m.getName(),m));
		
		List<Construct> cs = m.getAbstractConstructs();
//		//---------------------------
//		System.out.println(cs.isEmpty());
//		System.out.println(cs);
////		---------------------------
		if (!cs.isEmpty()){
//		DefaultMutableTreeNode costruttiNodo = new DefaultMutableTreeNode(new NodeInfo("Costrutti",cs));
//		
		for(Construct c:cs){
//			costruttiNodo.add(new DefaultMutableTreeNode(new NodeInfo(c.getName(),c)));
			DefaultMutableTreeNode cNodo = createsConstructNode(c);
			mNodo.add(cNodo);
		}
//		mNodo.add(costruttiNodo);
		}
		return mNodo;
	}


	private static DefaultMutableTreeNode createsConstructNode(Construct c) {
		DefaultMutableTreeNode cNodo = new DefaultMutableTreeNode(new NodeInfo(c.getName(),c));
		List<Property> ps = (List<Property>) c.getProperties();
		if (!ps.isEmpty()){
			for(Property p: ps){
				cNodo.add(new DefaultMutableTreeNode(new NodeInfo(p.getName()+": "+p.getType(),p)));
			}
			
		}
		List<Reference> rs = (List<Reference>) c.getReferences(); 
		if (!rs.isEmpty()){
			for(Reference r: rs){
				cNodo.add(new DefaultMutableTreeNode(new NodeInfo(r.getName()+": "+r.getTypeAsString(),r)));
			}
			
		}
		return cNodo;
	}
}


