package org.modelgen.jpf.defineModel.Tree.Popup;

import org.modelgen.commons.beans.model.Construct;
import org.modelgen.commons.beans.model.Model;
import org.modelgen.commons.persistence.PersistenceException;
import org.modelgen.facade.GeneralManagementFacade;
import org.modelgen.jpf.defineModel.Components.ProblemsScroll;
import org.modelgen.jpf.defineModel.Tree.Popup.PopupActions.ActionUtility;
import org.modelgen.jpf.defineModel.Tree.Popup.PopupActions.AddConstructAction;

import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.Collection;
import java.util.Iterator;

import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;

public class AddConstructPopupListener extends MouseAdapter {
	MouseEvent evt = null;
	
	
    public void mousePressed(MouseEvent e) {
    	evt = e;
        showPopup(e);
    }

    public void mouseReleased(MouseEvent e) {
    	evt = e;
        showPopup(e);
    }

    private void showPopup(MouseEvent e) {
    	
    /*   public boolean isPopupTrigger() Returns whether or not this mouse event is the popup menu trigger event 
    *   for the platform. 
    *   
    *   Note: Popup menus are triggered differently on different systems. Therefore, isPopupTrigger should be 
    *   checked in both mousePressed and mouseReleased for proper cross-platform functionality. 
    *   */   	
    	JPopupMenu popup = null;
//        if (e.isPopupTrigger()) {
        	popup = createPopup(e);
            popup.show(e.getComponent(),e.getX(), e.getY());
//        }
    }


	private JPopupMenu createPopup(MouseEvent e) {
		JPopupMenu popup = new JPopupMenu();
		
		Model model = ActionUtility.getModel();
		
		if (model==null){
//			JOptionPane.showMessageDialog(DefineModelTool.getIstance(),"Select a model", "Selection Warning" ,JOptionPane.WARNING_MESSAGE);
			ProblemsScroll.getInstance().logWarning("Select a model", "Add Construct", "model");
			return popup;
		}
		
//		Model superModel = InfoServer.getSuperModel();
		
//		Commentate da PaoloC 20070306 e rimpiazzate dalla riga seguente
//		Scopo: non fitrare la lista dei costrutti del SM in base a quelli
//		presenti nel modello. Questo perche' costrutti come il Lexical possono
//		essere usati per piu' costrutti per piu' di un costrutto nel modello,
//		es. Lexical puo' essere AttributeOfTypedTable e ColumnOfTable
		Model superModel = null;
		try {
			superModel = GeneralManagementFacade.getInstance().getSuperModel();
//			Collection availableConstructs = model.getAvailableConstructs(superModel);
			Collection<Construct> availableConstructs = superModel.getAbstractConstructs();
			
			Iterator<Construct> it = availableConstructs.iterator();
			Construct construct = null;
			JMenuItem consItem;
			while(it.hasNext()){
				construct = it.next();
				consItem = new JMenuItem(new AddConstructAction(construct,model));
				popup.add(consItem);			
			}
			return popup;
		} catch (PersistenceException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
			return null;
		}
	}

}
