package org.modelgen.jpf.defineModel.Tree.Popup;



import org.modelgen.commons.beans.model.Construct;
import org.modelgen.commons.beans.model.Model;
import org.modelgen.commons.beans.model.Property;
import org.modelgen.jpf.defineModel.Components.ProblemsScroll;
import org.modelgen.jpf.defineModel.Tree.Popup.PopupActions.ActionUtility;
import org.modelgen.jpf.defineModel.Tree.Popup.PopupActions.AddPropertyAction;

import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.Collection;
import java.util.Iterator;

import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;

public class AddPropertyPopupListener extends MouseAdapter {
	MouseEvent evt = null;
	
	
    public void mousePressed(MouseEvent e) {
    	evt = e;
        showPopup(e);
    }

    public void mouseReleased(MouseEvent e) {
    	evt = e;
        showPopup(e);
    }

    private void showPopup(MouseEvent e) {
    	
    /*   public boolean isPopupTrigger() Returns whether or not this mouse event is the popup menu trigger event 
    *   for the platform. 
    *   
    *   Note: Popup menus are triggered differently on different systems. Therefore, isPopupTrigger should be 
    *   checked in both mousePressed and mouseReleased for proper cross-platform functionality. 
    *   */   	
    	JPopupMenu popup = null;
//        if (e.isPopupTrigger()) {
        	popup = createPopup(e);
            popup.show(e.getComponent(),e.getX(), e.getY());
//        }
    }


	private JPopupMenu createPopup(MouseEvent e) {
		JPopupMenu popup = new JPopupMenu();
		
		Construct construct = ActionUtility.getConstruct();

		if (construct==null){
//			JOptionPane.showMessageDialog(DefineModelTool.getIstance(),"Select a construct", "Selection Warning" ,JOptionPane.WARNING_MESSAGE);
			ProblemsScroll.getInstance().logWarning("Select a construct", "Add Property", "construct");
			return popup;
		}
		
		Iterator<Property> it = null;
		
		
		Model model = ActionUtility.getConstructModel(); 
		Collection<Property> availableProperties = model.getAvailableProperties(construct);

		if (!availableProperties.isEmpty()){
			it = availableProperties.iterator();
			while(it.hasNext()){
				Property prop = it.next();
				JMenuItem propItem = new JMenuItem(new AddPropertyAction(construct,prop));
				popup.add(propItem);
			}
		}
		return popup;
	}

}