package org.modelgen.jpf.defineModel.Tree.Popup.PopupActions;



import org.modelgen.commons.beans.model.Construct;
import org.modelgen.commons.beans.model.Model;
import org.modelgen.commons.beans.model.Property;
import org.modelgen.commons.beans.model.Reference;
import org.modelgen.jpf.defineModel.Components.ProblemsScroll;
import org.modelgen.jpf.defineModel.Tree.WorkSpaceTree;
import org.modelgen.jpf.defineModel.Tree.ObjectDescription.NodeInfo;
import org.modelgen.jpf.defineModel.Tree.ObjectDescription.TreeContent;

import javax.swing.Action;
import javax.swing.tree.DefaultMutableTreeNode;



public class ActionUtility {
//	public static WorkSpaceTree getWorkSpaceTree(ActionEvent arg0){
//	TreeContent tree = getTreeContent(arg0);
//	JViewport viewPort = (JViewport) tree.getParent();
//	WorkSpaceTree scroll = (WorkSpaceTree)(viewPort.getParent());

//	return scroll;
//	}
//	public static TreeContent getTreeContent(ActionEvent arg0){
//	Component item = (Component)(arg0.getSource());
//	JPopupMenu popup = (JPopupMenu)(item.getParent());
//	TreeContent tree = (TreeContent)(popup.getInvoker());

//	return tree;
//	}

	public static DefaultMutableTreeNode getNode(boolean message){
		TreeContent tree = WorkSpaceTree.getIstance().getTree();
		DefaultMutableTreeNode node = (DefaultMutableTreeNode) tree.getLastSelectedPathComponent();
		// Se message  uguale a true, visualizza la jdialog
		if (node==null && message==true){
//			JOptionPane.showMessageDialog(DefineModelTool.getIstance(),"Nessun elemento selezionato", "Selection Warning" ,JOptionPane.WARNING_MESSAGE);
			ProblemsScroll.getInstance().logWarning("Select a component",Action.NAME , "");
		}
		return node;
	}

	public static NodeInfo getNodeInfo(){
		DefaultMutableTreeNode node = getNode(true);
		NodeInfo nodeInfo = null;
		if (node!=null)
			nodeInfo = (NodeInfo) node.getUserObject();
		return nodeInfo;
	}

	public static NodeInfo getNodeInfo(DefaultMutableTreeNode node){
		NodeInfo nodeInfo = null;
		if (node!=null)
			nodeInfo = (NodeInfo) node.getUserObject();
		return nodeInfo;
	}

//	public static NodeInfo getNodeInfo(DefaultMutableTreeNode node){
//	NodeInfo nodeInfo = null;
//	if (node!=null)
//	nodeInfo = (NodeInfo) node.getUserObject();
//	return nodeInfo;
//	}

	public static Model getModel(){
		/**************************************************/

		/**Prima richiama getNode()=> se non ci sono nodi selezionati visualizza un jdialog che
		 * informa dell'assenza di un nodo selezionato.
		 * Node info  null se non ci sono nodi selezionati o se non ci sono info associate a tale
		 * nodo, cosa peraltro non presente nell'implementazione attuale */
		NodeInfo nodeInfo = ActionUtility.getNodeInfo();

		Model model = null;		

		/**getModel restituisce null se, pur essendo associato un nodeIndo al nodo tale oggetto non
		 *  un modello */
		if (nodeInfo!=null){
			model = nodeInfo.getModel();
		}
		/**************************************************/
		return model;
	}

	public static Construct getConstruct(){
		/**************************************************/

		/**Prima richiama getNode()=> se non ci sono nodi selezionati visualizza un jdialog che
		 * informa dell'assenza di un nodo selezionato.
		 * Node info  null se non ci sono nodi selezionati o se non ci sono info associate a tale
		 * nodo, cosa peraltro non presente nell'implementazione attuale */
		NodeInfo nodeInfo = ActionUtility.getNodeInfo();

		Construct construct = null;		

		/**getModel restituisce null se, pur essendo associato un nodeIndo al nodo tale oggetto non
		 *  un modello */
		if (nodeInfo!=null){
			construct = nodeInfo.getConstruct();
		}
		/**************************************************/
		return construct;
	}

	public static Property getProperty(){
		/**************************************************/

		/**Prima richiama getNode()=> se non ci sono nodi selezionati visualizza un jdialog che
		 * informa dell'assenza di un nodo selezionato.
		 * Node info  null se non ci sono nodi selezionati o se non ci sono info associate a tale
		 * nodo, cosa peraltro non presente nell'implementazione attuale */
		NodeInfo nodeInfo = ActionUtility.getNodeInfo();

		Property property = null;		

		/**getModel restituisce null se, pur essendo associato un nodeIndo al nodo tale oggetto non
		 *  un modello */
		if (nodeInfo!=null){
			property = nodeInfo.getProperty();
		}
		/**************************************************/
		return property;
	}

	public static Model getConstructModel(){
		/**************************************************/

		/**Prima richiama getNode()=> se non ci sono nodi selezionati visualizza un jdialog che
		 * informa dell'assenza di un nodo selezionato.
		 * Node info  null se non ci sono nodi selezionati o se non ci sono info associate a tale
		 * nodo, cosa peraltro non presente nell'implementazione attuale */
		DefaultMutableTreeNode modelNode = (DefaultMutableTreeNode) ActionUtility.getNode(false).getParent();

		NodeInfo nodeInfo = ActionUtility.getNodeInfo(modelNode);

		Model model = null;		

		/**getModel restituisce null se, pur essendo associato un nodeIndo al nodo tale oggetto non
		 *  un modello */
		if (nodeInfo!=null){
			model = nodeInfo.getModel();
		}
		/**************************************************/
		return model;
	}

	public static Construct getPropertyConstruct(){
		/**************************************************/

		/**Prima richiama getNode()=> se non ci sono nodi selezionati visualizza un jdialog che
		 * informa dell'assenza di un nodo selezionato.
		 * Node info  null se non ci sono nodi selezionati o se non ci sono info associate a tale
		 * nodo, cosa peraltro non presente nell'implementazione attuale */
		DefaultMutableTreeNode modelNode = (DefaultMutableTreeNode) ActionUtility.getNode(false).getParent();

		NodeInfo nodeInfo = ActionUtility.getNodeInfo(modelNode);

		Construct construct = null;		

		/**getModel restituisce null se, pur essendo associato un nodeIndo al nodo tale oggetto non
		 *  un modello */
		if (nodeInfo!=null){
			construct = nodeInfo.getConstruct();
		}
		/**************************************************/
		return construct;
	}
	
	public static Model getPropertyModel(){
		DefaultMutableTreeNode modelNode = (DefaultMutableTreeNode) ActionUtility.getNode(false).getParent().getParent();

		NodeInfo nodeInfo = ActionUtility.getNodeInfo(modelNode);

		Model model = null;		

		/**getModel restituisce null se, pur essendo associato un nodeIndo al nodo tale oggetto non
		 *  un modello */
		if (nodeInfo!=null){
			model = nodeInfo.getModel();
		}
		/**************************************************/
		return model;
	}

	public static Reference getReference() {
		/**************************************************/

		/**Prima richiama getNode()=> se non ci sono nodi selezionati visualizza un jdialog che
		 * informa dell'assenza di un nodo selezionato.
		 * Node info  null se non ci sono nodi selezionati o se non ci sono info associate a tale
		 * nodo, cosa peraltro non presente nell'implementazione attuale */
		NodeInfo nodeInfo = ActionUtility.getNodeInfo();

		Reference reference = null;		

		/**getModel restituisce null se, pur essendo associato un nodeIndo al nodo tale oggetto non
		 *  un modello */
		if (nodeInfo!=null){
			reference = nodeInfo.getReference();
		}
		/**************************************************/
		return reference;
	}



}
