package org.modelgen.jpf.defineModel.Tree.Popup.PopupActions;

import org.modelgen.commons.beans.model.Construct;
import org.modelgen.commons.beans.model.Property;
import org.modelgen.facade.GeneralManagementFacade;
import org.modelgen.jpf.defineModel.Components.ConsoleScroll;
import org.modelgen.jpf.defineModel.Components.ProblemsScroll;
import org.modelgen.jpf.defineModel.Dialog.DMDialog;
import org.modelgen.jpf.defineModel.Dialog.DMOptionPane;
import org.modelgen.jpf.defineModel.Dialog.dialogIMPL.AddPropertyDialog;

import java.awt.event.ActionEvent;
import java.util.Map;

import javax.swing.AbstractAction;
import javax.swing.Action;

public class AddPropertyAction extends AbstractAction {
	private static final long serialVersionUID = 1L;

	private Construct construct;
	private Property superProperty;
	
	public AddPropertyAction(Construct cons,Property superProp){
		construct = cons;
		superProperty = superProp;
		putValue(Action.NAME,superProp.getName()+": "+superProp.getType());
	}

	
	public void actionPerformed(ActionEvent arg0) {
		ConsoleScroll.getInstance().logTask("Adding new property",Action.NAME,"construct");
		DMDialog addPropertyDialog = new AddPropertyDialog(superProperty);
		Map<String,String> values = (new DMOptionPane()).showInputDialog(addPropertyDialog);
		if(values==null){
//			//Se la Dialag viene chiusa
//			JOptionPane.showMessageDialog(DefineModelTool.getIstance(),"Non  stata definita alcuna propriet");
			ProblemsScroll.getInstance().logWarning("Select a property",Action.NAME , "property");
			return;
		}
		String propertyName = values.get("propertyName");
		
		//rimuovo tutte le signature e i vincoli e poi aggiungo la propriet
		GeneralManagementFacade.getInstance().removeBondToConstruct(construct);
		GeneralManagementFacade.getInstance().removeSignatureToConstruct(construct);
		GeneralManagementFacade.getInstance().addPropertyToConstruct(construct,propertyName,superProperty);
				

		RefreshAction.getIstance().actionPerformed(arg0);	
		
//		JOptionPane.showMessageDialog(DefineModelTool.getIstance(),"Property correctly added","Add Property", JOptionPane.INFORMATION_MESSAGE);
		ConsoleScroll.getInstance().logInformation("Property added: [Name: "+propertyName+ ", Mapping: "+superProperty.getName()+", Type: "+superProperty.getType()+"]",Action.NAME,"construct");
	}

}