package org.modelgen.jpf.defineModel.Tree.Popup.PopupActions;

import org.modelgen.commons.beans.model.Model;
import org.modelgen.facade.GeneralManagementFacade;
import org.modelgen.facade.ResourceFunctions;
import org.modelgen.jpf.defineModel.Components.ConsoleScroll;
import org.modelgen.jpf.defineModel.Components.ProblemsScroll;
import org.modelgen.jpf.defineModel.Dialog.DMDialog;
import org.modelgen.jpf.defineModel.Dialog.DMOptionPane;
import org.modelgen.jpf.defineModel.Dialog.dialogIMPL.NewModelDialog;

import java.awt.event.ActionEvent;
import java.util.Map;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.ImageIcon;

public class CloneModelAction extends AbstractAction {
	private static final long serialVersionUID = 9017120228680228529L;

	public static final String ACTION_NAME = "Clone Model";

	private static CloneModelAction istance;
	
	private CloneModelAction(){
		putValue(Action.SHORT_DESCRIPTION,ACTION_NAME);
		ImageIcon imageIcon = ResourceFunctions.openImageIcon(this.getClass(), "saveAll.png");
		putValue(Action.SMALL_ICON,imageIcon);
	}
	
	public static CloneModelAction getIstance(){
		if(istance == null)
			istance = new CloneModelAction();
		return istance;
	}

	
	public void actionPerformed(ActionEvent arg0) {
		ConsoleScroll.getInstance().logTask("Cloning an existing model model",Action.NAME,"workspace");
		
		Model model = ActionUtility.getModel();

		if (model==null){
			ProblemsScroll.getInstance().logWarning("Select a model",Action.NAME , "workspace");
			return;
		}
		
		DMDialog newModelDialog = new NewModelDialog();
		Map<String,String> values = (new DMOptionPane()).showInputDialog(newModelDialog);
		if(values==null){
			return;
		}
		
		String modelName = values.get("modelName");
		String modelShortName = values.get("modelShortName");
		

		boolean created = GeneralManagementFacade.getInstance().cloneModel(model, modelName, modelShortName);
			
		/*Performs RefreshAction*/
		RefreshAction.getIstance().actionPerformed(arg0);	
		if(created==true){
			ConsoleScroll.getInstance().logInformation("Model cloned: [Name: "+modelName+ ", ShortName:"+modelShortName+"]",Action.NAME,"workspace");
		}
		else{
			ProblemsScroll.getInstance().logError("Errors cloning model: [Name: "+modelName+ ", ShortName:"+modelShortName+"]",Action.NAME,"workspace");
		}
	}

}
