package org.modelgen.jpf.defineModel.Tree.Popup.PopupActions;

import org.modelgen.commons.beans.model.Construct;
import org.modelgen.facade.GeneralManagementFacade;
import org.modelgen.facade.ResourceFunctions;
import org.modelgen.jpf.defineModel.Components.ConsoleScroll;
import org.modelgen.jpf.defineModel.Components.ProblemsScroll;
import org.modelgen.jpf.defineModel.Dialog.DMDialog;
import org.modelgen.jpf.defineModel.Dialog.DMOptionPane;
import org.modelgen.jpf.defineModel.Dialog.dialogIMPL.CreateBondDialog;
import org.modelgen.signature.util.ToolTableaux;

import java.awt.event.ActionEvent;
import java.util.Map;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.ImageIcon;

public class CreateBondAction extends AbstractAction {
	private static final long serialVersionUID = 1L;

	public static final String ACTION_NAME = "View/Add Bonds";

	private static CreateBondAction istance;

	public static CreateBondAction getIstance(){
		if(istance == null)
			istance = new CreateBondAction();
		return istance;
	}	

	private CreateBondAction(){
		putValue(Action.SHORT_DESCRIPTION,ACTION_NAME);
		ImageIcon imageIcon = ResourceFunctions.openImageIcon(this.getClass(), "addBond.gif");
		putValue(Action.SMALL_ICON,imageIcon);
	}

	public void actionPerformed(ActionEvent arg0) {
		ConsoleScroll.getInstance().logTask("Create bonds",Action.NAME,"bond");

		Construct construct = ActionUtility.getConstruct();
		if (construct==null){
//			JOptionPane.showMessageDialog(DefineModelTool.getIstance(),"Per eseguire l'operazione richiesta occorre selezionare una propriet", "Selection Warning" ,JOptionPane.WARNING_MESSAGE);
			ProblemsScroll.getInstance().logWarning("Select a construct",Action.NAME , "workspace");
			return;
		}

		DMDialog createBondDialog = new CreateBondDialog(construct);
		Map<String,String> values = (new DMOptionPane()).showInputDialog(createBondDialog);
		if(values==null){
			return;
		}

		//semplifico la signature e i bonds estratti
		ToolTableaux tableau = new ToolTableaux(values.get("signature"));
		String fndSignature = tableau.formaNormDisgiuntiva();
		tableau = new ToolTableaux(values.get("bond"));
		String fndBonds = tableau.formaNormDisgiuntiva();

		GeneralManagementFacade.getInstance().addBondToConstruct(construct,fndBonds);
		GeneralManagementFacade.getInstance().addSignatureToConstruct(construct,fndSignature);


		RefreshAction.getIstance().actionPerformed(arg0);	

		if(values.get("bond")!=null)
			ConsoleScroll.getInstance().logInformation("Bond crated: [Name: "+values.get("bond")+"]",Action.NAME,"property");
		else
			ConsoleScroll.getInstance().logInformation("Bonds viewed ",Action.NAME,"property");
	}



}
