package org.modelgen.jpf.defineModel.Tree.Popup.PopupActions;

import org.modelgen.commons.beans.model.Construct;
import org.modelgen.facade.GeneralManagementFacade;
import org.modelgen.facade.ResourceFunctions;
import org.modelgen.jpf.core.ToolBoxFrame;
import org.modelgen.jpf.defineModel.Components.ConsoleScroll;
import org.modelgen.jpf.defineModel.Components.ProblemsScroll;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.ImageIcon;
import javax.swing.JOptionPane;

public class DeleteBondAction extends AbstractAction{


	private static final long serialVersionUID = 7757365662347800599L;
	public static final String ACTION_NAME = "Delete Bonds";
	private static DeleteBondAction istance;

	public static DeleteBondAction getIstance(){
		if(istance == null)
			istance = new DeleteBondAction();
		return istance;
	}	

	private DeleteBondAction(){
		putValue(Action.SHORT_DESCRIPTION,ACTION_NAME);
		ImageIcon imageIcon = ResourceFunctions.openImageIcon(this.getClass(), "deleteBond.gif");
		putValue(Action.SMALL_ICON,imageIcon);
	}

	public void actionPerformed(ActionEvent arg0) {
		ConsoleScroll.getInstance().logTask("Create bonds",Action.NAME,"bond");

		Construct construct = ActionUtility.getConstruct();
		if (construct==null){
//			JOptionPane.showMessageDialog(DefineModelTool.getIstance(),"Per eseguire l'operazione richiesta occorre selezionare una propriet", "Selection Warning" ,JOptionPane.WARNING_MESSAGE);
			ProblemsScroll.getInstance().logWarning("Select a construct",Action.NAME , "workspace");
			return;
		}

		int n = JOptionPane.showConfirmDialog(
				ToolBoxFrame.getIstance(),
				"Would you like to delete all bonds of the selected construct?",
				"Deletion confirm",
				JOptionPane.YES_NO_OPTION);

		if (n==JOptionPane.YES_OPTION){                      	
			GeneralManagementFacade.getInstance().removeBondToConstruct(construct);
			GeneralManagementFacade.getInstance().removeSignatureToConstruct(construct);

			/*Performs RefreshAction*/
			RefreshAction.getIstance().actionPerformed(arg0);	

		}else{
			ConsoleScroll.getInstance().logInformation("Bond deletion aborted",Action.NAME,"construct");
		}
	}

}
