package org.modelgen.jpf.defineModel.Tree.Popup.PopupActions;

import org.modelgen.commons.beans.model.Construct;
import org.modelgen.commons.beans.model.Model;
import org.modelgen.facade.GeneralManagementFacade;
import org.modelgen.facade.ResourceFunctions;
import org.modelgen.jpf.core.ToolBoxFrame;
import org.modelgen.jpf.defineModel.Components.ConsoleScroll;
import org.modelgen.jpf.defineModel.Components.ProblemsScroll;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.ImageIcon;
import javax.swing.JOptionPane;

public class DeleteConstructAction  extends AbstractAction {
	private static final long serialVersionUID = 1L;

	public static final String ACTION_NAME = "Delete Construct";
	
	private static DeleteConstructAction istance;
	
	public static DeleteConstructAction getIstance(){
		if(istance == null)
			istance = new DeleteConstructAction();
		return istance;
	}	
	
	
	private DeleteConstructAction(){
		putValue(Action.SHORT_DESCRIPTION,ACTION_NAME);
		ImageIcon imageIcon = ResourceFunctions.openImageIcon(this.getClass(), "deleteConstruct.gif");
		putValue(Action.SMALL_ICON,imageIcon);
	}
	


	
	public void actionPerformed(ActionEvent arg0) {
		ConsoleScroll.getInstance().logTask("Deleting construct",Action.NAME,"construct");
		
		Construct construct = ActionUtility.getConstruct();
		
		
		if (construct==null){
//			JOptionPane.showMessageDialog(DefineModelTool.getIstance(),"Per eseguire l'operazione richiesta occorre selezionare un costrutto", "Selection Warning" ,JOptionPane.WARNING_MESSAGE);
			ProblemsScroll.getInstance().logWarning("Select a construct",Action.NAME , "workspace");
			return;
		}
		
		Model model = ActionUtility.getConstructModel();
		
		int n = JOptionPane.showConfirmDialog(
			    ToolBoxFrame.getIstance(),
			    "Would you like to delete the selected construct?",
			    "Deletion confirm",
			    JOptionPane.YES_NO_OPTION);


		if(n==JOptionPane.YES_OPTION){
//			InfoServer.deleteConstructFromModel(construct,model);
			GeneralManagementFacade.getInstance().deleteConstructFromModel(construct,model);
			
			/*Performs RefreshAction*/
			RefreshAction.getIstance().actionPerformed(arg0);	
			
	//		JOptionPane.showMessageDialog(DefineModelTool.getIstance(),"L'eliminazione del costrutto  avvenuta correttamente", "Construct Deleted" ,JOptionPane.INFORMATION_MESSAGE);
			
			ConsoleScroll.getInstance().logInformation("Construct deleted: [Name: "+construct.getName()+ ", Model:"+model.getName()+"]",Action.NAME,"construct");
	//		if(deleteExc==null)
	//			JOptionPane.showMessageDialog(DefineModelTool.getIstance(),"L'eliminazione del modello  avvenuta correttamente", "Model Deleted" ,JOptionPane.INFORMATION_MESSAGE);
	//		else
	//			JOptionPane.showMessageDialog(DefineModelTool.getIstance(),"Si  verificato un errore nella cancellazione del modello \n Error: "+ deleteExc.getMessage(), "Errore" ,JOptionPane.ERROR_MESSAGE);			
			
	//		/** Dopo l'esecuzione dell'operazione non c' un nodo selezionato percui
	//		 * l'azione deve essere disabilitata
	//		 */
	//		this.setEnabled(false);
		}else{
			ConsoleScroll.getInstance().logInformation("Construct deletion aborted",Action.NAME,"construct");
		}
	}

}
	
