package org.modelgen.jpf.defineModel.Tree.Popup.PopupActions;



import org.modelgen.commons.beans.model.Model;
import org.modelgen.commons.persistence.PersistenceException;
import org.modelgen.facade.GeneralManagementFacade;
import org.modelgen.facade.ResourceFunctions;
import org.modelgen.jpf.core.ToolBoxFrame;
import org.modelgen.jpf.defineModel.Components.ConsoleScroll;
import org.modelgen.jpf.defineModel.Components.ProblemsScroll;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.ImageIcon;
import javax.swing.JOptionPane;



public class DeleteModelAction extends AbstractAction {
	private static final long serialVersionUID = 1L;
	
	public static final String ACTION_NAME = "Delete Model";
	
	private static DeleteModelAction istance;
	
	public static DeleteModelAction getIstance(){
		if(istance == null)
			istance = new DeleteModelAction();
		return istance;
	}	
	
	
	private DeleteModelAction(){
		putValue(Action.SHORT_DESCRIPTION,ACTION_NAME);
		ImageIcon imageIcon = ResourceFunctions.openImageIcon(this.getClass(), "delete.gif");
		putValue(Action.SMALL_ICON,imageIcon);
	}
	


	
	public void actionPerformed(ActionEvent arg0) {
		ConsoleScroll.getInstance().logTask("Deleting model",Action.NAME,"model");
		Model model = ActionUtility.getModel();
		
		if (model==null){
			ProblemsScroll.getInstance().logWarning("Select a model",Action.NAME , "workspace");
			return;
		}
		
		int n = JOptionPane.showConfirmDialog(
			    ToolBoxFrame.getIstance(),
			    "Would you like to delete the selected model?",
			    "Deletion confirm",
			    JOptionPane.YES_NO_OPTION);
		
		if (n==JOptionPane.YES_OPTION){                      	
			try {
				GeneralManagementFacade.getInstance().deleteModel(model);
				ConsoleScroll.getInstance().logInformation("Model deleted: [Name: "+model.getName()+ ", ShortName:"+model.getShortName()+"]",Action.NAME,"model");
			} catch (PersistenceException e) {
				ProblemsScroll.getInstance().logError("Errors deleting model: [Name: "+model.getName()+ ", ShortName:"+model.getShortName()+", Error: "+e.getMessage()+"]",Action.NAME,"model");
			}
				
			/*Performs RefreshAction*/
			RefreshAction.getIstance().actionPerformed(arg0);	
		
		}else{
			ConsoleScroll.getInstance().logInformation("Model deletion aborted",Action.NAME,"model");
		}
	}

}
