package org.modelgen.jpf.defineModel.Tree.Popup.PopupActions;

import org.modelgen.commons.beans.model.Construct;
import org.modelgen.commons.beans.model.Property;
import org.modelgen.facade.GeneralManagementFacade;
import org.modelgen.facade.ResourceFunctions;
import org.modelgen.jpf.core.ToolBoxFrame;
import org.modelgen.jpf.defineModel.Components.ConsoleScroll;
import org.modelgen.jpf.defineModel.Components.ProblemsScroll;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.ImageIcon;
import javax.swing.JOptionPane;

public class DeletePropertyAction  extends AbstractAction {
	private static final long serialVersionUID = 1L;
	
	public static final String ACTION_NAME = "Delete Property";
	
	private static DeletePropertyAction istance;
	
	public static DeletePropertyAction getIstance(){
		if(istance == null)
			istance = new DeletePropertyAction();
		return istance;
	}	
	
	
	private DeletePropertyAction(){
		putValue(Action.SHORT_DESCRIPTION,ACTION_NAME);
		ImageIcon imageIcon = ResourceFunctions.openImageIcon(this.getClass(), "deleteProperty.gif");
		putValue(Action.SMALL_ICON,imageIcon);
	}
	


	
	public void actionPerformed(ActionEvent arg0) {
		ConsoleScroll.getInstance().logTask("Deleting property",Action.NAME,"property");
		Property property = ActionUtility.getProperty();
		
		
		if (property==null){
//			JOptionPane.showMessageDialog(DefineModelTool.getIstance(),"Per eseguire l'operazione richiesta occorre selezionare una propriet", "Selection Warning" ,JOptionPane.WARNING_MESSAGE);
			ProblemsScroll.getInstance().logWarning("Select a property",Action.NAME , "workspace");
			return;
		}
		int n = JOptionPane.showConfirmDialog(
			    ToolBoxFrame.getIstance(),
			    "Would you like to delete the selected property?",
			    "Deletion confirm",
			    JOptionPane.YES_NO_OPTION);
		if (n==JOptionPane.YES_OPTION){		
			Construct construct = property.getOwnerConstruct();
	
			//rimuovo tutte le signature e i vincoli e poi aggiungo la propriet
			GeneralManagementFacade.getInstance().removeBondToConstruct(construct);
			GeneralManagementFacade.getInstance().removeSignatureToConstruct(construct);
			// Semplice istruzione di rimozione
			construct.removeProperty(property);
			
			/*Performs RefreshAction*/
			RefreshAction.getIstance().actionPerformed(arg0);	
			
	//		JOptionPane.showMessageDialog(DefineModelTool.getIstance(),"L'eliminazione della propriet  avvenuta correttamente", "Property Deleted" ,JOptionPane.INFORMATION_MESSAGE);
			ConsoleScroll.getInstance().logInformation("Property deleted: [Name: "+property.getName()+ ", Mapping:"+property.getMetaInfo().getName()+", Type: "+property.getType()+"]",Action.NAME,"property");
	////		if(deleteExc==null)
	////			JOptionPane.showMessageDialog(DefineModelTool.getIstance(),"L'eliminazione del modello  avvenuta correttamente", "Model Deleted" ,JOptionPane.INFORMATION_MESSAGE);
	////		else
	////			JOptionPane.showMessageDialog(DefineModelTool.getIstance(),"Si  verificato un errore nella cancellazione del modello \n Error: "+ deleteExc.getMessage(), "Errore" ,JOptionPane.ERROR_MESSAGE);			
		}else{
			ConsoleScroll.getInstance().logInformation("Property deletion aborted",Action.NAME,"property");

		}
	}
}