package org.modelgen.jpf.defineModel.Tree.Popup.PopupActions;

import org.modelgen.commons.beans.model.Model;
import org.modelgen.commons.persistence.xml.Exporter;
import org.modelgen.facade.GeneralManagementFacade;
import org.modelgen.facade.ResourceFunctions;
import org.modelgen.jpf.defineModel.Components.ConsoleScroll;
import org.modelgen.jpf.defineModel.Components.ProblemsScroll;
import org.modelgen.jpf.defineModel.Dialog.DMDialog;
import org.modelgen.jpf.defineModel.Dialog.DMOptionPane;
import org.modelgen.jpf.defineModel.Dialog.dialogIMPL.ExportModelDialog;

import java.awt.event.ActionEvent;
import java.io.File;
import java.util.Map;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.ImageIcon;

public class ExportModelAction extends AbstractAction {
	private static final long serialVersionUID = 1L;
	
	public static final String ACTION_NAME = "Export Model";

	private static final String FLATMODE = "flat";
	
	private static ExportModelAction istance;
	

	
	public static ExportModelAction getIstance(){
		if(istance == null){
			istance = new ExportModelAction();
		}
		return istance;
	}	
	


	private ExportModelAction(){
		putValue(Action.SHORT_DESCRIPTION,ACTION_NAME);
		ImageIcon imageIcon = ResourceFunctions.openImageIcon(this.getClass(), "export.gif");
		putValue(Action.SMALL_ICON,imageIcon);
	}
	


	
	public void actionPerformed(ActionEvent arg0) {
		ConsoleScroll.getInstance().logTask("Exporting model",Action.NAME,"model");
		Model exportingModel = ActionUtility.getModel();
		
		if (exportingModel==null){
			ProblemsScroll.getInstance().logWarning("Select a model",Action.NAME , "workspace");
			return;
		}
		
		DMDialog exportModelDialog = new ExportModelDialog();
		Map<String,String> values = (new DMOptionPane()).showInputDialog(exportModelDialog);
		if(values==null){
			return;
		}
		
		
		File file = new File(values.get("xmlFile"));
		String exportMode = values.get("exportMode");
		

		 try {
					
		 String xmlModel;
		 
	     if (exportMode.equals(FLATMODE))
	    	xmlModel = Exporter.model2XML(exportingModel);
	     else
	    	xmlModel = Exporter.model2NestedXML(exportingModel);

	     GeneralManagementFacade.getInstance().exportModel(file,xmlModel);
	
		 RefreshAction.getIstance().actionPerformed(arg0);
		 
		 ConsoleScroll.getInstance().logInformation("Model exported: [Method: "+exportMode+", Name: "+exportingModel.getName()+ ", ShortName:"+exportingModel.getShortName()+"]",Action.NAME,"model");
		 }catch (Exception exception) {
			 ProblemsScroll.getInstance().logError("Errors exporting model: [Method: "+exportMode+ ", Error:"+exception.getMessage()+"]",Action.NAME,"model");
		 }	

	
			
	}

}