package org.modelgen.jpf.defineModel.Tree.Popup.PopupActions;

import org.modelgen.facade.GeneralManagementFacade;
import org.modelgen.facade.ResourceFunctions;
import org.modelgen.jpf.defineModel.Components.ConsoleScroll;
import org.modelgen.jpf.defineModel.Components.ProblemsScroll;
import org.modelgen.jpf.defineModel.Dialog.DMDialog;
import org.modelgen.jpf.defineModel.Dialog.DMOptionPane;
import org.modelgen.jpf.defineModel.Dialog.dialogIMPL.ImportModelDialog;

import java.awt.event.ActionEvent;
import java.io.File;
import java.util.Map;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.ImageIcon;

public class ImportModelAction extends AbstractAction{
	private static final long serialVersionUID = 1L;
	
	public static final String ACTION_NAME = "Import Model";

//	private static final String FLATMODE = "flat";
	
	private static ImportModelAction istance;

	
	private File file;
	private String importMode;
	
	public static ImportModelAction getIstance(){
		if(istance == null){
			istance = new ImportModelAction();
		}
		return istance;
	}	
	


	private ImportModelAction(){
		putValue(Action.SHORT_DESCRIPTION,ACTION_NAME);
		ImageIcon imageIcon = ResourceFunctions.openImageIcon(this.getClass(), "import.gif");
		putValue(Action.SMALL_ICON,imageIcon);
	}
	


	
	public void actionPerformed(ActionEvent arg0) {
		ConsoleScroll.getInstance().logTask("Importing model",Action.NAME,"workspace");
		DMDialog importModelDialog = new ImportModelDialog();
		Map<String,String> values = (new DMOptionPane()).showInputDialog(importModelDialog);
		if(values==null){
			//Se la Dialag viene chiusa
//			JOptionPane.showMessageDialog(DefineModelTool.getIstance(),"Non  stato creato alcun modello");
			return;
		}
		
		
		file = new File(values.get("xmlFile"));
		importMode = values.get("importMode");
		String fileName = file.getAbsolutePath();
		
		 try {
		 
			 /**Aggiornamento lista modelli*/
			 /*boolean imported = */GeneralManagementFacade.getInstance().importedModel(fileName,importMode);
			 /*******************************/
			 
			 RefreshAction.getIstance().actionPerformed(arg0);
			 
			 ConsoleScroll.getInstance().logInformation("Model imported: [Method: "+importMode+", File: "+fileName+"]",Action.NAME,"workspace");				
		 } catch (Exception exception) {
			 exception.printStackTrace();
			 ProblemsScroll.getInstance().logWarning("Errors importing model: [Method: "+importMode+ ", File:"+fileName+", Error: "+exception.getMessage()+"]",Action.NAME,"workspace");
		 }	
		 
	
	}



}
