package org.modelgen.jpf.defineModel.Tree.Popup.PopupActions;

import org.modelgen.commons.beans.model.Model;
import org.modelgen.facade.ResourceFunctions;
import org.modelgen.jpf.defineModel.DefineModelTool;
import org.modelgen.jpf.defineModel.Components.ModelReport;
import org.modelgen.jpf.defineModel.Components.ProblemsScroll;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.ImageIcon;
import javax.swing.JTabbedPane;

public class ModelReportAction extends AbstractAction {
	private static final long serialVersionUID = 1L;

	public static final String ACTION_NAME = "Model Report";
	
	private static ModelReportAction istance;
	
	public static ModelReportAction getIstance(){
		if(istance == null)
			istance = new ModelReportAction();
		return istance;
	}	
	
	private ModelReportAction(){
		putValue(Action.SHORT_DESCRIPTION,ACTION_NAME);
		ImageIcon imageIcon = ResourceFunctions.openImageIcon(this.getClass(), "report.gif");
		putValue(Action.SMALL_ICON,imageIcon);
	}

	
	public void actionPerformed(ActionEvent arg0) {
		Model model = ActionUtility.getModel();
		
		if (model==null){
//			JOptionPane.showMessageDialog(DefineModelTool.getIstance(),"Per eseguire l'operazione richiesta occorre selezionare un modello", "Selection Warning" ,JOptionPane.WARNING_MESSAGE);
			ProblemsScroll.getInstance().logWarning("Select a model",Action.NAME , "");
			return;
		}
		
		
		JTabbedPane reportsTab = DefineModelTool.getReportsTab();
		ModelReport scroll = ModelReport.getInstance(model);
		
		//Scroll==null se il report del modello  gia presente tra i tab o se  stato cancellato e si vuole riaprirlo
		if (scroll.isNew()){
			reportsTab.addTab(model.getName(), ResourceFunctions.openImageIcon(this.getClass(), "littleReport.gif"),scroll,"Model Report");
		}
		reportsTab.setSelectedComponent(scroll);
		
		
		
//		DMDialog renameModelDialog = new RenameModelDialog();
//		Map<String,String> values = (new DMOptionPane()).showInputDialog(renameModelDialog);
//		if(values==null){
////			Se la Dialag viene chiusa
////			JOptionPane.showMessageDialog(DefineModelTool.getIstance(),"Dati non validi");
//			return;
//		}
//		String modelName = values.get("modelName");
//		String modelShortName = values.get("modelShortName");
//		Model m = new Model();			
//			m.setName(modelName);
//			m.setShortName(modelShortName);
//		
//		
//////		TreeContent tree = WorkSpaceTree.getIstance().getTree();
////
////		
//////		boolean renamed = tree.renameModel(modelName,modelShortName,model);
//////		boolean renamed = InfoServer.renameModel(modelName,modelShortName,model);
////			
////		/*Performs RefreshAction*/
////		RefreshAction.getIstance().actionPerformed(arg0);	
////		
////		JOptionPane.showMessageDialog(DefineModelTool.getIstance(),"Il modello  stato rinominato correttamente \n"+
////                "name:         "+modelName+"\n"+
////                "shortname: "+modelShortName,"Model Renamed",JOptionPane.INFORMATION_MESSAGE,null);
////		
//////		if(renamed==true)
//////			JOptionPane.showMessageDialog(DefineModelTool.getIstance(),"Il modello  stato rinominato correttamente \n"+
//////	                "name:         "+modelName+"\n"+
//////	                "shortname: "+modelShortName,"Model Renamed",JOptionPane.INFORMATION_MESSAGE,null);
//////			else
////			JOptionPane.showMessageDialog(DefineModelTool.getIstance(),"Si  verificato un errore nella ridenominazione del modello","Errore",JOptionPane.ERROR_MESSAGE);
	}

}