package org.modelgen.jpf.defineModel.Tree.Popup.PopupActions;

import org.modelgen.facade.GeneralManagementFacade;
import org.modelgen.facade.ResourceFunctions;
import org.modelgen.jpf.defineModel.Components.ConsoleScroll;
import org.modelgen.jpf.defineModel.Components.ProblemsScroll;
import org.modelgen.jpf.defineModel.Dialog.DMDialog;
import org.modelgen.jpf.defineModel.Dialog.DMOptionPane;
import org.modelgen.jpf.defineModel.Dialog.dialogIMPL.NewModelDialog;

import java.awt.event.ActionEvent;
import java.util.Map;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.ImageIcon;

public class NewModelAction extends AbstractAction {
	private static final long serialVersionUID = -1626464537817785510L;

	public static final String ACTION_NAME = "New Model";

	private static NewModelAction istance;
	
	private NewModelAction(){
		putValue(Action.SHORT_DESCRIPTION,ACTION_NAME);
		ImageIcon imageIcon = ResourceFunctions.openImageIcon(this.getClass(), "new.png");
		putValue(Action.SMALL_ICON,imageIcon);
	}
	
	public static NewModelAction getIstance(){
		if(istance == null)
			istance = new NewModelAction();
		return istance;
	}

	
	public void actionPerformed(ActionEvent arg0) {
		ConsoleScroll.getInstance().logTask("Adding new model",Action.NAME,"workspace");
		DMDialog newModelDialog = new NewModelDialog();
		Map<String,String> values = (new DMOptionPane()).showInputDialog(newModelDialog);
		if(values==null){
			//Se la Dialag viene chiusa
//			JOptionPane.showMessageDialog(DefineModelTool.getIstance(),"Non  stato creato alcun modello");
			return;
		}
		
		String modelName = values.get("modelName");
		String modelShortName = values.get("modelShortName");
		

			
//		Model m = new Model();			
//			m.setName(modelName);
//			m.setShortName(modelShortName);
			
//		TreeContent tree = WorkSpaceTree.getIstance().getTree();
		
//		boolean created = InfoServer.newModel(m);
		boolean created = false;
		created = GeneralManagementFacade.getInstance().newModel(modelName,modelShortName);
			
		/*Performs RefreshAction*/
		RefreshAction.getIstance().actionPerformed(arg0);	
		if(created==true){
//			JOptionPane.showMessageDialog(DefineModelTool.getIstance(),"E' stato creato un nuovo modello \n"+
//	                "name:         "+modelName+"\n"+
//	                "shortname: "+modelShortName,"Model Created",JOptionPane.INFORMATION_MESSAGE,null);
			ConsoleScroll.getInstance().logInformation("Model created: [Name: "+modelName+ ", ShortName:"+modelShortName+"]",Action.NAME,"workspace");
		}
		else{
//			JOptionPane.showMessageDialog(DefineModelTool.getIstance(),"Si  verificato un errore nella creazione del modello","Errore",JOptionPane.ERROR_MESSAGE);
			ProblemsScroll.getInstance().logError("Errors creating model: [Name: "+modelName+ ", ShortName:"+modelShortName+"]",Action.NAME,"workspace");
		}
	}

}
