package org.modelgen.jpf.defineModel.Tree.Popup.PopupActions;

import org.modelgen.commons.beans.model.Construct;
import org.modelgen.commons.beans.model.Model;
import org.modelgen.facade.ResourceFunctions;
import org.modelgen.jpf.defineModel.Components.ConsoleScroll;
import org.modelgen.jpf.defineModel.Components.ProblemsScroll;
import org.modelgen.jpf.defineModel.Dialog.DMDialog;
import org.modelgen.jpf.defineModel.Dialog.DMOptionPane;
import org.modelgen.jpf.defineModel.Dialog.dialogIMPL.RenameConstructDialog;

import java.awt.event.ActionEvent;
import java.util.Map;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.ImageIcon;

public class RenameConstructAction  extends AbstractAction {
	private static final long serialVersionUID = 1L;
	
	public static final String ACTION_NAME = "Rename Construct";
	
	private static RenameConstructAction istance;
	
	public static RenameConstructAction getIstance(){
		if(istance == null)
			istance = new RenameConstructAction();
		return istance;
	}	
	
	
	private RenameConstructAction(){
		putValue(Action.SHORT_DESCRIPTION,ACTION_NAME);
		ImageIcon imageIcon = ResourceFunctions.openImageIcon(this.getClass(), "renameConstruct.gif");
		putValue(Action.SMALL_ICON,imageIcon);
	}
	


	
	public void actionPerformed(ActionEvent arg0) {
		ConsoleScroll.getInstance().logTask("Renaming construct",Action.NAME,"construct");
		Construct construct = ActionUtility.getConstruct();
		
		
		if (construct==null){
//			JOptionPane.showMessageDialog(DefineModelTool.getIstance(),"Per eseguire l'operazione richiesta occorre selezionare un costrutto", "Selection Warning" ,JOptionPane.WARNING_MESSAGE);
			ProblemsScroll.getInstance().logWarning("Select a construct",Action.NAME , "workspace");
			return;
		}
		
		Model model = ActionUtility.getConstructModel();

		DMDialog renameConstructDialog = new RenameConstructDialog(model);
		Map<String,String> values = (new DMOptionPane()).showInputDialog(renameConstructDialog);
		if(values==null){
//			Se la Dialag viene chiusa
//			JOptionPane.showMessageDialog(DefineModelTool.getIstance(),"Dati non validi");
			return;
		}
		String constructName = values.get("constructName");
					
		
		//Sono stati fatti tutti i controllo prima di eseguire il commit nel dialog quindi is pu
		//rinominare il modello
		construct.setName(constructName);

			
		/*Performs RefreshAction*/
		RefreshAction.getIstance().actionPerformed(arg0);	
		
//		JOptionPane.showMessageDialog(DefineModelTool.getIstance(),"Il costrutto  stato rinominato correttamente \n"+
//                "name:         "+constructName,"Construct Renamed",JOptionPane.INFORMATION_MESSAGE,null);
		
		ConsoleScroll.getInstance().logInformation("Construct renamed: [Name: "+constructName+ ", Mapping:"+construct.getSuperModelConstructs().iterator().next().getName()+"]",Action.NAME,"construct");
//		if(renamed==true)
//			JOptionPane.showMessageDialog(DefineModelTool.getIstance(),"Il costrutto  stato rinominato correttamente \n"+
//	                "name:         "+constructName,"Construct Renamed",JOptionPane.INFORMATION_MESSAGE,null);
//			else
//			JOptionPane.showMessageDialog(DefineModelTool.getIstance(),"Si  verificato un errore nella ridenominazione del costrutto","Errore",JOptionPane.ERROR_MESSAGE);
	}

}
	

