package org.modelgen.jpf.defineModel.Tree.Popup.PopupActions;


import org.modelgen.commons.beans.model.Model;
import org.modelgen.facade.ResourceFunctions;
import org.modelgen.jpf.defineModel.Components.ConsoleScroll;
import org.modelgen.jpf.defineModel.Components.ProblemsScroll;
import org.modelgen.jpf.defineModel.Dialog.DMDialog;
import org.modelgen.jpf.defineModel.Dialog.DMOptionPane;
import org.modelgen.jpf.defineModel.Dialog.dialogIMPL.RenameModelDialog;

import java.awt.event.ActionEvent;
import java.util.Map;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.ImageIcon;


public class RenameModelAction extends AbstractAction {
	private static final long serialVersionUID = 1L;


	public static final String ACTION_NAME = "Rename Model";

	private static RenameModelAction istance;

	public static RenameModelAction getIstance(){
		if(istance == null)
			istance = new RenameModelAction();
		return istance;
	}	

	private RenameModelAction(){
		putValue(Action.SHORT_DESCRIPTION,ACTION_NAME);
		ImageIcon imageIcon = ResourceFunctions.openImageIcon(this.getClass(), "rename.gif");
		putValue(Action.SMALL_ICON,imageIcon);
	}


	public void actionPerformed(ActionEvent arg0) {
		ConsoleScroll.getInstance().logTask("Renaming model",Action.NAME,"model");
		Model model = ActionUtility.getModel();

		if (model==null){
//			JOptionPane.showMessageDialog(DefineModelTool.getIstance(),"Per eseguire l'operazione richiesta occorre selezionare un modello", "Selection Warning" ,JOptionPane.WARNING_MESSAGE);
			ProblemsScroll.getInstance().logWarning("Select a model",Action.NAME , "workspace");
			return;
		}

		DMDialog renameModelDialog = new RenameModelDialog();
		Map<String,String> values = (new DMOptionPane()).showInputDialog(renameModelDialog);
		if(values==null){
			return;
		}

		//qui il modello viene rinominato, ma solo nella struttura a oggetti
		String modelName = values.get("modelName");
		String modelShortName = values.get("modelShortName");
		model.setName(modelName);
		model.setShortName(modelShortName);


		/*Performs RefreshAction*/
		RefreshAction.getIstance().actionPerformed(arg0);	
		ConsoleScroll.getInstance().logInformation("Model renamed: [Name: "+modelName+ ", ShortName:"+modelShortName+"]",Action.NAME,"model");
	}

}
