package org.modelgen.jpf.defineModel.Tree.Popup.PopupActions;

import org.modelgen.commons.beans.model.Property;
import org.modelgen.facade.ResourceFunctions;
import org.modelgen.jpf.defineModel.Components.ConsoleScroll;
import org.modelgen.jpf.defineModel.Components.ProblemsScroll;
import org.modelgen.jpf.defineModel.Dialog.DMDialog;
import org.modelgen.jpf.defineModel.Dialog.DMOptionPane;
import org.modelgen.jpf.defineModel.Dialog.dialogIMPL.RenamePropertyDialog;

import java.awt.event.ActionEvent;
import java.util.Map;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.ImageIcon;

public class RenamePropertyAction  extends AbstractAction {
	private static final long serialVersionUID = 1L;
	
	public static final String ACTION_NAME = "Rename Property";
	
	private static RenamePropertyAction istance;
	
	public static RenamePropertyAction getIstance(){
		if(istance == null)
			istance = new RenamePropertyAction();
		return istance;
	}	
	
	
	private RenamePropertyAction(){
		putValue(Action.SHORT_DESCRIPTION,ACTION_NAME);
		ImageIcon imageIcon = ResourceFunctions.openImageIcon(this.getClass(), "renameProperty.gif");
		putValue(Action.SMALL_ICON,imageIcon);
	}
	


	
	public void actionPerformed(ActionEvent arg0) {
		ConsoleScroll.getInstance().logTask("Renaming property",Action.NAME,"property");
		Property property = ActionUtility.getProperty();
		
		
		if (property==null){
//			JOptionPane.showMessageDialog(DefineModelTool.getIstance(),"Per eseguire l'operazione richiesta occorre selezionare una propriet", "Selection Warning" ,JOptionPane.WARNING_MESSAGE);
			ProblemsScroll.getInstance().logWarning("Select a property",Action.NAME , "workspace");
			return;
		}
		
			
		DMDialog renameReferenceDialog = new RenamePropertyDialog();
		Map<String,String> values = (new DMOptionPane()).showInputDialog(renameReferenceDialog);
		if(values==null){
//			//Se la Dialag viene chiusa
//			JOptionPane.showMessageDialog(DefineModelTool.getIstance(),"La propriet non  stata rinominata");
			return;
		}
		String propertyName = values.get("propertyName");
		
		property.setName(propertyName);
		

		RefreshAction.getIstance().actionPerformed(arg0);	
		
//		JOptionPane.showMessageDialog(DefineModelTool.getIstance(),"Property correctly renamed","Rename Property", JOptionPane.INFORMATION_MESSAGE);
		ConsoleScroll.getInstance().logInformation("Property renamed: [Name: "+property.getName()+ ", Mapping:"+property.getMetaInfo().getName()+", Type: "+property.getType()+"]",Action.NAME,"property");
	}

}
