package org.modelgen.jpf.defineModel.Tree.Popup.PopupActions;

import org.modelgen.commons.beans.model.Reference;
import org.modelgen.facade.ResourceFunctions;
import org.modelgen.jpf.defineModel.Components.ConsoleScroll;
import org.modelgen.jpf.defineModel.Components.ProblemsScroll;
import org.modelgen.jpf.defineModel.Dialog.DMDialog;
import org.modelgen.jpf.defineModel.Dialog.DMOptionPane;
import org.modelgen.jpf.defineModel.Dialog.dialogIMPL.RenameReferenceDialog;

import java.awt.event.ActionEvent;
import java.util.Map;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.ImageIcon;

public class RenameReferenceAction extends AbstractAction {
	private static final long serialVersionUID = 1L;
	
	public static final String ACTION_NAME = "Rename Reference";
	
	private static RenameReferenceAction istance;
	
	public static RenameReferenceAction getIstance(){
		if(istance == null)
			istance = new RenameReferenceAction();
		return istance;
	}	
	
	
	private RenameReferenceAction(){
		putValue(Action.SHORT_DESCRIPTION,ACTION_NAME);
		ImageIcon imageIcon = ResourceFunctions.openImageIcon(this.getClass(), "renameReference.gif");
		putValue(Action.SMALL_ICON,imageIcon);
	}
	


	
	public void actionPerformed(ActionEvent arg0) {
		ConsoleScroll.getInstance().logTask("Renaming reference",Action.NAME,"reference");
		Reference reference = ActionUtility.getReference();
		
		
		if (reference==null){
//			JOptionPane.showMessageDialog(DefineModelTool.getIstance(),"Per eseguire l'operazione richiesta occorre selezionare un riferimento", "Selection Warning" ,JOptionPane.WARNING_MESSAGE);
			ProblemsScroll.getInstance().logWarning("Select a reference",Action.NAME , "workspace");
			return;
		}
		
			
		DMDialog renamePropertyDialog = new RenameReferenceDialog();
		Map<String,String> values = (new DMOptionPane()).showInputDialog(renamePropertyDialog);
		if(values==null){
//			//Se la Dialag viene chiusa
//			JOptionPane.showMessageDialog(DefineModelTool.getIstance(),"Il riferimento non  stato rinominato");
			return;
		}
		String referenceName = values.get("referenceName");
		
		reference.setName(referenceName);
		

		RefreshAction.getIstance().actionPerformed(arg0);	
		
//		JOptionPane.showMessageDialog(DefineModelTool.getIstance(),"Reference correctly renamed","Rename Reference", JOptionPane.INFORMATION_MESSAGE);
		ConsoleScroll.getInstance().logInformation("Reference renamed: [Name: "+referenceName+ ",Mapping:"+reference.getMetaInfo().getName()+"]",Action.NAME,"reference");
	}

}
