package org.modelgen.jpf.defineModel.Tree.Popup;


import org.modelgen.commons.beans.model.Construct;
import org.modelgen.commons.beans.model.Model;
import org.modelgen.commons.beans.model.Property;
import org.modelgen.commons.beans.model.Reference;
import org.modelgen.commons.persistence.PersistenceException;
import org.modelgen.facade.GeneralManagementFacade;
import org.modelgen.jpf.defineModel.Tree.ObjectDescription.NodeInfo;
import org.modelgen.jpf.defineModel.Tree.ObjectDescription.TreeContent;
import org.modelgen.jpf.defineModel.Tree.Popup.PopupActions.ActionUtility;
import org.modelgen.jpf.defineModel.Tree.Popup.PopupActions.AddConstructAction;
import org.modelgen.jpf.defineModel.Tree.Popup.PopupActions.AddPropertyAction;
import org.modelgen.jpf.defineModel.Tree.Popup.PopupActions.DeleteConstructAction;
import org.modelgen.jpf.defineModel.Tree.Popup.PopupActions.DeleteModelAction;
import org.modelgen.jpf.defineModel.Tree.Popup.PopupActions.DeletePropertyAction;
import org.modelgen.jpf.defineModel.Tree.Popup.PopupActions.ExportModelAction;
import org.modelgen.jpf.defineModel.Tree.Popup.PopupActions.ImportModelAction;
import org.modelgen.jpf.defineModel.Tree.Popup.PopupActions.ModelReportAction;
import org.modelgen.jpf.defineModel.Tree.Popup.PopupActions.NewModelAction;
import org.modelgen.jpf.defineModel.Tree.Popup.PopupActions.RenameConstructAction;
import org.modelgen.jpf.defineModel.Tree.Popup.PopupActions.RenameModelAction;
import org.modelgen.jpf.defineModel.Tree.Popup.PopupActions.RenamePropertyAction;
import org.modelgen.jpf.defineModel.Tree.Popup.PopupActions.RenameReferenceAction;
import org.modelgen.jpf.defineModel.Tree.Popup.PopupActions.StoreModelAction;
import org.modelgen.jpf.defineModel.Tree.Popup.PopupActions.VoidAddConstructAction;
import org.modelgen.jpf.defineModel.Tree.Popup.PopupActions.VoidAddPropertyAction;

import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.Collection;
import java.util.Iterator;

import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import javax.swing.tree.DefaultMutableTreeNode;





public class PopupListener extends MouseAdapter {
	MouseEvent evt = null;
	
    public void mousePressed(MouseEvent e) {
    	evt = e;
        showPopup(e);
    }

    public void mouseReleased(MouseEvent e) {
    	evt = e;
        showPopup(e);
    }

    private void showPopup(MouseEvent e) {
    /*   public boolean isPopupTrigger() Returns whether or not this mouse event is the popup menu trigger event 
    *   for the platform. 
    *   
    *   Note: Popup menus are triggered differently on different systems. Therefore, isPopupTrigger should be 
    *   checked in both mousePressed and mouseReleased for proper cross-platform functionality. 
    *   */   	
    	JPopupMenu popup = null;
        if (e.isPopupTrigger()) {
        	popup = createPopup(e);
            popup.show(e.getComponent(),e.getX(), e.getY());
        }
    }


	private JPopupMenu createPopup(MouseEvent e) {
		JPopupMenu popup = new JPopupMenu();
		TreeContent tree = (TreeContent)e.getSource();
		DefaultMutableTreeNode node = (DefaultMutableTreeNode)tree.getLastSelectedPathComponent();		
		if (node == null){
			JMenuItem menuItem = new JMenuItem("Select a component");
		    popup.add(menuItem);
		    return popup;
		}

		if(node.isRoot()){
			return rootPopupMenu(node);
		}
		NodeInfo nodeInfo = (NodeInfo)node.getUserObject();
//		String name = nodeInfo.getName();
		Object data = nodeInfo.getDataObject();
		
//		if(node.isRoot()){
//			return rootPopupMenu(node);
//		}
//		if(name.equals("Costrutti")){
//			return costruttiPopupMenu(node);
//		}
		/*Processa in base al parametro*/
		if (data instanceof Model) {
			return dataObjectPopup((Model) data);
		}
		if (data instanceof Construct) {
			return dataObjectPopup((Construct) data);	
		}
		if (data instanceof Reference) {
			return dataObjectPopup((Reference) data);	
		}
		if (data instanceof Property) {
			return dataObjectPopup((Property) data);	
		}
		
		
//	    if (node.isLeaf()) {
//        BookInfo book = (BookInfo)nodeInfo;
//        displayURL(book.bookURL);
//    } else {
//        displayURL(helpURL); 
//    }
		
//		popup = new JPopupMenu("Bella");

		return popup;
	}

	private JPopupMenu dataObjectPopup(Model m) {
		JPopupMenu pmenu = new JPopupMenu();
		
		JMenuItem exportM = new JMenuItem(ExportModelAction.getIstance());
			exportM.setText(ExportModelAction.ACTION_NAME);
		
		JMenu newConstruct = new JMenu(VoidAddConstructAction.getIstance());
			newConstruct.setText(VoidAddConstructAction.ACTION_NAME);
			addAvailableConstruct(newConstruct,m);
		
		JMenuItem renameM = new JMenuItem(RenameModelAction.getIstance());
			renameM.setText(RenameModelAction.ACTION_NAME);
		JMenuItem saveM = new JMenuItem(StoreModelAction.getIstance());
			saveM.setText(StoreModelAction.ACTION_NAME);
		JMenuItem reportM = new JMenuItem(ModelReportAction.getIstance());
			reportM.setText(ModelReportAction.ACTION_NAME);
		JMenuItem deleteM = new JMenuItem(DeleteModelAction.getIstance());
			deleteM.setText(DeleteModelAction.ACTION_NAME);
		
		pmenu.add(exportM);
		pmenu.add(reportM);
		pmenu.addSeparator();
		pmenu.add(newConstruct);
		pmenu.add(renameM);
		pmenu.add(saveM);
		pmenu.addSeparator();
		pmenu.add(deleteM);
		
		return pmenu;
	}
	private JPopupMenu dataObjectPopup(Construct c) {
		JPopupMenu pmenu = new JPopupMenu();
		Iterator<Property> it = null;
		
		
		Model model = ActionUtility.getConstructModel(); 
		Collection<Property> availableProperties = model.getAvailableProperties(c);
		JMenu addPropMenu = new JMenu(VoidAddPropertyAction.getIstance());
			addPropMenu.setText(VoidAddPropertyAction.ACTION_NAME);
		if (!availableProperties.isEmpty()){
			it = availableProperties.iterator();
			while(it.hasNext()){
				Property prop = it.next();
				JMenuItem propItem = new JMenuItem(new AddPropertyAction(c,prop));
				addPropMenu.add(propItem);
			}
			pmenu.add(addPropMenu);
		}
		
//		Collection availableReferences = model.getAvailableReferences(c);
//		JMenu addRefMenu = new JMenu(VoidAddReferenceAction.getIstance());
//		addRefMenu.setText(VoidAddReferenceAction.ACTION_NAME);
//		if (!availableReferences.isEmpty()){
//			it = availableReferences.iterator();
//			while(it.hasNext()){
//				Reference ref = (Reference) it.next();
//				JMenuItem refItem = new JMenuItem(new AddReferenceAction(model,c,ref));
//				addRefMenu.add(refItem);
//			}
//			pmenu.add(addRefMenu);
//		}
		
		pmenu.addSeparator();
	
		JMenuItem renameC = new JMenuItem(RenameConstructAction.getIstance());
			renameC.setText(RenameConstructAction.ACTION_NAME);
		JMenuItem deleteC = new JMenuItem(DeleteConstructAction.getIstance());
			deleteC.setText(DeleteConstructAction.ACTION_NAME);
		pmenu.add(renameC);
		pmenu.addSeparator();
		pmenu.add(deleteC);
		
//		Collection references = c.getReferences();	
//		if(references.isEmpty()){
//			pmenu.add(new JMenuItem("No references"));
//		} else {
//			pmenu.add(new JMenuItem("References:"));
//			it = references.iterator();
//			Reference ref = null;
//			while(it.hasNext()){
//				ref = (Reference) it.next();
//				JMenuItem refItem = new JMenuItem("  "+ref.getName());
//				pmenu.add(refItem);
//			}
//		}
//		pmenu.addSeparator();
//		
//		Collection properties = c.getProperties();	
//		if(properties.isEmpty()){
//			pmenu.add(new JMenuItem("No properties"));
//		} else {
//			pmenu.add(new JMenuItem("Properties:"));
//			it = properties.iterator();
//			Property prop = null;
//			while(it.hasNext()){
//				prop =  (Property) it.next();
//				JMenuItem refItem = new JMenuItem("  "+prop.getName());
//				pmenu.add(refItem);
//			}
//		}
		
		return pmenu;
	}
	private JPopupMenu dataObjectPopup(Property m) {
		JPopupMenu pmenu = new JPopupMenu();
		
		JMenuItem deleteP = new JMenuItem(DeletePropertyAction.getIstance());
			deleteP.setText(DeletePropertyAction.ACTION_NAME);
		JMenuItem renameP = new JMenuItem(RenamePropertyAction.getIstance());
			renameP.setText(RenamePropertyAction.ACTION_NAME);
		pmenu.add(renameP);
		pmenu.add(deleteP);
		
		return pmenu;
	}
	
	private JPopupMenu dataObjectPopup(Reference m) {
		JPopupMenu pmenu = new JPopupMenu();
		
//		JMenuItem deleteR = new JMenuItem(DeleteReferenceAction.getIstance());
//		deleteR.setText(DeleteReferenceAction.ACTION_NAME);
		JMenuItem renameR = new JMenuItem(RenameReferenceAction.getIstance());
			renameR.setText(RenameReferenceAction.ACTION_NAME);
//		pmenu.add(deleteR);
		pmenu.add(renameR);
		
		return pmenu;
	}

//	private JPopupMenu costruttiPopupMenu(DefaultMutableTreeNode node) {
//		JPopupMenu pmenu = new JPopupMenu();
//
//		return pmenu;
//	}

	private void addAvailableConstruct(JMenu newConstruct,Model model) {
//		Model superModel = InfoServer.getSuperModel();
		Model superModel = null;
		try {
			superModel = GeneralManagementFacade.getInstance().getSuperModel();
//			Commentate da PaoloC 20070306 e rimpiazzate dalla riga seguente
//			Scopo: non fitrare la lista dei costrutti del SM in base a quelli
//			presenti nel modello. Questo perche' costrutti come il Lexical possono
//			essere usati per piu' costrutti per piu' di un costrutto nel modello,
//			es. Lexical puo' essere AttributeOfTypedTable e ColumnOfTable
//			Collection availableConstructs = model.getAvailableConstructs(superModel);
			Collection<Construct> availableConstructs = superModel.getAbstractConstructs();
			
			Iterator<Construct> it = availableConstructs.iterator();
			Construct construct = null;
			JMenuItem consItem;
			while(it.hasNext()){
				construct = it.next();
				consItem = new JMenuItem(new AddConstructAction(construct,model));
				newConstruct.add(consItem);			
			}
		} catch (PersistenceException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	private JPopupMenu rootPopupMenu(DefaultMutableTreeNode node) {
		JPopupMenu pmenu = new JPopupMenu();

		JMenuItem importM = new JMenuItem(ImportModelAction.getIstance());
		importM.setText(ImportModelAction.ACTION_NAME);
		JMenuItem newM = new JMenuItem(NewModelAction.getIstance());
			newM.setText(NewModelAction.ACTION_NAME);
//		JMenuItem storeMs = new JMenuItem(StoreAllModelsAction.getIstance());
//			storeMs.setText(StoreAllModelsAction.ACTION_NAME);
		pmenu.add(importM);
		pmenu.addSeparator();
		pmenu.add(newM);
		pmenu.addSeparator();
//		pmenu.add(storeMs);
		return pmenu;
	}
}
