package org.modelgen.jpf.defineModel.utility;



import java.io.File;

import javax.swing.filechooser.FileFilter;

public class XMLFileFilter extends FileFilter {
	private static XMLFileFilter instance = null;
	
	public static XMLFileFilter getInstance(){
		if(instance==null)
			instance = new XMLFileFilter();
		return instance;
	}
	private XMLFileFilter(){}
	
	@Override
	public boolean accept(File f) {
		boolean accepted  = false;
		if (f.isDirectory()) {
			return true;
		    }

		    String extension = getExtension(f);
		    if (extension != null) {
				if (extension.equals("xml")) {
				    accepted = true;
				}
		    }
		return accepted;
	}

	public String getExtension(File f) {
        String ext = null;
        String s = f.getName();
        int i = s.lastIndexOf('.');

        if (i > 0 &&  i < s.length() - 1) {
            ext = s.substring(i+1).toLowerCase();
        }
        return ext;
	}
	
	public String getExtension(String file) {
        String ext = null;
        int i = file.lastIndexOf('.');

        if (i > 0 &&  i < file.length() - 1) {
            ext = file.substring(i+1).toLowerCase();
        }
        return ext;
	}

	@Override
	public String getDescription() {
	    return "xml";

	}


}
