package org.modelgen.jpf.defineScheme.Components;


import org.modelgen.commons.beans.scheme.Scheme;
import org.modelgen.commons.beans.scheme.SchemeObject;
import org.modelgen.commons.beans.scheme.SchemeObjectProperty;
import org.modelgen.commons.beans.scheme.SchemeObjectReference;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Font;
import java.awt.GradientPaint;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.RenderingHints;
import java.awt.geom.Ellipse2D;
import java.awt.geom.Line2D;
import java.awt.geom.Rectangle2D;
import java.awt.image.BufferedImage;
import java.util.Collection;
import java.util.Iterator;
import java.util.LinkedList;

public class SchemeReportImage extends BufferedImage {
	
	public static Scheme scheme;
	
	final static Color red = Color.red;
    final static Color white = Color.white;
    final static Color bg = Color.black;
    final static Color fg = Color.white;
    final static Color blue = Color.blue;
    final static Color green = Color.green;
    final static Color yellow = Color.yellow;
    final static BasicStroke stroke = new BasicStroke(1.0f);
    final static BasicStroke doubleStroke = new BasicStroke(2.0f);
    final static BasicStroke wideStroke = new BasicStroke(8.0f);
    
    private static Collection<SchemeObject> objects;
	
    public static int numberOfObjects;
    //private static Graphics g;
    //private static Timer timer;
    
//    public PrettyReportPanel(c) {
//    	//scheme = s;
//    	objects = ob;
//    }
	
//    public void init() {
//        //Initialize drawing colors
//        setBackground(bg);
//        setForeground(fg);
//    }
		
//    protected void clear(Graphics g) {
//        super.paint(g);
//      }
        
//    public void update(Graphics g)
//    {
//      paint( g );
//    }
    public SchemeReportImage(Scheme s){
     	super(2000,2000,BufferedImage.TYPE_INT_RGB);
     	scheme = s;
    	objects = s.getAbstractConstructs();
//    	Graphics2D g2d = (Graphics2D) this.getGraphics();
//    	System.out.println("Graphics "+g2d);
    	paint(this.getGraphics());
    }
//    public void counter(Collection ob) {
//    	Iterator i = ob.iterator();
//    	SchemeObject o = null;
//    	while(i.hasNext()) {
//    		o = (SchemeObject)i.next();
//    		if(o.getReferences().size()!=1 || o.getConstruct().getName().equals("Generalization"))
//    			numberOfObjects++;
//    	}
//    }

	
	public void paint(Graphics g) {	
//		this.setLayout(new BoxLayout(this,BoxLayout.Y_AXIS));
		
		Graphics2D g2 = (Graphics2D) g;
		g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
		
//		g2.setBackground(Color.GRAY);
		/*Ellipse2D.Double circleBorder = new Ellipse2D.Double(10,10,96,96);
	    g2.setStroke(doubleStroke);
	    g2.draw(circleBorder);*/
		
		
		//JOptionPane.showMessageDialog(frame,scheme.getName(),"Pretty Report",JOptionPane.INFORMATION_MESSAGE);
		//Collection objects = scheme.getObjects();
		Collection<SchemeObject> entities = new LinkedList<SchemeObject>();
		Collection<SchemeObject> relationships = new LinkedList<SchemeObject>();
		Collection<SchemeObject> attributes = new LinkedList<SchemeObject>();
		Collection<SchemeObject> everythingElse =  new LinkedList<SchemeObject>();
		//Collection objectsNoAttributes = new LinkedList();
//Gio
		if(objects.size()==0){
			return;
//			JOptionPane.showMessageDialog(frame,"No objects! Absurd!!!","Pretty Report",JOptionPane.ERROR_MESSAGE);
		}		
		Iterator<SchemeObject> itOb = objects.iterator();
		
		// Let' s iterate over all the scheme objects received through the constructor
		SchemeObject object = null;
		while (itOb.hasNext()){
			object = itOb.next();
			//Iterator iter = object.getConstruct().getSuperModelConstructs().iterator();
			//it only works with just one Supermodel construct in the list
			//String constructName ="";
			/*while(iter.hasNext()) {
				Construct construct = (Construct)iter.next();
				constructName = construct.getName();
			}*/
			
			if(object.getReferences().size()>1 && !object.getMetaInfo().getName().equals("ChildOfGeneralization") &&!object.getMetaInfo().getName().equals("ComponentOfForeignKey")) {
				relationships.add(object);
				everythingElse.add(object);
			} else if(object.getReferences().size()==0)
				entities.add(object);
			else if(object.getReferences().size()==1 && object.getMetaInfo().getName().equals("Generalization"))
				everythingElse.add(object);
			else 
				attributes.add(object);
			/*
			//Let' s separate the Abstract from the attributes or aggregations
			if(constructName.equals("Abstract")) {
				
				entities.add(object);}
			else if (object.getReferences().size()==1) {//TODO: gotta fix this, because the attributes are not the only constructs with just one reference, a generalization has only one too
				attributes.add(object); }
			else if(object.getReferences().size()>1) {
				//if(constructName.equals("AggregationOfAbstracts") || constructName.equals("BinaryAggregationOfAbstracts")) //these should be only aggregations, hopefully...
				relationships.add(object);
				objectsNoAttributes.add(object);}
			else
				everythingElse.add(object);
				objectsNoAttributes.add(object);
				*/			
		}	
	/*	if(entities.size()==0)
			JOptionPane.showMessageDialog(frame,"No abstracts! Why???","Pretty Report",JOptionPane.ERROR_MESSAGE);
			
		if(attributes.size()==0)
			JOptionPane.showMessageDialog(frame,"No attributes! Why???","Pretty Report",JOptionPane.ERROR_MESSAGE);
		
		if(relationships.size()==0)
			JOptionPane.showMessageDialog(frame,"No relationships! Why???","Pretty Report",JOptionPane.ERROR_MESSAGE);
	*/	
		Iterator<SchemeObject> itEnt = entities.iterator();		
		//Iterator itRel = relationships.iterator();
		
		SchemeObject entity = null;
		SchemeObject attribute = null;
		Collection<SchemeObject> attributesOfEntity = new LinkedList<SchemeObject>();
		Collection<SchemeObject> entity_references = new LinkedList<SchemeObject>();
		
		int x_entity = 0;
		int y_entityPrevious = 0;
		int y_entity;
		int width_entity = 0;
		int height_entity = 104;
		
		int y_ref = 35;
		
		
		Iterator<SchemeObject> every = everythingElse.iterator();
		while(every.hasNext()) {
			entities.add(every.next());
		}
		
		//itRel = relationships.iterator();
		itEnt = entities.iterator();
		// Let' s iterate over the Abstracts
		numberOfObjects = 0;
		
		while (itEnt.hasNext()) {
			entity = itEnt.next();
			/*
			JLabel label = new JLabel("       ");
			JLabel label1 = new JLabel("       ");
			JLabel label2 = new JLabel("       ");
			JLabel label3 = new JLabel("       ");
			JLabel label4 = new JLabel("       ");
			JLabel label5 = new JLabel("       ");
			JLabel label6 = new JLabel("       ");
			JLabel label7 = new JLabel("       ");
			JLabel label8 = new JLabel("       ");
			JLabel label9 = new JLabel("       ");
			JLabel label10 = new JLabel("       ");
			JLabel label11 = new JLabel("       ");
			JLabel label12 = new JLabel("       ");
			JLabel label13 = new JLabel("       ");
			JLabel label14 = new JLabel("       ");
			
			this.add(label);
			//this.append("<html>         <br>                <br>             <br>                <br>                  <br>          </html>");
			*/
			//Let' s create a collection of attributes related to this entity
			Iterator<SchemeObject> itAtt = attributes.iterator();
			while(itAtt.hasNext()) {
				attribute = itAtt.next();
				//TODO FIX THIS METHOD, GOTTA FILTER THE OBJECTS BY REFERENCE, BUT THIS CONTROL DOES NOT WORK, IT ALWAYS RETURNS NULL!!!! if(attribute.getReference(entity.getName())!=null)
				//FIXED
					Collection<SchemeObjectReference> references = attribute.getReferences();
					SchemeObjectReference reference = null;
					Iterator<SchemeObjectReference> it_ref = references.iterator();
					while(it_ref.hasNext()) {
						reference = it_ref.next();
						/**
						 * GIO
						 */
						if (reference.getValue()!=null && reference.getValue().getName().equals(entity.getName())) // if the attribute' s reference is the entity we' re considering, than add the attribute to the entity' s list of attributes
							attributesOfEntity.add(attribute);
					}	
			}
			int numberOfAttributes = attributesOfEntity.size();
			
			Collection<SchemeObjectProperty> properties = entity.getProperties();
			int numberOfProperties = properties.size();
			
			//check if it' s the first of the list
			if(y_entityPrevious==0)
				y_entity = 30;
			else //if(attributesOfEntity.size()!=0)
				y_entity = y_entityPrevious + 104 + 28 + 102 + 10;
				//else
				//	y_entity = y_entityPrevious + 104 + 28 + 10;	
			//Adjust the initial size of the Abstract according to how many attributes it has
			
			//if(entity.getReferences().size()==0)
			if(numberOfAttributes>numberOfProperties)
				width_entity = 200 + (202*numberOfAttributes) + 10*(numberOfAttributes-1); 
			else
				width_entity = 200 + (136*numberOfProperties) + 10*(numberOfProperties-1);
			
			
			//Entity or Table rectangle
			g2.setStroke(stroke);
			Rectangle2D.Double rectBorder = new Rectangle2D.Double(x_entity,y_entity,width_entity,height_entity);
			g2.draw(rectBorder);
			Rectangle2D.Double rect = new Rectangle2D.Double(x_entity+1,y_entity+1,width_entity-1,height_entity-1);
			
			if(entity.getReferences().size()==0) { // if it' s an Abstract
			
				GradientPaint redtowhite = new GradientPaint(x_entity+2,y_entity+2,red,x_entity+2+width_entity-2,y_entity+2+height_entity-2,white);
				g2.setPaint(redtowhite);
			} else { // if it' s a Relantionship, for instance
				GradientPaint greentowhite = new GradientPaint(x_entity+2,y_entity+2,green,x_entity+2+width_entity-2,y_entity+2+height_entity-2,white);
				g2.setPaint(greentowhite);
			}	
				
			g2.fill(rect);
			// Entity or Table text
			g2.setFont(new Font ("Arial",Font.BOLD,18));
			g2.setColor(fg);
			g2.drawString(entity.getName(),x_entity+10,y_entity+30);
			g2.setFont(new Font ("Arial",Font.ITALIC,16));
			g2.drawString("("+entity.getMetaInfo().getName()+")",x_entity+10,y_entity+50);
	    
			
			int x_att = 0;
			int y_att = y_entity + 104 + 28 + 1;
			int width_att = 202;
			int height_att = 102;
			
			int x1_line = 101;
			int y1_line = y_entity+height_entity+1;
			int x2_line = x1_line;
			int y2_line = y1_line + 28;
			
			Iterator<SchemeObject> itAttOfEnt = attributesOfEntity.iterator();
			//if(attributesOfEntity.size()==0)
				//JOptionPane.showMessageDialog(frame,"No attributes for this entity!","Pretty Report",JOptionPane.ERROR_MESSAGE);
				
			
			SchemeObject attOfEnt = null;
			while(itAttOfEnt.hasNext()) {
				attOfEnt = itAttOfEnt.next();
				
				//Line between Entity/Table and Attribute/Column
				Line2D.Double line = new Line2D.Double(x1_line,y1_line,x2_line,y2_line);
				g2.draw(line);
				x1_line = x1_line+ 102 + 10 + 102;
				x2_line = x1_line;
				
				//Attribute/Column rectangle
				Rectangle2D.Double miniRectBorder = new Rectangle2D.Double(x_att,y_att,width_att,height_att);
				Rectangle2D.Double miniRect = new Rectangle2D.Double(x_att+1,y_att+1,width_att-1,height_att-1);
				g2.draw(miniRectBorder);
				GradientPaint bluetowhite = new GradientPaint(x_att+1,y_att+1,blue,x_att+1+width_att-1,y_att+1+height_att-1,white);
				g2.setPaint(bluetowhite);
				g2.fill(miniRect);
				//Attribute Text
				g2.setColor(fg);
				g2.setFont(new Font ("Arial",Font.BOLD,16));
				g2.drawString(attOfEnt.getName(),x_att+10,y_entity+height_entity+51);
				g2.setFont(new Font ("Arial",Font.ITALIC,14));
				g2.drawString("("+attOfEnt.getMetaInfo().getName()+")",x_att+10,y_entity+height_entity+66);
				Collection<SchemeObjectProperty> props = attOfEnt.getProperties();
				Iterator<SchemeObjectProperty> it_prop = props.iterator();
				SchemeObjectProperty property = null;
				int y_space = 0;
				while (it_prop.hasNext()) {
					property = it_prop.next();
					g2.setFont(new Font ("Arial",Font.PLAIN,12));
					g2.drawString(property.getMetaInfo().getName(),x_att+10,y_entity+height_entity+86+y_space);
					g2.setFont(new Font ("Arial",Font.ITALIC,12));
					g2.drawString(property.getValue(),x_att+70,y_entity+height_entity+86+y_space);
					y_space = y_space + 20;
				}
				
				x_att =x_att+202+10;	
			}
			
			attributesOfEntity = new LinkedList<SchemeObject>();
			
	      
			if(entity.getReferences().size()==0) {
			//Let' s create a list of aggregations that reference this entity
			
			
			
			//Collection entity_references = new LinkedList();
			SchemeObject o = null;
			Iterator<SchemeObject> itRelLocal = everythingElse.iterator(); 
			while(itRelLocal.hasNext()) {
				o = itRelLocal.next();
				Collection<SchemeObjectReference> refs = o.getReferences();
				SchemeObjectReference reference = null;
				Iterator<SchemeObjectReference> it_ref = refs.iterator();
				while(it_ref.hasNext()) {
					reference = it_ref.next();
					/**
					 * GIO
					 */
					if (reference.getValue()!=null && reference.getValue().getName().equals(entity.getName())) 
						entity_references.add(o);
				}	
			}
			
			// Let' s iterate over those aggregations in order to display them
			Iterator<SchemeObject> itRef = entity_references.iterator();
			SchemeObject refer = null;
			
			//	Reference circle
			int x_ref = x_entity+width_entity + 50;
			
			int width_ref = 192;
			int height_ref = 96;

			int x1_mline = x_entity+width_entity; 
			int y1_mline = (height_entity/2)+y_entity;
			int x2_mline = x1_mline + 50;
			int y2_mline = (height_entity/2)+y_entity;
				
			/*if (entity_references.size()==0)
				JOptionPane.showMessageDialog(frame,"No references! Why???","Pretty Report",JOptionPane.ERROR_MESSAGE);
			*/
			int numberOfReferences = 0;
			while(itRef.hasNext()) {
				refer = itRef.next();
				numberOfReferences++;
						
				Ellipse2D.Double circleBorder = new Ellipse2D.Double(x_ref,y_ref,width_ref,height_ref);
				g2.setStroke(doubleStroke);
				g2.draw(circleBorder);
				Ellipse2D.Double circle = new Ellipse2D.Double(x_ref+1,y_ref+1,width_ref-2,height_ref-2);
				GradientPaint greentowhite = new GradientPaint(x_ref+1,y_ref+2,green,x_ref+196,y_ref+100,white);
				g2.setPaint(greentowhite);
				g2.fill(circle);
				//Reference text
				g2.setColor(bg);
				g2.setFont(new Font ("Arial",Font.BOLD,14));
				g2.drawString(refer.getName(),x_ref+20,y_ref+30);
				g2.setFont(new Font ("Arial",Font.PLAIN,12));
				g2.drawString(refer.getMetaInfo().getName(),x_ref+26,y_ref+46);
			
//				Line between Entity and Reference
				g2.setColor(fg);
				g2.setStroke(stroke);
				Line2D.Double miniLine = new Line2D.Double(x1_mline,y1_mline,x2_mline,y2_mline);
				g2.draw(miniLine);
								
				x_ref = x_ref+width_ref+50;
				x1_mline = x1_mline+width_ref+50;
				x2_mline = x1_mline+50;
			}	
			
			y_ref = y_ref+28+102+104+10;
			entity_references = new LinkedList<SchemeObject>();
			}	
		y_entityPrevious = y_entity;	
			
		
			if(properties.size()!=0) {
				int x_prop = x_entity+width_entity-140;
				int y_prop = y_entity+4;
				int width_prop = 136;
				int height_prop = 96;
				//Collection propss = entity.getProperties();
				
				//gio
//				if (properties.size()==0)
//					JOptionPane.showMessageDialog(frame,"No propss! Why???","Pretty Report",JOptionPane.ERROR_MESSAGE);
				
				Iterator<SchemeObjectProperty> itProp = properties.iterator();
				while(itProp.hasNext()) {
					SchemeObjectProperty prop = itProp.next();
				
					// Property square
					g2.setColor(bg);
					//g2.setStroke(wideStroke);
					Rectangle2D.Double insideRectBorder = new Rectangle2D.Double(x_prop,y_prop,width_prop,height_prop);
					g2.draw(insideRectBorder);
					Rectangle2D.Double insideRect = new Rectangle2D.Double(x_prop+2,y_prop+2,width_prop-2,height_prop-2);
					GradientPaint yellowtowhite = new GradientPaint(x_prop+2,y_prop+2,yellow,x_prop+width_prop-2,y_prop+96,white);
					g2.setPaint(yellowtowhite);
					g2.fill(insideRect);
					// Property text
					g2.setColor(bg);
					g2.setFont(new Font ("Arial",Font.BOLD,14));
					g2.drawString(prop.getMetaInfo().getName(),x_prop+6,y_prop+16);
					g2.setFont(new Font ("Arial",Font.PLAIN,12));
					g2.drawString(prop.getValue(),x_prop+6,y_prop+36);
				
					x_prop = x_prop - width_prop - 10;
				}	
				y_prop = y_prop +28+102+104+10;
				//properties = new LinkedList();
			
//				 Let' s iterate over those aggregations in order to display them
				Iterator<SchemeObjectReference> itRefs = entity.getReferences().iterator();
				SchemeObjectReference refr = null;
				
				//	Reference circle
				int x_ref = x_entity+width_entity + 50;
				
				int width_ref = 96;
				int height_ref = 96;

				int x1_mline = x_entity+width_entity; 
				int y1_mline = (height_entity/2)+y_entity;
				int x2_mline = x1_mline + 50;
				int y2_mline = (height_entity/2)+y_entity;
					
			/*	if (entity.getReferences().size()==0)
					JOptionPane.showMessageDialog(frame,"No Entities references! Why???","Pretty Report",JOptionPane.ERROR_MESSAGE);
			*/	
				int numberOfReferences = 0;
				while(itRefs.hasNext()) {
					refr = itRefs.next();
					numberOfReferences++;
					g2.setColor(fg);		
					Ellipse2D.Double circleBorder = new Ellipse2D.Double(x_ref,y_ref,width_ref,height_ref);
					g2.setStroke(doubleStroke);
					g2.draw(circleBorder);
					Ellipse2D.Double circle = new Ellipse2D.Double(x_ref+1,y_ref+1,width_ref-2,height_ref-2);
					GradientPaint redtowhite = new GradientPaint(x_ref+1,y_ref+2,red,x_ref+100,y_ref+100,white);
					g2.setPaint(redtowhite);
					g2.fill(circle);
					//Reference text
					g2.setColor(fg);
					g2.setFont(new Font ("Arial",Font.BOLD,14));
					/**
					 * GIO
					 */
					if(refr.getValue()!=null){
						g2.drawString(refr.getValue().getName(),x_ref+10,y_ref+30);
					}
					g2.setFont(new Font ("Arial",Font.PLAIN,12));
					/**
					 * GIO
					 */
					if(refr.getValue()!=null){
						g2.drawString(refr.getValue().getMetaInfo().getName(),x_ref+20,y_ref+46);
					}

				
//					Line between Entity and Reference
					g2.setColor(fg);
					g2.setStroke(stroke);
					Line2D.Double miniLine = new Line2D.Double(x1_mline,y1_mline,x2_mline,y2_mline);
					g2.draw(miniLine);
									
					x_ref = x_ref+96+50;
					x1_mline = x1_mline+width_ref+50;
					x2_mline = x1_mline+50;
				}	
				
				y_ref = y_ref+28+102+104+10;
					
			
			
			
			y_entityPrevious = y_entity;	
			
			
			
			
			
			
			
			
			
			
			} //g2.setColor(bg);
	    
	    
	    
	    //TextLayout text = new TextLayout("Text", new Font("Helvetica", Font.PLAIN, 96), new FontRenderContext(null, false, false));
	    //text.draw(g2,100,50);
		
		}
	    
	}

    
	    
//	public static void exportReport() {
//		
//		//frame = new JFrame("Modelgen");
//		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
//		Scheme scheme1 = ListSchemes.searchForScheme("Scheme_ERbinFull_BankAccounts");
//		int OID = scheme1.getOID();
//		Scheme s;
//		Collection objects = null;
//		try { PersistenceHandler ph= PersistenceHandlerFactory.getPersistenceHandler();
//		      s = ph.loadScheme(OID);
//		      objects = s.getObjects();
//				if (objects.size()==0)
//					JOptionPane.showMessageDialog(frame,"MACHECCRIBBIO SUCCEDE???","Pretty Report",JOptionPane.ERROR_MESSAGE);
//		} catch(Exception e) {
//			JOptionPane.showMessageDialog(frame,"ERROR FROM DATABASE","Pretty Report",JOptionPane.ERROR_MESSAGE);
//		}
//		
//		
//		
//		PrettyReportPanel panel = new PrettyReportPanel(objects);
//		panel.setIgnoreRepaint(true);
//		panel.init();
//		panel.setBackground(new Color(0xFFFFFF));
//		
//		panel.counter(objects);
//		//panel.setPreferredSize(new Dimension(1000,1000));
//		panel.setBounds(0,0,2000,numberOfObjects*270);
//		
//		ImageExporter exporter = new ImageExporter(panel,"beta");
//		exporter.addNotify();
//	}
	
//	public static ImageIcon createImageIcon(String path) {
//        java.net.URL imgURL = PrettyReportPanel.class.getResource(path);
//        if (imgURL != null) {
//            return new ImageIcon(imgURL);
//        } else {
//            System.err.println("Couldn't find file: " + path);
//            return null;
//        }
//    }
	
//	public static void createAndShowGUI() {
//		
//		JPanel p = new JPanel();
//		JLabel l = new JLabel();
//		ImageIcon report = createImageIcon("prettyreport.jpg");
//		l.setIcon(report);
//		p.add(l);
//		JScrollPane scroll = new JScrollPane(p);
//		scroll.setPreferredSize(new Dimension(500,500));
//		scroll.setIgnoreRepaint(true);
//		frame.getContentPane().add(scroll);
//		//frame.setUndecorated(true);
//		//frame.setLocation(500,500);
//		Dimension dim = Toolkit.getDefaultToolkit().getScreenSize();
//		frame.setBounds(0,0,500,500);
//		Rectangle abounds = frame.getBounds();
//		frame.setLocation((dim.width - abounds.width)/2,(dim.height - abounds.height) / 2);
//		frame.setSize(new Dimension(1000,1000));
//		//frame.setBounds(700,525,width,height);
//		//frame.setIgnoreRepaint(true);
//		frame.setVisible(true);
//		
//	}	
	
//	public static void setTimer() {
//		TimerTask task = new Task();
//		
//		timer = new Timer();
//		timer.schedule(task,4000);
//		//timer.setDelay(4000);
//	    //timer.setRepeats(false);
//		
//		
//	}
//	
//	public static void main(String[] args) {
//		exportReport();
//		//setTimer();
//	}
	
	
	
	
}