package org.modelgen.jpf.defineScheme.Components;


import org.modelgen.commons.beans.scheme.Scheme;
import org.modelgen.facade.GeneralManagementFacade;
import org.modelgen.facade.ResourceFunctions;
import org.modelgen.jpf.defineScheme.DefineSchemeTool;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.HashMap;
import java.util.Map;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JToolBar;
import javax.swing.JViewport;

public class VisualReport extends JScrollPane implements ActionListener{
	private static final long serialVersionUID = 1L;
	private boolean isNew;
	//Current Schem Model
	private Scheme scheme;
	//All models reported
	private static Map<String,VisualReport> reports = new HashMap<String,VisualReport>();
	
	
	private static VisualReport instance;
	
	public static VisualReport getInstance(Scheme s){
		String name = s.getName();
		VisualReport report = reports.get(name);
		if (report!=null){
			instance = report;
			instance.isNew = false;
		}else{
			instance = new VisualReport(s);
			reports.put(name,instance);
		}
		return instance;
	}

	 private VisualReport(Scheme s){
		/**Passandogli questo modello se il modello viene cancellato o se operazioni comportano la
		 * cancellazione del modello dal workspace, viene anche informato il report*/
//		model = InfoServer.getModelByName(m.getName());
		scheme = GeneralManagementFacade.getInstance().getSchemeByName(s.getName());
		setSchemeReportView();	
		isNew = true;
	}
	
	 private void setSchemeReportView() {
			JViewport port = null;
			try{
				//Collection objects = scheme.getObjects();
				port = new JViewport();
				JLabel label = new JLabel(new ImageIcon(new SchemeReportImage(scheme)));
				JPanel p = new JPanel();p.setLayout(new BorderLayout());
					p.add(createTabBar(),BorderLayout.PAGE_START);
					p.add(label,BorderLayout.EAST);
					port.add(p);

			}catch (RuntimeException e) {
				e.printStackTrace();
				port = new JViewport();port.add(new JLabel("Errore nella visualizzazione dello schema" +scheme.getName()));
			}
			setViewportView(port);
		}



	private void refresh(){
		JTabbedPane tabbed = ((JTabbedPane)getParent());
		
		/***********Finezza: per cambiare il titolo del tab in caso di rinominazione del modello ************/
		int index = tabbed.getSelectedIndex();
		tabbed.setTitleAt(index,scheme.getName());
		/************************/
		
		setSchemeReportView();
		updateUI();
		
	}
	private Component createTabBar() {
//		/*******************************************************************/
		JToolBar barra = new JToolBar("Tab Bar");
		JButton refresh = new JButton(ResourceFunctions.openImageIcon(this.getClass(), "refresh.gif"));
			refresh.setActionCommand("refresh");		
				refresh.addActionListener(this);
			
		JButton close = new JButton(ResourceFunctions.openImageIcon(this.getClass(), "button_cancel.png"));
			close.setActionCommand("close");
				close.addActionListener(DefineSchemeTool.getIstance().getReportsTab());
				close.addActionListener(this);			
			
		Color bcolor = this.getBackground();
			refresh.setBackground(bcolor);
			close.setBackground(bcolor);
			
			/******************************/
//			close.putClientProperty("report",this);
			/******************************/
			
			
		barra.setLayout(new FlowLayout(FlowLayout.LEFT));
		barra.setFloatable(false);
			barra.add(close);
			barra.add(refresh);
//		/********************************************************************/
		return barra;
	}

	public boolean isNew() {
		return isNew;
	}

	public void actionPerformed(ActionEvent arg0) {
		String command = arg0.getActionCommand();
		if (command.equals("refresh"))
			refresh();	
		else
			removeReportFromMap();
	}

	private void removeReportFromMap() {
//		System.out.println("ModelReport.removeReportFromMap");
		reports.remove(scheme.getName());		
	}

	public Scheme getScheme() {
		return scheme;
		
	}
}


