package org.modelgen.jpf.defineScheme.Dialog;


import java.awt.Dimension;
import java.awt.Frame;
import java.util.Map;

import javax.swing.JDialog;

/** Classe astratta perch DMDialog nasce per essere esclusivamente estesa
 * */
public abstract class DSDialog extends JDialog{
	
	//Prima di chiudere la JDialog va eseguito il metodo setValues() dell'OptionPane
	protected DSOptionPane optionPane = null;
	
	public DSDialog(Frame owner, String title, boolean modal,double height,double width){
		super(owner,title,modal);
		Dimension dim = this.getToolkit().getScreenSize();
		double screenWidth = dim.getWidth();
		double screenHeight = dim.getHeight();
		if(width==-1){
			width = screenWidth/4;
		}
		if(height==-1){
			height = screenHeight/5.5;
		}
		double thisX = (screenWidth-width)/2;
		double thisY = (screenHeight-height)/2;
		this.setBounds((int)thisX,(int)thisY,(int)width,(int)height);
	}
	public DSDialog(Frame owner, String title, boolean modal){
		this(owner,title,modal,-1,-1);
	}
//	public DMDialog(Frame owner, String title, boolean modal){
//		super(owner,title,modal);
//		Dimension dim = this.getToolkit().getScreenSize();
//		double screenWidth = dim.getWidth();
//		double screenHeight = dim.getHeight();
//		double width = screenWidth/4;
//		double height = screenHeight/5.5;
//		double thisX = (screenWidth-width)/2;
//		double thisY = (screenHeight-height)/2;
//		this.setBounds((int)thisX,(int)thisY,(int)width,(int)height);
//	}

	public void setOptionPane(DSOptionPane optionPane) {
		this.optionPane = optionPane;
	}


	/** METODO ESEGUITO DAI PULSANTI DI CONFERMA DELLA DIALOG PER SETTARE LA MAPPA DELL' OPTIONPANE
	 * */
	protected void setValues(Map<String,Object> values) {
		optionPane.setValues(values);
	}
	

}

