package org.modelgen.jpf.defineScheme.Dialog.dialogIMPL;

import org.modelgen.commons.beans.model.Construct;
import org.modelgen.commons.beans.model.Property;
import org.modelgen.commons.beans.model.Reference;
import org.modelgen.commons.beans.scheme.SchemeObject;
import org.modelgen.commons.beans.scheme.SchemeObjectProperty;
import org.modelgen.commons.beans.scheme.SchemeObjectReference;
import org.modelgen.facade.ResourceFunctions;
import org.modelgen.jpf.core.ToolBoxFrame;
import org.modelgen.jpf.defineScheme.Components.ProblemsScroll;
import org.modelgen.jpf.defineScheme.Components.SpringUtilities;
import org.modelgen.jpf.defineScheme.Dialog.DSDialog;
import org.modelgen.jpf.defineScheme.Tree.Popup.PopupActions.ActionUtility;
import org.modelgen.jpf.defineScheme.utility.ErrorTable;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JFormattedTextField;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.SpringLayout;
import javax.swing.SwingConstants;


public class ModifySchemeObjectDialog extends DSDialog implements ActionListener{
	private static final long serialVersionUID = -5553687076607083358L;

	//Costrutto associato al nuovo SchemeObject
	private SchemeObject obj;
	private Construct construct;
	
	//Da qui si reperiscono le info sugli oggetti da creare
	private JFormattedTextField textName = null;
	private List<JComboBox> refCombos = new LinkedList<JComboBox>();;
	private List<JCheckBox> propCheckBoxs = new LinkedList<JCheckBox>();;
	private List<JFormattedTextField> propTextFields = new LinkedList<JFormattedTextField>();;
	
	//Utilit di formattazione
	String leftSpace = "        ";
	
	public ModifySchemeObjectDialog(SchemeObject schemeOBJ) {
		super(ToolBoxFrame.getIstance(), "Modifing Object", true,Toolkit.getDefaultToolkit().getScreenSize().getHeight()/2,Toolkit.getDefaultToolkit().getScreenSize().getWidth()/3.5);
		this.obj = schemeOBJ;
		construct = obj.getMetaInfo();
		defineStructure(this.getContentPane());
	}

//	private AddSchemeObjectDialog(Frame owner, String title, boolean modal,Dimension dim) {
//		super(ToolBoxFrame.getIstance(), title, true,dim.getHeight()/2,-1);
//	}

	private void defineStructure(Container contentPane) {
		ImageIcon icon = ResourceFunctions.openImageIcon(this.getClass(), "renameConstruct.gif");
		
		JLabel messageLabel = new JLabel("SchemeObject Modifying \n          ",icon,SwingConstants.LEFT);
			contentPane.add(BorderLayout.NORTH,messageLabel);
		
		JPanel infoPanel = new JPanel();
//			infoPanel.setLayout(new GridLayout(3,1,15,10));
			infoPanel.setLayout(new BoxLayout(infoPanel, BoxLayout.Y_AXIS));
			infoPanel.setBorder(BorderFactory.createEmptyBorder(0,5,0,5));
			
			JPanel namePanel = createNamePanel();
				infoPanel.add(namePanel);
			Collection<Property> props = construct.getProperties();
			if(!props.isEmpty()){
				JPanel propPanel = createPropertiesPanel((List<Property>)props);
//				propPanel.setPreferredSize(namePanel.getSize());
				infoPanel.add(propPanel);
			}
			Collection<Reference> refs = construct.getReferences();
			if(!refs.isEmpty()){
				infoPanel.add(createReferencesPanel((List<Reference>)refs));
			}
		

		JScrollPane infoScroll = new JScrollPane(infoPanel);
			infoScroll.setBorder(BorderFactory.createEmptyBorder());
			contentPane.add(BorderLayout.CENTER,infoScroll);
	
		JPanel controlPanel = new JPanel();
			JButton okButton = new JButton("Ok");
				okButton.setActionCommand("commit");
				okButton.addActionListener(this);
			JButton resetButton = new JButton("reset");
				resetButton.setActionCommand("reset");
				resetButton.addActionListener(this);
			controlPanel.add(okButton);
			controlPanel.add(resetButton);
		contentPane.add(BorderLayout.SOUTH,controlPanel);
		
	}

	private JPanel createReferencesPanel(List<Reference> references) {
		JPanel p = new JPanel();
		p.setLayout(new FlowLayout(FlowLayout.LEFT));
		p.setBorder(BorderFactory.createTitledBorder("References"));
		Dimension textDimension = new Dimension(150,20);
		

		JPanel pSpring = new JPanel();
			pSpring.setLayout(new SpringLayout());
			
		for(SchemeObjectReference soRef: (List<SchemeObjectReference>)obj.getReferences()){
			Reference ref = soRef.getMetaInfo();
				JLabel nameLabel = new JLabel(ref.getName()+"           ",JLabel.LEFT);
				
				Vector<String> v = new Vector<String>();
				List<SchemeObject> compatibleTargetObjects = new LinkedList<SchemeObject>();
				
				int index = 0;
				int selectedItem = 0;
				if(ref.getTargetConstruct()!=null) {
//					v.add("Select...");
					String targetConstruct = ref.getTargetConstruct().getName();
					List<SchemeObject> schemeObjects = ActionUtility.getSOScheme().getAbstractConstructs();
					Iterator<SchemeObject> i = schemeObjects.iterator();
					SchemeObject o = null;
					while(i.hasNext()) {
						o = i.next();
						String referenceConstruct = o.getMetaInfo().getName();
						if(targetConstruct.equals(referenceConstruct)){
							compatibleTargetObjects.add(o);
							String soTargName = o.getName();
							v.add(soTargName);
							SchemeObject soRefTarget = soRef.getValue(); 
							if (soRefTarget!=null && soTargName.equals(soRefTarget.getName())){
//								System.out.println("soRef.getValue().getName()");
								selectedItem = index;
							}
							index++;
							
						}
					}
				}
				
//				we should always consider to have a null reference
//				this code is the same in AddSchemeObject!!! 
				SchemeObject nullReferenceObject = null;
				String nullReferenceName = SchemeObject.MDM_UNSPECIFIED;
				compatibleTargetObjects.add(nullReferenceObject);
				v.add(nullReferenceName);

				JComboBox combo = new JComboBox(v);
					combo.setPreferredSize(textDimension);
					combo.setSelectedIndex(selectedItem);
					/*Consente di reperire il riferimento e i possibili targetObject*/
					combo.putClientProperty("reference",ref);
					combo.putClientProperty("compatibleTargetObjects",compatibleTargetObjects);
					refCombos.add(combo);
					
				pSpring.add(nameLabel);

				pSpring.add(combo);
				
		}
		SpringUtilities.makeCompactGrid(pSpring,
				references.size(), 2, 
                6, 6,        
                6, 6);
		p.add(pSpring);
		return p;
	}

	private JPanel createPropertiesPanel(List<Property> properties) {
		JPanel p = new JPanel();
		p.setLayout(new FlowLayout(FlowLayout.LEFT));
		p.setBorder(BorderFactory.createTitledBorder("Properties"));
		Dimension textDimension = new Dimension(150,20);
		

		JPanel pSpring = new JPanel();
		pSpring.setLayout(new SpringLayout());
		
		int a = 0;
		int i = 0;
		
		for(SchemeObjectProperty soProp: (List<SchemeObjectProperty>) obj.getProperties()){
			Property prop = soProp.getMetaInfo();
			if(prop.getType().equals("bit") | prop.getType().equals("boolean")){
				a++;
				
				JCheckBox box = new JCheckBox();
					box.putClientProperty("property",prop);
					propCheckBoxs.add(box);
					
				JLabel bLabel = new JLabel(prop.getName());
				bLabel.setLabelFor(box);	
				box.setSelected((new Boolean(soProp.getValue())).booleanValue());
				
				pSpring.add(bLabel);
				pSpring.add(box);
			}
			if(prop.getType().equals("varchar")){	
				i++;
				JLabel nameLabel = new JLabel(prop.getName()+"           ",JLabel.LEFT);
				JFormattedTextField textValue = new JFormattedTextField(soProp.getValue());
					textValue.setPreferredSize(textDimension);
					
					/*Consente di reperire la propriet associata al campo testo*/
					textValue.putClientProperty("property",prop);
					propTextFields.add(textValue);
				
				pSpring.add(nameLabel);

				pSpring.add(textValue);
				
			}
		}

		SpringUtilities.makeCompactGrid(pSpring,
                a+i, 2, 
                6, 6,        
                6, 6);
		p.add(pSpring);
		return p;
	}

	private JPanel createNamePanel() {
		JPanel p = new JPanel();
		p.setBorder(BorderFactory.createTitledBorder("General"));
		p.setLayout(new FlowLayout(FlowLayout.LEFT));
		
		
		Dimension textDimension = new Dimension(150,20);
		
		JLabel nameLabel = new JLabel(leftSpace+"Name        ");
		textName = new JFormattedTextField(obj.getName());
		textName.setPreferredSize(textDimension);
		
			p.add(nameLabel);
			p.add(textName);
		
		return p;
	}

	public void actionPerformed(ActionEvent ae) {
		JButton actionButton = (JButton) ae.getSource();
		String actionCommand = actionButton.getActionCommand();
		if(actionCommand.equals("commit"))
			commit();
		else
			reset();
		
	}

	private void reset() {
		textName.setText("");
		//Seleziona il primo elemento dei combos(riferimento)
		for(JComboBox refCombo: refCombos){
			refCombo.setSelectedIndex(0);
		}
		//Deseleziona i chech delle propriet
		for(JCheckBox check: propCheckBoxs){
			check.setSelected(false);
		}
		//Deseleziona i chech delle propriet
		for(JFormattedTextField propText: propTextFields){
			propText.setText("");
		}
	}

	@SuppressWarnings("unchecked")
	private void commit() {
		ErrorTable errors = new ErrorTable();

		String objName = textName.getText();
		if (objName.equals("") | objName.contains(" ") | !SchemeObject.isValidName(objName)){
			errors.addError("invalid scheme-object name");
		}
	    //Vanno controllate solo le propriet, perch i riferimenti hanno sempre un valore  valido
		//e le prop booleane sono sempre a false
		for(JFormattedTextField propText:propTextFields){
		String propTextValue = propText.getText();
			if (propTextValue.equals("") | propTextValue.contains(" ")){
				errors.addError("invalid property value");
			}
		}
		
		if (!errors.isEmpty()){
			JOptionPane.showMessageDialog(this,"Errors:\n"+errors);
			ProblemsScroll.getInstance().logWarning("Check data","New SchemeObject", "");
			this.getToolkit().beep();
			reset();
			return;
			// Non viene eseguito this.setVisible(true) quindi il controllo resta sulla Dialog corrente
		}
		
		/* Aggiungiamo i tre paramentri relativi al nome, le propriet e i targetObject dei riferimenti
		 * */
		Map<String,Object> values= new HashMap<String,Object>();
			values.put("objName",objName);
			
		Map<Property,String> objPropertyMap = new HashMap<Property,String>();
			for(JCheckBox chech:propCheckBoxs){
				objPropertyMap.put((Property) chech.getClientProperty("property"),(new Boolean(chech.isSelected())).toString());
			}
			for(JFormattedTextField propTextValue:propTextFields){
				objPropertyMap.put((Property) propTextValue.getClientProperty("property"),propTextValue.getText());
			}
			values.put("objProperties",objPropertyMap);
			
		Map<Reference,SchemeObject> objReferenceMap = new HashMap<Reference,SchemeObject>();
			for(JComboBox combo:refCombos){
				int index= combo.getSelectedIndex();
				SchemeObject targetObject = ((List<SchemeObject>)combo.getClientProperty("compatibleTargetObjects")).get(index);
				objReferenceMap.put((Reference) combo.getClientProperty("reference"),targetObject);
			}
			values.put("objReferences",objReferenceMap);
			
			
		super.setValues(values);		
		this.dispose();
	}





}



