package org.modelgen.jpf.defineScheme.Dialog.dialogIMPL;

import org.modelgen.commons.beans.scheme.Scheme;
import org.modelgen.facade.GeneralManagementFacade;
import org.modelgen.facade.ResourceFunctions;
import org.modelgen.jpf.core.ToolBoxFrame;
import org.modelgen.jpf.defineScheme.Components.ProblemsScroll;
import org.modelgen.jpf.defineScheme.Dialog.DSDialog;
import org.modelgen.jpf.defineScheme.utility.ErrorTable;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Frame;
import java.awt.LayoutManager;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.HashMap;
import java.util.Map;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFormattedTextField;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.SwingConstants;

public class RenameSchemeDialog extends DSDialog implements ActionListener{
	private static final long serialVersionUID = 1L;
private JFormattedTextField textName = null;
//private JFormattedTextField textShortName = null;

public RenameSchemeDialog() {
	this(ToolBoxFrame.getIstance(), "Rename Scheme", true);
	
}

public RenameSchemeDialog(Frame owner, String title, boolean modal) {
	super(ToolBoxFrame.getIstance(), title , true);
	defineStructure(this.getContentPane());
}

private void defineStructure(Container contentPane) {
	ImageIcon icon = ResourceFunctions.openImageIcon(this.getClass(), "rename.gif");
	
	JLabel messageLabel = new JLabel("Scheme renamination \n          ",icon,SwingConstants.LEFT);
	contentPane.add(BorderLayout.NORTH,messageLabel);



	JPanel infoPanel = new JPanel();
//		infoPanel.setLayout(new GridLayout(2,1));
	JPanel firstRow = new JPanel();
	LayoutManager layout = new FlowLayout(FlowLayout.RIGHT,30,0);
		firstRow.setLayout(layout);
//	JPanel secondRow = new JPanel();
//		secondRow.setLayout(layout);

	// Artifici di separazione
	String leftSpace = "           ";
	Dimension textDimension = new Dimension(150,20);
	
	JLabel nameLabel = new JLabel(leftSpace+"Name        ");
	textName = new JFormattedTextField();
		textName.setPreferredSize(textDimension);
		firstRow.add(nameLabel);
		firstRow.add(textName);
	//JLabel shortNameLabel = new JLabel(leftSpace+"Shortname");
//	textShortName = new JFormattedTextField();
//		textShortName.setPreferredSize(textDimension);
//		secondRow.add(shortNameLabel);
//		secondRow.add(textShortName);
		
	infoPanel.add(firstRow);
//	infoPanel.add(secondRow);

	contentPane.add(BorderLayout.CENTER,infoPanel);		
	


	//Serve a dare lo spazio dal margine sinistro
	contentPane.add(BorderLayout.EAST,new JLabel("  "));
	
	JPanel controlPanel = new JPanel();
		JButton okButton = new JButton("Ok");
			okButton.setActionCommand("commit");
			okButton.addActionListener(this);
		JButton resetButton = new JButton("reset");
//			resetButton.setActionCommand("reset");
			resetButton.addActionListener(this);
		controlPanel.add(okButton);
		controlPanel.add(resetButton);
	contentPane.add(BorderLayout.SOUTH,controlPanel);
	
}

public void actionPerformed(ActionEvent ae) {
	JButton actionButton = (JButton) ae.getSource();
	String actionCommand = actionButton.getActionCommand();
	if(actionCommand.equals("commit"))
		commit();
	else
		reset();
	
}

private void reset() {
	textName.setText("");
//	textShortName.setText("");		
}

private void commit() {
	String schemeName = textName.getText();
//	String modelShortName = textShortName.getText();
	
	ErrorTable errors = new ErrorTable();

	if (schemeName.equals("") | schemeName.contains(" ") | !Scheme.isValidName(schemeName)){
		errors.addError("invalid scheme name");
	}
//	if (InfoServer.getModelByName(modelName)!=null){
//		errors.addError("A model with this name aleady exists");
//	}
	if (GeneralManagementFacade.getInstance().getSchemeByName(schemeName)!=null){
		errors.addError("A scheme with this name aleady exists");
	}
	if (!errors.isEmpty()){
		JOptionPane.showMessageDialog(this,"Errors:\n"+errors);
		ProblemsScroll.getInstance().logWarning("Check data","Rename Scheme", "scheme");
		this.getToolkit().beep();
		reset();
		return;
		// Non viene eseguito this.setVisible(true) quindi il controllo resta sulla Dialog corrente
	}

	Map<String,Object> values= new HashMap<String,Object>();
		values.put("schemeName",schemeName);
//		values.put("modelShortName",modelShortName);
	super.setValues(values);		
	this.setVisible(false);
}

}