package org.modelgen.jpf.defineScheme.Tree.ObjectDescription;


import org.modelgen.commons.beans.scheme.SchemeObject;
import org.modelgen.facade.ResourceFunctions;

import java.awt.Component;

import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeCellRenderer;

public class DSTreeCellRender extends DefaultTreeCellRenderer {
	private static final long serialVersionUID = 4958306164706894750L;
	
	private static DSTreeCellRender instance = null;
	public static DSTreeCellRender getInstance(){
		if (instance==null)
			instance = new DSTreeCellRender();
		return instance;
	}

    private DSTreeCellRender() {
    }

    public Component getTreeCellRendererComponent(
                        JTree tree,
                        Object value,
                        boolean sel,
                        boolean expanded,
                        boolean leaf,
                        int row,
                        boolean hasFocus) {

        super.getTreeCellRendererComponent(
                        tree, value, sel,
                        expanded, leaf, row,
                        hasFocus);

               
        if (isSchemeNode(value)) {
	        if (leaf){
	       		 setIcon(ResourceFunctions.openImageIcon(this.getClass(), "modelOut.gif"));
	       	}else{
	       		 setIcon(ResourceFunctions.openImageIcon(this.getClass(), "model.gif"));
	       	}
//	        Scheme s = getNodeInfo(value).getScheme();
//          setToolTipText("Name: "+ s.getName());  
            setToolTipText("Name: "+ getNodeInfo(value).getScheme().getName());
        }
//        else {
//            setToolTipText(null); 
//        } 
        
        if (isSchemeObjectNode(value)) {
        	if (leaf){
        		 setIcon(ResourceFunctions.openImageIcon(this.getClass(), "constructOut.gif"));
        	}else{
        		 setIcon(ResourceFunctions.openImageIcon(this.getClass(), "construct.gif"));
        	}
            SchemeObject sObj = getNodeInfo(value).getSchemeObject();
            setToolTipText("Name: "+ sObj.getName()+"\nMapping: "+sObj.getMetaInfo().getName());
        } else 
//        {
//            setToolTipText(null); 
//        } 
        
        if (isSchemeObjectPropertyNode(value)) {
        	String type = ((NodeInfo)((DefaultMutableTreeNode)value).getUserObject()).getSchemeObjectProperty().getMetaInfo().getType();
            if(type.equals("bit") || type.equals("boolean"))
            	setIcon(ResourceFunctions.openImageIcon(this.getClass(), "booleanProp.gif"));
            else
            	setIcon(ResourceFunctions.openImageIcon(this.getClass(), "textProp.gif"));
//            SchemeObjectProperty p = getNodeInfo(value).getSchemeObjectProperty();
//            setToolTipText("Name: "+p.getModelProperty().getName()+"\nType: "+p.getType()+"\nMapping: "+p.getSuperModelProperty().getName());
        } 
//        else {
//            setToolTipText(null); 
//        } 
        if (isSchemeObjectReferenceNode(value)) {
            setIcon(ResourceFunctions.openImageIcon(this.getClass(), "reference.png"));
            	
//            Reference r = getNodeInfo(value).getReference();
//            setToolTipText("Name: "+r.getName()+"\nType: "+r.getTypeAsString()+"\nMapping: "+r.getSuperModelReference().getName());
        }
//            else {
//            setToolTipText(null); 
//            
//        } 
        if (isRoot(value)){
        	setIcon(ResourceFunctions.openImageIcon(this.getClass(), "workspace.png"));
        }

        return this;
    }

   private boolean isRoot(Object value) {
	   return ((DefaultMutableTreeNode)value).isRoot();
	}

private NodeInfo getNodeInfo(Object value) {
		return ((NodeInfo)(((DefaultMutableTreeNode)value).getUserObject()));
	}

	 private boolean isSchemeObjectReferenceNode(Object value) {
    	return ((NodeInfo)((DefaultMutableTreeNode)value).getUserObject()).getSchemeObjectReference()!=null;
	}

	private boolean isSchemeObjectPropertyNode(Object value) {
		return ((NodeInfo)((DefaultMutableTreeNode)value).getUserObject()).getSchemeObjectProperty()!=null;
	}

	private boolean isSchemeObjectNode(Object value) {
		return ((NodeInfo)((DefaultMutableTreeNode)value).getUserObject()).getSchemeObject()!=null;
	}

	private boolean isSchemeNode(Object value) {	
		return ((NodeInfo)((DefaultMutableTreeNode)value).getUserObject()).getScheme()!=null;
	}


}



