package org.modelgen.jpf.defineScheme.Tree.Popup.PopupActions;





import org.modelgen.commons.beans.scheme.Scheme;
import org.modelgen.commons.beans.scheme.SchemeObject;
import org.modelgen.jpf.defineScheme.Components.ProblemsScroll;
import org.modelgen.jpf.defineScheme.Tree.WorkSpaceTree;
import org.modelgen.jpf.defineScheme.Tree.ObjectDescription.NodeInfo;
import org.modelgen.jpf.defineScheme.Tree.ObjectDescription.TreeContent;

import javax.swing.Action;
import javax.swing.tree.DefaultMutableTreeNode;



public class ActionUtility {
	
	public static DefaultMutableTreeNode getNode(boolean message){
		TreeContent tree = WorkSpaceTree.getIstance().getTree();
		DefaultMutableTreeNode node = (DefaultMutableTreeNode) tree.getLastSelectedPathComponent();
		// Se message  uguale a true, visualizza la jdialog
		if (node==null && message==true){
			ProblemsScroll.getInstance().logWarning("Select a component",Action.NAME , "");
		}
		return node;
		}
	
	private static NodeInfo getNodeInfo(){
		DefaultMutableTreeNode node = getNode(true);
		NodeInfo nodeInfo = null;
		if (node!=null)
			nodeInfo = (NodeInfo) node.getUserObject();
		return nodeInfo;
		}
	
	private static NodeInfo getNodeInfo(DefaultMutableTreeNode node){
		NodeInfo nodeInfo = null;
		if (node!=null)
			nodeInfo = (NodeInfo) node.getUserObject();
		return nodeInfo;
		}
	
	public static Scheme getScheme(){
        /**************************************************/

	/**Prima richiama getNode()=> se non ci sono nodi selezionati visualizza un jdialog che
	* informa dell'assenza di un nodo selezionato.
	* Node info  null se non ci sono nodi selezionati o se non ci sono info associate a tale
	* nodo, cosa peraltro non presente nell'implementazione attuale */
	NodeInfo nodeInfo = ActionUtility.getNodeInfo();
	
	Scheme scheme = null;		
	
	/**getModel restituisce null se, pur essendo associato un nodeIndo al nodo tale oggetto non
	*  un modello */
	if (nodeInfo!=null){
	scheme = nodeInfo.getScheme();
	}
					/**************************************************/
	return scheme;
	}
	public static SchemeObject getSchemeObject(){

	NodeInfo nodeInfo = ActionUtility.getNodeInfo();
	
		SchemeObject obj = null;		
		
		/**getModel restituisce null se, pur essendo associato un nodeIndo al nodo tale oggetto non
		*  un modello */
		if (nodeInfo!=null){
		obj = nodeInfo.getSchemeObject();
		}
					/**************************************************/
	return obj;
	}
//	public static Scheme getSOScheme(){
//		DefaultMutableTreeNode schemeNode = (DefaultMutableTreeNode) ActionUtility.getNode(false).getParent();
//		
//		NodeInfo nodeInfo = ActionUtility.getNodeInfo(schemeNode);
//		
//		Scheme scheme = null;		
//		
//		/**getModel restituisce null se, pur essendo associato un nodeIndo al nodo tale oggetto non
//		*  un modello */
//		if (nodeInfo!=null){
//			scheme = nodeInfo.getScheme();
//		}
//					/**************************************************/
//		return scheme;
//	}
	public static Scheme getSOScheme(){
		DefaultMutableTreeNode schemeNode = (DefaultMutableTreeNode) ActionUtility.getNode(false).getParent();
		while(schemeNode.getPath().length!=2){
			schemeNode = (DefaultMutableTreeNode) schemeNode.getParent();
		}
		
		
		
		NodeInfo nodeInfo = ActionUtility.getNodeInfo(schemeNode);
		
		Scheme scheme = null;		
		
		/**getModel restituisce null se, pur essendo associato un nodeIndo al nodo tale oggetto non
		*  un modello */
		if (nodeInfo!=null){
			scheme = nodeInfo.getScheme();
		}
					/**************************************************/
		return scheme;
	}
}
