package org.modelgen.jpf.defineScheme.Tree.Popup.PopupActions;

import org.modelgen.commons.beans.scheme.Scheme;
import org.modelgen.facade.GeneralManagementFacade;
import org.modelgen.facade.ResourceFunctions;
import org.modelgen.jpf.defineScheme.Components.ConsoleScroll;
import org.modelgen.jpf.defineScheme.Components.ProblemsScroll;
import org.modelgen.jpf.defineScheme.Dialog.DSDialog;
import org.modelgen.jpf.defineScheme.Dialog.DSOptionPane;
import org.modelgen.jpf.defineScheme.Dialog.dialogIMPL.CloneSchemeDialog;

import java.awt.event.ActionEvent;
import java.util.Map;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.ImageIcon;

public class CloneSchemeAction extends AbstractAction {

	private static final long serialVersionUID = -1432839448403099908L;

	public static final String ACTION_NAME = "Clone...";

	private static CloneSchemeAction istance;

	public static CloneSchemeAction getIstance(){
		if(istance == null)
			istance = new CloneSchemeAction();
		return istance;
	}	

	private CloneSchemeAction(){
		putValue(Action.SHORT_DESCRIPTION,ACTION_NAME);
		ImageIcon imageIcon = ResourceFunctions.openImageIcon(this.getClass(), "saveAll.png");
		putValue(Action.SMALL_ICON,imageIcon);
	}


	public void actionPerformed(ActionEvent arg0) {
		ConsoleScroll.getInstance().logTask("Cloning scheme",Action.NAME,"scheme");
		Scheme scheme = ActionUtility.getScheme();

		if (scheme==null){
			ProblemsScroll.getInstance().logWarning("Select a scheme", "Clone scheme", "scheme");
			return;
		}

		DSDialog saveSchemeDialog = new CloneSchemeDialog();
		Map<String,Object> values = (new DSOptionPane()).showInputDialog(saveSchemeDialog);
		if(values==null){
			return;
		}
		String newSchemeName = (String) values.get("schemeName");


		boolean result = GeneralManagementFacade.getInstance().cloneScheme(scheme, newSchemeName);
		if(result)
			ConsoleScroll.getInstance().logInformation("Scheme cloned: [Name: "+scheme.getName()+"]",Action.NAME,"scheme");
		else
			ConsoleScroll.getInstance().logInformation("No scheme cloned: [Name: "+scheme.getName()+"]",Action.NAME,"scheme");

		/*Performs RefreshAction*/
		RefreshAction.getIstance().actionPerformed(arg0);

	}

}
