package org.modelgen.jpf.defineScheme.Tree.Popup.PopupActions;




import org.modelgen.commons.beans.scheme.Scheme;
import org.modelgen.commons.persistence.PersistenceException;
import org.modelgen.facade.GeneralManagementFacade;
import org.modelgen.facade.ResourceFunctions;
import org.modelgen.jpf.core.ToolBoxFrame;
import org.modelgen.jpf.defineScheme.Components.ConsoleScroll;
import org.modelgen.jpf.defineScheme.Components.ProblemsScroll;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.ImageIcon;
import javax.swing.JOptionPane;



public class DeleteSchemeAction extends AbstractAction {
	private static final long serialVersionUID = 6866211201216585992L;

	public static final String ACTION_NAME = "Delete Scheme";
	
	private static DeleteSchemeAction istance;
	
	public static DeleteSchemeAction getIstance(){
		if(istance == null)
			istance = new DeleteSchemeAction();
		return istance;
	}	
	
	
	private DeleteSchemeAction(){
		putValue(Action.SHORT_DESCRIPTION,ACTION_NAME);
		ImageIcon imageIcon = ResourceFunctions.openImageIcon(this.getClass(), "delete.gif");
		putValue(Action.SMALL_ICON,imageIcon);
	}
	


	
	public void actionPerformed(ActionEvent arg0) {
		ConsoleScroll.getInstance().logTask("Deleting scheme",Action.NAME,"scheme");
		Scheme scheme = ActionUtility.getScheme();
		
		if (scheme==null){
			ProblemsScroll.getInstance().logWarning("Select a scheme",Action.NAME , "workspace");
			return;
		}
		
		int n = JOptionPane.showConfirmDialog(
			    ToolBoxFrame.getIstance(),
			    "Would you like to delete the selected scheme?",
			    "Deletion confirm",
			    JOptionPane.YES_NO_OPTION);
		
		if (n==JOptionPane.YES_OPTION){                      	
			try {
				GeneralManagementFacade.getInstance().deleteScheme(scheme);
				ConsoleScroll.getInstance().logInformation("Scheme deleted: [Name: "+scheme.getName()+"]",Action.NAME,"scheme");
			} catch (PersistenceException e) {
				ProblemsScroll.getInstance().logError("Errors deleting model: [Name: "+scheme.getName()+", Error: "+e.getMessage()+"]",Action.NAME,"scheme");
			}
				
			/*Performs RefreshAction*/
			RefreshAction.getIstance().actionPerformed(arg0);	
		
		}else{
			ConsoleScroll.getInstance().logInformation("Scheme deletion aborted",Action.NAME,"scheme");
		}
	}

}
