package org.modelgen.jpf.defineScheme.Tree.Popup.PopupActions;

import org.modelgen.commons.beans.scheme.Scheme;
import org.modelgen.commons.beans.scheme.SchemeObject;
import org.modelgen.facade.GeneralManagementFacade;
import org.modelgen.facade.ResourceFunctions;
import org.modelgen.jpf.core.ToolBoxFrame;
import org.modelgen.jpf.defineScheme.Components.ConsoleScroll;
import org.modelgen.jpf.defineScheme.Components.ProblemsScroll;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.ImageIcon;
import javax.swing.JOptionPane;


public class DeleteSchemeObjectAction  extends AbstractAction {
	private static final long serialVersionUID = 5876249947156219285L;

	public static final String ACTION_NAME = "Delete Object";
	
	private static DeleteSchemeObjectAction istance;
	
	public static DeleteSchemeObjectAction getIstance(){
		if(istance == null)
			istance = new DeleteSchemeObjectAction();
		return istance;
	}	
	
	
	private DeleteSchemeObjectAction(){
		putValue(Action.SHORT_DESCRIPTION,ACTION_NAME);
		ImageIcon imageIcon = ResourceFunctions.openImageIcon(this.getClass(), "deleteConstruct.gif");
		putValue(Action.SMALL_ICON,imageIcon);
	}
	


	
	public void actionPerformed(ActionEvent arg0) {
		ConsoleScroll.getInstance().logTask("Deleting object",Action.NAME,"object");
		
		SchemeObject obj = ActionUtility.getSchemeObject();
		
		
		if (obj==null){
			ProblemsScroll.getInstance().logWarning("Select an object",Action.NAME , "workspace");
			return;
		}
		
		Scheme scheme = ActionUtility.getSOScheme();
		
		int n = JOptionPane.showConfirmDialog(
			    ToolBoxFrame.getIstance(),
			    "Would you like to delete the selected object?",
			    "Deletion confirm",
			    JOptionPane.YES_NO_OPTION);


		if(n==JOptionPane.YES_OPTION){
			GeneralManagementFacade.getInstance().deleteSchemeObject(obj,scheme);
			
			/*Performs RefreshAction*/
			RefreshAction.getIstance().actionPerformed(arg0);	
			
			ConsoleScroll.getInstance().logInformation("Object deleted: [Name: "+obj.getName()+ ", Model:"+scheme.getName()+"]",Action.NAME,"object");
		}else{
			ConsoleScroll.getInstance().logInformation("Object deletion aborted",Action.NAME,"object");
		}
	}

}
	
