package org.modelgen.jpf.defineScheme.Tree.Popup.PopupActions;

import org.modelgen.commons.beans.scheme.Scheme;
import org.modelgen.commons.persistence.xml.Exporter;
import org.modelgen.facade.GeneralManagementFacade;
import org.modelgen.facade.ResourceFunctions;
import org.modelgen.jpf.defineScheme.Components.ConsoleScroll;
import org.modelgen.jpf.defineScheme.Components.ProblemsScroll;
import org.modelgen.jpf.defineScheme.Dialog.DSDialog;
import org.modelgen.jpf.defineScheme.Dialog.DSOptionPane;
import org.modelgen.jpf.defineScheme.Dialog.dialogIMPL.ExportSchemeDialog;

import java.awt.event.ActionEvent;
import java.io.File;
import java.util.Map;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.ImageIcon;

public class ExportSchemeAction extends AbstractAction {

	private static final long serialVersionUID = -8068327639613408386L;
	
	public static final String ACTION_NAME = "Export Scheme";
	
	private static ExportSchemeAction istance;


	public static ExportSchemeAction getIstance(){
		if(istance == null){
			istance = new ExportSchemeAction();
		}
		return istance;
	}	
	
	
	private ExportSchemeAction(){
		putValue(Action.SHORT_DESCRIPTION,ACTION_NAME);
		ImageIcon imageIcon = ResourceFunctions.openImageIcon(this.getClass(), "export.gif");
		putValue(Action.SMALL_ICON,imageIcon);
	}
	
	
	
	
	public void actionPerformed(ActionEvent arg0) {
		ConsoleScroll.getInstance().logTask("Exporting scheme",Action.NAME,"scheme");
		Scheme exportingScheme = ActionUtility.getScheme();
		
		if (exportingScheme==null){
			ProblemsScroll.getInstance().logWarning("Select a scheme",Action.NAME , "workspace");
			return;
		}
		
		DSDialog exportModelDialog = new ExportSchemeDialog();
		Map<String,Object> values = (new DSOptionPane()).showInputDialog(exportModelDialog);
		if(values==null){
			return;
		}
		
		File file = new File((String) values.get("xmlFile"));
		
		 try {
					
		 String xmlScheme = Exporter.scheme2XML(exportingScheme);
	 
		 GeneralManagementFacade.getInstance().exportScheme(file,xmlScheme);
	
		 RefreshAction.getIstance().actionPerformed(arg0);
		 
		 ConsoleScroll.getInstance().logInformation("Model exported: [Name: "+exportingScheme.getName()+"]",Action.NAME,"scheme");
		 }catch (Exception exception) {
			 ProblemsScroll.getInstance().logError("Errors exporting model: [Error:"+exception.getMessage()+"]",Action.NAME,"scheme");
		 }	
	
	
			
	}

}