package org.modelgen.jpf.defineScheme.Tree.Popup.PopupActions;


import org.modelgen.facade.GeneralManagementFacade;
import org.modelgen.facade.ResourceFunctions;
import org.modelgen.jpf.defineScheme.Components.ConsoleScroll;
import org.modelgen.jpf.defineScheme.Components.ProblemsScroll;
import org.modelgen.jpf.defineScheme.Dialog.DSDialog;
import org.modelgen.jpf.defineScheme.Dialog.DSOptionPane;
import org.modelgen.jpf.defineScheme.Dialog.dialogIMPL.ImportSchemeDialog;

import java.awt.event.ActionEvent;
import java.io.File;
import java.util.Map;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.ImageIcon;

public class ImportSchemeAction extends AbstractAction{
	private static final long serialVersionUID = 5668861408150086238L;

	public static final String ACTION_NAME = "Import Scheme";
	
	private static ImportSchemeAction istance;

	
	private File file;
	private String importMode;
	
	public static ImportSchemeAction getIstance(){
		if(istance == null){
			istance = new ImportSchemeAction();
		}
		return istance;
	}	
	


	private ImportSchemeAction(){
		putValue(Action.SHORT_DESCRIPTION,ACTION_NAME);
		ImageIcon imageIcon = ResourceFunctions.openImageIcon(this.getClass(), "import.gif");
		putValue(Action.SMALL_ICON,imageIcon);
	}
	


	
	public void actionPerformed(ActionEvent arg0) {
		ConsoleScroll.getInstance().logTask("Importing scheme",Action.NAME,"workspace");
		DSDialog importSchemeDialog = new ImportSchemeDialog();
		Map<String,Object> values = (new DSOptionPane()).showInputDialog(importSchemeDialog);
		if(values==null){
			return;
		}
		
		
		file = new File((String)values.get("xmlFile"));
		String fileName = file.getAbsolutePath();
		
		 try {
		 
			 /**Aggiornamento lista modelli*/
			 /*boolean imported = */GeneralManagementFacade.getInstance().importScheme(fileName);
			 /*******************************/
			 
			 RefreshAction.getIstance().actionPerformed(arg0);
			 
			 ConsoleScroll.getInstance().logInformation("Scheme imported: [Method: "+importMode+", File: "+fileName+"]",Action.NAME,"workspace");				
		 } catch (Exception exception) {
			 exception.printStackTrace();
			 ProblemsScroll.getInstance().logWarning("Errors importing scheme: [Method: "+importMode+ ", File:"+fileName+", Error: "+exception.getMessage()+"]",Action.NAME,"workspace");
		 }	
		 
	
	}



}
