package org.modelgen.jpf.defineScheme.Tree.Popup.PopupActions;

import org.modelgen.commons.beans.model.Property;
import org.modelgen.commons.beans.model.Reference;
import org.modelgen.commons.beans.scheme.SchemeObject;
import org.modelgen.facade.GeneralManagementFacade;
import org.modelgen.facade.ResourceFunctions;
import org.modelgen.jpf.defineScheme.Components.ConsoleScroll;
import org.modelgen.jpf.defineScheme.Components.ProblemsScroll;
import org.modelgen.jpf.defineScheme.Dialog.DSDialog;
import org.modelgen.jpf.defineScheme.Dialog.DSOptionPane;
import org.modelgen.jpf.defineScheme.Dialog.dialogIMPL.ModifySchemeObjectDialog;

import java.awt.event.ActionEvent;
import java.util.Map;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.ImageIcon;


public class ModifySchemeObjectAction extends AbstractAction {
	private static final long serialVersionUID = -860604266490642342L;
	public static final String ACTION_NAME = "Modifying Object";
	private static ModifySchemeObjectAction istance;

	private ModifySchemeObjectAction(){
		putValue(Action.SHORT_DESCRIPTION,ACTION_NAME);
		ImageIcon imageIcon = ResourceFunctions.openImageIcon(this.getClass(), "renameConstruct.gif");
		putValue(Action.SMALL_ICON,imageIcon);
	}
	public static ModifySchemeObjectAction getIstance(){
		if(istance == null)
			istance = new ModifySchemeObjectAction();
		return istance;
	}
	
	@SuppressWarnings("unchecked")
	public void actionPerformed(ActionEvent arg0) {

		ConsoleScroll.getInstance().logTask("Modifyinf object",Action.NAME,"object");
		
		SchemeObject obj = ActionUtility.getSchemeObject();
		
		if (obj==null){
			ProblemsScroll.getInstance().logWarning("Select an object",Action.NAME , "scheme");
			return;
		}
		DSDialog modifySchemeObjectDialog = new ModifySchemeObjectDialog(obj);
		Map<String,Object> values = (new DSOptionPane()).showInputDialog(modifySchemeObjectDialog);
		
		if(values==null){
			return;
		}
		
		String objName = (String)values.get("objName");
		Map<Property,String> objPropertyMap = (Map<Property, String>) values.get("objProperties");
		Map<Reference,SchemeObject> objReferenceMap = (Map<Reference, SchemeObject>) values.get("objReferences");
		
		GeneralManagementFacade.getInstance().modifySchemeObject(obj, objName, objPropertyMap, objReferenceMap);

		RefreshAction.getIstance().actionPerformed(arg0);

		ConsoleScroll.getInstance().logInformation("SchemeObject modified: [Name: "+objName+ "]",Action.NAME,"object");
	}

}