package org.modelgen.jpf.defineScheme.Tree.Popup.PopupActions;

import org.modelgen.commons.beans.model.Model;
import org.modelgen.facade.GeneralManagementFacade;
import org.modelgen.jpf.defineScheme.Components.ConsoleScroll;
import org.modelgen.jpf.defineScheme.Dialog.DSDialog;
import org.modelgen.jpf.defineScheme.Dialog.DSOptionPane;
import org.modelgen.jpf.defineScheme.Dialog.dialogIMPL.NewSchemeDialog;

import java.awt.event.ActionEvent;
import java.util.Map;

import javax.swing.AbstractAction;
import javax.swing.Action;

public class NewSchemeAction extends AbstractAction {
	private static final long serialVersionUID = 1L;

	private Model model;

	public NewSchemeAction(Model mod){
		model = mod;
		putValue(Action.NAME,model.getName());
	}

	public void actionPerformed(ActionEvent arg0) {
		ConsoleScroll.getInstance().logTask("Adding new scheme",Action.NAME,"workspace");
		
		DSDialog newSchemeDialog = new NewSchemeDialog();
		Map<String,Object> values = (new DSOptionPane()).showInputDialog(newSchemeDialog);
		if(values==null){
				return;
		}
		
		String schemeName = (String)values.get("schemeName");
		
		GeneralManagementFacade.getInstance().newScheme(schemeName,model);

		RefreshAction.getIstance().actionPerformed(arg0);
		
		ConsoleScroll.getInstance().logInformation("Scheme added: [Name: "+schemeName+ ", Model: "+model.getName()+"]",Action.NAME,"model");
	}

}