package org.modelgen.jpf.defineScheme.Tree.Popup.PopupActions;

import org.modelgen.commons.beans.model.Construct;
import org.modelgen.commons.beans.model.Property;
import org.modelgen.commons.beans.model.Reference;
import org.modelgen.commons.beans.scheme.Scheme;
import org.modelgen.commons.beans.scheme.SchemeObject;
import org.modelgen.facade.GeneralManagementFacade;
import org.modelgen.jpf.defineScheme.Components.ConsoleScroll;
import org.modelgen.jpf.defineScheme.Dialog.DSDialog;
import org.modelgen.jpf.defineScheme.Dialog.DSOptionPane;
import org.modelgen.jpf.defineScheme.Dialog.dialogIMPL.AddSchemeObjectDialog;

import java.awt.event.ActionEvent;
import java.util.Map;

import javax.swing.AbstractAction;
import javax.swing.Action;

public class NewSchemeObjectAction extends AbstractAction {
	private static final long serialVersionUID = 5950430788898017775L;
	Construct cons;

	public NewSchemeObjectAction(Construct c){
		cons = c;
		putValue(Action.NAME,cons.getName());
	}

	@SuppressWarnings("unchecked")
	public void actionPerformed(ActionEvent arg0) {

		ConsoleScroll.getInstance().logTask("Adding new object",Action.NAME,"scheme");
		
		DSDialog newSchemeObjectDialog = new AddSchemeObjectDialog(cons);
		Map<String,Object> values = (new DSOptionPane()).showInputDialog(newSchemeObjectDialog);
		if(values==null){
				return;
		}
		Scheme s = ActionUtility.getScheme();
		String objName = (String)values.get("objName");
		Map<Property,String> objPropertyMap = (Map<Property, String>) values.get("objProperties");
		Map<Reference,SchemeObject> objReferenceMap = (Map<Reference, SchemeObject>) values.get("objReferences");
		
		GeneralManagementFacade.getInstance().addSchemeObject(s, cons, objName, objPropertyMap, objReferenceMap);
//
		RefreshAction.getIstance().actionPerformed(arg0);
//
		ConsoleScroll.getInstance().logInformation("SchemeObject added: [Name: "+objName+ ", Scheme: "+s.getName()+"]",Action.NAME,"scheme");
	}

}