package org.modelgen.jpf.defineScheme.Tree.Popup.PopupActions;

import org.modelgen.facade.ResourceFunctions;
import org.modelgen.jpf.defineScheme.Tree.WorkSpaceTree;

import java.awt.event.ActionEvent;
import java.util.Collections;
import java.util.Enumeration;
import java.util.List;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.ImageIcon;
import javax.swing.JTree;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreeNode;
import javax.swing.tree.TreePath;


public class RefreshAction extends AbstractAction{
	private static final long serialVersionUID = -3345779358970335113L;

	public static final String ACTION_NAME = "Refresh Workspace";

	
	private static RefreshAction istance;
	
	public static RefreshAction getIstance(){
		if(istance == null)
			istance = new RefreshAction();
		return istance;
	}	
	
	private RefreshAction(){
		putValue(Action.SHORT_DESCRIPTION,ACTION_NAME);
		ImageIcon imageIcon = ResourceFunctions.openImageIcon(this.getClass(), "delete.gif");
		putValue(Action.SMALL_ICON,imageIcon);
	}
	
	
	public void actionPerformed(ActionEvent arg0) {
		WorkSpaceTree scroll = WorkSpaceTree.getIstance();
			JTree tree = scroll.getTree();
			DefaultTreeModel model = ((DefaultTreeModel)tree.getModel());
			TreePath tp = tree.getSelectionPath();

			List<TreePath> tps = null;
			Enumeration<TreePath> en = tree.getExpandedDescendants(new TreePath(model.getPathToRoot((TreeNode)model.getRoot())));
			if(en!=null){
				tps = Collections.list(en);
			}
			
			WorkSpaceTree.setLastSelectedPath(tp);	
			WorkSpaceTree.setLastExpandedPaths(tps);
			
			/** GIO VALUECHANGED */
//			((TreeContent)scroll.getTree()).notificaAggiornamentoSelezione();

			scroll.refresh();
	}

}
