package org.modelgen.jpf.defineScheme.Tree.Popup.PopupActions;

import org.modelgen.commons.beans.scheme.Scheme;
import org.modelgen.facade.ResourceFunctions;
import org.modelgen.jpf.defineScheme.Components.ConsoleScroll;
import org.modelgen.jpf.defineScheme.Components.ProblemsScroll;
import org.modelgen.jpf.defineScheme.Dialog.DSDialog;
import org.modelgen.jpf.defineScheme.Dialog.DSOptionPane;
import org.modelgen.jpf.defineScheme.Dialog.dialogIMPL.RenameSchemeDialog;

import java.awt.event.ActionEvent;
import java.util.Map;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.ImageIcon;


public class RenameSchemeAction extends AbstractAction {
	private static final long serialVersionUID = 2616157675955024877L;

	public static final String ACTION_NAME = "Rename Scheme";
	
	private static RenameSchemeAction istance;
	
	public static RenameSchemeAction getIstance(){
		if(istance == null)
			istance = new RenameSchemeAction();
		return istance;
	}	
	
	private RenameSchemeAction(){
		putValue(Action.SHORT_DESCRIPTION,ACTION_NAME);
		ImageIcon imageIcon = ResourceFunctions.openImageIcon(this.getClass(), "rename.gif");
		putValue(Action.SMALL_ICON,imageIcon);
	}

	
	public void actionPerformed(ActionEvent arg0) {
	
		ConsoleScroll.getInstance().logTask("Renaming scheme",Action.NAME,"model");
		Scheme scheme = ActionUtility.getScheme();
		
		if (scheme==null){
			ProblemsScroll.getInstance().logWarning("Select a scheme",Action.NAME , "workspace");
			return;
		}
		
		DSDialog renameModelDialog = new RenameSchemeDialog();
		Map<String, Object> values = (new DSOptionPane()).showInputDialog(renameModelDialog);
	
		if(values==null){
			return;
		}
		
		//rinominiamo lo schema manon rendiamo persistenti le modifiche
		String schemeName = (String) values.get("schemeName");
		scheme.setName(schemeName);

		/*Performs RefreshAction*/
		RefreshAction.getIstance().actionPerformed(arg0);	
	
		ConsoleScroll.getInstance().logInformation("Scheme renamed: [Name: "+schemeName+ "]",Action.NAME,"scheme");
	}

}
