package org.modelgen.jpf.defineScheme.Tree.Popup.PopupActions;


import org.modelgen.commons.beans.scheme.Scheme;
import org.modelgen.commons.persistence.PersistenceException;
import org.modelgen.facade.GeneralManagementFacade;
import org.modelgen.facade.ResourceFunctions;
import org.modelgen.jpf.defineScheme.Components.ConsoleScroll;
import org.modelgen.jpf.defineScheme.Components.ProblemsScroll;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.ImageIcon;

public class StoreSchemeAction extends AbstractAction {

	private static final long serialVersionUID = 2436114989192680438L;

	public static final String ACTION_NAME = "Save...";
	
	private static StoreSchemeAction istance;
	
	public static StoreSchemeAction getIstance(){
		if(istance == null)
			istance = new StoreSchemeAction();
		return istance;
	}	
	
	private StoreSchemeAction(){
		putValue(Action.SHORT_DESCRIPTION,ACTION_NAME);
		ImageIcon imageIcon = ResourceFunctions.openImageIcon(this.getClass(), "save.png");
		putValue(Action.SMALL_ICON,imageIcon);
	}

	
	public void actionPerformed(ActionEvent arg0) {
		ConsoleScroll.getInstance().logTask("Saving scheme",Action.NAME,"scheme");
		Scheme scheme = ActionUtility.getScheme();
		
		if (scheme==null){
			ProblemsScroll.getInstance().logWarning("Select a scheme", "Save scheme", "scheme");
			return;
		}

		try {
			GeneralManagementFacade.getInstance().storeScheme(scheme);
			ConsoleScroll.getInstance().logInformation("Scheme saved: [Name: "+scheme.getName()+"]",Action.NAME,"scheme");
		} catch (PersistenceException e) {
			ProblemsScroll.getInstance().logError("Errors saving scheme: ["+e.getMessage()+"]",Action.NAME,"scheme");
		}
		
		
		/*Performs RefreshAction*/
		RefreshAction.getIstance().actionPerformed(arg0);
		
	}

}