package org.modelgen.jpf.defineScheme.Tree.Popup.PopupActions;

import org.modelgen.commons.beans.scheme.Scheme;
import org.modelgen.facade.ResourceFunctions;
import org.modelgen.jpf.defineScheme.DefineSchemeTool;
import org.modelgen.jpf.defineScheme.Components.ConsoleScroll;
import org.modelgen.jpf.defineScheme.Components.ProblemsScroll;
import org.modelgen.jpf.defineScheme.Components.TextReport;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.ImageIcon;
import javax.swing.JTabbedPane;

public class TextReportSchemeAction extends AbstractAction {
	private static final long serialVersionUID = -5695677282259423443L;
	public static final String ACTION_NAME = "Text Report";
	
	private static TextReportSchemeAction istance;
	
	public static TextReportSchemeAction getIstance(){
		if(istance == null)
			istance = new TextReportSchemeAction();
		return istance;
	}	
	
	
	private TextReportSchemeAction(){
		putValue(Action.SHORT_DESCRIPTION,ACTION_NAME);
		ImageIcon imageIcon = ResourceFunctions.openImageIcon(this.getClass(), "textRep.png");
		putValue(Action.SMALL_ICON,imageIcon);
	}
	
	
	public void actionPerformed(ActionEvent arg0) {
		ConsoleScroll.getInstance().logTask("Reporting text scheme",Action.NAME,"scheme");
		Scheme scheme = ActionUtility.getScheme();
		
		if (scheme==null){
			ProblemsScroll.getInstance().logWarning("Select a scheme",Action.NAME , "workspace");
			return;
		}

		JTabbedPane reportsTab = DefineSchemeTool.getIstance().getReportsTab();

		TextReport scroll = TextReport.getInstance(scheme);

		if (scroll.isNew()){
			reportsTab.addTab(scheme.getName(),ResourceFunctions.openImageIcon(this.getClass(), "littleReport.gif"),scroll,"Visual Report");
		}
		reportsTab.setSelectedComponent(scroll);
	}

}
