package org.modelgen.jpf.defineScheme.Tree.Popup.PopupActions;

import org.modelgen.commons.beans.scheme.Scheme;
import org.modelgen.facade.ResourceFunctions;
import org.modelgen.jpf.defineScheme.DefineSchemeTool;
import org.modelgen.jpf.defineScheme.Components.ConsoleScroll;
import org.modelgen.jpf.defineScheme.Components.ProblemsScroll;
import org.modelgen.jpf.defineScheme.Components.VisualReport;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.ImageIcon;
import javax.swing.JTabbedPane;

public class VisualReportSchemeAction extends AbstractAction {
	private static final long serialVersionUID = 2482298386529271326L;
	public static final String ACTION_NAME = "Visual Report";
	
	private static VisualReportSchemeAction istance;
	
	public static VisualReportSchemeAction getIstance(){
		if(istance == null)
			istance = new VisualReportSchemeAction();
		return istance;
	}	
	
	
	private VisualReportSchemeAction(){
		putValue(Action.SHORT_DESCRIPTION,ACTION_NAME);
		ImageIcon imageIcon = ResourceFunctions.openImageIcon(this.getClass(), "visualRep.png");
		putValue(Action.SMALL_ICON,imageIcon);
	}
	


	
	public void actionPerformed(ActionEvent arg0) {
		ConsoleScroll.getInstance().logTask("Reporting visual scheme",Action.NAME,"scheme");
		Scheme scheme = ActionUtility.getScheme();
		
		if (scheme==null){
			ProblemsScroll.getInstance().logWarning("Select a scheme",Action.NAME , "workspace");
			return;
		}

		JTabbedPane reportsTab = DefineSchemeTool.getIstance().getReportsTab();

		VisualReport scroll = VisualReport.getInstance(scheme);

		if (scroll.isNew()){
			reportsTab.addTab(scheme.getName(),ResourceFunctions.openImageIcon(this.getClass(), "littleReport.gif"),scroll,"Visual Report");
		}
		reportsTab.setSelectedComponent(scroll);
	}

}
