package org.modelgen.jpf.defineScheme.Tree;

import org.modelgen.commons.beans.scheme.Scheme;
import org.modelgen.commons.beans.scheme.SchemeObject;
import org.modelgen.jpf.defineScheme.DefineSchemeTool;
import org.modelgen.jpf.defineScheme.Components.StatusUtility;
import org.modelgen.jpf.defineScheme.Tree.ObjectDescription.NodeInfo;
import org.modelgen.jpf.defineScheme.Tree.ObjectDescription.TreeContent;

import java.awt.Color;
import java.awt.Dimension;
import java.util.List;

import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JToolBar;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.TreePath;

public class WorkSpaceTree extends JScrollPane implements TreeSelectionListener{
		private static final long serialVersionUID = 6616585849640244130L;
				
		private static TreeContent tree;
		
		private static WorkSpaceTree istance = null;
		
		private static TreePath lastSelectedPath = null;
		private static List<TreePath> lastExpandedPaths = null;
		
		public static WorkSpaceTree getIstance(){
			if (istance==null){
				istance = new WorkSpaceTree();
			}
			return istance;
		}

		private WorkSpaceTree(){
			 super();
			 JPanel columnHeader = new JPanel();
			 	columnHeader.setBackground(Color.WHITE);
			 	columnHeader.setPreferredSize(new Dimension(0,5));
			 	
			 	setColumnHeaderView(columnHeader);
			 tree = TreeContent.createsTreeContent();
			 if (tree!=null){
				 paintWorkSpace(tree);
			 }else{
				 paintError();
			 }
			 
			 /*Init ScrollPane Properties*/
//			 Dimension minimumSize = new Dimension(100, 50);
//			 setMinimumSize(minimumSize);
			 Dimension screenDim = getToolkit().getScreenSize();
			 int thisWidth = (int) (screenDim.getWidth()/(5.4));
			 setMinimumSize(new Dimension(thisWidth,0)); 		
		}
			 

		private void paintWorkSpace(JComponent treeNew) {
			tree.addTreeSelectionListener(this);
			setViewportView(treeNew);		
			updateUI();
		}
		
		private void paintError() {
			JPanel panel = new JPanel();
			JLabel errL = new JLabel("Errore nel DataBase");
			panel.add(errL);
			paintWorkSpace(panel);
		}
		
		public void refresh() {
//			tree = TreeContent.creaTreeContent();		
//			paintWorkSpace(tree);
			tree = TreeContent.createsTreeContent();		
			if (tree!=null){
				paintWorkSpace(tree);
			}else{
				paintError();
			}
		}

		public TreeContent getTree() {
			return tree;
		}

		public void valueChanged(TreeSelectionEvent arg0){
			JToolBar toolBar = DefineSchemeTool.getIstance().getToolBar();
			StatusUtility statusUtil = new StatusUtility(toolBar);
			
			statusUtil.enableStatus("root");
			statusUtil.disableOthers();
			
			if(arg0==null){
				return;
			}
					
			Object objPath = tree.getLastSelectedPathComponent();
			
			if (objPath==null){
				return;
			}
			
			DefaultMutableTreeNode node = (DefaultMutableTreeNode) objPath;
		
			/*Controllo importante (node==null prima di node.isRoot())*/	
			if(node.isRoot()){;
				return;
		    }
			/***********************/
			Object obj = node.getUserObject();
			NodeInfo nodeInfo;
			if(obj==null){
				return;
			}

			nodeInfo = (NodeInfo) obj;

			
			Object dataObject = nodeInfo.getDataObject();
				
			if(dataObject instanceof Scheme){
				statusUtil.enableStatus("scheme");
				statusUtil.disableOthers();
				return;
			}
			
			if(dataObject instanceof SchemeObject){
				statusUtil.enableStatus("object");
				statusUtil.disableOthers();
				return;
			}
			
		}



		public static List<TreePath> getLastExpandedPaths() {
			return lastExpandedPaths;
		}



		public static void setLastExpandedPaths(List<TreePath> lastExpandedPaths) {
			WorkSpaceTree.lastExpandedPaths = lastExpandedPaths;
		}



		public static TreePath getLastSelectedPath() {
			return lastSelectedPath;
		}



		public static void setLastSelectedPath(TreePath lastSelectedPath) {
			WorkSpaceTree.lastSelectedPath = lastSelectedPath;
		}
		
}

