package org.modelgen.jpf.defineScheme.utility;


import org.modelgen.commons.beans.model.Construct;
import org.modelgen.commons.beans.model.Model;
import org.modelgen.commons.beans.scheme.Scheme;
import org.modelgen.facade.GeneralManagementFacade;
import org.modelgen.jpf.defineScheme.Tree.Popup.PopupActions.NewSchemeAction;
import org.modelgen.jpf.defineScheme.Tree.Popup.PopupActions.NewSchemeObjectAction;
import org.modelgen.jpf.defineScheme.Tree.Popup.PopupActions.TextReportSchemeAction;
import org.modelgen.jpf.defineScheme.Tree.Popup.PopupActions.VisualReportSchemeAction;
import org.modelgen.jpf.defineScheme.Tree.Popup.PopupActions.VoidNewSchemeAction;
import org.modelgen.jpf.defineScheme.Tree.Popup.PopupActions.VoidNewSchemeObjectAction;
import org.modelgen.jpf.defineScheme.Tree.Popup.PopupActions.VoidReportAction;

import java.awt.Container;
import java.awt.MenuContainer;
import java.util.Collection;
import java.util.Iterator;

import javax.swing.JMenu;
import javax.swing.JMenuItem;

public class MenuGenerator {
	private static MenuGenerator istance;
	
	public static MenuGenerator getIstance(){
			if(istance == null){
				istance = new MenuGenerator();
			}
			return istance;
	}	
	
	public JMenu createReportMenu(){
		JMenu reportScheme = new JMenu(VoidReportAction.getIstance());
			reportScheme.setText(VoidReportAction.ACTION_NAME);
		JMenuItem visualRep = new JMenuItem(VisualReportSchemeAction.getIstance());
		visualRep.setText(VisualReportSchemeAction.ACTION_NAME);
		JMenuItem textRep = new JMenuItem(TextReportSchemeAction.getIstance());
		textRep.setText(TextReportSchemeAction.ACTION_NAME);
			reportScheme.add(visualRep);
			reportScheme.add(textRep);
		return reportScheme;
	}
	public JMenu createAvailableModelsMenu(){
		JMenu menu = new JMenu(VoidNewSchemeAction.getIstance());
			menu.setText(VoidNewSchemeAction.ACTION_NAME);
			addAvailableSchemeModels(menu);
		return menu;
	}
	
	public void addAvailableSchemeModels(MenuContainer menu) {
		Collection<Model> availableModels = null;
		try {
			availableModels = GeneralManagementFacade.getInstance().getModelsLoaded();
		} catch (Exception e) {
			e.printStackTrace();
		}
		if (availableModels==null)
			return;
		if(availableModels.isEmpty()){
			((Container) menu).add(new JMenuItem("There are no available models"));
		}
		
			Iterator<Model> it = availableModels.iterator();
			while(it.hasNext()){
				((Container) menu).add(new JMenuItem(new NewSchemeAction(it.next())));
			}
		
		
	}

	public JMenu createAvailableSchemeObjectsMenu(Scheme s){
		JMenu menu = new JMenu(VoidNewSchemeObjectAction.getIstance());
			addAvailableSchemeObjects(menu,s);
		return menu;
	}
	public void addAvailableSchemeObjects(Container c, Scheme s){
		Collection<Construct> availableConstruct = s.getAvailableConstructs();
		Iterator<Construct> it = null;
			it = availableConstruct.iterator();
			while(it.hasNext()){
				c.add(new JMenuItem(new NewSchemeObjectAction(it.next())));
			}
	}
	
}
