/*
 * Listener for tool bar 
 */
package org.modelgen.jpf.defineSkolem;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 * @author  Domenico  Listener for tool bar
 */
class ActionListenerToolBar implements ActionListener{
	// References to the class to listen
	private ToolBarSkolem tbSkolem;
	private ManagementSkolemTool mngSkolem;
	
	/**
	 * Class construnctor
	 * @param tbSkolem The references to the tool bar
	 * @param mngSkolem The references to main window
	 */
	public ActionListenerToolBar(ToolBarSkolem tbSkolem, 
			ManagementSkolemTool mngSkolem) {
		super();
		this.tbSkolem = tbSkolem;
		this.mngSkolem = mngSkolem;
	}

	public void actionPerformed(ActionEvent e) {
		if(e.getSource() == this.tbSkolem.btnInsert)
			this.mngSkolem.addPanelNewSkolem();
		else if(e.getSource() == this.tbSkolem.btnDelete)
			this.tbSkolem.deleteSkolem();
		else if(e.getSource() == this.tbSkolem.btnExport)
			this.mngSkolem.addPanelExport();
		else if(e.getSource() == this.tbSkolem.btnImport)
			this.mngSkolem.addPanelImport();
		else if(e.getSource() == this.tbSkolem.btnPrintSuperModel)
			this.mngSkolem.addPanelPrintSuperModel();
	} 
}