/*
 * Create icon for button. It's a completly static class 
 */
package org.modelgen.jpf.defineSkolem.util;

import org.modelgen.facade.ResourceFunctions;

import javax.swing.ImageIcon;

/**
 * @author gabriele
 * Create icon for button
 */
public class FactoryIcon {
	// Parameter for icon
	private static final String INSERT = 
		"new.png";
	private static final String DELETE = 
		"deleteConstruct.png";
	private static final String IMPORT = 
		"import.png";
	private static final String EXPORT = 
		"export.png";
	private static final String PRINT_SUPER_MODEL = 
		"report.png";
	private static final String CLOSE = 
		"button_cancel.png";
	
	/**
	 * Create image icon for insert
	 * @return ImageIcon
	 */
	public static ImageIcon createInsertIcon() {
		return ResourceFunctions.openImageIcon(FactoryIcon.class, INSERT);
	}
	
	/**
	 * Create image icon for delete
	 * @return ImageIcon
	 */
	public static ImageIcon createDeleteIcon() {
		return ResourceFunctions.openImageIcon(FactoryIcon.class, DELETE);
	}
	
	/**
	 * Create image icon for import
	 * @return ImageIcon
	 */
	public static ImageIcon createImportIcon() {
		return ResourceFunctions.openImageIcon(FactoryIcon.class, IMPORT);
	}
	
	/**
	 * Create image icon for export
	 * @return ImageIcon
	 */
	public static ImageIcon createExportIcon() {
		return ResourceFunctions.openImageIcon(FactoryIcon.class, EXPORT);
	}
	
	/**
	 * Create image icon for print super model
	 * @return ImageIcon
	 */
	public static ImageIcon createPrintSuperModelIcon() {
		return ResourceFunctions.openImageIcon(FactoryIcon.class, PRINT_SUPER_MODEL);
	}
	
	/**
	 * Create icon for close
	 * @return ImageIcon
	 */
	public static ImageIcon createCloseIcon() {
		return ResourceFunctions.openImageIcon(FactoryIcon.class, CLOSE);
	}
}