package org.modelgen.jpf.opgen;

import java.util.concurrent.Callable;

import org.modelgen.regole.MacroRegola;

/**
 * acts as an executor for time-consuming operator generations.
 * It also implements the command pattern, every command is unified under the same CommandWorker
 * abstract class. A concrete CommandWorker actually implements the method.
 * @author luigi, francesca
 *
 */
public abstract class CommandWorker implements Callable<MacroRegola> {
			
	public MacroRegola call() throws Exception {
		return executeCommand();		
	}
	
	/**
	 * the actual command
	 * @return the actual command
	 */
	public abstract MacroRegola executeCommand();
		
	

}
