package org.modelgen.jpf.opgen.common;

/**
 * represents a reference qualified with the corresponding
 * VariantConstruct type
 * @author luigi, francesca
 *
 */
public class InstanciatedReference {
	
	/* the reference and the VariantConstruct it links */
	private MsmReference reference;
	private VariantConstruct variantConstruct;

	public InstanciatedReference(MsmReference ref, VariantConstruct variantConstruct) {
		this.reference = ref;
		this.variantConstruct = variantConstruct;
	}
	
	public MsmReference getMsmReference() {
		return this.reference;
	}
	
	public VariantConstruct getVariantConstruct() {
		return this.variantConstruct;
	}
	
	/**
	 * returns the name of the variant construct which 
	 * instanciates this reference
	 * @return construct name
	 */
	public String getConstructName() {
		return this.variantConstruct.getName();
	}
	
	/**
	 * returns the name of the reference it instanciates
	 * @return reference name
	 */
	public String getReferenceName() {
		return this.reference.getName();
	}
	
}
