package org.modelgen.jpf.opgen.common;

import java.io.Serializable;
import java.util.Set;

import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Table;

import org.modelgen.regole.SkolemFunction;
/**
 * represents a MsmSkolemFunction
 * @author luigi, francesca
 *
 */
@Entity
@Table(name="MSM_SKOLEMFUNCTION")
public class MsmSkolemfunction implements Serializable {
	@Id
	private int oid;

	private String name;

	@ManyToOne
	@JoinColumn(name="CONSTRUCTOID")
	private MsmConstruct constructoid;

	@OneToMany(mappedBy="functionoid")
	private Set<MsmSkolemfunctionargument> msmSkolemfunctionargumentCollection;

	private static final long serialVersionUID = 1L;

	public MsmSkolemfunction() {
		super();
	}

	public int getOid() {
		return this.oid;
	}

	public void setOid(int oid) {
		this.oid = oid;
	}

	public String getName() {
		return this.name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public MsmConstruct getConstructoid() {
		return this.constructoid;
	}

	public void setConstructoid(MsmConstruct constructoid) {
		this.constructoid = constructoid;
	}

	public Set<MsmSkolemfunctionargument> getMsmSkolemfunctionargumentCollection() {
		return this.msmSkolemfunctionargumentCollection;
	}

	public void setMsmSkolemfunctionargumentCollection(Set<MsmSkolemfunctionargument> msmSkolemfunctionargumentCollection) {
		this.msmSkolemfunctionargumentCollection = msmSkolemfunctionargumentCollection;
	}
	
	
	/**
	 * returns a skolem function which is usable with RegolaDatalog
	 * @return a skolem function which is usable with RegolaDatalog
	 */
	public SkolemFunction getSkolemFunction() {
		return new SkolemFunction("SM_" + this.constructoid.getName(), "OID", this.name);
	}

}
