package org.modelgen.jpf.opgen.common;
import java.util.Collections;
import java.util.LinkedList;
import java.util.List;

/**
 * contains set operators
 * @author luigi, francesca
 *
 */
public class SetOperator {
	
	/**
	 * computes the n-ary cartesian product among
	 * list of T objects
	 * @param <T>
	 * @param insiemi
	 * @return the n-ary cartesian product
	 */
	public <T> List<List<T>> prod(List<List<T>> insiemi) {
		
		/* tuples of the cartesian product */
		List<List<T>> risultato = new LinkedList<List<T>>();
		
		/* base case (one set) */
		if(insiemi.size()==1)
			for(T l: insiemi.get(0)) {
				List<T> parz = new LinkedList<T>();
				parz.add(l);		
				/* result is the set of the sets composed */
				/* by any element of the one set */
				risultato.add(parz);
			}
		
		/* recursive case */
		else { 
			List<List<T>> insiemi1 = deepCopy(insiemi);
			
			/* extracts and removes the first element */
			List<T> primo = insiemi1.get(0);
			insiemi1.remove(0);
			
			List<List<T>> insiemeApp = prod(insiemi1);		
			
			/* starting from the recursive result, adds */
			/* the elements of the removed list */
			for(T t : primo) {
				List<List<T>> risParz = new LinkedList<List<T>>();
				risParz = deepCopy(insiemeApp);
				for(List<T> lt : risParz) {
					Collections.reverse(lt);
					lt.add(t);
					Collections.reverse(lt);
				}
			risultato.addAll(risParz);
			
			
			}
		}
			
		return risultato;	
		
	}
	
	/**
	 * actually copies a list (not just references)
	 * @param <T>
	 * @param l
	 * @return the list copy
	 */
	private <T> List<List<T>> deepCopy(List<List<T>> l) {
		List<List<T>> result = new LinkedList<List<T>>();
		for(List<T> lt : l)
			result.add(new LinkedList<T>(lt));
		
		return result;
		
	}
	
	
		
}
