package org.modelgen.jpf.opgen.ormHandling;

import javax.persistence.EntityManagerFactory;

/**
 * a proxy for toplink EntityManagerFactory which performs
 * the classLoader switching.
 * @author luigi, francesca
 *
 */
public class EntityManagerFactoryProxy extends Switcher {
	
	private EntityManagerFactory emf;
	
	
	/**
	 * builds a proxy for an entity manager storing the base for thread switching
	 * @param emf
	 * @param threadLoader
	 */
	public EntityManagerFactoryProxy(EntityManagerFactory emf, ClassLoader threadLoader) {
		super(threadLoader);
		this.emf = emf;		
	}	
	
	public EntityManagerProxy createEntityManagerProxy() throws SwitchingException {
		switchClassLoader();
		EntityManagerProxy emp = null;
		try {
			emp = new EntityManagerProxy(emf.createEntityManager(),threadLoader);
		} catch (Exception ex) {
			System.out.println("OpGen: Exception occurred during ClassLoader switching");
			System.out.println("Message: "+ ex.getMessage());
			throw new SwitchingException();
		} finally {
			switchClassLoader();
		}
		return emp;
		
	}

}
