package org.modelgen.jpf.opgen.ormHandling;

import javax.persistence.EntityManager;

/**
 * a proxy for toplink EntityManager which performs
 * the classLoader switching.
 * @author luigi, francesca
 *
 */
public class EntityManagerProxy extends Switcher {
	
	private EntityManager em;
	
	/**
	 * builds an entity manager, storing a base for thread switching 
	 * @param em
	 * @param threadLoader
	 */
	public EntityManagerProxy(EntityManager em, ClassLoader threadLoader) {
		super(threadLoader);
		this.em = em;		
	}
	
	/**
	 * builds classess given the primary key
	 * @param <T>
	 * @param entityClass
	 * @param primaryKey
	 * @return classess given the primary key
	 */
	public <T> T find(Class<T> entityClass, Object primaryKey) throws SwitchingException {
		switchClassLoader();
		T t = null;
		try {
			t = em.find(entityClass, primaryKey);
		} catch (Exception ex) {
			System.out.println("OpGen: Exception occurred during ClassLoader switching");
			System.out.println("Message: "+ ex.getMessage());
			throw new SwitchingException();
		} finally {
			switchClassLoader();
		}
		return t;
	}
	

}
