package org.modelgen.jpf.opgen.ormHandling;

import javax.persistence.Persistence;

/**
 * a proxy for toplink Persistence which performs
 * the classLoader switching.
 * @author luigi, francesca
 *
 */
public class ORMProxy extends Switcher {
	
	private static ORMProxy instance = null;
	
	private ORMProxy() {
		super(Thread.currentThread().getContextClassLoader());
	}
	
	public static ORMProxy getInstance() {
		if(instance==null)
			instance = new ORMProxy();
		return instance;
	}

	/**
	 * returns a proxy for entity manager factory.
	 * @param pu
	 * @return a proxy for entity manager factory.
	 */
	public EntityManagerFactoryProxy createEntityManagerFactoryProxy(String pu) throws SwitchingException {
		this.switchClassLoader();
		
		EntityManagerFactoryProxy emfp = null;
		
		try {
			emfp = new EntityManagerFactoryProxy(Persistence.createEntityManagerFactory(pu),threadLoader);		
		} catch (Exception ex) {
			System.out.println("OpGen: Exception occurred during ClassLoader switching");
			System.out.println("Message: "+ ex.getMessage());
			throw new SwitchingException();
		} finally {
			switchClassLoader();
		}
		
		return emfp;
	}
	
	
}
