package org.modelgen.jpf.signatureApplication.applicationView;

import org.modelgen.jpf.signatureApplication.applicationView.action.ActionListenerMenu;
import org.modelgen.jpf.signatureApplication.load.FactoryIcon;

import java.awt.Toolkit;
import java.awt.event.ActionListener;

import javax.swing.JInternalFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.KeyStroke;


/**
 * @author Fabrizio Celli
 */
public class MenuSignatureApplication extends JMenuBar {
	private static final long serialVersionUID = 8105446230570226130L;
	// Singleton
	private static MenuSignatureApplication instance;
	// Internal frame
	private JInternalFrame main;
	// Listener
	private ActionListener lstAction;
	// Component of menu
	private JMenu file;
	public JMenuItem execute;
	public JMenuItem finish;
	public JMenuItem exit;
	
	/**
	 * Class constructor
	 * @param main The internal frame under this menu
	 * @param pnlCopy The references to the panel with copy function
	 * @param pnlRules The references to the panel with apply instance rules function
	 */
	private MenuSignatureApplication(JInternalFrame main,  
			PanelRules pnlRules) {   
		this.main = main;
		// Creates listener
		this.lstAction = new ActionListenerMenu(this,  pnlRules);
		// Creates menu and components
		this.file = new JMenu("File");
		this.execute = new JMenuItem("Execute");
		this.execute.setIcon(FactoryIcon.createExecuteIcon());
		this.execute.setAccelerator(KeyStroke.getKeyStroke(
				'E', Toolkit.getDefaultToolkit().getMenuShortcutKeyMask(), false));
		this.execute.addActionListener(this.lstAction);
		this.finish = new JMenuItem("Finish");
		this.finish.setIcon(FactoryIcon.createFinishIcon());
		this.finish.setAccelerator(KeyStroke.getKeyStroke(
				'E', Toolkit.getDefaultToolkit().getMenuShortcutKeyMask(), false));
		this.finish.addActionListener(this.lstAction);
		this.exit = new JMenuItem("Exit");
		this.exit.setIcon(FactoryIcon.createCloseIcon());
		this.exit.setAccelerator(KeyStroke.getKeyStroke(
				'Q', Toolkit.getDefaultToolkit().getMenuShortcutKeyMask(), false));
		// Add to menu
		this.file.addSeparator();
		this.file.add(this.execute);
		this.file.add(this.finish);
		this.file.addSeparator();
		this.file.add(this.exit);
		// Add to menu bar
		this.add(this.file);
	}
	
	/**
	 * Return an instance of class
	 * @param main The internal frame under this menu
	 * @param pnlRules The references to the panel with apply instance rules function
	 */
	public static MenuSignatureApplication getInstance(JInternalFrame main,  
			PanelRules pnlRules) { 
		/* Singleton */
		if(instance == null)
			instance = new MenuSignatureApplication(main,  pnlRules); 
		return instance;
	}
	
	/**
	 * Close this plugin
	 */
	public void close() {
		this.main.doDefaultCloseAction();
	}
}