package org.modelgen.jpf.signatureApplication.applicationView.action;

import org.modelgen.commons.beans.model.Model;
import org.modelgen.commons.persistence.PersistenceException;
import org.modelgen.facade.GeneralManagementFacade;
import org.modelgen.jpf.signatureApplication.applicationView.PanelInfo;
import org.modelgen.signature.ModelSignature;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

public class ActionListenerCmb implements ActionListener {
	// References to the class to listen
	private PanelInfo panel;

	/**
	 * Class constructor
	 */
	public ActionListenerCmb(PanelInfo panel) {
		super();
		this.panel = panel;
	}

	
	/**
	 * Determina la Cmb sorgente dell'evento e calcola la segnatura legata ad essa.
	 */
	public void actionPerformed(ActionEvent e) {
		if(e.getSource() == this.panel.getCmbSchemes()){
			/* 
			String schema = panel.getSelectedSchema();
			ModelSignature msSchema = null;
			if(schema.charAt(0)!='.'){
				String number = schema.substring(0, 2);
				int oid;
				if(number.charAt(1)==':'){
					oid = Integer.parseInt(schema.substring(0, 1));
				}
				else{
					oid = Integer.parseInt(number);
				}
				try {
					msSchema = GeneralManagementFacade.getInstance().getSignatureSuperModelSchema(oid);
				} catch (PersistenceException e1) {
					e1.printStackTrace();
				}
				if(msSchema!=null){
					panel.getScheme().setText("SOURCE:\n"+msSchema.toString());
					panel.setSource(msSchema);
				}
			}
			else{
				panel.getScheme().setText("no source scheme selected");
				panel.setSource(null);
			}
			*/
			
			String model = panel.getSelectedSchema();
			if(model.charAt(0)!='.'){
				String modelName = this.getModelName(model);
				Model modello;
				try {
					modello = GeneralManagementFacade.getInstance().getModelForName(modelName);
					ModelSignature msModel = modello.getModelSignature();
					if(msModel!=null){
						panel.getScheme().setText("SOURCE:\n"+msModel.toString());
						panel.setSource(msModel);
					}
				} catch (PersistenceException e1) {
					e1.printStackTrace();
				}
			}
			else{
				panel.getScheme().setText("no target model selected");
				panel.setSource(null);
			}
			
		}
		else
			if(e.getSource() == this.panel.getCmbModels()){
				String model = panel.getSelectetModel();
				if(model.charAt(0)!='.'){
					String modelName = this.getModelName(model);
					Model modello;
					try {
						modello = GeneralManagementFacade.getInstance().getModelForName(modelName);
						ModelSignature msModel = modello.getModelSignature();
						if(msModel!=null){
							panel.getModel().setText("TARGET:\n"+msModel.toString());
							panel.setTarget(msModel);
						}
					} catch (PersistenceException e1) {
						e1.printStackTrace();
					}
				}
				else{
					panel.getModel().setText("no target model selected");
					panel.setTarget(null);
				}
			}

	}

	/**
	 * Data una stringa del tipo:
	 * 	NOME_MODELLO (SHORT_NAME)
	 * riporta la sottostringa NOME_MODELLO
	 * @param model
	 */
	private String getModelName(String model) {
		int posParentesi = model.indexOf("(");
		if(posParentesi!=-1)
			model = model.substring(0, posParentesi-1);
		return model;
	}

}
