/*
 * Create icon for button
 */
 
package org.modelgen.jpf.signatureApplication.load;

import org.modelgen.facade.ResourceFunctions;

import javax.swing.ImageIcon;

/**
 * Create icon for button
 */
public class FactoryIcon {
	// Parameter for icon
	private static final String FINISH = 
		"gtk-apply.png";
	private static final String ADD = 
		"arrow_right.png";
	private static final String REMOVE = 
		"arrow_left.png";
	private static final String EXECUTE = 
		"book_next.png";
	private static final String CLOSE = 
		"button_cancel.png";
	
	/**
	 * Create image icon for "finish" application
	 * @return ImageIcon
	 */
	public static ImageIcon createFinishIcon() {
		return ResourceFunctions.openImageIcon(FactoryIcon.class, FINISH);
	}
	
	/**
	 * Create image icon for execute rule
	 * @return ImageIcon
	 */
	public static ImageIcon createExecuteIcon() {
		return ResourceFunctions.openImageIcon(FactoryIcon.class, EXECUTE);
	}
	
	/**
	 * Create image icon for add
	 * @return ImageIcon
	 */
	public static ImageIcon createAddIcon() {
		return ResourceFunctions.openImageIcon(FactoryIcon.class, ADD);
	}
	
	/**
	 * Create image icon for remove
	 * @return ImageIcon
	 */
	public static ImageIcon createRemoveIcon() {
		return ResourceFunctions.openImageIcon(FactoryIcon.class, REMOVE);
	}
	
	/**
	 * Create image icon for exit
	 * @return ImageIcon
	 */
	public static ImageIcon createCloseIcon() {
		return ResourceFunctions.openImageIcon(FactoryIcon.class, CLOSE);
	}

}