package org.modelgen.jpf.signatureApplication.test;

import org.modelgen.commons.persistence.PersistenceException;
import org.modelgen.facade.GeneralManagementFacade;
import org.modelgen.jpf.signatureApplication.facade.SignatureApplicationFacade;
import org.modelgen.signature.DiffContainer;
import org.modelgen.signature.MacroRuleSignature;
import org.modelgen.signature.ModelSignature;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Scanner;
import java.util.Set;

public class Application {

	public static void main(String[] args) {
		boolean fine = false;
		List<MacroRuleSignature> scelte = new ArrayList<MacroRuleSignature>();
		SignatureApplicationFacade facade = SignatureApplicationFacade.getInstance();
		//l'utente seleziona lo schema sorgente
		ModelSignature source =  selectSource(facade);
		//l'utente seleziona il modello target
		ModelSignature target = selectTarget(facade);
		while(!fine){
			System.out.print("--------------------------------------------------------------");;
			System.out.println("--------------------------------------------------------------");

			System.out.print("current model: ");
			System.out.println(source);
			if(facade.isCompatibile(source, target))
				System.out.println("------matches with target model!!!");
			System.out.println();
			Map<MacroRuleSignature, DiffContainer> regole = facade.viewUsefulMacro(source, target);
			Set<MacroRuleSignature> setRegole = regole.keySet();
			int i = 0;
			for(MacroRuleSignature r: setRegole){
				System.out.println("*********************************");
				System.out.print("macrorule number: "+i);
				System.out.println(", file's name: "+r.getFileName());
				i++;
				DiffContainer container = regole.get(r);
				if(container!=null){
					System.out.print("added constructs: ");
					System.out.println(container.getAggiunti());
					System.out.print("removed constructs: ");
					System.out.println(container.getRimossi());
					System.out.print("ignored constructs with their ignored properties: ");
					System.out.println(container.getIgnorate());
					System.out.print("reachable model: ");
					ModelSignature newSource = container.getArrivo();
					System.out.println(newSource);
					System.out.print("target model: ");
					System.out.println(facade.getTarget());
					if(facade.isCompatibile(newSource))
						System.out.println("->->->matches with target model");
					else
						System.out.println("does not match with target model");
				}
				else
					System.out.println("empty");
			}	
			System.out.println();
			String primaParola = null;
			int numero = -1;
			while(primaParola==null){
				System.out.println("<<<insert macrorule number or 'end' to end the application>>>");
				System.out.print("> ");
				Scanner scanner = new Scanner(System.in);
				String inputLine = scanner.nextLine();
				scanner = new Scanner(inputLine);
				if(scanner.hasNext())
					primaParola = scanner.next();  // prima parola
				//nota: ignoriamo il resto della linea
				if(primaParola!=null){
					if(primaParola.equals("end"))
						fine = true;
					else {
						try{
							numero = Integer.parseInt(primaParola);
						}
						catch (NumberFormatException e){
							System.out.println("#-invalid format");
							primaParola = null;
						}
						if(numero>setRegole.size()-1 || numero == -1){
							System.out.println("#-invalid macrorule number");
							primaParola = null;
							numero = -1;
						}
					}
				}

			}
			if(!fine){
				List<MacroRuleSignature> appoggio = new ArrayList<MacroRuleSignature>();
				appoggio.addAll(setRegole);
				MacroRuleSignature scelta = appoggio.get(numero);
				scelte.add(scelta);
				source = regole.get(scelta).getArrivo();
			}
			System.out.println();
			System.out.println();
			System.out.println();
			System.out.println();
			System.out.println();
			System.out.println();
			System.out.println();
			System.out.println();
		}
		System.out.println("reached model:");
		System.out.println(source);
		if(facade.isCompatibile(source, target))
			System.out.print("------matches with target model!!!");
		else
			System.out.print("---does not match with target model!!!");
		System.out.println();
		if(scelte.size()>0){
			System.out.println("to reach this model you have chosen the following macrorules:");
			for(MacroRuleSignature r: scelte)
				System.out.println("-> "+r.getFileName());
		}
	}

	private static ModelSignature selectSource(SignatureApplicationFacade facade){
		ModelSignature source = null;
		String inputLine;
		String primaParola = null;
		Scanner scanner;
		while(source == null){
			System.out.println("Please, choose the number of your source scheme");
			System.out.print("> ");
			scanner = new Scanner(System.in);
			inputLine = scanner.nextLine();
			scanner = new Scanner(inputLine);
			if(scanner.hasNext())
				primaParola = scanner.next();  // prima parola
			//nota: ignoriamo il resto della linea
			if (primaParola!= null){
				try{
					int index = Integer.parseInt(primaParola);
					source = GeneralManagementFacade.getInstance().getSignatureSuperModelSchema(index);
				}
				catch(PersistenceException e){
					System.out.println("number out of bound");
				}
				catch(Exception e){
					System.out.println("invalid number");
				}
				System.out.println();
			}
		}
		System.out.println("you have chosen the follwing scheme:");
		System.out.println(source);
		System.out.println();
		return source;
	}

	private static ModelSignature selectTarget(SignatureApplicationFacade facade){
		ModelSignature target = null;
		String inputLine;
		String primaParola = null;
		Scanner scanner;

		while(target == null){
			System.out.println("Please, choose the number of your target model:");
			System.out.println("   - insert '1' to select BINARY ER MODEL");
			System.out.println("   - insert '2' to select ENNARY ER MODEL");
			System.out.println("   - insert '3' to select BINARY ER MODEL WITHOUT MANY TO MANY RELATIONSHIPS");
			System.out.println("   - insert '4' to select RELATIONAL MODEL");
			System.out.println("   - insert '5' to select RELATIONAL MODEL WITHOUT NULL VALUE ON COLUMN");
			System.out.println("   - insert '6' to select OBJECT RELATIONAL MODEL");
			System.out.println("   - insert '7' to select XSD MODEL");
			System.out.print("> ");
			scanner = new Scanner(System.in);
			inputLine = scanner.nextLine();
			scanner = new Scanner(inputLine);
			if(scanner.hasNext())
				primaParola = scanner.next();  // prima parola
			//nota: ignoriamo il resto della linea
			if (primaParola!= null){
				try{
					int index = Integer.parseInt(primaParola);
					//se il numero  fuori dai margini sollevo un'eccezione che posso catturare
					if(index<1 || index>7)
						throw new Exception();
					switch (index){
						case 1 : target = ModelSignaturPredefinite.getModelErBin();
						case 2 : target = ModelSignaturPredefinite.getModelErN();
						case 3 : target = ModelSignaturPredefinite.getModelErNoMtN();
						case 4 : target = ModelSignaturPredefinite.getModelRel();
						case 5 : target = ModelSignaturPredefinite.getModelRelNoN();
						case 6 : target = ModelSignaturPredefinite.getModelObjRel();
						case 7 : target = ModelSignaturPredefinite.getModelXsd();
					}
				}
				catch(Exception e){
					System.out.println("invalid number");
				}
				System.out.println();
			}
		}
		System.out.println("you have chosen the follwing target model:");
		System.out.println(target);
		System.out.println();
		return target;
	}

}
