package org.modelgen.jpf.signatureApplication.test;

import org.modelgen.signature.ConstructSignature;
import org.modelgen.signature.ModelSignature;

/**
 * Classe che restituisce le ModelSignature dei modelli pi conosciuti
 * @author Fabrizio Celli
 * @since 01-06-2007
 *
 */
public class ModelSignaturPredefinite {

	//	MODELLO ER BINARY
	public static ModelSignature getModelErBin(){
		ModelSignature schema = new ModelSignature("ERbin");
		ConstructSignature cons = new ConstructSignature("Abstract");
		schema.insert(cons);
		cons = new ConstructSignature("Lexical");
		schema.insert(cons);
		cons = new ConstructSignature("Generalization");
		schema.insert(cons);
		cons = new ConstructSignature("ChildOfGeneralization");
		schema.insert(cons);
		cons = new ConstructSignature("BinaryAggregationOfAbstracts");
		String formula = "(BinaryAggregationOfAbstracts.isFunctional1 OR (NOT BinaryAggregationOfAbstracts.isFunctional2))";
		cons.setFormula(formula);
		schema.insert(cons);
		return schema;
	}
	
	//	MODELLO ER ENNARY
	public static ModelSignature getModelErN(){
		ModelSignature schema = new ModelSignature("ERennary");
		ConstructSignature cons = new ConstructSignature("Abstract");
		schema.insert(cons);
		cons = new ConstructSignature("Lexical");
		schema.insert(cons);
		cons = new ConstructSignature("Generalization");
		schema.insert(cons);
		cons = new ConstructSignature("ChildOfGeneralization");
		schema.insert(cons);
		cons = new ConstructSignature("ComponentOfAggregationOfAbstracts");
		schema.insert(cons);
		cons = new ConstructSignature("AggregationOfAbstracts");
		schema.insert(cons);
		return schema;
	}
	
	//	MODELLO ER BINARY SENZA RELAZIONI MOLTI A MOLTI
	public static ModelSignature getModelErNoMtN(){
		ModelSignature schema = new ModelSignature("ERbinNoMtN");
		ConstructSignature cons = new ConstructSignature("Abstract");
		schema.insert(cons);
		cons = new ConstructSignature("Lexical");
		schema.insert(cons);
		cons = new ConstructSignature("Generalization");
		schema.insert(cons);
		cons = new ConstructSignature("ChildOfGeneralization");
		schema.insert(cons);
		cons = new ConstructSignature("BinaryAggregationOfAbstracts");
		String formula = "BinaryAggregationOfAbstracts.isFunctional1";
		cons.setFormula(formula);
		schema.insert(cons);
		return schema;
		
	}
	
	//	MODELLO RELAZIONALE SEMPLICE
	public static ModelSignature getModelRel(){
		ModelSignature schema = new ModelSignature("Rel");
		ConstructSignature cons = new ConstructSignature("Aggregation");
		schema.insert(cons);
		cons = new ConstructSignature("Lexical");
		schema.insert(cons);
		cons = new ConstructSignature("ForeignKey");
		schema.insert(cons);
		cons = new ConstructSignature("ComponentOfForeignKey");
		schema.insert(cons);
		return schema;
	}
	
	//	MODELLO RELAZIONALE SEMPLICE SENZA VALORI NULLI
	public static ModelSignature getModelRelNoN(){
		ModelSignature schema = new ModelSignature("RelNon");
		ConstructSignature cons = new ConstructSignature("Aggregation");
		schema.insert(cons);
		cons = new ConstructSignature("Lexical");
		String formula ="(NOT Lexical.isNullable)";
		cons.setFormula(formula);
		schema.insert(cons);
		cons = new ConstructSignature("ForeignKey");
		schema.insert(cons);
		cons = new ConstructSignature("ComponentOfForeignKey");
		schema.insert(cons);
		return schema;
	}
	
	//	MODELLO XSD
	public static ModelSignature getModelXsd(){
		ModelSignature schema = new ModelSignature("Xsd");
		ConstructSignature cons = new ConstructSignature("Abstract");
		schema.insert(cons);
		cons = new ConstructSignature("Lexical");
		schema.insert(cons);
		cons = new ConstructSignature("ForeignKey");
		schema.insert(cons);
		cons = new ConstructSignature("ComponentOfForeignKey");
		schema.insert(cons);
		cons = new ConstructSignature("Nest");
		schema.insert(cons);
		return schema;
	}
	
	//	MODELLO OBJECT RELATIONAL
	public static ModelSignature getModelObjRel(){
		ModelSignature schema = new ModelSignature("ObjRel");
		ConstructSignature cons = new ConstructSignature("Abstract");
		schema.insert(cons);
		cons = new ConstructSignature("Lexical");
		schema.insert(cons);
		cons = new ConstructSignature("ForeignKey");
		schema.insert(cons);
		cons = new ConstructSignature("ComponentOfForeignKey");
		schema.insert(cons);
		cons = new ConstructSignature("Nest");
		schema.insert(cons);
		cons = new ConstructSignature("ChildOfGeneralization");
		schema.insert(cons);
		cons = new ConstructSignature("Generalization");
		schema.insert(cons);
		cons = new ConstructSignature("StructOfAttributes");
		schema.insert(cons);
		cons = new ConstructSignature("AbstractAttribute");
		schema.insert(cons);
		return schema;
	}

}
