package org.modelgen.jpf.signatureApplication.test;

import org.modelgen.commons.beans.model.Construct;
import org.modelgen.commons.beans.model.Model;
import org.modelgen.commons.beans.model.Property;
import org.modelgen.regole.CostanteDatalog;
import org.modelgen.regole.Letterale;
import org.modelgen.regole.RegolaDatalog;
import org.modelgen.regole.VariabileDatalog;
import org.modelgen.signature.ModelSignature;
import org.modelgen.signature.RuleSignature;
import org.modelgen.signature.application.ruleapplication.ServicesApplication;

public class TestApplicable {

	private static RuleSignature sig;
	private static ModelSignature model;

	public static void main(String[] args){

		init();
		ServicesApplication applicate = new ServicesApplication();
		System.out.println(sig);
		System.out.println(model);
		System.out.println(applicate.applicable(sig, model));

		init2();
		applicate = new ServicesApplication();
		System.out.println(sig);
		System.out.println(model);
		System.out.println(applicate.applicable(sig, model));
		
		/* METODO RESO PRIVATO
		String muMap = applicate.muMap("NOT isnullable", sig.getMap());
		System.out.println(muMap);
		muMap = applicate.muMap("isnullable", sig.getMap());
		System.out.println(muMap);
		muMap = applicate.muMap("NOT isopt1", sig.getMap());
		System.out.println(muMap);
		muMap = applicate.muMap("isopt1", sig.getMap());
		System.out.println(muMap);*/


	}

	private static void init(){
		RegolaDatalog regola = new RegolaDatalog();
		Letterale l = new Letterale("SM_RELAZIONE", "DEST");
		CostanteDatalog c1 = new CostanteDatalog("true");
		VariabileDatalog v1 = new VariabileDatalog("isopt");
		CostanteDatalog c2 = new CostanteDatalog("false");
		CostanteDatalog c3 = new CostanteDatalog("true");
		CostanteDatalog c4 = new CostanteDatalog("name");
		l.inserisciArgomentoEtichettato("isfunct1", c1);
		l.inserisciArgomentoEtichettato("isfunct2", c2);
		l.inserisciArgomentoEtichettato("isnullable", c3);
		l.inserisciArgomentoEtichettato("isopt2", c4);
		l.inserisciArgomentoEtichettato("isopt1", v1);
		regola.setTesta(l);

		Letterale l1 = new Letterale("SM_RELAZIONE", "SRC");
		l1.inserisciArgomentoEtichettato("isfunct1", c4);
		l1.inserisciArgomentoEtichettato("isfunct2", c2);
		l1.inserisciArgomentoEtichettato("isnullable", v1);
		l1.inserisciArgomentoEtichettato("isopt2", c1);
		l1.inserisciArgomentoEtichettato("isopt1", c3);
		regola.addElementoCorpo(l1);

		sig = new RuleSignature(regola);

		Model modello = new Model(0, "er");
		Construct con1 = new Construct(0, "RELAZIONE"); 
		Property p1 = new Property(0,"isfunct1");
		con1.addProperty(p1);
		modello.addConstruct(con1);
		model = modello.getModelSignature();
	}

	//modifica il modello
	public static void init2(){
		Model modello = new Model(0,"er");
		Construct con1 = new Construct(0,"ENTITA"); 
		Property p1 = new Property(0,"isfunct1");
		con1.addProperty(p1);
		modello.addConstruct(con1);
		model = modello.getModelSignature();
	}


}
