package org.modelgen.jpf.signatureApplication.test;

import org.modelgen.commons.beans.model.Construct;
import org.modelgen.commons.beans.model.Model;
import org.modelgen.commons.beans.model.Property;
import org.modelgen.commons.beans.scheme.Scheme;
import org.modelgen.commons.beans.scheme.SchemeObject;
import org.modelgen.regole.CostanteDatalog;
import org.modelgen.regole.Letterale;
import org.modelgen.regole.RegolaDatalog;
import org.modelgen.regole.VariabileDatalog;
import org.modelgen.signature.ConstructSignature;
import org.modelgen.signature.ModelSignature;
import org.modelgen.signature.RuleSignature;
import org.modelgen.signature.application.ruleapplication.ServicesApplication;

public class TestApplicateOne {

	private static RuleSignature sig;
	private static ModelSignature model;
	private static ConstructSignature costr;

	public static void main(String[] args){
		init();
		System.out.println(sig);
		System.out.println(model);
		ServicesApplication appl = new ServicesApplication();
		costr = appl.applicateOne(sig, model);
		System.out.println(costr);
		
		System.out.println();
		
		/*init2();
		System.out.println(sig);
		System.out.println(model);
		ServicesApplication appl2 = new ServicesApplication();
		costr = appl2.applicateOne(sig, model);
		System.out.println(costr);*/
	}

	private static void init(){
		
		//INIZIALIZZAZIONE DELLA REGOLA
		
		RegolaDatalog regola = new RegolaDatalog();
		Letterale l = new Letterale("SM_RELAZIONE", "DEST");
		CostanteDatalog c1 = new CostanteDatalog("true");
		VariabileDatalog v1 = new VariabileDatalog("isopt");
		CostanteDatalog c2 = new CostanteDatalog("false");
		CostanteDatalog c3 = new CostanteDatalog("true");
		//CostanteDatalog c4 = new CostanteDatalog("name");
		l.inserisciArgomentoEtichettato("isfunct1", c1);
		l.inserisciArgomentoEtichettato("isfunct2", c2);
		l.inserisciArgomentoEtichettato("isopt2", v1);
		l.inserisciArgomentoEtichettato("isident", c3);
		l.inserisciArgomentoEtichettato("isopt1", c2);
		regola.setTesta(l);

		Letterale l1 = new Letterale("SM_RELAZIONE", "SRC");
		l1.inserisciArgomentoEtichettato("isfunct1", c2);
		l1.inserisciArgomentoEtichettato("isfunct2", c2);
		l1.inserisciArgomentoEtichettato("isopt1", v1);
		regola.addElementoCorpo(l1);
		Letterale l2 = new Letterale("SM_ENTITA", "SRC");
		regola.addElementoCorpo(l2);

		sig = new RuleSignature(regola);

		//INIZIALIZZAZIONE DELLO SCHEMA
		//((RELAZIONE.isfunct1 OR (NOT RELAZIONE.isfunct2)) AND (NOT RELAZIONE.isopt1));

		model = new ModelSignature("er");
		ConstructSignature costrutto = new ConstructSignature("RELAZIONE");
		costrutto.setFormula("((RELAZIONE.isfunct1 OR (NOT RELAZIONE.isfunct2)) AND (NOT RELAZIONE.isopt1))");
		model.insert(costrutto);
		costrutto = new ConstructSignature("ENTITA");
		model.insert(costrutto);

	}
	
	
@SuppressWarnings("unused")
private static void init2(){
		
		//INIZIALIZZAZIONE DELLA REGOLA
		
		RegolaDatalog regola = new RegolaDatalog();
		Letterale l = new Letterale("SM_ENTITA", "DEST");
		regola.setTesta(l);

		Letterale l2 = new Letterale("SM_ENTITA", "SRC");
		regola.addElementoCorpo(l2);

		sig = new RuleSignature(regola);

		//INIZIALIZZAZIONE DELLO SCHEMA
		//((RELAZIONE.isfunct1 OR (NOT RELAZIONE.isfunct2)) AND (NOT RELAZIONE.isopt1));

		Model m = new Model(0,"er");

		Scheme schema = new Scheme(0,"test",null,false);

		Construct c = new Construct(1,"RELAZIONE"); 
		Property p = new Property(0,"isfunct1");
		c.addProperty(p);
		SchemeObject s1 = new SchemeObject(0,"professore",c);
		s1.setProperty("isfunct1", "true");

		c = new Construct(4,"RELAZIONE"); 
		p = new Property(0,"isfunct2");
		c.addProperty(p);
		p = new Property(0,"isopt1");
		c.addProperty(p);
		SchemeObject s2 = new SchemeObject(0,"studente",c);
		s2.setProperty("isfunct2", "false");
		s2.setProperty("isopt1", "false");

		Construct c5 = new Construct(2,"ENTITA");
		SchemeObject s3 = new SchemeObject(0,"scuola",c5);

		schema.addObject(s1);
		schema.addObject(s2);
		schema.addObject(s3);
		schema.setMetaInfo(m);

		model = schema.getModelSignature();

	}

}
