package org.modelgen.jpf.signatureApplication.test;

import org.modelgen.commons.persistence.PersistenceException;
import org.modelgen.facade.GeneralManagementFacade;
import org.modelgen.signature.DiffContainer;
import org.modelgen.signature.MacroRuleSignature;
import org.modelgen.signature.ModelSignature;
import org.modelgen.signature.application.macroruleapplication.SignatureApplicationUtility;
import org.modelgen.signature.application.ruleapplication.ApplicateRuleSignature;

import java.util.ArrayList;
import java.util.List;

public class TestDiffContainer {

	private static ModelSignature scheme;
	private static MacroRuleSignature regola;
	

	public static void main(String[] args) {
		init();
		System.out.println();
		System.out.println("schema: "+scheme);
		System.out.println();
		System.out.println("regola: "+regola.getRulesSignatures());
		System.out.println();
		ApplicateRuleSignature applicator = new ApplicateRuleSignature();
		ModelSignature arrivo = applicator.createModelSignature(regola, scheme);
		DiffContainer container = new DiffContainer(scheme, arrivo, regola);
		System.out.println(container.getIgnorate());
	}
	
	private static void init(){
		System.out.println("carico lo schema");
		try {
			scheme = GeneralManagementFacade.getInstance().getSignatureSuperModelSchema(3);
		} catch (PersistenceException e) {
			// TODO Blocco catch generato automaticamente
			e.printStackTrace();
		}
		
		System.out.println("carico le macroregole");
		
		List<MacroRuleSignature> regole = new ArrayList<MacroRuleSignature>();;
		regole = SignatureApplicationUtility.getInstance().getMacroRegole();
		System.out.println("caricate");
		List<MacroRuleSignature> applicabili = SignatureApplicationUtility.getInstance().usefulMacroRules(regole, scheme);
		regola = applicabili.get(1);
	}

}
