package org.modelgen.jpf.signatureApplication.test;

import org.modelgen.signature.ConstructSignature;
import org.modelgen.signature.ModelSignature;
import org.modelgen.signature.application.macroruleapplication.SignatureApplicationUtility;

/**
 * TESTATO IL 01-06-2007
 * @author Fabrizio
 *
 */
public class TestIsCompatibile {
	
	private static ModelSignature trg;
	private static ModelSignature cur;
	
	public static void main(String[] args){
		init();	//compatibile
		System.out.println(SignatureApplicationUtility.getInstance().isCompatibile(trg, cur));
		
		init2();	//non compatibile
		System.out.println(SignatureApplicationUtility.getInstance().isCompatibile(trg, cur));
		
		init3();	//non compatibile
		System.out.println(SignatureApplicationUtility.getInstance().isCompatibile(trg, cur));
		//	compatibile
		System.out.println(SignatureApplicationUtility.getInstance().isCompatibile(cur, trg));
		
		init4();
		System.out.println(SignatureApplicationUtility.getInstance().isCompatibile(trg, cur));
	}
	
	private static void init(){
		trg = new ModelSignature("trg");
		cur = new ModelSignature("cur");
		
		ConstructSignature a = new ConstructSignature("a");
		ConstructSignature a2 = new ConstructSignature("a");
		ConstructSignature b = new ConstructSignature("b");
		
		String formulaA = "(((F1 AND (NOT F2)) AND O1) OR (F1 AND O2))";
		a.setFormula(formulaA);
		String formulaA2 = "(((F1 AND O1) AND (NOT F2)) AND O2)";
		a2.setFormula(formulaA2);
		
		trg.insert(a);
		trg.insert(b);
		cur.insert(a2);
		
	}
	
	private static void init2(){
		trg = new ModelSignature("trg");
		cur = new ModelSignature("cur");
		
		ConstructSignature a = new ConstructSignature("a");
		ConstructSignature a2 = new ConstructSignature("a");
		ConstructSignature b = new ConstructSignature("b");
		
		String formulaA = "(((F1 AND (NOT F2)) AND O1) OR (F1 AND O2))";
		a.setFormula(formulaA);
		String formulaA2 = "((F1 AND O1) OR O2)";
		a2.setFormula(formulaA2);
		
		trg.insert(a);
		trg.insert(b);
		cur.insert(a2);
		
	}
	
	private static void init3(){
		cur = ModelSignaturPredefinite.getModelErBin();
		trg = ModelSignaturPredefinite.getModelErNoMtN();
		
	}
	
	private static void init4(){
		trg = ModelSignaturPredefinite.getModelRel();
		cur = new ModelSignature("Ex");
		ConstructSignature cons = new ConstructSignature("Lexical");
		cur.insert(cons);
		
	}

}
