package org.modelgen.jpf.signatureApplication.test;

import org.modelgen.commons.beans.scheme.Scheme;
import org.modelgen.commons.beans.scheme.SchemeObject;
import org.modelgen.commons.beans.scheme.SchemeObjectProperty;
import org.modelgen.commons.persistence.PersistenceException;
import org.modelgen.commons.persistence.database.CacheProxyDBHandler;
import org.modelgen.commons.persistence.database.RealDBHandler;
import org.modelgen.facade.GeneralManagementFacade;

import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

public class TestSchemDatabaseSignature {

	/**
	 * @param args
	 * @throws PersistenceException 
	 * @throws SQLException 
	 * @throws ClassNotFoundException 
	 */
	public static void main(String[] args) throws PersistenceException, ClassNotFoundException, SQLException {

		GeneralManagementFacade.getInstance().startServer();

		RealDBHandler db = new RealDBHandler();
		CacheProxyDBHandler proxyHandler = new CacheProxyDBHandler(db);
		System.out.println(proxyHandler);
		System.out.println();

		//prendo la lista degli schemi
		Collection<Scheme> modelli = proxyHandler.getSuperModelSchemes();
		List<Scheme> models = new ArrayList<Scheme>();
		models.addAll(modelli);

		Scheme modello = models.get(5);
		System.out.println("MODELLO 4");
		System.out.println("NOME:"+modello.getName());
		System.out.println("OID: "+modello.getOID());
		//System.out.println("SIGNATURE: "+modello.getModelSignature());
		List<SchemeObject> objs = modello.getAbstractConstructs();
		System.out.println("CONSTRUCTS:\n "+objs);
		System.out.println();
		for(SchemeObject obj: objs){
			System.out.println(obj.getMetaInfo().getName());
			
			Collection<SchemeObjectProperty> properties = obj.getProperties();
			System.out.println(properties);
			//Scandisco le SchemeObjectProperty
			for(SchemeObjectProperty prop: properties){
				System.out.println(obj.getMetaInfo().getName()+"."+prop.getMetaInfo().getName());
				System.out.println(prop.getValue());
			}
			System.out.println();
		}

		GeneralManagementFacade.getInstance().stopServer();
	}

}
