package org.modelgen.jpf.visualizer;

import org.modelgen.jpf.visualizer.modelgenview.mvc.model.ModelComponent;

import java.awt.Component;

import javax.swing.JTabbedPane;

/**
 * Class <code>ToolTipableTabbedPane</code> defines
 * @author Riccardo Pietrucci
 * @version 0.1
 */
public class ToolTipableTabbedPane extends JTabbedPane {
	private static final long serialVersionUID = 1L;

	public ToolTipableTabbedPane() {
		super();
	}

	public void add(ModelComponent structureWrapped, Component viewer) {
		String tooltip = structureWrapped.getTooltipText();
		this.add(structureWrapped.getName(), viewer);
		// Get index of new tab
		int index = this.getTabCount()-1;
		this.setToolTipTextAt(index, tooltip);    
	}



}
