package org.modelgen.jpf.visualizer.commons;

import org.modelgen.facade.ResourceFunctions;
import org.modelgen.jpf.visualizer.DSPlugin;

import java.io.File;

import javax.swing.ImageIcon;

/**
 * Class <code>ToolConfigurationManager</code> defines
 * @author Riccardo Pietrucci
 * @version 0.1
 */
public class ToolConfigurationManager {
	public static ToolConfigurationManager sharedInstance = new ToolConfigurationManager();
	public static final String LAYOUTS_PATH = "layouts";
	public static final String RULES_PATH = "rules";
	public static final String DATABASE_CLONE_PATH = "databaseClone";

	private ToolConfigurationManager() {
	}

	public ImageIcon getIcon(String identifier) {
		ImageIcon icon = ResourceFunctions.openImageIcon(this.getClass(), identifier);
		return icon;
	}

	public File getLayoutsPath() {
		return this.getPath(LAYOUTS_PATH);
	}

	public File getRulesPath() {
		return this.getPath(RULES_PATH);
	}

	public File getDatabaseClonePath() {
		return this.getPath(DATABASE_CLONE_PATH);
	}

	private File getPath(String dir) {
		return ResourceFunctions.createDirIfNotExist(this.getClass(), dir, DSPlugin.PLUGIN_ID);
	}
}
