package org.modelgen.jpf.visualizer.facade;

import org.modelgen.commons.beans.model.Model;
import org.modelgen.commons.beans.scheme.Scheme;
import org.modelgen.jpf.visualizer.modelgenview.ModelGenBuilder;
import org.modelgen.jpf.visualizer.modelgenview.modelgen.AbstractModelGenBuilderFacade;
import org.modelgen.jpf.visualizer.modelgenview.modelgen.adapters.MultiDirectionAbstractStructure;
import org.modelgen.jpf.visualizer.modelgenview.modelgen.adapters.imp.StructureModelAdapter;
import org.modelgen.jpf.visualizer.modelgenview.modelgen.adapters.imp.StructureSchemeAdapter;
import org.modelgen.jpf.visualizer.modelgenview.mvc.model.ModelGraph;
import org.modelgen.jpf.visualizer.pac.top.views.view.ViewGraphJGraph;

/**
 * Class <code>VisualizerFacade</code> defines
 * @author Riccardo Pietrucci
 * @version 0.1
 */
public class VisualizerFacade {
    
    /** @return la struttura complessiva di modelgen,
     * a partire da cui e' possibile interrogare rispettivi modelli,
     * schemi e istanze */
    public static MultiDirectionAbstractStructure getSuperModel() throws ClassNotFoundException, Exception {
	MultiDirectionAbstractStructure rootTree = AbstractModelGenBuilderFacade.getInstance().getSuperModel();
	return rootTree;
    }
    
    public static MultiDirectionAbstractStructure convertSuperModel(Model superModel) {
	return new StructureModelAdapter(null, superModel);
    }
    
    public static MultiDirectionAbstractStructure convertModel(Model model, MultiDirectionAbstractStructure superModel) {
	return new StructureModelAdapter(superModel, model);
    }
    
    public static MultiDirectionAbstractStructure convertScheme(Scheme scheme, MultiDirectionAbstractStructure model) {
	return new StructureSchemeAdapter(model, scheme, false);
    }
    
    public static MultiDirectionAbstractStructure convertSuperModelScheme(Scheme smScheme, MultiDirectionAbstractStructure superModel) {
	return new StructureSchemeAdapter(superModel, smScheme, true);
    }
    
    public static ViewGraphJGraph createView(MultiDirectionAbstractStructure aStructure) throws ClassNotFoundException, Exception {
	
	ModelGraph forwardModelGraph = ModelGenBuilder.parse(aStructure, null, false);
	
	//ModelGraphViewHandler mediator = new ModelGraphViewHandler();
	ViewGraphJGraph viewer = new ViewGraphJGraph(null, forwardModelGraph);
	
	return viewer;
    }
    
}
