package org.modelgen.jpf.visualizer.modelgenview.modelgen;

import org.modelgen.commons.beans.model.Construct;
import org.modelgen.commons.beans.scheme.SchemeObject;
import org.modelgen.jpf.visualizer.modelgenview.modelgen.adapters.AbstractConstruct;
import org.modelgen.jpf.visualizer.modelgenview.modelgen.adapters.BaseInfo;
import org.modelgen.jpf.visualizer.modelgenview.modelgen.adapters.imp.ConstructAdapter;
import org.modelgen.jpf.visualizer.modelgenview.modelgen.adapters.imp.InstanceObject;
import org.modelgen.jpf.visualizer.modelgenview.modelgen.adapters.imp.SchemeObjectAdapter;

/**
 * Class <code>BaseInfoConvenienceFunctions</code> defines
 * @author Riccardo Pietrucci
 * @version 0.1
 */
public class BaseInfoKeyConvenienceFunctions {
    public static SchemeObjectAdapter getSuperModelSchemeObject(int smConstructOID, int smSchemeObjectOID) {
	BaseInfo.setSaveDatabaseEnabled(false);
	
	Construct c = new Construct(smConstructOID, null);
	ConstructAdapter smConstruct = new ConstructAdapter(null, null, c);
	
	SchemeObject s = new SchemeObject(smSchemeObjectOID, null, c);
	AbstractConstruct smSchemeObject = new SchemeObjectAdapter(null, smConstruct, s);
	
	String sid = smSchemeObject.getSid();
	
	BaseInfo.setSaveDatabaseEnabled(true);
	
	
	
	return (SchemeObjectAdapter) BaseInfo.getDatabase().get(sid);
    }
    
    public static InstanceObject getInstanceObject(int smConstructOID, int smSchemeObjectOID, int smInstanceObjectOID) {
	BaseInfo.setSaveDatabaseEnabled(false);
	
	Construct c = new Construct(smConstructOID, null);
	ConstructAdapter smConstruct = new ConstructAdapter(null, null, c);
	
	SchemeObject s = new SchemeObject(smSchemeObjectOID, null, c);
	AbstractConstruct smSchemeObject = new SchemeObjectAdapter(null, smConstruct, s);
	
	AbstractConstruct smInstanceObject = new InstanceObject(null, smSchemeObject, smInstanceObjectOID, null, false);
	
	String sid = smInstanceObject.getSid();
	
	BaseInfo.setSaveDatabaseEnabled(true);
	
	return (InstanceObject) BaseInfo.getDatabase().get(sid);
    }
}
