package org.modelgen.jpf.visualizer.modelgenview.modelgen.adapters;

/**
 * Class <code>PropertyAdapter</code> defines
 * @author Riccardo Pietrucci
 * @version 0.1
 */
public abstract class AbstractProperty extends ProxyBaseInfo<AbstractProperty> {
    private transient AbstractConstruct construct;
    public AbstractProperty(AbstractConstruct construct, AbstractProperty parent, int oid, String name) {
	this(construct, parent, null, oid, name);
    }
    public AbstractProperty(AbstractConstruct construct, AbstractProperty parent, Object realSubject, int oid, String name) {
	super(parent, realSubject, oid, name);
	this.construct = construct;
    }
    public abstract String getValue();
    public abstract String getType();
    
    public AbstractConstruct getAbstractConstruct() {
        return construct;
    }
    
    @Override
    public TypeID getTypeId() {
	return TypeID.AbstractProperty;
    }
    
    
    @Override
    public String getTypeString() {
	return construct.getTypeString() + "'s Property";
    }
	
	@Override
    public MultiDirectionAbstractStructure getStructure() {
        return this.construct.getStructure();
    }

    
}
