package org.modelgen.jpf.visualizer.modelgenview.modelgen.adapters;

import java.util.LinkedHashMap;


/**
 * Mantiene tutti i BaseInfo creati
 * referenziabili tramite sid
 * di {@link BaseInfo#getSid()}
 * @author Riccardo Pietrucci
 * @version 0.1
 */
public class BaseInfoDatabase implements Cloneable {
    private LinkedHashMap<String, BaseInfo<? extends BaseInfo<?>>> data = new LinkedHashMap<String, BaseInfo<? extends BaseInfo<?>>>();
    
    public BaseInfoDatabase() {}
    
    private BaseInfoDatabase(LinkedHashMap<String, BaseInfo<? extends BaseInfo<?>>> data) {
	this.data = data;
    }
    
    void add(BaseInfo<? extends BaseInfo<?>> baseInfo) {
	this.data.put(baseInfo.getSid(), baseInfo);
    }
    
    void delete(BaseInfo<? extends BaseInfo<?>> baseInfo) {
	this.delete(baseInfo.getSid());
    }
    
    void delete(String sid) {
	this.data.remove(sid);
    }
    
    // Unica operazione accessibile dall'esterno
    public BaseInfo get(String sid) {
	return this.data.get(sid);
    }

    @SuppressWarnings("unchecked")
	@Override
    protected Object clone() throws CloneNotSupportedException {
	LinkedHashMap<String, BaseInfo<? extends BaseInfo<?>>> dataClone = (LinkedHashMap<String, BaseInfo<? extends BaseInfo<?>>>) this.data.clone();
	BaseInfoDatabase databaseClone = new BaseInfoDatabase(dataClone);
	return databaseClone;
    }

}
