package org.modelgen.jpf.visualizer.modelgenview.modelgen.adapters.imp;

import org.modelgen.commons.beans.model.Reference;
import org.modelgen.commons.beans.model.Reference.ReferenceType;
import org.modelgen.jpf.visualizer.modelgenview.modelgen.adapters.AbstractConstruct;
import org.modelgen.jpf.visualizer.modelgenview.modelgen.adapters.AbstractReference;

/**
 * Class <code>ConstructReference</code> defines
 * @author Riccardo Pietrucci
 * @version 0.1
 */
public class ConstructReference extends AbstractReference {
	private static final long serialVersionUID = 1L;
	private transient Reference reference;

    public ConstructReference(ConstructReference parent, Reference reference, AbstractConstruct owner, AbstractConstruct target) {
	super(parent, reference, owner, target, reference.getOID(), reference.getName());
	this.reference = reference;
    }

    public void setName(String name) {
	this.reference.setName(name);
    }

    public void setOID(int OID) {
	this.reference.setOID(OID);
    }

    @Override
    public ReferenceType getType() {
	return this.reference.getType();
    }

    @Override
    public String getTypeAsString() {
	return this.reference.getTypeAsString();
    }

}
