package org.modelgen.jpf.visualizer.modelgenview.modelgen.adapters.imp;

import org.modelgen.commons.beans.model.Reference.ReferenceType;
import org.modelgen.jpf.visualizer.modelgenview.modelgen.adapters.AbstractConstruct;
import org.modelgen.jpf.visualizer.modelgenview.modelgen.adapters.AbstractReference;

/**
 * Class <code>InstanceReference</code> defines
 * @author Riccardo Pietrucci
 * @version 0.1
 */
public class InstanceReference extends AbstractReference {
	private static final long serialVersionUID = 1L;
	private transient ReferenceType type;

    public InstanceReference(AbstractReference parent, int oid, String name, ReferenceType type, AbstractConstruct owner, AbstractConstruct target) {
	super(parent, null, owner, target, oid, name);
	this.type = type;
    }
    
    public InstanceReference(AbstractReference parent, int oid, String name, ReferenceType type) {
	this(parent, oid, name, type, null, null);
    }

    @Override
    public ReferenceType getType() {
	return this.type;
    }

    @Override
    public String getTypeAsString() {
	return "" + type;
    }

}
