package org.modelgen.jpf.visualizer.modelgenview.modelgen.adapters.imp;

import org.modelgen.commons.beans.model.Reference.ReferenceType;
import org.modelgen.commons.beans.scheme.SchemeObjectReference;
import org.modelgen.jpf.visualizer.modelgenview.modelgen.adapters.AbstractReference;

/**
 * Class <code>SchemeReference</code> defines
 * @author Riccardo Pietrucci
 * @version 0.1
 */
public class SchemeReference extends AbstractReference {
	private static final long serialVersionUID = 1L;
	private transient SchemeObjectReference schemeReference;

    public SchemeReference(ConstructReference parent, SchemeObjectReference schemeReference, SchemeObjectAdapter owner, SchemeObjectAdapter target) {
	super(parent, schemeReference, owner, target, schemeReference.getMetaInfo().getOID(), schemeReference.getMetaInfo().getName());
	assert owner != null;
	this.schemeReference = schemeReference;
    }
    
    @Override
    public ReferenceType getType() {
	return this.schemeReference.getMetaInfo().getType();
    }

    @Override
    public String getTypeAsString() {
	return this.schemeReference.getMetaInfo().getTypeAsString();
    }

}
