package org.modelgen.jpf.visualizer.modelgenview.modelgen.adapters.imp;

import org.modelgen.jpf.visualizer.modelgenview.modelgen.adapters.AbstractConstruct;
import org.modelgen.jpf.visualizer.modelgenview.modelgen.adapters.MultiDirectionAbstractStructure;

import java.util.SortedSet;

/**
 * La classe <code>SimpleStructure</code> rappresenta
 * una struttura inizializzata dall'esterno.
 * 
 * Non adatta quindi alcuna classe ed e' pensata per
 * essere utilizzata da una funzione esterna che all'inizio
 * carichi valori dal database e successivamente li memorizzi
 * in questa struttura di appoggio, conforme all'interfaccia
 * {@link MultiDirectionAbstractStructure}
 * 
 * @author Riccardo Pietrucci
 * @version 0.1
 */
public abstract class SimpleStructure extends MultiDirectionAbstractStructure {
    public SimpleStructure(MultiDirectionAbstractStructure parent, int oid, String name, SortedSet<AbstractConstruct> abstractContructs) {
	super(parent, oid, name);
	if (abstractContructs != null) {
	    this.abstractConstructs = abstractContructs;
	}
    }

    @Override
    protected SortedSet<AbstractConstruct> doCreateAbstractConstructs(MultiDirectionAbstractStructure proxyStructure) {
	return this.abstractConstructs;
    }
    
    
    @Override
    public String getTypeString() {
	return "Instance";
    }

}
