package org.modelgen.jpf.visualizer.modelgenview.modelgen.util;

import org.modelgen.commons.utils.TypeTranslator;
import org.modelgen.jpf.visualizer.modelgenview.modelgen.adapters.AbstractProperty;

import java.io.Serializable;

/**
 * Class <code>ModelGenValueConverter</code> defines
 * @author Riccardo Pietrucci
 * @version 0.1
 */
public class ModelGenValueConverter {
    public static Serializable convertValue(AbstractProperty property) {
	Serializable valueConverted;
	Boolean boolValue;
	Number numberValue;
	String textValue = property.getValue();
	
	Class<?> classType = TypeTranslator.getJavaType(property.getType());
	
	/* Se la proprieta' esiste ma non ha valore, 
	 * significa semplicemente che la abilita
	 * Quindi se value == null, allora value = true */
	if (textValue == null) {
	    classType = Boolean.class;
	    textValue = "true";
	}
	
	if (classType.equals(Boolean.class)) {
	    boolValue = Boolean.parseBoolean(textValue);
	    valueConverted = boolValue;
	} else if (classType.equals(Number.class)) {
	    numberValue = Integer.getInteger(textValue);
	    valueConverted = numberValue;
	} else {
	    valueConverted = textValue;
	}
	
	return valueConverted;
    }
}
