package org.modelgen.jpf.visualizer.modelgenview.mvc.view.jgraph.util;

import org.jgraph.graph.GraphModel;

/**
 * Class <code>JGraphDebug</code> defines
 * @author Riccardo Pietrucci
 * @version 0.1
 */
public class JGraphDebug {
    public static void dumpGroupStructure (GraphModel gm)
    {
	for (int i = 0; i < gm.getRootCount (); i++)
	{
	    Object o = gm.getRootAt (i);
	    System.out.println ("\n" + o + ": " + classify (gm, o));
	    dumpGroup (gm, o, 1);
	}   
    }

    public static void dumpGroup (GraphModel gm, Object o, int level)
    {   
	for (int i = 0; i < gm.getChildCount (o); i++)
	{
	    for (int j = 0; j < 3 * level; j++)
		System.out.print (" ");

	    Object c = gm.getChild (o, i);
	    System.out.println (c + ": " + classify (gm, c));
	    if (c != null)
		dumpGroup (gm, c, level+1);
	}
    }

    public static String classify (GraphModel gm, Object o)
    {
	if (gm.isEdge (o))
	    return "Edge [Source = " + gm.getSource (o) +
	    ", Target = " + gm.getTarget (o) + "]";
	else
	    if (gm.isPort (o))
		return "Port";
	    else
		return "Vertex or Group";
    }
}
