package org.modelgen.jpf.visualizer.modelgenview.mvc.view.jgraph.vertexviews;

import org.modelgen.jpf.visualizer.modelgenview.mvc.view.jgraph.groupable.JGraphGroupVertexRenderer;

import java.awt.BasicStroke;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.GradientPaint;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.Polygon;
import java.awt.geom.Point2D;

import javax.swing.JLabel;
import javax.swing.SwingConstants;

import org.jgraph.JGraph;
import org.jgraph.graph.CellView;
import org.jgraph.graph.CellViewRenderer;
import org.jgraph.graph.DefaultGraphCell;
import org.jgraph.graph.GraphConstants;
import org.jgraph.graph.VertexView;

/**
 * Class <code>OctagonalView</code> defines
 * @author Riccardo Pietrucci
 * @version 0.1
 */
public class OctagonalView extends VertexView {
    private static final long serialVersionUID = 1L;
    public static transient OctogonalRenderer renderer = new OctogonalRenderer();
    
    public OctagonalView(DefaultGraphCell cell) {
	super(cell);
    }
    
    public CellViewRenderer getRenderer() {
	return renderer;
    }
    
    /*public Point2D getPerimeterPoint(EdgeView edge, Point2D source, Point2D p) {
	Point2D center = AbstractCellView.getCenterPoint(this);
	double width = getBounds().getWidth();
	double height = getBounds().getHeight();
	double halfwidth = width / 2;
	double halfheight = height / 2;
	Point2D top = new Point2D.Double(center.getX(), center.getY() - halfheight);
	Point2D bottom = new Point2D.Double(center.getX(), center.getY() + halfheight);
	Point2D left = new Point2D.Double(center.getX() - halfwidth, center.getY());
	Point2D right = new Point2D.Double(center.getX() + halfwidth, center.getY());
	// Special case for intersecting the diamond's points
	if (center.getX() == p.getX()) {
	    if (center.getY() > p.getY()) // top point
		return (top);
	    return bottom;
	}
	if (center.getY() == p.getY()) {
	    if (center.getX() > p.getX()) // left point
		return (left);
	    // right point
	    return right;
	}
	// In which quadrant will the intersection be?
	// set the slope and offset of the border line accordingly
	
	// punti dell'ottagono
	Point2D p1 = new Point2D.Double(width/4D, 0);
	Point2D p2 = new Point2D.Double(3*width/4D, 0);
	Point2D p3 = new Point2D.Double(width, height/4D);
	Point2D p4 = new Point2D.Double(width, 3*height/4D);
	Point2D p5 = new Point2D.Double(3*width/4D, height);
	Point2D p6 = new Point2D.Double(width/4D, height);
	Point2D p7 = new Point2D.Double(0, 3*height/4D);
	Point2D p8 = new Point2D.Double(0, height/4D);
	
	// origine in alto a sinitra
	Point2D origin = new Point2D.Double(center.getX() - halfwidth, center.getY() - halfheight);
	Point2D points[] = {p1, p2, p3, p4, p5, p6, p7, p8};
	
	// sposta i punti dell'ottagono all'origine
	for(Point2D point : points) {
	    point.setLocation(point.getX() + origin.getX(), point.getY() + origin.getY());
	}
	
	double distance = Double.MAX_VALUE;
	Point2D octagonPointNearest1 = null;
	
	// trova il primo punto piu vicino
	for(Point2D octagonPoint : points) {
	    double distanceCurrent = octagonPoint.distanceSq(p);
	    if (distanceCurrent < distance) {
		distance = distanceCurrent;
		octagonPointNearest1 = octagonPoint;
	    }
	}
	
	// il secondo punto e' il precedente nella lista
	Point2D octagonPointNearest2 = null;
	for(int i = 0; i < points.length; i++) {
	    Point2D point = points[i];
	    if (point == octagonPointNearest1) {
		int indexAdvanced = (Math.abs(i - 1)) % points.length;
		octagonPointNearest2 = points[indexAdvanced];
	    }
	}
	
	Point2D i = intersection(p, center, octagonPointNearest1, octagonPointNearest2);
	return i;
    }*/

    /**
     * Find the point of intersection of two straight lines (which follow the
     * equation y=mx+b) one line is an incoming edge and the other is one side
     * of the diamond.
     */
    public Point2D intersection(Point2D lineOneStart, Point2D lineOneEnd,
	    Point2D lineTwoStart, Point2D lineTwoEnd) {
	// m = delta y / delta x, the slope of a line
	// b = y - mx, the axis intercept
	double m1 = (lineOneEnd.getY() - lineOneStart.getY())
	/ (lineOneEnd.getX() - lineOneStart.getX());
	double b1 = lineOneStart.getY() - m1 * lineOneStart.getX();
	double m2 = (lineTwoEnd.getY() - lineTwoStart.getY())
	/ (lineTwoEnd.getX() - lineTwoStart.getX());
	double b2 = lineTwoStart.getY() - m2 * lineTwoStart.getX();
	double xinter = (b1 - b2) / (m2 - m1);
	double yinter = m1 * xinter + b1;
	Point2D intersection = getAttributes().createPoint(xinter, yinter);
	return intersection;
    }
    
    
    public static class OctogonalRenderer extends JGraphGroupVertexRenderer {
	private static final long serialVersionUID = 1L;

	OctogonalRenderer() {
	    super();
	}

	public void paint(Graphics g) {
	    Graphics2D g2 = (Graphics2D) g;
	    int b = borderWidth;
	    Dimension d = getSize();
	    int width = d.width - b; // allow for border
	    int height = d.height - b; // allow for border
	    
	    
	    Point p1 = new Point((int) (width/4D), 0);
	    Point p2 = new Point((int) (3*width/4D), 0);
	    Point p3 = new Point(width, (int) (height/4D));
	    Point p4 = new Point(width, (int) (3*height/4D));
	    Point p5 = new Point((int) (3*width/4D), height);
	    Point p6 = new Point((int) (width/4D), height);
	    Point p7 = new Point(0, (int) (3*height/4D));
	    Point p8 = new Point(0, (int) (height/4D));
	    
	    
	    int[] xpoints = {p1.x, p2.x, p3.x, p4.x, p5.x, p6.x, p7.x, p8.x};
	    int[] ypoints = {p1.y, p2.y, p3.y, p4.y, p5.y, p6.y, p7.y, p8.y};
	    int numpoints = 8;
	    
	    Polygon octagon = new Polygon(xpoints, ypoints, numpoints);

	    boolean tmp = selected;
	    if (super.isOpaque()) {
		g.setColor(super.getBackground());
		if (gradientColor != null && !preview) {
		    setOpaque(false);
		    g2.setPaint(new GradientPaint(0, 0, getBackground(), getWidth(),
			    getHeight(), gradientColor, true));
		}
		g.fillPolygon(octagon);
	    }
	    try {
		setBorder(null);
		setOpaque(false);
		selected = false;
		super.paint(g);
	    } finally {
		selected = tmp;
	    }
	    if (bordercolor != null) {
		g.setColor(bordercolor);
		g2.setStroke(new BasicStroke(b));
		g.drawPolygon(octagon);
	    }
	    if (selected) {
		g2.setStroke(GraphConstants.SELECTION_STROKE);
		g.setColor(highlightColor);
		g.drawPolygon(octagon);
	    }
	}

	protected void paintBorder(Graphics g) {
	    super.paintBorder(g);
	}
	
	@Override
	public Component getRendererComponent(JGraph graph, CellView view, boolean sel, boolean focus, boolean preview) {
	    JLabel c =  (JLabel) super.getRendererComponent(graph, view, sel, focus, preview);
	    //c.setBorder(new ShadowBorder(this.bordercolor));
	    this.setVerticalAlignment(SwingConstants.TOP);
	    return c;
	}


    }
    
    

}
