package org.modelgen.jpf.visualizer.modelgenview.mvc.view.jgraph.vertexviews;

import org.modelgen.jpf.visualizer.modelgenview.mvc.view.jgraph.groupable.JGraphGroupVertexRenderer;

import java.awt.Component;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.SwingConstants;
import javax.swing.border.Border;

import org.jgraph.JGraph;
import org.jgraph.graph.CellView;
import org.jgraph.graph.CellViewRenderer;
import org.jgraph.graph.DefaultGraphCell;
import org.jgraph.graph.VertexRenderer;
import org.jgraph.graph.VertexView;

/**
 * Class <code>RectangularView</code> defines
 * @author Riccardo Pietrucci
 * @version 0.1
 */
public class RectangularView extends VertexView {
    private static final long serialVersionUID = 1L;
    public static transient final int LABEL_SIZE = 20;
    public static transient VertexRenderer renderer = new RectangularRenderer();

    public RectangularView(DefaultGraphCell cell) {
	super(cell);
    }

    public CellViewRenderer getRenderer() {
	return renderer;
    }

    public static class RectangularRenderer extends JGraphGroupVertexRenderer {
	private static final long serialVersionUID = 1L;

	public RectangularRenderer() {
	    super();
	}

	public Border getMyBorder() {
	    return BorderFactory.createLineBorder(bordercolor);
	}

	@Override
	public Component getRendererComponent(JGraph graph, CellView view, boolean sel, boolean focus, boolean preview) {
	    JLabel c =  (JLabel) super.getRendererComponent(graph, view, sel, focus, preview);
	    //c.setBorder(new ShadowBorder(this.bordercolor));
	    
	    if(c.isOpaque()) {
		Border border = this.getMyBorder();
		c.setBorder(border);
	    }
	    this.setVerticalAlignment(SwingConstants.TOP);
	    return c;
	}
    }

}
