package org.modelgen.jpf.visualizer.modelgenview.mvc.view.jtable.table;

import org.modelgen.jpf.visualizer.modelgenview.mvc.model.ModelComponent;
import org.modelgen.jpf.visualizer.modelgenview.mvc.view.jtable.rows.multivalue.MultiValueTableModel;

import java.awt.Component;

import javax.swing.JComponent;
import javax.swing.JTable;

/**
 * Class <code>NullCellRenderer</code> defines
 * @author Riccardo Pietrucci
 * @version 0.1
 */
class ModelComponentCellRenderer extends MultiValueCellRenderer {

    public ModelComponentCellRenderer(MultiValueTableModel<?> model) {
	super(model);
    }

    private static final long serialVersionUID = 1L;

    @Override
    public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected, boolean hasFocus, int row, int column) {
	ModelComponent modelData = (ModelComponent) value;
	
	JComponent renderer;
	if (modelData != null) {
	    // cella vuota come nulla
	    String cellText = modelData.toString();
	    
	    Object cellValue = modelData.getInfo();
	    if(cellValue == null || cellValue.toString() == null) {
	    	cellValue = modelData;
	    }
	    
	    if (cellText == null) { 
		renderer = (JComponent) super.getTableCellRendererComponent(table, null, isSelected, hasFocus, row, column);
	    } else { // ha un valore
		    /*if (cellText.equals("")) {
		    	renderer = (JComponent) super.getTableCellRendererComponent(table, EMPTY_VALUE, isSelected, hasFocus, row, column);
		    } else {*/
		    	renderer = (JComponent) super.getTableCellRendererComponent(table, cellValue, isSelected, hasFocus, row, column);
		    //}
		//TableCellRenderer componentToDecorate = table.getDefaultRenderer(modelData.getInfo().getClass());
		//renderer = (JComponent) componentToDecorate.getTableCellRendererComponent(table, modelData.getInfo(), isSelected, hasFocus, row, column);   
	    }
	} else {
		renderer = (JComponent) super.getTableCellRendererComponent(table, null, isSelected, hasFocus, row, column);
	}


	/* Se il Boolean ha un valore null, viene trattato semplicemente
	 * come un valore false. Per questo viene verificato se ho
	 * un'istanza di DefaultTableCellRenderer */
	if (modelData != null) {
	    String myTooltip = modelData.getTooltipText();
	    renderer.setToolTipText(myTooltip);
	}

	

	/* Restituisci il renderer modificato */
	return renderer;
    }

}
