package org.modelgen.jpf.visualizer.modelgenview.tooltip;

import org.modelgen.jpf.visualizer.modelgenview.modelgen.adapters.AbstractConstruct;
import org.modelgen.jpf.visualizer.modelgenview.modelgen.adapters.AbstractProperty;
import org.modelgen.jpf.visualizer.modelgenview.modelgen.adapters.AbstractReference;
import org.modelgen.jpf.visualizer.modelgenview.modelgen.adapters.MultiDirectionAbstractStructure;
import org.modelgen.jpf.visualizer.util.HtmlString;

import java.util.Vector;

/**
 * Class <code>ToolTipManager</code> defines
 * @author Riccardo Pietrucci
 * @version 0.1
 */
public class ToolTipManager implements ToolTipFactory {
    public static ToolTipManager instance = new ToolTipManager();
    private static ToolTipFactory factory = new DefaultToolTipFactory();
    
    static {
	// mantiene i tooltip sempre visibili
	javax.swing.ToolTipManager.sharedInstance().setDismissDelay(Integer.MAX_VALUE);
    }
    
    public static void setToolTipFactory(DefaultToolTipFactory userFactory) {
	factory = userFactory;
    }

    public HtmlString createToolTip(MultiDirectionAbstractStructure info) {
	return factory.createToolTip(info);
    }

    public HtmlString createToolTip(AbstractConstruct info) {
	return factory.createToolTip(info);
    }
    
    public HtmlString createToolTip(AbstractConstruct target, Vector<AbstractConstruct> showPreview) {
	return factory.createToolTip(target, showPreview);
    }

    public HtmlString createToolTip(AbstractReference info) {
	return factory.createToolTip(info);
    }

    public HtmlString createToolTip(AbstractProperty info) {
	return factory.createToolTip(info);
    }
    
    
}
