package org.modelgen.jpf.visualizer.pac.actions;

import org.modelgen.jpf.visualizer.commons.ToolConfigurationManager;
import org.modelgen.jpf.visualizer.pac.TopLevelPAC;
import org.modelgen.jpf.visualizer.pac.actions.wizard.NewApplyRuleDebuggerWizard;

import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.ImageIcon;
import javax.swing.KeyStroke;
/**
 * Class <code>NewWindowAction</code> defines
 * @author Riccardo Pietrucci
 * @version 0.1
 */
public class NewApplyRuleDebuggerAction extends AbstractAction {
    private static final long serialVersionUID = 1L;

    public static final String ACTION_NAME = "New Debug Session";
    public static final String ACTION_DESCRIPTION = "New Apply Rule Debug Session";
    public static final int ACTION_MNEMONIC = KeyEvent.VK_N;
    private ImageIcon icon;

    public static NewApplyRuleDebuggerAction sharedInstance = new NewApplyRuleDebuggerAction();

    private NewApplyRuleDebuggerAction() {
	this.setEnabled(true);
	putValue(Action.NAME,ACTION_NAME);
	putValue(Action.SHORT_DESCRIPTION,ACTION_DESCRIPTION);
	putValue(Action.ACCELERATOR_KEY, KeyStroke.getKeyStroke('N', java.awt.event.InputEvent.CTRL_DOWN_MASK));
	putValue(Action.MNEMONIC_KEY,ACTION_MNEMONIC);
	ImageIcon icon = ToolConfigurationManager.sharedInstance.getIcon("debug.png");
	if (icon != null) putValue(Action.SMALL_ICON, icon);
    }

    public void actionPerformed(ActionEvent event) {
	NewApplyRuleDebuggerWizard receiver = NewApplyRuleDebuggerWizard.getInstance(TopLevelPAC.getFrame());
	if(icon != null) receiver.setIconImage(icon.getImage());
	receiver.doWizard();
    }

}
