package org.modelgen.jpf.visualizer.pac.actions;

import org.modelgen.jpf.visualizer.commons.ToolConfigurationManager;
import org.modelgen.jpf.visualizer.pac.top.AbstractPerspective;

import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.ImageIcon;
import javax.swing.KeyStroke;

/**
 * Class <code>NewWindowAction</code> defines
 * @author Riccardo Pietrucci
 * @version 0.1
 */
public class NextAction extends AbstractAction {
    private static final long serialVersionUID = 1L;

    public static final String ACTION_NAME = "Next";
    public static final int ACTION_MNEMONIC = KeyEvent.VK_N;

    private AbstractPerspective receiver;

    public static NextAction sharedInstance = new NextAction();

    private NextAction() {
	setEnabled(false);
	putValue(Action.NAME,ACTION_NAME);
	putValue(Action.MNEMONIC_KEY,ACTION_MNEMONIC);
	ImageIcon icon = ToolConfigurationManager.sharedInstance.getIcon("arrow_right.png");
	if (icon != null) putValue(Action.SMALL_ICON,icon);
	putValue(Action.ACCELERATOR_KEY, KeyStroke.getKeyStroke("N"));
    }

    public void actionPerformed(ActionEvent event) {
	receiver.next();
    }
    
    @Override
    public void setEnabled(boolean newValue) {
	super.setEnabled(newValue);
	if (newValue == false) {
	    putValue(Action.SHORT_DESCRIPTION,null);
	} else {
	    putValue(Action.SHORT_DESCRIPTION,receiver.getNextActionDescription());
	}
    }

    public void setReceiver(AbstractPerspective receiver) {
        this.receiver = receiver;
        putValue(Action.SHORT_DESCRIPTION,receiver.getNextActionDescription());
    }

}
