package org.modelgen.jpf.visualizer.pac.actions;

import org.modelgen.jpf.visualizer.commons.ToolConfigurationManager;
import org.modelgen.jpf.visualizer.pac.TopLevelPAC;

import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.ImageIcon;
import javax.swing.KeyStroke;
/**
 * Class <code>NewWindowAction</code> defines
 * @author Riccardo Pietrucci
 * @version 0.1
 */
public class OpenPerspectiveVisualizerAction extends AbstractAction {
    private static final long serialVersionUID = 1L;

    public static final String ACTION_NAME = "View";
    public static final String ACTION_DESCRIPTION = "Open View Perspective";
    public static final int ACTION_MNEMONIC = KeyEvent.VK_E;

    public static OpenPerspectiveVisualizerAction sharedInstance = new OpenPerspectiveVisualizerAction();

    private OpenPerspectiveVisualizerAction() {
	this.setEnabled(true);
	putValue(Action.NAME,ACTION_NAME);
	putValue(Action.SHORT_DESCRIPTION,ACTION_DESCRIPTION);
	putValue(Action.ACCELERATOR_KEY, KeyStroke.getKeyStroke('V', java.awt.event.InputEvent.CTRL_DOWN_MASK));
	putValue(Action.MNEMONIC_KEY,ACTION_MNEMONIC);
	ImageIcon icon = ToolConfigurationManager.sharedInstance.getIcon("viewPerspective.png");
	if (icon != null) putValue(Action.SMALL_ICON,icon);
    }

    public void actionPerformed(ActionEvent event) {
	TopLevelPAC receiver = TopLevelPAC.getInstance();
	receiver.setViewPerspective();
    }

}
