package org.modelgen.jpf.visualizer.pac.top.views.view;

import org.modelgen.jpf.visualizer.modelgenview.mvc.model.MvcModel;

import java.io.Serializable;

import javax.swing.JComponent;

/**
 * Class <code>GenericView</code> defines
 * @author Riccardo Pietrucci
 * @version 0.1
 */
public abstract class AbstractView<M extends MvcModel> implements Serializable {
    protected ModelGraphViewHandler mediator;
    protected M model;
    private JComponent view = null;
    
    public AbstractView(ModelGraphViewHandler mediator, M model) {
	this.mediator = mediator;
	this.model = model;
	this.view = doCreateView();
    }
    
    public JComponent getView() {
	return view;
    }
    
    public M getModel() {
	return model;
    }
    
    // metodo hook per le sottoclassi
    public void close() {
    }
    
    /* Metodo Factory */
    protected abstract JComponent doCreateView();
}
