package org.modelgen.jpf.visualizer.pac.top.views.view;

import org.modelgen.jpf.visualizer.modelgenview.mvc.model.ModelComponent;
import org.modelgen.jpf.visualizer.modelgenview.mvc.model.ModelGraph;

/**
 * Class <code>DefaultViewFactory</code> defines
 * @author Riccardo Pietrucci
 * @version 0.1
 */
public class DefaultViewFactory extends ViewFactory {

    public DefaultViewFactory() {
	super(null);
    }

    public DefaultViewFactory(ModelGraphViewHandler mediator) {
	super(mediator);
    }

    public ViewComponent createViewComponent(ModelComponent modelComponent) {
	return new ViewComponentJTable(super.mediator, modelComponent);
    }

    public ViewGraph createViewGraph(ModelGraph modelGraph) {
	class OpenTableClickListener implements ModelDoubleClickListener {
	    private ModelGraphViewHandler mediator;
	    public OpenTableClickListener(ModelGraphViewHandler mediator) {
		this.mediator = mediator;
	    }
	    public void doubleClickedPerformed(ModelComponent modelComponent) {
		ModelComponent root = modelComponent.calculateRoot();
		this.mediator.open(root);
	    }
	}
	
	ModelDoubleClickListener doubleClickAction = new OpenTableClickListener(super.mediator);
	ViewGraphJGraph viewGraph = new ViewGraphJGraph(super.mediator, modelGraph);
	viewGraph.addClickEvent(doubleClickAction);
	
	return viewGraph;
    }

}
