package org.modelgen.jpf.visualizer.pac.top.views.view;

import org.modelgen.jpf.visualizer.modelgenview.mvc.model.ModelComponent;
import org.modelgen.jpf.visualizer.modelgenview.mvc.model.ModelGraph;

/**
 * Class <code>ViewFactory</code> defines
 * @author Riccardo Pietrucci
 * @version 0.1
 */
public abstract class ViewFactory {
    protected ModelGraphViewHandler mediator;
    public ViewFactory(ModelGraphViewHandler mediator) {
	this.mediator = mediator;
    }
    public abstract ViewGraph createViewGraph(ModelGraph modelGraph);
    public abstract ViewComponent createViewComponent(ModelComponent modelComponent);
    
    public ModelGraphViewHandler getMediator() {
        return mediator;
    }
    public void setMediator(ModelGraphViewHandler mediator) {
        this.mediator = mediator;
    }
}
