package org.modelgen.jpf.visualizer.test;

import org.modelgen.jpf.visualizer.modelgenview.mvc.model.ModelComponent;
import org.modelgen.jpf.visualizer.modelgenview.mvc.model.ModelGraph;
import org.modelgen.jpf.visualizer.pac.top.views.view.ViewGraph;
import org.modelgen.jpf.visualizer.pac.top.views.view.ViewGraphJGraph;
import org.modelgen.jpf.visualizer.util.HtmlString;

import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JScrollPane;

/**
 * Class <code>ModelTest</code> defines
 * @author Riccardo Pietrucci
 * @version 0.1
 */
public class ModelTest {

    public static void main(String[] args) {

	ModelGraph graph = new ModelGraph("prova", "id"); 

	ModelComponent ricibald = new ModelComponent("Ricibald");
	ricibald.setTooltip(new HtmlString("Il piu' bello del mondo"));
	graph.addVertex(ricibald);
	ModelComponent emanuela = new ModelComponent("Emanuela");
	graph.addVertex(emanuela);


	/* Gruppo Italia */
	ModelComponent roma = new ModelComponent("Roma");
	ModelComponent napoli = new ModelComponent("Napoli");
	ModelComponent italia = new ModelComponent("Italia");
	italia.addChildren(roma);
	italia.addChildren(napoli);

	/* Gruppo Estero */
	ModelComponent parigi = new ModelComponent("Parigi");
	ModelComponent barcellona = new ModelComponent("Barcellona");
	ModelComponent estero = new ModelComponent("Estero");
	estero.addChildren(parigi);
	estero.addChildren(barcellona);

	/* Gruppo Posti Visitati */
	ModelComponent posti = new ModelComponent("Posti Visitati");
	posti.addChildren(italia);
	posti.addChildren(estero);

	/* Gruppo Passioni */
	ModelComponent canto = new ModelComponent("Canto");
	ModelComponent ballo = new ModelComponent("Ballo");
	ModelComponent passioni = new ModelComponent("Passioni");
	passioni.addChildren(canto);
	passioni.addChildren(ballo);

	/* Elemento ungrouped */
	ModelComponent ungrouped = new ModelComponent("Ungrouped");
	graph.addVertex(ungrouped);

	/* Gruppo RicibaldWorld */
	ModelComponent ricibaldWorld = new ModelComponent("RicibaldWorld");
	graph.addVertex(ricibaldWorld);
	ricibaldWorld.addChildren(posti);
	ricibaldWorld.addChildren(passioni);
	ricibaldWorld.addChildren(ungrouped);


	ricibald.addChildren(emanuela);

	/* Archi */
	graph.addConnection(ricibald, emanuela, "coppia");
	//graphBuilder.addEdge("lavora a", ricibald, roma, "1..*", "1");
	//graphBuilder.addEdge("vive a", ricibald, roma, "1", "1..*");
	//graphBuilder.addEdge("vive a", emanuela, roma, "1", "1..*");
	//graphBuilder.addEdge("viaggio a", ricibald, parigi, "1", "1..*");
	//graphBuilder.addEdge("viaggio a", emanuela, parigi, "1", "1..*");
	//graphBuilder.addEdge("viaggio a", ricibald, barcellona, "1", "1..*");
	graph.addConnection(ricibald, ungrouped, "ungroupedEdge");
	graph.addConnection(ricibald, ricibaldWorld, "possiede");
	graph.addConnection(ricibald, posti, "posti");
	graph.addConnection(emanuela, ricibaldWorld, "pos22siede22");
	graph.addConnection(emanuela, posti, "po22sti22");

	/* un arco non puo' essere condiviso, come in 
	 * graph.addConnection(emanuela, ungrouped, "ungroupedEdge");
	 */

	/* Fine composizione grafo. Restituisci il risultato */
	ViewGraph viewGraph = new ViewGraphJGraph(null, graph);
	JComponent view = viewGraph.getView();


	JFrame frame = new JFrame();
	frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	frame.getContentPane().add(new JScrollPane(view));
	frame.pack();
	frame.setVisible(true);

    }
}
