package org.modelgen.jpf.visualizer.test;

import org.modelgen.jpf.visualizer.pac.TopLevelPAC;

import java.awt.Dimension;
import java.awt.Frame;
import java.awt.event.WindowEvent;

import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JInternalFrame;
import javax.swing.UIManager;

/**
 * Class <code>VisualTest</code> defines
 * @author Riccardo Pietrucci
 * @version 0.1
 */
public class VisualTest {
    public static void main(String[] args) {
	try {
	    UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
	} catch (Exception e) {
	    /* TODO: cosa fare? */
	}
	CloseableFrame frame = new CloseableFrame("test");
	frame.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
	JInternalFrame internalFrame = new JInternalFrame("test internal");
	internalFrame.setClosable(true);
	frame.getContentPane().add(internalFrame);
	
	TopLevelPAC.setFrame(frame);
	TopLevelPAC.setParent(internalFrame);
	TopLevelPAC top = TopLevelPAC.getInstance();
	JComponent view = top.getView();
	if (view != null) {
	    internalFrame.getContentPane().add(view);
	    internalFrame.pack();
	    internalFrame.setMinimumSize(new Dimension(200,200));
	    frame.setExtendedState(Frame.MAXIMIZED_BOTH);
	    frame.setVisible(true);
	    internalFrame.setVisible(true);
	} else {
	    frame.close();
	}
    }
    
    public static class CloseableFrame extends JFrame {
		private static final long serialVersionUID = 1L;

	public CloseableFrame(String title) {
	    super(title);
	}

	public void close() {
	    WindowEvent event = new WindowEvent(this, WindowEvent.WINDOW_CLOSING);
	    this.processWindowEvent(event);
	}
	
    }
}
