package org.modelgen.jpf.visualizer.util;

import java.util.Collections;
import java.util.Comparator;
import java.util.SortedSet;
import java.util.TreeSet;

public class CollectionFunctions {

    public static <E> SortedSet<E> reverse(SortedSet<E> originalCollection) {
    	SortedSet<E> collectionReversed;
    	Comparator<? super E> reverseComparator =
    		originalCollection.comparator();
    	if(reverseComparator==null) {
    		reverseComparator=Collections.reverseOrder();
    	} else {
    		reverseComparator=Collections.reverseOrder(reverseComparator);
    	}
    	collectionReversed = new TreeSet<E>(reverseComparator);
    	
    	for(E e : originalCollection) {
    		collectionReversed.add(e);
    	}
    	return collectionReversed;
	}
}
