package org.modelgen.jpf.visualizer.util;

/**
 * La classe <code>DescriptionHolder</code> 
 * consente di descrivere un oggetto tramite una descrizione
 * semplice e una dettagliata
 * 
 * @author Riccardo Pietrucci
 * @version 0.1
 */
public class DescriptionHolder<T> {
    private T info;
    private String simpleDescription;
    private String extendedDescription;

    public DescriptionHolder(T info, String simpleDescription, String extendedDescription) {
	this.info = info;
	this.simpleDescription = simpleDescription;
	this.extendedDescription = extendedDescription;
    }

    public String getExtendedDescription() {
        return extendedDescription;
    }

    public T getInfo() {
        return info;
    }

    public String getSimpleDescription() {
        return simpleDescription;
    }

    @Override
    public String toString() {
	return simpleDescription;
    }
    
}
