package org.modelgen.jpf.visualizer.util;

/**
 * La classe <code>DescriptionProxy</code>
 * consente di definire una descrizione utile
 * nei metodi che richiedono un toString() senza
 * dover necessariamente ridefinire il metodo toString
 * della classe interessata.
 * 
 * @param <T> il tipo da descrivere
 * @author Riccardo Pietrucci
 * @version 0.1
 */
public class DescriptionProxy<T> {
    T info;
    String description;

    public DescriptionProxy(T info, String description) {
	this.info = info;
	this.description = description;
    }
    
    public String getDescription() {
        return this.description;
    }

    public T getInfo() {
        return this.info;
    }

    @Override
    public String toString() {
	return this.description;
    }
    
    
}
