package org.modelgen.jpf.visualizer.util;

import java.util.Vector;

/**
 * Class <code>MathFunctions</code> defines
 * @author Riccardo Pietrucci
 * @version 0.1
 */
public class MathFunctions {
    public static <T> Vector<Vector<T>> transposeMatrix(Vector<Vector<T>> matrix) {
	assert isMatrix(matrix);
	int rowsSize = matrix.size();
	int colsSize = matrix.get(0).size();
	
	/* Inizializzo il vettore */
	Vector<Vector<T>> result = new Vector<Vector<T>>(colsSize);
	for (int i = 0; i < colsSize; i++) {
	    Vector<T> row = new Vector<T>(rowsSize);
	    for (int j = 0; j < rowsSize; j++) {
		row.add(null);
	    }
	    result.add(row);
	}
	
	/* Costruisci la matrice trasposta */
	for (int i = 0; i < rowsSize; i++) {
	    for (int j = 0; j < colsSize; j++) {
		T value = matrix.get(i).get(j);
		result.get(j).set(i, value);
	    }
	}
	
	return result;
    }
    
    public static <T> boolean isMatrix(Vector<Vector<T>> matrix) {
	int colSize = -1;
	for (Vector<?> col : matrix) {
	    if (colSize == -1) {
		colSize = col.size();
	    }
	    if (col.size() != colSize) {
		return false;
	    }
	}
	return true;
    }
    
    public static void main(String[] args) {
	/* Test matrice trasposta */
	Vector<Vector<Integer>> matrix = new Vector<Vector<Integer>>(4);
	Vector<Integer> row1, row2, row3, row4;
	
	row1 = new Vector<Integer>(3);
	row1.add(1); row1.add(2); row1.add(3);
	
	row2 = new Vector<Integer>(3);
	row2.add(4); row2.add(5); row2.add(6);
	
	row3 = new Vector<Integer>(3);
	row3.add(7); row3.add(8); row3.add(9);
	
	row4 = new Vector<Integer>(3);
	row4.add(10); row4.add(11); row4.add(12);
	
	matrix.add(row1);
	matrix.add(row2);
	matrix.add(row3);
	matrix.add(row4);
	
	Vector<Vector<Integer>> matrixTransposed = transposeMatrix(matrix);
	
	System.out.println(matrix);
	System.out.println();
	System.out.println(matrixTransposed);
    }
}
