package org.modelgen.jpf.visualizer.util;

import java.io.Serializable;

/**
 * Class <code>Edge</code> defines
 * @author Riccardo Pietrucci
 * @version 0.1
 */
public class Pair<A,B> implements Serializable {
    private static final long serialVersionUID = 1L;
    
    private A first;
    private B second;
    /** 
     * Creates a new <code>Edge</code>
     * @param first
     * @param second
     */
    public Pair(A first, B second) {
	this.first = first;
	this.second = second;
    }
    /** 
     * Returns first
     * @return first
     */
    public A getFirst() {
        return this.first;
    }
    /** 
     * Set first
     * @param first first to set
     */
    public void setFirst(A first) {
        this.first = first;
    }
    /** 
     * Returns second
     * @return second
     */
    public B getSecond() {
        return this.second;
    }
    /** 
     * Set second
     * @param second second to set
     */
    public void setSecond(B second) {
        this.second = second;
    }
    @Override
    public String toString() {
	return "( "+this.first+", "+this.second+" )";
    }
    @Override
    public boolean equals(Object obj) {
	Pair<?,?> otherPair = (Pair<?, ?>) obj;
	return first.equals(otherPair.first) && second.equals(otherPair.second);
    }
    @Override
    public int hashCode() {
	int h = (first == null ? 0 : first.hashCode());
	if ( second != null )
	    h ^= second.hashCode();
	return h;
    }

    public static <X extends Comparable<X>, Y extends Comparable<Y>> int compareTo(Pair<X,Y> current, Pair<X,Y> other) {
	// check
	int compare = current.first.compareTo(other.first);
	if (compare == 0) { // se sono uguali vai ai secondi
	    compare = current.second.compareTo(other.second); 
	}
	return compare;
    }
}
