package org.modelgen.jpf.visualizer.util;

import java.awt.Component;
import java.awt.Graphics;
import java.awt.Insets;

import javax.swing.border.AbstractBorder;

/**
 * Class <code>RoundBorder</code> defines
 * @author Riccardo Pietrucci
 * @version 0.1
 */
public class RhombBorder extends AbstractBorder {
    private static final long serialVersionUID = 1L;

    public void paintBorder(Component c, Graphics g, int xStart, int yStart, int width, int height) {
	g.setColor ( c.getForeground() ) ;
	int xEnd = xStart + width;
	int yEnd = yStart + height;
	int xCenter = xStart + width/2;
	int yCenter = yStart + height/2;
	
	// linea da sinistra in alto
	g.drawLine(xStart, yCenter, xCenter, yStart);
	
	// linea da alto a destra
	g.drawLine(xCenter, yStart, xEnd, yCenter);
	
	// linea da destra in basso
	g.drawLine(xEnd, yCenter, xCenter, yEnd);
	
	// linea da basso a sinistra
	g.drawLine(xCenter, yEnd, xStart, yCenter);
	
    }
    
    
    public Insets getBorderInsets ( ) {
	return new Insets ( 1000,1000,1000,1000) ;
    }
    
    
}