package org.modelgen.jpf.visualizer.util;

import java.awt.Component;
import java.awt.Graphics;
import java.awt.Insets;

import javax.swing.border.AbstractBorder;

/**
 * Class <code>RoundBorder</code> defines
 * @author Riccardo Pietrucci
 * @version 0.1
 */
public class RoundBorder extends AbstractBorder {
    private static final long serialVersionUID = 1L;
    private static final int ROUNDFACTOR_DEFAULT = 30;
    private int roundFactor;
    
    public RoundBorder() {
	this(ROUNDFACTOR_DEFAULT);
    }
    
    public RoundBorder(int roundFactor) {
	this.roundFactor = roundFactor;
    }

    public void paintBorder(Component c, Graphics g, int x, int y, int width, int height) {
	g.setColor ( c.getForeground() ) ;
	
	/* Lascia spazio */
	if (width > 0) {
	    width--; 
	}
	
	if (height > 0) {
	    height--;
	}
	
	// disegna un rettangolo arrotondato
	g.drawRoundRect ( x , y , width - 1 , height - 1 , roundFactor, roundFactor) ;
    }
    public Insets getBorderInsets ( ) {
	return new Insets ( 0,0,0,0) ;
    }

}
