package org.modelgen.jpf.visualizer.util;

import java.math.BigDecimal;
import java.sql.Array;
import java.sql.Blob;
import java.sql.Clob;
import java.sql.Date;
import java.sql.Ref;
import java.sql.Time;
import java.sql.Timestamp;
import java.util.LinkedHashMap;
import java.util.Map;

/**
 * Class <code>TypeConverter</code> defines
 * @author Riccardo Pietrucci
 * @version 0.1
 */
public class TypeConverter {
    
    static Map<String,Object> map = new LinkedHashMap<String,Object>();
    static {
	/* 
	 * mappa basata sull'articolo:
	 * http://java.sun.com/j2se/1.3/docs/guide/jdbc/getstart/mapping.html
	 */
	map.put("TINYINT", Byte.class);
	map.put("SMALLINT", Short.class);
	map.put("INTEGER", Integer.class);
	map.put("BIGINT", Long.class);
	map.put("REAL", Float.class);
	map.put("FLOAT", Double.class);
	map.put("DOUBLE", Double.class);
	map.put("DECIMAL", BigDecimal.class);
	map.put("NUMERIC", BigDecimal.class);
	map.put("BIT", Boolean.class);
	map.put("CHAR", String.class);
	map.put("VARCHAR", String.class);
	map.put("LONGVARCHAR", String.class);
	map.put("BINARY", Byte.class);
	map.put("VARBINARY", Byte.class);
	map.put("LONGVARBINARY", Byte.class);
	map.put("DATE", Date.class);
	map.put("TIME", Time.class);
	map.put("TIMESTAMP", Timestamp.class);
	map.put("CLOB", Clob.class);
	map.put("BLOB", Blob.class);
	map.put("ARRAY", Array.class);
	map.put("REF", Ref.class);
	map.put("STRUCT", Object.class);
	
	/*
	 * Rimanenti associazioni java-based
	 */
	map.put("INT", Integer.class);
	map.put("STRING", String.class);
	map.put("BOOLEAN", Boolean.class);
	map.put("BOOL", Boolean.class);
    }
    
    public static Object getType(String typeDescription) {
	Object type = map.get(typeDescription);
	if (type == null) {
	    type = Object.class; // default
	}
	return type;
    }
}
