/*
 * Created on 11-dic-2003
 *
 */
package org.modelgen.applyrule;

import java.util.LinkedList;


/**
 * MacroRule contains the various SimpleRule and BlockOfRules and
 * the file which was used to build the MacroRule .
 * 
 * @author Luca
 *
 */
public class MacroRule {

	private LinkedList<Rule> items = null; //Each item can be a SimpleRule or a BlockOfRules.
	private String filename = null;

	/**
	 * There is no real constructor. The initialization is done in MacroRuleReader class.
	 * @see org.modelgen.applyrule.reader.MacroRuleReader
	 */
	public MacroRule() {
		items = new LinkedList<Rule>();
	}

	/**
	 * @return the rules of this MacroRule object
	 */
	public LinkedList<Rule> getItems() {
		return items;
	}

	/**
	 * Adds the given SimpleRule rule to this MacroRule object.
	 * This method exists as to give a compiler-time check for arguments.
	 * @param rule
	 */
	public void addRule(Rule rule) {
		items.add(rule);
	}

	/**
	 * Returns the string representation of the name of the file which was used to build the MacroRule.
	 * @return filename, the name of the file used to build the MacroRule.
	 */
	public String getFilename() {
		return filename;
	}

	/**
	 * Sets the name of the file used to build the MacroRule.
	 * @param string
	 */
	public void setFilename(String string) {
		filename = string;
	}

}
