/*
 * Created on 11-dic-2003
 *
 */
package org.modelgen.applyrule;

import java.util.LinkedList;
/**
 * Contains the info about a simple rule.
 *  
 * @author Luca
 *
 */
public class SimpleRule implements Rule {

	private LinkedList<Statement> statements = new LinkedList<Statement>(); //If we have a SimpleRule, it'll be filled sooner or later.
	private boolean mustBeIterated = false;
	private String filename = null;
	 
	/**
	 * @return if this simple rule has to be iterated
	 */
	public boolean isMustBeIterated() {
		return mustBeIterated;
	}

	/**
	 * @return the statements of this SimpleRule object
	 */
	public LinkedList<Statement> getStatements() {
		return statements;
	}
	
	
	/**
	 * @param s the statement to add
	 */
	public void addStatement(Statement s) {
		statements.add(s);
	}
	
	/**
	 * @param mustBeIterated if this simple rule has to be iterated
	 */
	public void setMustBeIterated(boolean mustBeIterated) {
		this.mustBeIterated = mustBeIterated;
	}

	/** 
	 * Returns the string representation of the name of the file which was used to build the SimpleRule.
	 * @return filename, the name of the file used to build the SimpleRule.
	 */
	public String getFilename() {
		return filename;
	}

	/**
	 * @param string
	 */
	public void setFilename(String string) {
		filename = string;
	}

}
