/*
 * Created on 17-apr-2004
 *
 */
package org.modelgen.commons.beans.scheme;

import org.modelgen.commons.beans.AbstractBean;
import org.modelgen.commons.beans.model.Property;
/**
 * The SchemeObjectProperty is a property of a {@link SchemeObject}.<p> 
 * 
 * It contains the <i>values</i> of the properties declared in the
 * referring {@link Property}.<p>
 * 
 * Therefore we can't assign a <code>null</code> value to {@link #setMetaInfo(Property)} 
 * 
 * @author Luca
 *
 */
public class SchemeObjectProperty extends AbstractBean<Property> {
	private String value;
	
	/**
	 * Creates a scheme object's property with the oid, the name and the
	 * referring property specified.
	 * 
	 * @param oid the scheme object property's oid
	 * @param name the scheme object property's name
	 * @param parent the referring property
	 */
	public SchemeObjectProperty(int oid, String name, Property parent) {
		super(oid, name, parent);
	}

	/**
	 * @return this property's value
	 */
	public String getValue() {
		return value;
	}

	/**
	 * @param value this property's value
	 */
	public void setValue(String value) {
		this.value = value;
	}
	
	public String toString(){
		return this.getMetaInfo().getName()+" value: "+this.getValue();
	}

}
