/*
 * Created on 17-apr-2004
 *
 */
package org.modelgen.commons.beans.scheme;

import org.modelgen.commons.beans.AbstractBean;
import org.modelgen.commons.beans.model.Reference;
/**
 * The SchemeObjectReference is a reference of a {@link SchemeObject}.<p> 
 * 
 * It contains the the references's <i>pointing values</i> declared in the
 * referring {@link Reference}.<p>
 * 
 * Therefore we can't assign a <code>null</code> value to {@link #setMetaInfo(Reference)} 
 * 
 * @author Luca
 *
 */
public class SchemeObjectReference extends AbstractBean<Reference> {
	private SchemeObject value;

	/**
	 * Creates a scheme object's reference with the oid, the name and the
	 * referring reference specified.
	 * 
	 * @param oid the scheme object reference's oid
	 * @param name the scheme object reference's name
	 * @param parent the referring reference
	 */
	public SchemeObjectReference(int oid, String name, Reference parent) {
		super(oid, name, parent);
	}

	/**
	 * @return this reference's value
	 */
	public SchemeObject getValue() {
		return value;
	}

	/**
	 * @param value this reference's value
	 */
	public void setValue(SchemeObject value) {
		this.value = value;
	}

}
