/*
 * Created on 10-mar-2004
 *
 */
package org.modelgen.commons.persistence;

import java.io.PrintStream;
import java.io.PrintWriter;
/**
 * Specific type exception useful to distinguish errors
 * caused by persistence.
 * 
 * @author Luca
 *
 */
public class PersistenceException extends Exception {
	private static final long serialVersionUID = 1L;
	Throwable nested = null;

	public PersistenceException() {
		super();
	}

	public PersistenceException(final String message) {
		super(message);
	}

	public PersistenceException(final Throwable cause) {
		super(cause);
		nested = cause;
	}
	
	public PersistenceException(final String message, final Throwable cause) {
		super(message, cause);
		nested = cause;
	}
	
	public void printStackTrace(final PrintStream ps) {
		super.printStackTrace(ps);
		if (nested != null) {
			try {
				ps.println("Nested cause: ");
			} catch (final Exception ex) {}
			nested.printStackTrace(ps);
		}
	}
	public void printStackTrace(final PrintWriter pw) {
		super.printStackTrace(pw);
		if (nested != null) {
			try {
				pw.println("Nested cause: ");
			} catch (final Exception ex) {}
			nested.printStackTrace(pw);
		}
	}
}
