package org.modelgen.commons.persistence;

/**
 * The listener for a db reload action.
 * 
 * @see PersistenceHandlerFactory#addReloadListener(PersistenceHandlerFactoryReloadListener)
 * @see PersistenceHandlerFactory#reload()
 * @see PersistenceHandlerFactory#resetDBHandler(org.modelgen.commons.persistence.database.DBHandler)
 * 
 * @author Riccardo Pietrucci
 *
 */
public interface PersistenceHandlerFactoryReloadListener {
	/**
	 * Invoked when the {@link PersistenceHandler} used
	 * in {@link PersistenceHandlerFactory} changes.
	 * 
	 * <p>This happens in {@link  PersistenceHandlerFactory#reload()} and
	 * in {@link  PersistenceHandlerFactory#resetDBHandler(org.modelgen.commons.persistence.database.DBHandler)}
	 * where the {@link PersistenceHandler} is reloaded.
	 * 
	 * @see PersistenceHandlerFactory#addReloadListener(PersistenceHandlerFactoryReloadListener)
	 * @see PersistenceHandlerFactory#reload()
	 * @see PersistenceHandlerFactory#resetDBHandler(org.modelgen.commons.persistence.database.DBHandler)
	 */
	public void dbReloaded();
}
