/*
 * Created on 9-gen-2005
 *
 */
package org.modelgen.commons.persistence.xml;

import org.modelgen.commons.persistence.xml.jaxb.model.Model;
import org.modelgen.commons.persistence.xml.jaxb.model.ModelConstructType;
import org.modelgen.commons.persistence.xml.jaxb.model.ModelPropertyType;
import org.modelgen.commons.persistence.xml.jaxb.model.ModelReferenceType;
import org.modelgen.commons.persistence.xml.jaxb.model.impl.BasicConstructTypeImpl;
import org.modelgen.commons.persistence.xml.jaxb.model.impl.BasicPropertyTypeImpl;
import org.modelgen.commons.persistence.xml.jaxb.model.impl.BasicReferenceTypeImpl;
import org.modelgen.commons.persistence.xml.jaxb.model.impl.ModelConstructTypeImpl;
import org.modelgen.commons.persistence.xml.jaxb.model.impl.ModelImpl;
import org.modelgen.commons.persistence.xml.jaxb.model.impl.ModelPropertyTypeImpl;
import org.modelgen.commons.persistence.xml.jaxb.model.impl.ModelReferenceTypeImpl;
import org.modelgen.commons.persistence.xml.jaxb.model.impl.ModelTypeImpl;

import java.io.FileWriter;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
/**
 * @author lucasantarelli
 *
 */
class Test {

	public static void main(String[] args) {
		Model m = new ModelImpl();
		m.setName("Entita Relazione Nario");
		m.setShortName("ERN");
		m.setConstructs(new ModelTypeImpl.ConstructsTypeImpl());
		m.setProperties(new ModelTypeImpl.PropertiesTypeImpl());
		m.setReferences(new ModelTypeImpl.ReferencesTypeImpl());
		
		ModelConstructType c = new ModelConstructTypeImpl();
		c.setName("Entita");
		c.setMappingToConstruct(new BasicConstructTypeImpl());
		c.getMappingToConstruct().setName("Abstract");
		
		m.getConstructs().getConstruct().add(c);

		c = new ModelConstructTypeImpl();
		c.setName("AttributoDiEntita");
		c.setMappingToConstruct(new BasicConstructTypeImpl());
		c.getMappingToConstruct().setName("AttributeOfAbstract");

		ModelPropertyType p = new ModelPropertyTypeImpl();
		p.setName("ammetteNullo");
		p.setBelongingTo("AttributoDiEntita");
		p.setType("booleano");
		p.setMappingToProperty(new BasicPropertyTypeImpl());
		p.getMappingToProperty().setName("isNullable");
		p.getMappingToProperty().setBelongingTo("AttributeOfAbstract");
		p.getMappingToProperty().setType("bit");
		
		m.getProperties().getProperty().add(p);
		
		ModelReferenceType r = new ModelReferenceTypeImpl();
		r.setName("entitaOID");
		r.setBelongingTo("AttributoDiEntita");
		r.setTargeting("Entita");
		r.setType("D"); //TODO: check the Db (or the object) for the correct value.
		r.setMappingToReference(new BasicReferenceTypeImpl());
		r.getMappingToReference().setName("abstractOID");
		r.getMappingToReference().setBelongingTo("AttributeOfAbstract");
		r.getMappingToReference().setTargeting("Abstract");
		r.getMappingToReference().setType("D");
		
		m.getReferences().getReference().add(r);
		FileWriter fw = null;
		
		try {
			fw = new FileWriter("test-ern-model.xml");
		}
		catch (Exception e) {
			e.printStackTrace();
		}
		
		try {
			JAXBContext context = JAXBContext.newInstance("org.modelgen.commons.persistence.xml.jaxb");
			Marshaller marshaller = context.createMarshaller();
			marshaller.marshal(m, fw);
		}
		catch (JAXBException je) {
			je.printStackTrace();
		}
		try {
			if(fw != null) {
				fw.close();
			}
		}
		catch (Exception e) {
			e.printStackTrace();
		}
	}
}
