/*
 * Created on 9-apr-2004
 *
 */
package org.modelgen.commons.utils;

import org.apache.log4j.Logger;
/**
 * Simple mapping from sql-type to java-type or to html-type.
 * 
 * @author Luca
 *
 */
public class TypeTranslator {
	//The logger.
	private static Logger log = Logger.getLogger(TypeTranslator.class);
	
	/**
	 * @param type the sql type
	 * @return the java type. A string rappresentation otherwise
	 */
	public static Class getJavaType(String type) {
		if (type.equalsIgnoreCase("varchar") || type.equalsIgnoreCase("text"))
			return String.class;
		if (type.equalsIgnoreCase("bit") || type.equalsIgnoreCase("boolean"))
			return Boolean.class;
		//TODO: add the other datatypes. Currently they are all fixed (SQL types) but in the future they could
		//become "dynamic", meaning a "AttributeOfAbstract" may become a data type!
		
		//If we get here, we couldn't find a match.
		log.fatal("an unknown type was requested (" + type + "), returning String."); 
		return (String.class); //A failsafe: (almost) everything can be represented as a String (provided a toString method exists ;-)).
	}
	
	/**
	 * @param type the sql type
	 * @return the java type. The simple "text" rappresentation otherwise
	 */
	public static String getHTMLType(String type) {
		if (type.equalsIgnoreCase("varchar") || type.equalsIgnoreCase("text"))
			return "text";
		if (type.equalsIgnoreCase("bit") || type.equalsIgnoreCase("boolean"))
			return "checkbox";
		
		//If we get here, we couldn't find a match.
		log.fatal("an unknown type was requested (" + type + "), returning String."); 
		return "text";
	}
}
