package org.modelgen.jpf.core;

import java.util.Comparator;

import org.java.plugin.registry.Extension;

/**
 * Gives a specific plugins sorting. 
 * 
 * @author paoloc
 */
class PluginNameComparator implements Comparator<Extension>{


	/**
	 * Gives a specific plugins sorting.
	 * @param o1 the first extension
	 * @param o2 the second extension
	 * @return -1 if (o1 &lt; o2), 0 if (o1 == o2), 1 if (o1 &gt; o2) 
	 */
	public int compare(Extension o1, Extension o2) {
		if (o1.getParameter("name").valueAsString().equals("Define Model")) {
			return -1;
		}
		if (o1.getParameter("name").valueAsString().equals("Define Schema")) {
			if (o2.getParameter("name").valueAsString().equals("Define Model"))
				return 1;
			else return -1;
		}
		if (o1.getParameter("name").valueAsString().equals("Define Skolem")) {
			if (o2.getParameter("name").valueAsString().equals("Define Model")
				|| o2.getParameter("name").valueAsString().equals("Define Schema"))
				return 1;
			else return -1;
		}
		if (o1.getParameter("name").valueAsString().equals(" Apply Schema Rules")) {
			if (o2.getParameter("name").valueAsString().equals("Define Model")
				|| o2.getParameter("name").valueAsString().equals("Define Schema")
				|| o2.getParameter("name").valueAsString().equals("Define Skolem")
			)
				return 1;
			else return -1;
		}
		if (o1.getParameter("name").valueAsString().equals("Apply Instance Rules")) {
			if (o2.getParameter("name").valueAsString().equals("Define Model")
				|| o2.getParameter("name").valueAsString().equals("Define Schema")
				|| o2.getParameter("name").valueAsString().equals("Define Skolem")
				|| o2.getParameter("name").valueAsString().equals("Apply Schema Rules")
			)
				return 1;
			else return -1;
		}
		if (o1.getParameter("name").valueAsString().equals("Define Macrorule Tool")) {
			if (o2.getParameter("name").valueAsString().equals("Define Model")
				|| o2.getParameter("name").valueAsString().equals("Define Schema")
				|| o2.getParameter("name").valueAsString().equals("Define Skolem")
				|| o2.getParameter("name").valueAsString().equals("Apply Schema Rules")
				|| o2.getParameter("name").valueAsString().equals("Apply Instance Rules")
			)
				return 1;
			else return -1;
		}
		if (o1.getParameter("name").valueAsString().equals("open Editor Datalog")) {
			if (o2.getParameter("name").valueAsString().equals("Define Model")
				|| o2.getParameter("name").valueAsString().equals("Define Schema")
				|| o2.getParameter("name").valueAsString().equals("Define Skolem")
				|| o2.getParameter("name").valueAsString().equals("Apply Schema Rules")
				|| o2.getParameter("name").valueAsString().equals("Apply Instance Rules")
				|| o2.getParameter("name").valueAsString().equals("Define Macrorule Tool")
			)
				return 1;
			else return -1;
		}
		if (o1.getParameter("name").valueAsString().equals("Macro Rules editor")) {
			if (o2.getParameter("name").valueAsString().equals("Define Model")
				|| o2.getParameter("name").valueAsString().equals("Define Schema")
				|| o2.getParameter("name").valueAsString().equals("Define Skolem")
				|| o2.getParameter("name").valueAsString().equals("Apply Schema Rules")
				|| o2.getParameter("name").valueAsString().equals("Apply Instance Rules")
				|| o2.getParameter("name").valueAsString().equals("Define Macrorule Tool")
				|| o2.getParameter("name").valueAsString().equals("open Editor Datalog")
			)
				return 1;
			else return -1;
		}
		if (o1.getParameter("name").valueAsString().equals("Signature Application Tool")) {
			if (o2.getParameter("name").valueAsString().equals("Define Model")
				|| o2.getParameter("name").valueAsString().equals("Define Schema")
				|| o2.getParameter("name").valueAsString().equals("Define Skolem")
				|| o2.getParameter("name").valueAsString().equals("Apply Schema Rules")
				|| o2.getParameter("name").valueAsString().equals("Apply Instance Rules")
				|| o2.getParameter("name").valueAsString().equals("Define Macrorule Tool")
				|| o2.getParameter("name").valueAsString().equals("open Editor Datalog")
				|| o2.getParameter("name").valueAsString().equals("Macro Rules editor")
			)
				return 1;
			else return -1;
		}
		if (o1.getParameter("name").valueAsString().equals("Automatic Signature Application Tool")) {
			if (o2.getParameter("name").valueAsString().equals("Define Model")
				|| o2.getParameter("name").valueAsString().equals("Define Schema")
				|| o2.getParameter("name").valueAsString().equals("Define Skolem")
				|| o2.getParameter("name").valueAsString().equals("Apply Schema Rules")
				|| o2.getParameter("name").valueAsString().equals("Apply Instance Rules")
				|| o2.getParameter("name").valueAsString().equals("Define Macrorule Tool")
				|| o2.getParameter("name").valueAsString().equals("open Editor Datalog")
				|| o2.getParameter("name").valueAsString().equals("Macro Rules editor")
				|| o2.getParameter("name").valueAsString().equals("Signature Application Tool")
			)
				return 1;
			else return -1;
		}
		if (o1.getParameter("name").valueAsString().equals("Import Export Tool")) {
			if (o2.getParameter("name").valueAsString().equals("Define Model")
				|| o2.getParameter("name").valueAsString().equals("Define Schema")
				|| o2.getParameter("name").valueAsString().equals("Define Skolem")
				|| o2.getParameter("name").valueAsString().equals("Apply Schema Rules")
				|| o2.getParameter("name").valueAsString().equals("Apply Instance Rules")
				|| o2.getParameter("name").valueAsString().equals("Define Macrorule Tool")
				|| o2.getParameter("name").valueAsString().equals("open Editor Datalog")
				|| o2.getParameter("name").valueAsString().equals("Macro Rules editor")
				|| o2.getParameter("name").valueAsString().equals("Signature Application Tool")
				|| o2.getParameter("name").valueAsString().equals("Automatic Signature Application Tool")
			)
				return 1;
			else return -1;
		}
		if (o1.getParameter("name").valueAsString().equals("Visualizer and Rule Debugger Tool")) {
			if (o2.getParameter("name").valueAsString().equals("Define Model")
				|| o2.getParameter("name").valueAsString().equals("Define Schema")
				|| o2.getParameter("name").valueAsString().equals("Define Skolem")
				|| o2.getParameter("name").valueAsString().equals("Apply Schema Rules")
				|| o2.getParameter("name").valueAsString().equals("Apply Instance Rules")
				|| o2.getParameter("name").valueAsString().equals("Define Macrorule Tool")
				|| o2.getParameter("name").valueAsString().equals("open Editor Datalog")
				|| o2.getParameter("name").valueAsString().equals("Macro Rules editor")
				|| o2.getParameter("name").valueAsString().equals("Signature Application Tool")
				|| o2.getParameter("name").valueAsString().equals("Automatic Signature Application Tool")
				|| o2.getParameter("name").valueAsString().equals("Import Export Tool")
			)
				return 1;
			else return -1;
		}
		return 1;
	}

}
