package org.modelgen.jpf.core.actions;

import org.modelgen.facade.ResourceFunctions;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.ImageIcon;

/**
 * Manage Options Action
 */
public class ManageOptionsAction extends AbstractAction{
	private static final long serialVersionUID = 3457721066930274350L;

	/**
	 * The action's name
	 */
	public static final String ACTION_NAME = "Set Preferences...";
	
	/*Singleton*/
	private static ManageOptionsAction istance;
	
	/**
	 * @return the unique shared instance
	 */
	public synchronized static ManageOptionsAction getIstance(){
		if(istance == null)
			istance = new ManageOptionsAction();
		return istance;
	}	
	private ManageOptionsAction(){
		putValue(Action.NAME,ACTION_NAME);
		ImageIcon imageIcon = ResourceFunctions.openImageIcon(this.getClass(), "optionsMenuItem.png");
		putValue(Action.SMALL_ICON,imageIcon);
	}

	/**
	 * Invoked when this action occurs. Creates a new 
	 * {- @link ManageOptionsDialog} and shows it.
	 */
	public void actionPerformed(ActionEvent arg0) {
		System.out.println("Dialog");
		new ManageOptionsDialog().setVisible(true);		
	}

}
