package org.modelgen.jpf.core.actions;

import org.modelgen.facade.GeneralManagementFacade;
import org.modelgen.facade.ResourceFunctions;
import org.modelgen.jpf.core.ToolBoxFrame;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.ImageIcon;
import javax.swing.JOptionPane;

/**
 * Re-initialized Database Action
 */
public class ReInitializeDataBaseAction extends AbstractAction{
	private static final long serialVersionUID = 9022706164171656811L;
	
	/**
	 * The action's name
	 */
	public static final String ACTION_NAME = "Re-initialized DataBase";
	
	/*Singleton*/
	private static ReInitializeDataBaseAction istance = null;
	
	/**
	 * @return the unique shared instance
	 */
	public static ReInitializeDataBaseAction getIstance(){
		if(istance == null){
			istance = new ReInitializeDataBaseAction();
		}
		return istance;
	}	
	private ReInitializeDataBaseAction(){
		putValue(Action.NAME,ACTION_NAME);
		ImageIcon imageIcon = ResourceFunctions.openImageIcon(this.getClass(), "deleteDB.png");
		putValue(Action.SMALL_ICON,imageIcon);
	}
	
	/**
	 * Invoked when this action occurs.
	 */
	public void actionPerformed(ActionEvent arg0) {
		setEnabled(false);
		int n = JOptionPane.showConfirmDialog(
			    ToolBoxFrame.getIstance(),
			    "Would you really like to reinitialize the database?",
			    "DataBase management",
			    JOptionPane.YES_NO_OPTION);
		if (n==JOptionPane.YES_OPTION){		
			GeneralManagementFacade.getInstance().deleteDataBase();
		}else{
			setEnabled(true);
		}
	}

}