package org.modelgen.jpf.core.actions;

import org.modelgen.commons.persistence.PersistenceHandlerFactory;
import org.modelgen.facade.GeneralManagementFacade;
import org.modelgen.facade.ResourceFunctions;
import org.modelgen.jpf.core.ToolBoxFrame;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.ImageIcon;
import javax.swing.JOptionPane;

/**
 * Start Server Action
 */
public class StartDbServerAction extends AbstractAction{
	private static final long serialVersionUID = 9022706164171656811L;
	
	/**
	 * The action's name
	 */
	public static final String ACTION_NAME = "Start Server";
	
	/*Singleton*/
	private static StartDbServerAction istance = null;
	
	/**
	 * @return the unique shared instance
	 */
	public static StartDbServerAction getIstance(){
		if(istance == null){
			istance = new StartDbServerAction();
		}
		return istance;
	}	
	private StartDbServerAction(){
		putValue(Action.NAME,ACTION_NAME);
		ImageIcon imageIcon = ResourceFunctions.openImageIcon(this.getClass(), "startDb.png");
		putValue(Action.SMALL_ICON,imageIcon);
	}
	
	/**
	 * Invoked when this action occurs.
	 */
	public void actionPerformed(ActionEvent arg0) {
		performsAction();
	}
	
	/**
	 * Invoked when this action occurs.
	 */
//	Definendo il comportamento in un altro metodo � possibile invocarlo direttamente dal Core
	public void performsAction() {
		setEnabled(false);
		
		boolean isCorrectlyStarted = false;
		
		/* riccardop: forza a creare un nuovo handler */
		PersistenceHandlerFactory.reload();
		
		isCorrectlyStarted = GeneralManagementFacade.getInstance().startServer();
		
		if (!isCorrectlyStarted){
			JOptionPane.showMessageDialog(ToolBoxFrame.getIstance(),"An error has occured during the database initialization","DataBase Error",JOptionPane.ERROR_MESSAGE);		
		}
		
		StopDbServerAction.getIstance().setEnabled(true);
		ReInitializeDataBaseAction.getIstance().setEnabled(false);
	}

}
