package org.modelgen.jpf.core.actions;

import org.modelgen.facade.GeneralManagementFacade;
import org.modelgen.facade.ResourceFunctions;
import org.modelgen.jpf.core.ToolBoxFrame;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.ImageIcon;

/**
 * Stop Server Action
 */
public class StopDbServerAction extends AbstractAction{
	private static final long serialVersionUID = -2784175570797729775L;
	
	/**
	 * The action's name
	 */
	public static final String ACTION_NAME = "Stop Server";
	
	/*Singleton*/
	private static StopDbServerAction istance = null;
	
	/**
	 * @return the unique shared instance
	 */
	public static StopDbServerAction getIstance(){
		if(istance == null)
			istance = new StopDbServerAction();
		return istance;
	}	

	private StopDbServerAction(){
		setEnabled(false);
		putValue(Action.NAME,ACTION_NAME);
		ImageIcon imageIcon = ResourceFunctions.openImageIcon(this.getClass(), "stopDb.png");
		putValue(Action.SMALL_ICON,imageIcon);
	}
	
	/**
	 * Invoked when this action occurs.
	 */
	public void actionPerformed(ActionEvent arg0) {
		performsAction();
	}
	
	/**
	 * Invoked when this action occurs.
	 */
	public void performsAction() {
		setEnabled(false);
		
		GeneralManagementFacade.getInstance().stopServer();
		//Chiude le frames eventualmente aperte
		ToolBoxFrame.getIstance().closeTools();
		
		StartDbServerAction.getIstance().setEnabled(true);
		ReInitializeDataBaseAction.getIstance().setEnabled(true);	
	}

}


