package org.modelgen.jpf.core.commons;

import java.util.Map;

/**
 * "Home" interface for particular tool. It is used by application core
 * to start up tool when user selects appropriate "button" on the main
 * application window.
 */
public interface Tool {
    /**
     * This method is called once during application life cycle to allow
     * tool to initialize and show itself.
     * @param applicationObjects the shared map
     */
    public void init(Map<String,Object> applicationObjects);
    /**
     * This method is called to get the shared map
     * @return the shared map
     */   
    public Map<String,Object> getInfo();
}
