package org.modelgen.polyhandler;

import org.modelgen.commons.utils.ModelgenConfigurationManager;

import java.awt.Dimension;
import java.awt.Rectangle;
import java.awt.Toolkit;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JPanel;

public class PolyGUI {

	//private static JFrame frame;
	
	private static void createAndShowGUI() {
        JFrame frame = new JFrame("PolyHandler Graphic Tester");
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        
        JPanel contentPane = new JPanel();
        contentPane.setLayout(new BoxLayout(contentPane,BoxLayout.Y_AXIS));
        
        String macroRulesDir = ModelgenConfigurationManager.getIstance().getProperty("rootnode", "", "paths")      // ./rules/
		+ ModelgenConfigurationManager.getIstance().getProperty("macrorules", "", "paths");
        System.out.println(macroRulesDir);
        String modelsDir = ModelgenConfigurationManager.getIstance().getProperty("modelsPath", "", "paths");      // ./Models
		System.out.println(modelsDir);
        
        String[] models = PolyGUIpopulator.populateBox(modelsDir.substring(1)); // to trim slash
        JComboBox combo1 = new JComboBox(models);
        contentPane.add(combo1);
        
        String[] macroRules = PolyGUIpopulator.populateBox(macroRulesDir);
        JComboBox combo2 = new JComboBox(macroRules);
        contentPane.add(combo2);
        
        JButton ok = new JButton("OK");
        ok.addActionListener(new PolyGUIlistener(combo1,combo2));
        contentPane.add(ok);
        
        contentPane.setOpaque(true); //content panes must be opaque
            
        frame.setContentPane(contentPane);
        int width = 400;
        int height = 300;
        Dimension dim = Toolkit.getDefaultToolkit().getScreenSize();
		frame.setBounds(0,0,width,height);
		Rectangle abounds = frame.getBounds();
		frame.setLocation((dim.width - abounds.width)/2,(dim.height - abounds.height) / 2);
		frame.setSize(new Dimension(width,height));
        //frame.setPreferredSize(new Dimension(400,300));
        frame.pack();
        frame.setVisible(true);
    }
	
	/**
	 * Runs the interface
	 * @param args
	 */
	public static void main(String[] args) {
       javax.swing.SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                createAndShowGUI();
            }
        });
    }
}	