package org.modelgen.polyhandler;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class PolyResolved {

	private Map<String,List<String>> resolved;
	private Map<String,List<String>> skolem;
	private Map<String,List<String>> append;
	private Map<String,List<String>> specs; 
		
	public PolyResolved() {
		/* The structure which will store the association: ConstructOrigin -> {ConstructResult1,ConstructResult2...}
		 * E.g.: Abstract -> {Aggregation}
		 * 	 or: Abstract -> {Aggregation,Abstract} (it means that some Abstract have been translated into Aggregation and some other into Abstract)
		 */
		resolved = new HashMap<String,List<String>>();
	
		/* The association ConstructOrigin -> {Skolem1,Skolem2...} as above
		 * 
		 */
		skolem = new HashMap<String,List<String>>();
		
		/* The association ConstructOrigin -> {ruleBody1,ruleBody2...}
		 * in order to specify the various translations when a ConstructOrigin has been translated
		 * into two or more different constructs within a Macrorule
		 * The "ruleBodyK" string will be appended (if necessary) to the instantiated rules derived from the processing
		 * of the polymorphic ones
		 */
		append = new HashMap<String,List<String>>();
		specs = new HashMap<String,List<String>>();
	}
	
	public void setAllButSpecs(Map<String,List<String>> res, Map<String,List<String>> sk, Map<String,List<String>> app, Map<String,List<String>> sp) {
		this.resolved = res;
		this.skolem = sk;
		this.append = app;
		this.specs = sp;
	}
	
	public Map<String,List<String>> getResolved() {
		return this.resolved;
	}
	public Map<String,List<String>> getSkolem() {
		return this.skolem;
	}
	public Map<String,List<String>> getAppend() {
		return this.append;
	}
	public Map<String,List<String>> getSpecs() {
		return this.specs;
	}
	public void setResolved(Map<String,List<String>> res) {
		this.resolved = res;
	}
	public void setSkolem(Map<String,List<String>> sk) {
		this.skolem = sk;
	}
	public void setAppend(Map<String,List<String>> app) {
		this.append = app;
	}
	public void setSpecs(Map<String,List<String>> specs) {
		this.specs = specs;
	}
	
	
}
