/*
 * Created on 23-mag-2005
 *
 */
package org.modelgen.regole;

import java.util.HashSet;
import java.util.Set;

import junit.framework.TestCase;

/**
 * @author luigi, francesca
 *
 */
class ConditionSetTest extends TestCase {

	public static void main(String[] args) {
		junit.textui.TestRunner.run(ConditionSetTest.class);
	}

	/*
	 * Class under test for boolean addAll(Set)
	 */
	public void testAddSet() {
		
	
	
		
		CondizioneSemplice c1 = new CondizioneSemplice("var2.OID","var3.aggregationOfAbstractsOID","=");
		CondizioneSemplice c2 = new CondizioneSemplice("var1.OID","var2.OID","=");
		CondizioneSemplice c3 = new CondizioneSemplice("var1.OID","var3.aggregationOfAbstractsOID","=");
		
		CondizioneSemplice c4 = new CondizioneSemplice("var1.schemeOID","?2","=");
		CondizioneSemplice c5 = new CondizioneSemplice("var2.schemeOID","?2","=");
		CondizioneSemplice c6 = new CondizioneSemplice("var3.schemeOID","?2","=");
		
		CondizioneSemplice c7 = new CondizioneSemplice("b","a","=");
		CondizioneSemplice c8 = new CondizioneSemplice("c","a","=");
		CondizioneSemplice c9 = new CondizioneSemplice("b","c","=");
				
				
		
		ConditionSet cs = new ConditionSet();
		assertTrue(c4.getOperando2().startsWith("?"));
		assertTrue(cs.add(c1));
		assertTrue(cs.add(c2));
		assertFalse(cs.add(c3));
		assertTrue(cs.add(c4));
		assertTrue(cs.add(c5));
		assertTrue(cs.add(c6));
		assertTrue(cs.add(c7));
		assertTrue(cs.add(c8));
		assertFalse(cs.add(c9));
		
	
	}
	
	/*
	 * Class under test for boolean addAll(Set)
	 */
	public void testAddAllSet() {
	    
		/*
		
		var1.schemeOID = ?2
	    AND var3.schemeOID = ?2
	    AND var2.schemeOID = ?2
	    AND var2.OID = var3.aggregationOfAbstractsOID
	    AND var1.OID = var2.OID
	    AND var1.OID = var3.aggregationOfAbstractsOID
		
		*/
		
		CondizioneSemplice c1 = new CondizioneSemplice("var2.OID","var3.aggregationOfAbstractsOID","=");
		CondizioneSemplice c2 = new CondizioneSemplice("var1.OID","var2.OID","=");
		CondizioneSemplice c3 = new CondizioneSemplice("var1.OID","var3.aggregationOfAbstractsOID","=");
		
		CondizioneSemplice c4 = new CondizioneSemplice("var1.schemeOID","?2","=");
		CondizioneSemplice c5 = new CondizioneSemplice("var2.schemeOID","?2","=");
		CondizioneSemplice c6 = new CondizioneSemplice("var3.schemeOID","?2","=");
		
		ConditionSet cs = new ConditionSet();
		Set<CondizioneSemplice> set = new HashSet<CondizioneSemplice>();
		
		set.add(c4);
		set.add(c5);
		set.add(c6);
		set.add(c1);
		set.add(c2);
		set.add(c3);
		
		cs.addAll(set);
		
		assertFalse(cs.contains(c3));
		
		
	

		
	}

}
