/*
 * Created on 19-mag-2005
 *
 */
package org.modelgen.regole;
import org.modelgen.regole.utilities.VarGenerator;

import java.util.Map;
import java.util.Set;


/**
 * Rappresenta il tipo di una condizione WHERE
 * Estende Comparable per definire un ordinamento convenzionale
 * tra le condizioni where, utile ad esempio nella stampa.
 * @author luigi, francesca
 * 
 */
public interface Condizione extends Comparable<Condizione> {
	
	/**
	 * 
	 * @return il livello di priorit nell'ordinamento della condizione
	 */
	public int getPriority();
	
	/**
	 * 
	 * @param tabelle la mappa delle corrispondenza letterale variabile
	 * @param vg il generatore di variabili
	 * @return l'insieme delle condizioni SqlB
	 */
	public Set<? extends Condizione> generaCondizioniB(Map<String,Tabella> tabelle, VarGenerator vg);
	
	/**
	 * 
	 * @return l'eventuale primo operando della condizione
	 */
	public String getOperando1();
	
	/**
	 * 
	 * @return l'eventuale secondo operando della condizione
	 */
	public String getOperando2();
	
	/**
	 * 
	 * @return l'eventuale terzo operando della condizione
	 */
	public String getOperatore();
	
	
}
