/*
 * Created on 14-mag-2005
 *
 */
package org.modelgen.regole;

import org.modelgen.regole.Exception.VarNotFoundException;

import java.util.Map;


/**
 * Rappresenta una condizione Datalog
 * @author luigi, francesca
 * 
 */
public class CondizioneDatalog {
	private String operatore; // gli operatori possono essere: <, >, =, <>
	private Manipolabile operando1;
	private Manipolabile operando2;
	
	public CondizioneDatalog(Manipolabile operando1, Manipolabile operando2, String operatore) {
		this.operando1 = operando1;
		this.operando2 = operando2;
		this.operatore = operatore;
	}
	
	public void setOperatore(String o) {
		this.operatore = o;
	}
	
	public String getOperatore() {
		return this.operatore;
	}
	
	public void setOperando1(Manipolabile m) {
		this.operando1 = m;
	}
	
	public Manipolabile getOperando1() {
		return this.operando1;
	}
	
	public void setOperando2(Manipolabile m) {
		this.operando2 = m;
	}
	
	public Manipolabile getOperando2() {
		return this.operando2;
	}
	
	/**
	 * 
	 * @param tabelle la mappa delle corrispondenze Letterale variabile
	 * @return una CondizioneSemplice
	 */
	public Condizione generaCondizione(Map<String,Tabella> tabelle) {
		try {
			return new CondizioneSemplice(operando1.generaSemicondizione(tabelle),operando2.generaSemicondizione(tabelle),operatore);
		} catch(VarNotFoundException ex) {
			/* non si pu verificare perch una condizione */
			/* se viene creata  sempre corretta */
			return null;
		}
		
	}
	
	public String toString() {
		return (operando1.toString() + " " + operatore + " " + operando2.toString());
	}
	
}
