/*
 * Created on 19-mag-2005
 *
 */
package org.modelgen.regole;

import org.modelgen.regole.utilities.CollectionFormatter;
import org.modelgen.regole.utilities.VarGenerator;

import java.util.Collections;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Set;



/**
 * Rappresenta una condizione del tipo: not exists select * from ..
 * @author luigi, francesca
 * 
 */
public class CondizioneNotExist implements Condizione {
	private String predicateName;  // la tabella su cui  definita la condizione
	private Set<Condizione> condizioni;        // di tipo Condizione
	private final int PRIORITY = 4;
	
	public CondizioneNotExist(String predicateName){
		this.predicateName = predicateName;
		this.condizioni = new ConditionSet();
	}
	
	public void setPredicateName(String pn){
		this.predicateName = pn;
	}
	
	public String getOperando1() {
		return "";
	}
	
	public String getOperando2(){
		return "";
	}
	
	public String getOperatore() {
		return "Not Exist";
	}
	
	public Set<Condizione> getCondizioniWhere() {
		return condizioni;
	}
	
	/**
	 * 
	 * @return un booleano che indica se la condizione  vuota o meno
	 */
	public boolean isVuota() {
		return condizioni.size()==0;
	}
	
	public String getPredicateName() {
		return this.predicateName;
	}
	
	public void addCondizione(Condizione c){
		condizioni.add(c);
	}
	
	public int getPriority() {
		return this.PRIORITY;
	}
	
	/**
	 * Aggiunge un insieme di condizioni alla NOT EXISTS
	 * @param s un insieme di condizioni
	 */
	public void addSetCondizioni(Set<? extends Condizione> s) {
		condizioni.addAll(s);
	}
	
	public Set<CondizioneNotExist> generaCondizioniB(Map<String,Tabella> tabelle, VarGenerator vg){
		Set<CondizioneNotExist> condizioni = new HashSet<CondizioneNotExist>();
		condizioni.add(this);
		return condizioni;
		
	}
	
	public int compareTo(Condizione c) {
		return this.PRIORITY - c.getPriority(); // secondo le convenzioni di compareTo
		
	}
	
	public int hashCode() {
		return toString().hashCode();
	}
	
	public boolean equals(Object o) {
		CondizioneNotExist cne = (CondizioneNotExist)o;
		return predicateName.equals(cne.getPredicateName()) && condizioni.equals(cne.getCondizioniWhere());
	}
	
	public String toString() {
		
		/* ordinamento delle condizioni where della NotExist */
		List<Condizione> condizioniOrdinate = new LinkedList<Condizione>(condizioni);
		Collections.sort(condizioniOrdinate);
		
		
		String IND = "    ";
		StringBuffer buf = new StringBuffer();
		buf.append(" NOT EXISTS (\n");
		buf.append(IND + IND + "SELECT *\n");
		buf.append(IND + IND + "FROM \n"+ IND + IND + IND + CollectionFormatter.getInstance().mettiTraSeparatore(predicateName) + " varNotExist \n");
		buf.append(IND + IND + "WHERE \n");
		buf.append("   " + IND + IND + IND + IND + CollectionFormatter.getInstance().getSequenzaComponenti(condizioniOrdinate,"\n" + IND + IND + IND + "AND "));
		buf.append(")");
		return buf.toString();
		
	}
		
	
	

}
