/*
 * Created on 19-mag-2005
 *
 */
package org.modelgen.regole;
import org.modelgen.regole.Exception.TooManyFunctorArgumentsException;
import org.modelgen.regole.utilities.VarGenerator;

import java.util.List;
import java.util.Map;
import java.util.Set;


/**
 * Rappresenta il tipo di una clausola della parte SELECT
 * @author luigi, francesca
 * 
 */
public interface CondizioneSelect {
	
	/**
	 * Per ogni condizione SELECT, date le corrispondenze letterali-variabili e le condizioni
	 * WHERE attuali, il metodo incrementa le nuove corrispondenze letterali-variabili e le nuove
	 * condizioni where con le condizioni generate dalla risoluzione della condizione select 
	 * che lo implementa. Restituisce la corrispondente condizione select risolta.
	 * @param tabelle l'attuale corrispondenza letterali - variabili
	 * @param tabelle1 le corrispondenze letterali-variabili da aggiungere
	 * @param where le attuali condizioni where
	 * @param where1 le condizioni where da aggiungere
	 * @param vg l'istanza di var generator relativa a questa regola
	 * @param regole le regole insert skolem generate da aggiungere
	 * @param cne la condizione notExist corrispondente ai funtori target
	 * @param colonnaRiferimento la colonna a cui questa CondizioneSelect fa riferimento
	 * @return la condizione Select risolta
	 */
	public CondizioneSelect getTradotto(Map<String,Tabella> tabelle, Map<String,Tabella> tabelle1, Set<Condizione> where,Set<Condizione> where1, VarGenerator vg, List<Regola> regole, CondizioneNotExist cne, String colonnaRiferimento) throws TooManyFunctorArgumentsException;
	
	

}
