/*
 * Created on 19-mag-2005
 *
 */
package org.modelgen.regole;
import org.modelgen.regole.utilities.CollectionFormatter;
import org.modelgen.regole.utilities.VarGenerator;

import java.util.HashSet;
import java.util.Map;
import java.util.Set;


/**
 * Rappresenta una condizione del tipo: varX.attributo = [costante|varY.attributo]
 * @author luigi, francesca
 * 
 */
public class CondizioneSemplice implements Condizione {
	private String operando1;
	private String operando2;
	private String operatore;
	private final int PRIORITY = 1; // priorit massima nell'ordinamento
	
	public CondizioneSemplice(String operando1, String operando2, String operatore){
		this.operando1 = operando1;
		this.operando2 = operando2;
		this.operatore = operatore;
	}
	
	public String getOperando1() {
		return this.operando1;
	}
	
	
	public String getOperando2() {
		return this.operando2;
	}
	
	public String getOperatore() {
		return this.operatore;
	}
	
	public Set<CondizioneSemplice> generaCondizioniB(Map<String,Tabella> tabelle, VarGenerator vg){
		HashSet<CondizioneSemplice> s =  new HashSet<CondizioneSemplice>();
		s.add(this);
		return s;
	}
	
	public int getPriority() {
		/* Per mettere prima le condizioni */
		/* sullo schemeOID */
		if(operando2.startsWith("?"))
			return 0;
		/* condizioni esplicite */
		else		
			if(!operatore.equals("="))
				return 3;
		else
			return PRIORITY;
	}
	
	
	
	/**
	 * E' necessario ridefinire l'uguaglianza per evitare duplicati
	 * nel ConditionSet
	 */	
	public boolean equals(Object o) {
		CondizioneSemplice c = (CondizioneSemplice)o;
		String operando1 = c.getOperando1();
		String operando2 = c.getOperando2();
		String operatore = c.getOperatore();
		boolean uguali = false;
		if (operatore.equals(this.operatore)){
			if(operando1.equals(this.operando1) && operando2.equals(this.operando2))
				uguali = true;
			if(operatore.equals("=") && operando1.equals(this.operando2) && operando2.equals(this.operando1))
				uguali = true;		
		}
		return uguali;
	}
	
	
	
	public int compareTo(Condizione c) {
		return this.getPriority() - c.getPriority(); // secondo le convenzioni di compareTo
						
	}
	
	public int hashCode() {
		String a = toString();
		int i=0;
		int somma = 0;
		for(i=0;i<a.length();i++) {
			somma+= a.charAt(i);
		}
		
		return somma;
	}
	
	
	
	public String toString() {
		return CollectionFormatter.getInstance().mettiSeparatoreDopoPunto(operando1) + " " + operatore + " " + CollectionFormatter.getInstance().mettiSeparatoreDopoPunto(operando2);
	}
	
	
}
