package org.modelgen.regole.Exception;

/**
 * Eccezione che rappresenta il fallimento della traduzione 
 * di una regola Datalog sugli schemi in una regola Datalog sulle istanze
 * @author luigi, francesca
 *
 */
public class InstanceTranslationException extends Exception {
	private static final long serialVersionUID = 1L;
	private static final String ERRORE_DI_TRADUZIONE_PER_ISTANZA = "Errore di traduzione per istanza: ";

	public InstanceTranslationException(String message) {
		super(message);
	}
	
	public InstanceTranslationException() {
		super();
	}
	
	/**
	 * Costruzione a partire da un'eccezione di livello inferiore. La traduzione
	 * non va a buon fine se la regola originale  temporanea.
	 * @param ife
	 */
	public InstanceTranslationException(InstanceFromTempException ife) {
		super(ERRORE_DI_TRADUZIONE_PER_ISTANZA + ife.getMessage());
	}
	
	public InstanceTranslationException(InstanceFromComposedArgumentException ex) {
		super(ERRORE_DI_TRADUZIONE_PER_ISTANZA + ex.getMessage());
	}
	
	public InstanceTranslationException(InstanceMultipleLexicalException ex) {
		super(ERRORE_DI_TRADUZIONE_PER_ISTANZA + ex.getMessage());
	}
	
}
