/*
 * Created on 19-mag-2005
 *
 */
package org.modelgen.regole;

import org.modelgen.regole.utilities.CollectionFormatter;

import java.util.LinkedList;
import java.util.List;

/**
 *  Rappresenta la parte insert di una query SQLAlto
 * @author luigi, francesca
 *
 */
public class InsertPart {
	private String nomeTabella;  // insert into nomeTabella
	private List<String> colonne;
	
	public InsertPart(String nomeTabella){
		this.nomeTabella = nomeTabella;
		this.colonne = new LinkedList<String>();
	}
	
	public InsertPart(InsertPart ip){
		this.nomeTabella = new String(ip.getNomeTabella());
		this.colonne = new LinkedList<String>();	
		
		for(String colonna : ip.getColonne()) {
			colonne.add(new String(colonna));
		}
		
	}
	public void setNomeTabella(String n) {
		this.nomeTabella = n;
	}
	
	public String getNomeTabella() {
		return this.nomeTabella;
	}
	
	public void setColonne(List<String> colonne) {
		this.colonne = colonne;
		
	}
	public List<String> getColonne() {
		return this.colonne;
		
	}
	public void addColonna(String colonna) {
		this.colonne.add(colonna);
	}
	
	/**
	 * Restituisce il nome di una colonna data la sua posizione
	 * @param i l'indice della colonna da restituire
	 * @return l'i-esima colonna della parte insert
	 */
	public String getColonna(int i) {
		return colonne.get(i);
	}
	
	public String toString() {
		StringBuffer buf = new StringBuffer();
		buf.append("INSERT INTO "+ CollectionFormatter.getInstance().mettiTraSeparatore(nomeTabella) + "(");
		List colonne = CollectionFormatter.getInstance().mettiElementiListaTraSeparatori(this.colonne);
		buf.append(CollectionFormatter.getInstance().getSequenzaComponenti(colonne));
		buf.append(")\n");
		return buf.toString();
	}
}
