package org.modelgen.regole;


import org.modelgen.commons.persistence.PersistenceHandler;
import org.modelgen.commons.persistence.PersistenceHandlerFactory;

import java.util.Iterator;
import java.util.Map;

/*
 * Creato il 19-apr-2004
 *
 * Per modificare il modello associato a questo file generato, aprire
 * Finestra&gt;Preferenze&gt;Java&gt;Generazione codice&gt;Codice e commenti
 */

/**
 * @author paolo
 * 
 * Per modificare il modello associato al commento di questo tipo generato,
 * aprire Finestra&gt;Preferenze&gt;Java&gt;Generazione codice&gt;Codice e
 * commenti
 */
public class MappaSkolemFunctorDatalog {
	private final static char ACCAPO = '\n';

	public Map<String,SkolemFunction> mappaFunzioni;

	
	public MappaSkolemFunctorDatalog() {
		/*
		 * mappaFunzioni = new HashMap(); this.inizializzaMappaFunzioni();
		 */
		// luca s 2004-11-16 - Spostamento ad una gestione persistente delle
		// funzioni di Skolem.
		mappaFunzioni = null;
		try {
			PersistenceHandler ph = PersistenceHandlerFactory
					.getPersistenceHandler();
			mappaFunzioni = ph.getMappaFuntoriSkolem();
			if (mappaFunzioni == null) { //TODO: il DB non contiene alcuna
										 // funzione di Skolem: non va certo
										 // bene. Per ora le carichiamo noi, in
										 // futuro questa chiamata andra'
										 // RIMOSSA.
				//2005-01-31: luca s: poiche' abbiamo spostato le funzioni in Initializer
				//non serve piu' che siano qui. Non solo: se non si trovano nel database
				//significa che il database e' messo MALE ed e' meglio fermare tutto quanto.
				throw new NullPointerException(
					"Attenzione, il database non contiene alcuna funzione di Skolem e questo e' male. " +
					"[cfr: Egon Spengler, Ghostbusters]. Assicurati di avere dato il parametro --skolem " +
					"ad Initializer o di avere definito manualmente qualche funzione di skolem tramite l'apposita webapp"	
				);
				//2005-01-31: luca s: fine.
				//this.inizializzaMappaFunzioni();
				//ph.storeSkolemFunctions(mappaFunzioni); //Cosi' le salviamo e la prossima volta verranno caricate.
			}
		} catch (Exception e) {
			e.printStackTrace();
			mappaFunzioni = null;
		}
	}


	/**
	 * @return la funzione associata al nome
	 */
	public SkolemFunction getFunzione(String nomeFunzione) {
		SkolemFunction funzione = this.mappaFunzioni
				.get(nomeFunzione);
		return funzione;
	}
	
	public String toString() {
		StringBuffer sb = new StringBuffer();
		Iterator i = mappaFunzioni.entrySet().iterator();
		while (i.hasNext()) {
			Map.Entry entry = (Map.Entry) i.next();
			sb.append("Key: " + entry.getKey());
			sb.append("Value: " + entry.getValue());

			sb.append(MappaSkolemFunctorDatalog.ACCAPO);
		}
		return sb.toString();
	}

}
