package org.modelgen.regole;

import org.modelgen.regole.Exception.FunctorVariableNotFoundException;
import org.modelgen.regole.Exception.InstanceFromComposedArgumentException;
import org.modelgen.regole.Exception.VarNotFoundException;
import org.modelgen.regole.utilities.CollectionFormatter;

import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Set;


/**
 * Rappresenta la funzione fn(value1, value2, ... valueN) che indica l'indecidibilit�
 * del motore riguardo al legame tra Value nella testa e uno degli N value nei letterali
 * del corpo)
 * @author luigi, francesca
 *
 */
public class ValueFunction implements Argomento {
	
	private List<VariabileDatalog> variabili; // lista di variabili
	public final static String FUNCTION_NAME = "@fn"; 
	
	public void setLetterale(Letterale letterale) {
		
	}
	
	public ValueFunction() {
		variabili = new LinkedList<VariabileDatalog>();
	}
	
	public void addVariabile(VariabileDatalog vd) {
		variabili.add(vd);
	}
	
	
	public Argomento getArgomentoPerIstanza() {
		return null;
	}
	
	public String getNome() {
		return FUNCTION_NAME;
	}
	
	public Set<? extends Condizione> generaCondizioni(String var, Map<String, Tabella> tabelle, String attributo) throws FunctorVariableNotFoundException {
		return null;
	}
	
	/**
	 * In caso di value multipli nel corpo di una regola di istanza
	 * la traduzione in SQLA non pu� essere ottenuta e si genera
	 * necessariamente un'eccezione.
	 */
	public CondizioneSelect getSelect(Map<String, Tabella> tabelle) throws VarNotFoundException, FunctorVariableNotFoundException {
//		paoloc 200705171656 - START
//		throw new MultipleValueException();
		
		StringBuilder clausola = new StringBuilder();
		List<CondizioneSelectSemplice> cssList = new LinkedList<CondizioneSelectSemplice>();
		Iterator<VariabileDatalog> i = this.variabili.iterator();
		while (i.hasNext()) {
			VariabileDatalog vd = i.next();
			try {
				Letterale l = vd.getLetterale();
				String attr = l.getAttributoPerVariabile(vd.getNome());
				Tabella tabella = tabelle.get(l.getID());
				String var = tabella.getVarOID();
				clausola.append(var + "." + attr + " + ");
				cssList.add(new CondizioneSelectSemplice(var + "." + attr));
			} catch(VarNotFoundException ex) {
				throw ex;
			}
		}
//		if I'm here, I'm happy!
		
//		we decided to return a sql-string value to value, in order to avoid 
//		the sum of integer values (that may lead to collision in values)
//		String result = clausola.toString().substring(0, clausola.toString().lastIndexOf('+')).trim();
		String result = clausola.append("' '").toString();
		return new CondizioneSelectSemplice(result);
	}
	
	public Condizione getTMP(String var, Map<String, Tabella> tabelle, String attributo) throws VarNotFoundException {
		return null;
	}
	
	public Argomento getArgomentoPerIstanza(RegolaDatalog nuova, Letterale newLetterale) throws InstanceFromComposedArgumentException {
		return null;
	}
	
	public Argomento duplicate(RegolaDatalog nuova, Letterale newLetterale, boolean isSpecialContext) {
		return null;
	}
	
	public String toString() {
		StringBuffer sb = new StringBuffer();
		sb.append(FUNCTION_NAME + "(");
		sb.append(CollectionFormatter.getInstance().getSequenzaComponenti(variabili));
		sb.append(")");
		return sb.toString();
	}
	
	public String getValore() {
		return null;
	}
	
	
	
	

	
}
