package org.modelgen.regole.launcher;

/*
 * GUIMDM.java
 *
 * Created on 24 febbraio 2004, 15.29
 */

import org.modelgen.commons.utils.ModelgenConfigurationManager;
import org.modelgen.regole.Regola;
import org.modelgen.regole.RegolaB;
import org.modelgen.regole.RegolaDatalog;
import org.modelgen.regole.reader.DatalogRulesReader;

import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;



/**
 * Semplice interfaccia per aprire e tradurre regole
 * @author  paolo
 */
public class GUIMDM extends javax.swing.JFrame {
	private static final long serialVersionUID = 1L;
	private RegolaDatalog regolaDatalog = null;
    private Regola regolaSQLA = null;
    private RegolaB regolaSQLB = null;
    
    /** Creates new form GUIMDM */
    public GUIMDM() {
        //this.setLocationRelativeTo(null);
        
        initComponents();
        
		try {
			UIManager.setLookAndFeel(
					UIManager.getSystemLookAndFeelClassName()
					//UIManager.getCrossPlatformLookAndFeelClassName()
					);
			System.out.println("impostato Look&Feel");
		} catch (InstantiationException e) {
		} catch (ClassNotFoundException e) {
		} catch (UnsupportedLookAndFeelException e) {
		} catch (IllegalAccessException e) {
		}
       //setDefaultLookAndFeelDecorated(true);
        this.setSize(500,350);
        this.setLocation(100, 150);
    }
    
    private String getHelp() {
        return "-) usare File->Open per scegliere il file con la regola datalog \n\r" +
        "-) usare Rule->Translate per tradurre la regola Datlog in SQL-A ed SQL-B\n\r" +
        "-) usare File->SaveAs per salvare la regola SQL-B in un file\n\r" +
        "\n\r" +
        "nota: \n\r" +
        "     -) la regola di skolem SQL-B non e' visibile (working on...)\n\r" +
        "     -) tutte le regole sono visibili sulle schede con gli stessi nomi\n\r";
    }
    
    private String getAbout() {
        return "ModelGen GUI 0.1-alpha";
    }
    
    private String getNoSQLBRulaAviable() {
        return "no SQL-B rule aviable to save for: \n\r miss translation step?";
    }
    
     private String getNoDatalogRuleAviable() {
        return "no Datalolg rule aviable: \n\r any datalog rule loaded?";
    }
    
    /*private String getNoSkolemGenerated() {
		return "no Skolem rule generated: \n\r probably no target skolem functor " +
			"defined in datalog rule \n\r \"#funtoreA, SK(...)\"";
    }*/
    
    private String getFailedTranslationSQLB() {
		return "something went wrong in translation process \n\r" +
			"no SQL-B rule generated";
    }
    
	private String getFailedTranslationSQLA() {
		return "something went wrong in translation process \n\r" +
			"no SQL-A rule generated";
	}
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jFileChooser1 = new javax.swing.JFileChooser();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTextArea1 = new javax.swing.JTextArea();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTextArea2 = new javax.swing.JTextArea();
        jScrollPane3 = new javax.swing.JScrollPane();
        jTextArea3 = new javax.swing.JTextArea();
        jScrollPane4 = new javax.swing.JScrollPane();
        jTextArea4 = new javax.swing.JTextArea();
        jScrollPane5 = new javax.swing.JScrollPane();
        jTextArea5 = new javax.swing.JTextArea();
        jScrollPane6 = new javax.swing.JScrollPane();
        jTextArea6 = new javax.swing.JTextArea();
        menuBar = new javax.swing.JMenuBar();
        fileMenu = new javax.swing.JMenu();
        openMenuItem = new javax.swing.JMenuItem();
        saveMenuItem = new javax.swing.JMenuItem();
        saveAsMenuItem = new javax.swing.JMenuItem();
        exitMenuItem = new javax.swing.JMenuItem();
        ruleMenu = new javax.swing.JMenu();
        translateRuleMenu = new javax.swing.JMenuItem();
        helpMenu = new javax.swing.JMenu();
        contentsMenuItem = new javax.swing.JMenuItem();
        aboutMenuItem = new javax.swing.JMenuItem();

        setTitle("MDM - Translator");
        setFont(new java.awt.Font("Default", 0, 12));
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        jScrollPane1.setViewportView(jTextArea1);

        jTabbedPane1.addTab("Datalog", jScrollPane1);

        jScrollPane2.setViewportView(jTextArea2);

        jTabbedPane1.addTab("SQL-A", jScrollPane2);

        jScrollPane3.setViewportView(jTextArea3);

        jTabbedPane1.addTab("SQL-B", null, jScrollPane3, "manca la Skolem");
        
        jScrollPane4.setViewportView(jTextArea4);
        
        jTabbedPane1.addTab("Datalog-I", jScrollPane4);
        
        jScrollPane5.setViewportView(jTextArea5);
        
        jTabbedPane1.addTab("SQL-A-I", jScrollPane5);
        
        jScrollPane6.setViewportView(jTextArea6);
        
        jTabbedPane1.addTab("SQL-B-I", jScrollPane6);

        getContentPane().add(jTabbedPane1, java.awt.BorderLayout.CENTER);

        fileMenu.setText("File");
        openMenuItem.setText("Open");
        openMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                openMenuItemActionPerformed(evt);
            }
        });

        fileMenu.add(openMenuItem);

        saveMenuItem.setText("Save");
        fileMenu.add(saveMenuItem);

        saveAsMenuItem.setText("Save As ...");
        saveAsMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveAsMenuItemActionPerformed(evt);
            }
        });

        fileMenu.add(saveAsMenuItem);

        exitMenuItem.setText("Exit");
        exitMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                exitMenuItemActionPerformed(evt);
            }
        });

        fileMenu.add(exitMenuItem);

        menuBar.add(fileMenu);

        ruleMenu.setText("Rule");
        translateRuleMenu.setText("Translate");
        translateRuleMenu.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                try {
                	translateRuleMenuActionPerformed(evt);
                } catch(Exception ex) {
                	System.out.println(ex.getMessage());
                }
            }
        });

        ruleMenu.add(translateRuleMenu);

        menuBar.add(ruleMenu);

        helpMenu.setText("Help");
        contentsMenuItem.setText("Contents");
        contentsMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                contentsMenuItemActionPerformed(evt);
            }
        });

        helpMenu.add(contentsMenuItem);

        aboutMenuItem.setText("About");
        aboutMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                aboutMenuItemActionPerformed(evt);
            }
        });

        helpMenu.add(aboutMenuItem);

        menuBar.add(helpMenu);

        setJMenuBar(menuBar);

        pack();
    }//GEN-END:initComponents

    private void saveAsMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveAsMenuItemActionPerformed
        
        if (regolaSQLB != null) {
            String save = ModelgenConfigurationManager.getIstance().getProperty("rootnode","","paths");
            System.out.println("save dir: " + save);
            jFileChooser1 = new JFileChooser(save);
            int returnVal = jFileChooser1.showSaveDialog(this);
            String fileToWrite = null;
            if(returnVal == JFileChooser.APPROVE_OPTION) {
                fileToWrite = jFileChooser1.getSelectedFile().getAbsolutePath();
                System.out.println("You chose to save to this file: " + fileToWrite);
            }
            saveAsToFile(fileToWrite);
        } else JOptionPane.showMessageDialog(this, getNoSQLBRulaAviable());
    }

	private void saveAsToFile(String fileToWrite) {
		/*try {
		    //regolaSQLA.writeToFile(fileToWrite);
			PrintWriter bw = new PrintWriter(
				new BufferedWriter(new FileWriter(fileToWrite)));
			if (regolaSQLB_SK!=null) {
				bw.print(regolaSQLB_SK.toString());
				bw.println(";");
				bw.println();
			}
			
			bw.print(regolaSQLB.toString());
			bw.println(";");
			
			bw.flush();
			bw.close();
		} catch (IOException ioe) {
		    System.out.println("unable to write to this file: " + fileToWrite);
		} */
	}//GEN-LAST:event_saveAsMenuItemActionPerformed

    private void aboutMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_aboutMenuItemActionPerformed
        
        JOptionPane.showMessageDialog(this, getAbout());
    }//GEN-LAST:event_aboutMenuItemActionPerformed

    private void contentsMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_contentsMenuItemActionPerformed
        
        //helpTextArea.setText(this.getHelp());
        JOptionPane.showMessageDialog(this, getHelp());
    }//GEN-LAST:event_contentsMenuItemActionPerformed

    private void translateRuleMenuActionPerformed(java.awt.event.ActionEvent evt) throws Exception {//GEN-FIRST:event_translateRuleMenuActionPerformed
        try {
        	
   
        if (regolaDatalog != null) {
            regolaSQLA = regolaDatalog.traduciInSQLAlto();
            if (regolaSQLA!=null) jTextArea2.setText(regolaSQLA.toString());
			else JOptionPane.showMessageDialog(this, getFailedTranslationSQLA());
            
             regolaSQLB = regolaSQLA.traduciSqlBasso();
             
             
        
             // regolaSQLB_SK = regolaSQLA.traduciSkolem();
            StringBuffer sb = new StringBuffer();          
            
            //sb.append("\n\r\n\r");
			if (regolaSQLB!=null) sb.append(regolaSQLB.toString());
			else JOptionPane.showMessageDialog(this, getFailedTranslationSQLB());
            jTextArea3.setText(sb.toString());
            
            RegolaDatalog regola = regolaDatalog.traduciPerIstanza();
          
            jTextArea4.setText(regola.toString());
            jTextArea5.setText(regola.traduciInSQLAlto().toString());
            jTextArea6.setText(regola.traduciInSQLAlto().traduciSqlBasso().toString());
            
            
        } else JOptionPane.showMessageDialog(this, getNoDatalogRuleAviable());
      } catch(Exception ex) {
        	JOptionPane.showMessageDialog(this,ex.getMessage());
        }
    }//GEN-LAST:event_translateRuleMenuActionPerformed

    private void openMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_openMenuItemActionPerformed
        
        String fileNameToRead = null;
        String rootnode = ModelgenConfigurationManager.getIstance().getProperty("rootnode", "", "paths");
            System.out.println("rootnode: " + ModelgenConfigurationManager.getIstance() + rootnode);
		String simplenode = ModelgenConfigurationManager.getIstance().getProperty("simplerules","","paths");
			System.out.println("simplenode: " + ModelgenConfigurationManager.getIstance() + rootnode);
		String node = rootnode + simplenode;
		System.out.println("node: " + node);
        jFileChooser1 = new JFileChooser(node);
        int returnVal = jFileChooser1.showOpenDialog(this);
        if(returnVal == JFileChooser.APPROVE_OPTION) {
            fileNameToRead = jFileChooser1.getSelectedFile().getAbsolutePath();
            System.out.println("You chose to open this file: " + fileNameToRead);
        }
        try {
        	regolaDatalog = DatalogRulesReader.read(fileNameToRead);
        } catch (Exception e) {
        	System.out.println("file non trovato o sintassi della regola errata");
        	e.printStackTrace();
        }
        regolaSQLA = null;
        regolaSQLB = null;
		//regolaSQLB_SK = null;
        jTextArea1.setText(regolaDatalog.toString());
        jTextArea2.setText("");
        jTextArea3.setText("");
        jTextArea4.setText("");
        jTextArea5.setText("");
        jTextArea6.setText("");
        
    }//GEN-LAST:event_openMenuItemActionPerformed
    
    private void exitMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_exitMenuItemActionPerformed
        System.exit(0);
    }//GEN-LAST:event_exitMenuItemActionPerformed
    
    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        System.exit(0);
    }//GEN-LAST:event_exitForm
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        new GUIMDM().setVisible(true);
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JMenuItem aboutMenuItem;
    private javax.swing.JMenuItem contentsMenuItem;
    private javax.swing.JMenuItem exitMenuItem;
    private javax.swing.JMenu fileMenu;
    private javax.swing.JMenu helpMenu;
    private javax.swing.JFileChooser jFileChooser1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JScrollPane jScrollPane5;
    private javax.swing.JScrollPane jScrollPane6;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JTextArea jTextArea1;
    private javax.swing.JTextArea jTextArea2;
    private javax.swing.JTextArea jTextArea3;
    private javax.swing.JTextArea jTextArea4;
    private javax.swing.JTextArea jTextArea5;
    private javax.swing.JTextArea jTextArea6;
    private javax.swing.JMenuBar menuBar;
    private javax.swing.JMenuItem openMenuItem;
    private javax.swing.JMenu ruleMenu;
    private javax.swing.JMenuItem saveAsMenuItem;
    private javax.swing.JMenuItem saveMenuItem;
    private javax.swing.JMenuItem translateRuleMenu;
    
    // End of variables declaration//GEN-END:variables
    
}
