/*
 * Created on 15-giu-2005
 *
 */
package org.modelgen.regole.launcher;


import org.modelgen.commons.utils.ModelgenConfigurationManager;
import org.modelgen.regole.MacroRegola;
import org.modelgen.regole.reader.ParametricDatalogRulesReader;

import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;




/**
 * Semplice interfaccia per aprire e tradurre macroregole
 * @author luigi, francesca
 *
 */
public class MacroTester extends javax.swing.JFrame {
	private static final long serialVersionUID = 1L;
	private MacroRegola macroRegola;
    
    /** Creates new form GUIMDM */
    public MacroTester() {
        //this.setLocationRelativeTo(null);
        
        initComponents();
        
		try {
			UIManager.setLookAndFeel(
					UIManager.getSystemLookAndFeelClassName()
					//UIManager.getCrossPlatformLookAndFeelClassName()
					);
			System.out.println("impostato Look&Feel");
		} catch (InstantiationException e) {
		} catch (ClassNotFoundException e) {
		} catch (UnsupportedLookAndFeelException e) {
		} catch (IllegalAccessException e) {
		}
       //setDefaultLookAndFeelDecorated(true);
        this.setSize(500,350);
        this.setLocation(100, 150);
    }
    
    private String getHelp() {
        return "-) usare File->Open per scegliere il file con la macro regola \n\r" +
        "-) usare Rule->Translate per tradurre la macroregola in SQL";
    }
    
    private String getAbout() {
        return "MacroTester 1.0 \nLuigi Bellomarini, Francesca Bugiotti";
    }
    
    /*private String getNoDatalogRuleAviable() {
        return "no Datalolg rule aviable: \n\r any datalog rule loaded?";
    }
    
    private String getFailedTranslationSQLB() {
		return "something went wrong in translation process \n\r" +
			"no SQL-B rule generated";
    }*/
    

    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jFileChooser1 = new javax.swing.JFileChooser();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTextArea1 = new javax.swing.JTextArea();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTextArea2 = new javax.swing.JTextArea();
        jScrollPane3 = new javax.swing.JScrollPane();
        jTextArea3 = new javax.swing.JTextArea();
        jTextArea4 = new javax.swing.JTextArea(); // MacroRegola per istanza
        jScrollPane4 = new javax.swing.JScrollPane();
        jTextArea5 = new javax.swing.JTextArea(); // MacroRegola per istanza SQLA
        jScrollPane5 = new javax.swing.JScrollPane();
        jTextArea6 = new javax.swing.JTextArea(); // MacroRegola per istanza SQLB
        jScrollPane6 = new javax.swing.JScrollPane();
        
        menuBar = new javax.swing.JMenuBar();
        fileMenu = new javax.swing.JMenu();
        openMenuItem = new javax.swing.JMenuItem();
        saveMenuItem = new javax.swing.JMenuItem();
        saveAsMenuItem = new javax.swing.JMenuItem();
        exitMenuItem = new javax.swing.JMenuItem();
        ruleMenu = new javax.swing.JMenu();
        translateRuleMenu = new javax.swing.JMenuItem();
        helpMenu = new javax.swing.JMenu();
        contentsMenuItem = new javax.swing.JMenuItem();
        aboutMenuItem = new javax.swing.JMenuItem();

        setTitle("MacroTester - Translator");
        setFont(new java.awt.Font("Default", 0, 12));
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        jScrollPane1.setViewportView(jTextArea1);

        jTabbedPane1.addTab("MacroRegola Datalog", jScrollPane1);

        jScrollPane2.setViewportView(jTextArea2);

        jTabbedPane1.addTab("MacroRegola SQLB", jScrollPane2);

        jScrollPane3.setViewportView(jTextArea3);

        jTabbedPane1.addTab("MacroRegola SQLA", jScrollPane3);
        
        jScrollPane4.setViewportView(jTextArea4);
        
        jTabbedPane1.addTab("MacroRegolaI", jScrollPane4);
        
        jScrollPane5.setViewportView(jTextArea5);
        
        jTabbedPane1.addTab("MacroRegola SQLB-I", jScrollPane5);
        
        jScrollPane6.setViewportView(jTextArea6);
        
        jTabbedPane1.addTab("MacroRegola SQLA-I", jScrollPane6);

        getContentPane().add(jTabbedPane1, java.awt.BorderLayout.CENTER);

        fileMenu.setText("File");
        openMenuItem.setText("Open");
        openMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                openMenuItemActionPerformed(evt);
            }
        });

        fileMenu.add(openMenuItem);

        saveMenuItem.setText("Save");
        

        saveAsMenuItem.setText("Save As ...");
        
        

        

        exitMenuItem.setText("Exit");
        exitMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                exitMenuItemActionPerformed(evt);
            }
        });

        fileMenu.add(exitMenuItem);

        menuBar.add(fileMenu);

        ruleMenu.setText("Rule");
        translateRuleMenu.setText("Translate");
        translateRuleMenu.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt){
                translateRuleMenuActionPerformed(evt);
            }
        });

        ruleMenu.add(translateRuleMenu);

        menuBar.add(ruleMenu);

        helpMenu.setText("Help");
        contentsMenuItem.setText("Contents");
        contentsMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                contentsMenuItemActionPerformed(evt);
            }
        });

        helpMenu.add(contentsMenuItem);

        aboutMenuItem.setText("About");
        aboutMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                aboutMenuItemActionPerformed(evt);
            }
        });

        helpMenu.add(aboutMenuItem);

        menuBar.add(helpMenu);

        setJMenuBar(menuBar);

        pack();
    }//GEN-END:initComponents

  


    private void aboutMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_aboutMenuItemActionPerformed
        
        JOptionPane.showMessageDialog(this, getAbout());
    }//GEN-LAST:event_aboutMenuItemActionPerformed

    private void contentsMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_contentsMenuItemActionPerformed
        
        //helpTextArea.setText(this.getHelp());
        JOptionPane.showMessageDialog(this, getHelp());
    }//GEN-LAST:event_contentsMenuItemActionPerformed

    private void translateRuleMenuActionPerformed(java.awt.event.ActionEvent evt){//GEN-FIRST:event_translateRuleMenuActionPerformed
    	// COMMENTED OUT TO TEST OPGEN
    	//try {
        
            
           jTextArea1.setText(macroRegola.toString());
		 
           // COMMENT OUT IF NOT TESTING OPGEN
           System.out.println(macroRegola.toStringTradotto(false));
           
           // COMMENTED OUT TO TEST OPGEN
           jTextArea2.setText(macroRegola.toStringTradotto(false));
           
           // COMMENTED OUT TO TEST OPGEN
           //jTextArea3.setText(macroRegola.toStringTradotto(true));
           
           //MacroRegola mr = macroRegola.getMacroRegolaPerIstanza();
           
           // COMMENTED OUT TO TEST OPGEN
           //jTextArea4.setText(mr.toString());
           //jTextArea5.setText(mr.toStringTradotto(false));
           //jTextArea6.setText(mr.toStringTradotto(true));
           
           //COMMENTED OUT TO TEST OPGEN
        //} catch(InstanceTranslationException ex) {
        	//JOptionPane.showMessageDialog(this,ex.getMessage());
        //}
    }//GEN-LAST:event_translateRuleMenuActionPerformed
    
    private void openMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_openMenuItemActionPerformed
        
        String fileNameToRead = null;
        String rootnode = ModelgenConfigurationManager.getIstance().getProperty("rootnode", "", "paths");
            System.out.println("rootnode: " + ModelgenConfigurationManager.getIstance() + rootnode);
		String simplenode = ModelgenConfigurationManager.getIstance().getProperty("macrorules","","paths");
			System.out.println("simplenode: " + ModelgenConfigurationManager.getIstance() + rootnode);
		String node = rootnode + simplenode;
		System.out.println("node: " + node);
        jFileChooser1 = new JFileChooser(node);
        int returnVal = jFileChooser1.showOpenDialog(this);
        if(returnVal == JFileChooser.APPROVE_OPTION) {
            fileNameToRead = jFileChooser1.getSelectedFile().getAbsolutePath();
            System.out.println("You chose to open this file: " + fileNameToRead);
        }
        try {
        	macroRegola = ParametricDatalogRulesReader.read(fileNameToRead);
        } catch (Exception e) {
        	System.out.println("file non trovato o sintassi della regola errata");
        	e.printStackTrace();
        }
     
	
        jTextArea1.setText(macroRegola.toString());
        jTextArea2.setText("");
        jTextArea3.setText("");
        jTextArea4.setText("");
        jTextArea5.setText("");
        jTextArea6.setText("");
        
        
    }//GEN-LAST:event_openMenuItemActionPerformed
    
    private void exitMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_exitMenuItemActionPerformed
        System.exit(0);
    }//GEN-LAST:event_exitMenuItemActionPerformed
    
    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        System.exit(0);
    }//GEN-LAST:event_exitForm
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        new MacroTester().setVisible(true);
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JMenuItem aboutMenuItem;
    private javax.swing.JMenuItem contentsMenuItem;
    private javax.swing.JMenuItem exitMenuItem;
    private javax.swing.JMenu fileMenu;
    private javax.swing.JMenu helpMenu;
    private javax.swing.JFileChooser jFileChooser1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JScrollPane jScrollPane5;
    private javax.swing.JScrollPane jScrollPane6;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JTextArea jTextArea1;
    private javax.swing.JTextArea jTextArea2;
    private javax.swing.JTextArea jTextArea3;
    private javax.swing.JTextArea jTextArea4;
    private javax.swing.JTextArea jTextArea5;
    private javax.swing.JTextArea jTextArea6;
    private javax.swing.JMenuBar menuBar;
    private javax.swing.JMenuItem openMenuItem;
    private javax.swing.JMenu ruleMenu;
    private javax.swing.JMenuItem saveAsMenuItem;
    private javax.swing.JMenuItem saveMenuItem;
    private javax.swing.JMenuItem translateRuleMenu;
    // End of variables declaration//GEN-END:variables
    
}


