package org.modelgen.regole.utilities;

import org.modelgen.regole.Regola;
import org.modelgen.regole.RegolaDatalog;

import java.util.concurrent.Callable;

/**
 * A SimpleTranslator is a mono-thread worker which translates
 * a DatalogRule into a RegolaB
 * @author luigi, francesca
 *
 */
public class SimpleTranslator implements Callable<Regola> {
	
	private RegolaDatalog regolaDatalog;
	private boolean traduciA; // if only SQLA translation
	
	public SimpleTranslator(RegolaDatalog rd, boolean traduciA) {
		this.regolaDatalog = rd;
		this.traduciA = traduciA;
	}

	public Regola call() throws Exception {		
		return traduci();
	}
	
	/**
	 * translates a single RegolaDatalog.
	 */
	private Regola traduci(){
		
		Regola rb = null;
		
		try {
			/* this translator just works for SQLB full translation */
			if(!traduciA) // only SQLA
				rb = regolaDatalog.traduciInSQLAlto().traduciSqlBasso();
			else // SQLA and SQLB
				rb = regolaDatalog.traduciInSQLAlto();
		} catch (Exception e){
			System.err.print("Translation Error: ");
			e.printStackTrace();
		}
		return rb;
	}

}
