package org.modelgen.regole.utilities;

import org.modelgen.regole.Regola;
import org.modelgen.regole.RegolaDatalog;

import java.util.LinkedList;
import java.util.List;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;

/**
 * A TranslatorWorker can translate a list of datalog rules (coming from a macrorule)
 * by instantiating a pool of Simple Translators.
 * @author luigi, francesca
 *
 */
public class TranslatorWorker {
	
	/**
	 * translates a list of RegolaDatalog into a List of RegolaB
	 * @param regola
	 * @param traduciA if only SQLA translation
	 */
	public List<Regola> traduci(List<RegolaDatalog> regola, boolean traduciA){
		
		List<Future<Regola>> listfrb = new LinkedList<Future<Regola>>();
		/* pool of translators */
		ExecutorService es = Executors.newFixedThreadPool(50);
		List<Regola> a = new LinkedList<Regola>();
		
		/* for each rule starts a translator worker */
		/* which returns a Future. The Futures are collected */
		/* in a lista. */
		for(RegolaDatalog rd: regola)			
			listfrb.add(es.submit(new SimpleTranslator(rd,traduciA)));			
		
		
		/* converts the Future list into a RegolaB list */
		for(Future<Regola> flb : listfrb)
			try {
			a.add(flb.get());
			} catch (Exception e) {
				System.out.println("Execution error");	
			}				
		
		return a;
	}

}
