package org.modelgen.signature.application.macroruleapplication;

import org.modelgen.signature.MacroRuleSignature;

import java.util.List;
import java.util.Map;

/**
 * Classe singleton che implementa una sorta di cache per la
 * lista di tutte le macroregole esistenti
 * @author Fabrizio Celli
 *
 */
public class NaiveCacheMacroRuleSignature {

	private List<MacroRuleSignature> regole = null;
	private Map<String, MacroRuleSignature> mapRegole = null;
	
	//singleton
	private static NaiveCacheMacroRuleSignature instance = null;

	public static NaiveCacheMacroRuleSignature getInstance(){
		if(instance == null)
			instance = new NaiveCacheMacroRuleSignature();
		return instance;
	}

	public List<MacroRuleSignature> getRegole(){
		return this.regole;
	}


	public void setRegole(List<MacroRuleSignature> regole){
		this.regole = regole;
	}

	public Map<String, MacroRuleSignature> getMapRegole() {
		return mapRegole;
	}

	public void setMapRegole(Map<String, MacroRuleSignature> mapRegole) {
		this.mapRegole = mapRegole;
	}
	
	public MacroRuleSignature getRegola(String name){
		return mapRegole.get(name);
	}
	
	

}
