package org.modelgen.signature.test;

import org.modelgen.facade.GeneralManagementFacade;
import org.modelgen.signature.ConstructSignature;
import org.modelgen.signature.MacroRuleSignature;
import org.modelgen.signature.ModelSignature;
import org.modelgen.signature.application.ruleapplication.ApplicateRuleSignature;

public class MacroRuleApplicationTest {
	
	private static MacroRuleSignature regola;
	private static ModelSignature schema;
	
	private static void initMacroRule(){
		regola = GeneralManagementFacade.getInstance().getMacroRegolaByfileName("16.00.elimM2NBinAggOfAbs.txt");
		System.out.println(regola);
		System.out.println();
	}
	
	private static void initModel(){
		schema = new ModelSignature("ERbin");
		ConstructSignature cons = new ConstructSignature("Abstract");
		schema.insert(cons);
		cons = new ConstructSignature("Lexical");
		schema.insert(cons);
		cons = new ConstructSignature("Generalization");
		schema.insert(cons);
		cons = new ConstructSignature("ChildOfGeneralization");
		schema.insert(cons);
		cons = new ConstructSignature("BinaryAggregationOfAbstracts");
		String formula = "(BinaryAggregationOfAbstracts.isFunctional1 OR (NOT BinaryAggregationOfAbstracts.isFunctional2))";
		cons.setFormula(formula);
		schema.insert(cons);
		System.out.println(schema);
		System.out.println();
	}
	
	public static void main(String[] args){
		
		GeneralManagementFacade.getInstance().startServer();
		
		initMacroRule();
		initModel();
		
		ApplicateRuleSignature applicator = new ApplicateRuleSignature();
		ModelSignature result = applicator.createModelSignature(regola, schema);
		System.out.println(result);
		System.out.println();
		
		GeneralManagementFacade.getInstance().stopServer();
		
	}

}
