package org.modelgen.signature.test;

import org.modelgen.facade.GeneralManagementFacade;
import org.modelgen.signature.MacroRuleSignature;
import org.modelgen.signature.ModelSignature;
import org.modelgen.signature.application.loader.RulesLoader;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

public class ModelSignatureFromBodies {
	
	public static void main(String[] args) throws IOException{
		//carico le trasformazioni
		List<String> transformations = RulesLoader.getInstance().loadTransformations();
		
		//carico le segnature delle trasformazioni
		List<MacroRuleSignature> transSign = new ArrayList<MacroRuleSignature>();;
		
		for (int i = 0; i < transformations.size(); i++) {//rulesName.size(); i++) {
			MacroRuleSignature mrdp = GeneralManagementFacade.getInstance().getMacroRegolaByfileName(transformations.get(i));
			transSign.add(mrdp);
		}
		
		//calcolo le ModelSignature
		for(MacroRuleSignature sign: transSign){
			ModelSignature model = sign.getModelSignatureFromBodies();
			System.out.println("-----------------------------------");
			System.out.println(model.getName());
			System.out.println(model);
			System.out.println("-----------------------------------");
		}
	}

}
