package org.modelgen.signature.test;

import org.modelgen.facade.GeneralManagementFacade;
import org.modelgen.signature.MacroRuleSignature;
import org.modelgen.signature.application.treeSearcher.OrderedReductionsWriter;

import java.io.IOException;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

public class OrderedReductionWriterTest {
	
	public static Map<String, List<MacroRuleSignature>> transformationToReductions;
	
	public static void init(){
		transformationToReductions = new HashMap<String, List<MacroRuleSignature>>();
		List<MacroRuleSignature> reductions = new LinkedList<MacroRuleSignature>();
		reductions.add(GeneralManagementFacade.getInstance().getMacroRegolaByfileName("15.00.elimLexOfOne2XBinAggOfAbs.txt"));
		reductions.add(GeneralManagementFacade.getInstance().getMacroRegolaByfileName("24.00.lexOfAbs4StructOfAttNestedInAbs.txt"));
		reductions.add(GeneralManagementFacade.getInstance().getMacroRegolaByfileName("26.00.lexOfAgg4StructOfAttNestedInAgg.txt"));
		transformationToReductions.put("28.00.rel2ER.txt", reductions);
		transformationToReductions.put("29.00.rel2ER.txt", reductions);
	}
	
	public static void main(String[] args) throws IOException{
		GeneralManagementFacade.getInstance().startServer();
		init();
		System.out.println(transformationToReductions);
		OrderedReductionsWriter out = new OrderedReductionsWriter();
		System.out.println(out);
		//out.addFamily("PROVA", transformationToReductions);
		GeneralManagementFacade.getInstance().stopServer();
	}

}
