package org.modelgen.signature.test;

import org.modelgen.facade.GeneralManagementFacade;
import org.modelgen.signature.ConstructSignature;
import org.modelgen.signature.MacroRuleSignature;
import org.modelgen.signature.ModelSignature;
import org.modelgen.signature.application.loader.RulesLoader;
import org.modelgen.signature.application.treeSearcher.TreeSearcher;

import java.io.IOException;
import java.util.LinkedList;
import java.util.List;

public class TreeSearcherSimulation {

	private static List<MacroRuleSignature> reductions = null;
	
	public static void main(String[] args) throws IOException{
		initReductions();
		TreeSearcher searcher = new TreeSearcher();
		System.out.println(getFamily());
		System.out.println(getTarget());
		List<MacroRuleSignature> reduction = searcher.getReductionFromFamilyToModel(getFamily(), getTarget(), reductions);
		
		System.out.println("reduction:\n");
		for(MacroRuleSignature macro: reduction)
			System.out.println(macro.getFileName());
	}
	
	private static void initReductions() throws IOException{
		reductions = new LinkedList<MacroRuleSignature>();
		List<String> redNames = RulesLoader.getInstance().loadReductions();
		for(String reduction: redNames){
			reductions.add(GeneralManagementFacade.getInstance().getMacroRegolaByfileName(reduction));
		}
	}
	
	//MODELLO ER BINARY
	public static ModelSignature getFamily(){
		ModelSignature schema = new ModelSignature("ERbin");
		ConstructSignature cons = new ConstructSignature("Abstract");
		schema.insert(cons);
		cons = new ConstructSignature("Lexical");
		schema.insert(cons);
		cons = new ConstructSignature("Generalization");
		schema.insert(cons);
		cons = new ConstructSignature("ChildOfGeneralization");
		schema.insert(cons);
		cons = new ConstructSignature("BinaryAggregationOfAbstracts");
		String formula = "(BinaryAggregationOfAbstracts.isFunctional1 OR (NOT BinaryAggregationOfAbstracts.isFunctional2))";
		cons.setFormula(formula);
		schema.insert(cons);
		return schema;
	}
	
	//MODELLO TARGET, CARICATO DALLA MACROREGOLA 21.00.ER2Rel.txt
	public static ModelSignature getTarget(){
		MacroRuleSignature mrSign = GeneralManagementFacade.getInstance().getMacroRegolaByfileName("21.00.ER2Rel.txt");
		return mrSign.getModelSignatureFromBodies();
	}
}
