package org.modelgen.tmphandler;

/** 
 * This class represents an attribute with its argument of a TMP lexical found in a Datalog rule,
 * at the extent of which it is useful for the TmpHandler class work.
 * 
 * @author Daniele
 *
 */
public class AttTemp {

	private String attribute;
	private String type;
	
	public AttTemp(String a, String t) {
		this.attribute = a;
		this.type = t;
	}
	
	/** 
	 * Returns the attribute name
	 * 
	 * @return a String, the attribute name
	 */
	public String getAttribute() {
		return this.attribute;
	}
	
	public String getType() {
		return this.type;
	}
	
	/** 
	 * Sets the attribute name
	 * 
	 * @param a - a String, the attribute name
	 */
	public void setAttribute(String a) {
		this.attribute = a;
	}

	public void setType(String t) {
		this.type = t;
	}
	
}
