package org.modelgen.tmphandler;
import java.util.Collection;
import java.util.Iterator;
import java.util.LinkedList;

/** 
 * This class represents a TMP lexical of a Datalog rule, according to its usefulness
 * in the TmpHandler class.
 * 
 * @author Daniele
 *
 */
public class LexTemp {
	
	private String predicateName;
	
	private Collection<AttTemp> attributes;
	
	public LexTemp(String predicateName) {
		this.predicateName = predicateName;
		this.attributes = new LinkedList<AttTemp>();
	}
	
	
	
	
	public String getPredicateName() {
		return this.predicateName;
	}
	
	public Collection<AttTemp> getAttributes() {
		return this.attributes;
	}
	
	public void setPredicateName(String n) {
		this.predicateName = n;
	}
	
	/** 
	 * Adds attributes to this TMP lexicals. Duplicates are not allowed. 
	 * 
	 * @param a - an AttTemp object
	 */
	public void addAttribute(AttTemp a) throws Exception {
		Iterator<AttTemp> i = this.attributes.iterator();
		AttTemp b = null;
		String aName = a.getAttribute();
		String aType = a.getType();
		boolean found = false;
		while(i.hasNext()) {
			b = i.next();
			String bName = b.getAttribute(); 
			String bType = b.getType();
			if(aName.equalsIgnoreCase(bName) && !aType.equalsIgnoreCase(bType)) {
				throw new Exception("NUN PO' ACCADE'!!! Stesso letterale, stesso attributo ma con tipo diverso!!!");
			}
			
			if(aName.equalsIgnoreCase(bName)) {
				found = true;
			}
		}
		if (found==false) {
			this.attributes.add(a);
		}
		
	}
	
	public int getNumberOfAttributes() {
		return this.attributes.size();
	}
		
}
