/*
 * $Id: DirectionUtils.java,v 1.2 2007/03/19 12:30:49 david Exp $
 * Copyright (c) 2005-2007, David Benson
 *
 * All rights reserved.
 *
 * This file is licensed under the JGraph software license, a copy of which
 * will have been provided to you in the file LICENSE at the root of your
 * installation directory. If you are unable to locate this file please
 * contact JGraph sales for another copy.
 */
package com.jgraph.layout.orthogonal;

public class DirectionUtils {

    public static int getCounterClockWiseDirection (int direction) {
        switch (direction) {
            case IDirectionable.LEFT:
                return IDirectionable.BOTTOM;
            case IDirectionable.RIGHT:
                return IDirectionable.TOP;
            case IDirectionable.TOP:
                return IDirectionable.LEFT;
            case IDirectionable.BOTTOM:
                return IDirectionable.RIGHT;
            default:
                throw new IllegalArgumentException ();
        }
    }

    public static int getClockWiseDirection (int direction) {
        switch (direction) {
            case IDirectionable.LEFT:
                return IDirectionable.TOP;
            case IDirectionable.RIGHT:
                return IDirectionable.BOTTOM;
            case IDirectionable.TOP:
                return IDirectionable.RIGHT;
            case IDirectionable.BOTTOM:
                return IDirectionable.LEFT;
            default:
                throw new IllegalArgumentException ();
        }
    }

}
