/*
 * $Id: IDirectionable.java,v 1.2 2007/03/19 12:31:22 david Exp $
 * Copyright (c) 2005-2007, David Benson
 *
 * All rights reserved.
 *
 * This file is licensed under the JGraph software license, a copy of which
 * will have been provided to you in the file LICENSE at the root of your
 * installation directory. If you are unable to locate this file please
 * contact JGraph sales for another copy.
 */package com.jgraph.layout.orthogonal;

public interface IDirectionable {

    public static final int CENTER = 0;
    public static final int LEFT = 1;
    public static final int RIGHT = 2;
    public static final int TOP = 4;
    public static final int BOTTOM = 8;

    public static final int TOP_LEFT = TOP | LEFT;
    public static final int TOP_RIGHT = TOP | RIGHT;
    public static final int BOTTOM_LEFT = BOTTOM | LEFT;
    public static final int BOTTOM_RIGHT = BOTTOM | RIGHT;

    public static final int ANY = LEFT | RIGHT | TOP | BOTTOM;

    /**
     * Returns a direction.
     * @return the direction - the value could be one of pre-defined static field in IDirectionable interface
     */
    public int getDirection ();

}
